// Copyright (c) rAthena Dev Teams - Licensed under GNU GPL
// For more information, see LICENCE in the main folder

#ifndef SCRIPT_CONSTANTS_HPP
#define SCRIPT_CONSTANTS_HPP

	#define export_constant(a) script_set_constant(#a,a,false,false)
	#define export_constant2(a,b) script_set_constant(a,b,false,false)
	#define export_constant_offset(a,offset) script_set_constant(#a + (offset),a,false,false)
	#define export_parameter(a,b) script_set_constant(a,b,true,false)
	#define export_deprecated_constant(a) script_set_constant(#a,a,false,true)
	#define export_deprecated_constant2(a,b) script_set_constant(a,b,false,true)
	#define export_deprecated_constant3(a,b,c) script_set_constant_(a,b,c,false,true)

	/* min and maximum variable value */
	export_constant(INT_MIN);
	export_constant(INT_MAX);

	/* server defines */
	export_constant(PACKETVER);
	export_constant(MAX_LEVEL);
	export_constant(MAX_STORAGE);
	export_constant(MAX_INVENTORY);
	export_constant(MAX_CART);
	export_constant(MAX_ZENY);
	export_constant(MAX_PARTY);
	export_constant(MAX_GUILD);
	export_constant(MAX_GUILDLEVEL);
	export_constant(MAX_GUARDIANS);
	export_constant(MAX_GUILD_STORAGE);
	export_constant(MAX_BG_MEMBERS);
	export_constant(MAX_CHAT_USERS);
	export_constant(VIP_SCRIPT);
	export_constant(MIN_STORAGE);
	export_constant(MAX_SLOTS);
	export_constant(MAX_ITEM_RDM_OPT);
	export_constant(NAME_LENGTH);
	export_constant(PASSWD_LENGTH);

	/* boolean values */
	export_constant(true);
	export_constant(false);

	/* jobs */
	export_constant(JOB_NOVICE);
	export_constant(JOB_SWORDMAN);
	export_constant(JOB_MAGE);
	export_constant(JOB_ARCHER);
	export_constant(JOB_ACOLYTE);
	export_constant(JOB_MERCHANT);
	export_constant(JOB_THIEF);
	export_constant(JOB_KNIGHT);
	export_constant(JOB_PRIEST);
	export_constant(JOB_WIZARD);
	export_constant(JOB_BLACKSMITH);
	export_constant(JOB_HUNTER);
	export_constant(JOB_ASSASSIN);
	export_constant(JOB_KNIGHT2);
	export_constant(JOB_CRUSADER);
	export_constant(JOB_MONK);
	export_constant(JOB_SAGE);
	export_constant(JOB_ROGUE);
	export_constant(JOB_ALCHEMIST);
	export_constant(JOB_BARD);
	export_constant(JOB_DANCER);
	export_constant(JOB_CRUSADER2);
	export_constant(JOB_WEDDING);
	export_constant(JOB_SUPER_NOVICE);
	// For backwards compatability
	export_constant2("Job_SuperNovice",JOB_SUPER_NOVICE); // TODO: Refactor NPCs to use the new constant
	export_constant(JOB_GUNSLINGER);
	export_constant(JOB_NINJA);
	export_constant(JOB_XMAS);
	export_constant(JOB_SUMMER);
	export_constant(JOB_HANBOK);
	export_constant(JOB_OKTOBERFEST);
	export_constant(JOB_SUMMER2);

	export_constant(JOB_NOVICE_HIGH);
	export_constant(JOB_SWORDMAN_HIGH);
	export_constant(JOB_MAGE_HIGH);
	export_constant(JOB_ARCHER_HIGH);
	export_constant(JOB_ACOLYTE_HIGH);
	export_constant(JOB_MERCHANT_HIGH);
	export_constant(JOB_THIEF_HIGH);
	export_constant(JOB_LORD_KNIGHT);
	export_constant(JOB_HIGH_PRIEST);
	export_constant(JOB_HIGH_WIZARD);
	export_constant(JOB_WHITESMITH);
	export_constant(JOB_SNIPER);
	export_constant(JOB_ASSASSIN_CROSS);
	export_constant(JOB_LORD_KNIGHT2);
	export_constant(JOB_PALADIN);
	export_constant(JOB_CHAMPION);
	export_constant(JOB_PROFESSOR);
	export_constant(JOB_STALKER);
	export_constant(JOB_CREATOR);
	export_constant(JOB_CLOWN);
	export_constant(JOB_GYPSY);
	export_constant(JOB_PALADIN2);

	export_constant(JOB_BABY);
	export_constant(JOB_BABY_SWORDMAN);
	export_constant(JOB_BABY_MAGE);
	export_constant(JOB_BABY_ARCHER);
	export_constant(JOB_BABY_ACOLYTE);
	export_constant(JOB_BABY_MERCHANT);
	export_constant(JOB_BABY_THIEF);
	export_constant(JOB_BABY_KNIGHT);
	export_constant(JOB_BABY_PRIEST);
	export_constant(JOB_BABY_WIZARD);
	export_constant(JOB_BABY_BLACKSMITH);
	export_constant(JOB_BABY_HUNTER);
	export_constant(JOB_BABY_ASSASSIN);
	export_constant(JOB_BABY_KNIGHT2);
	export_constant(JOB_BABY_CRUSADER);
	export_constant(JOB_BABY_MONK);
	export_constant(JOB_BABY_SAGE);
	export_constant(JOB_BABY_ROGUE);
	export_constant(JOB_BABY_ALCHEMIST);
	export_constant(JOB_BABY_BARD);
	export_constant(JOB_BABY_DANCER);
	export_constant(JOB_BABY_CRUSADER2);
	export_constant(JOB_SUPER_BABY);

	export_constant(JOB_TAEKWON);
	export_constant(JOB_STAR_GLADIATOR);
	export_constant(JOB_STAR_GLADIATOR2);
	export_constant(JOB_SOUL_LINKER);

	export_constant(JOB_GANGSI);
	export_constant(JOB_DEATH_KNIGHT);
	export_constant(JOB_DARK_COLLECTOR);

	export_constant(JOB_RUNE_KNIGHT);
	export_constant(JOB_WARLOCK);
	export_constant(JOB_RANGER);
	export_constant(JOB_ARCH_BISHOP);
	export_constant(JOB_MECHANIC);
	export_constant(JOB_GUILLOTINE_CROSS);

	export_constant(JOB_RUNE_KNIGHT_T);
	export_constant(JOB_WARLOCK_T);
	export_constant(JOB_RANGER_T);
	export_constant(JOB_ARCH_BISHOP_T);
	export_constant(JOB_MECHANIC_T);
	export_constant(JOB_GUILLOTINE_CROSS_T);

	export_constant(JOB_ROYAL_GUARD);
	export_constant(JOB_SORCERER);
	export_constant(JOB_MINSTREL);
	export_constant(JOB_WANDERER);
	export_constant(JOB_SURA);
	export_constant(JOB_GENETIC);
	export_constant(JOB_SHADOW_CHASER);

	export_constant(JOB_ROYAL_GUARD_T);
	export_constant(JOB_SORCERER_T);
	export_constant(JOB_MINSTREL_T);
	export_constant(JOB_WANDERER_T);
	export_constant(JOB_SURA_T);
	export_constant(JOB_GENETIC_T);
	export_constant(JOB_SHADOW_CHASER_T);

	export_constant(JOB_RUNE_KNIGHT2);
	export_constant(JOB_RUNE_KNIGHT_T2);
	export_constant(JOB_ROYAL_GUARD2);
	export_constant(JOB_ROYAL_GUARD_T2);
	export_constant(JOB_RANGER2);
	export_constant(JOB_RANGER_T2);
	export_constant(JOB_MECHANIC2);
	export_constant(JOB_MECHANIC_T2);

	export_constant(JOB_BABY_RUNE_KNIGHT);
	export_constant(JOB_BABY_WARLOCK);
	export_constant(JOB_BABY_RANGER);
	export_constant(JOB_BABY_ARCH_BISHOP);
	export_constant(JOB_BABY_MECHANIC);
	export_constant(JOB_BABY_GUILLOTINE_CROSS);
	export_constant(JOB_BABY_ROYAL_GUARD);
	export_constant(JOB_BABY_SORCERER);
	export_constant(JOB_BABY_MINSTREL);
	export_constant(JOB_BABY_WANDERER);
	export_constant(JOB_BABY_SURA);
	export_constant(JOB_BABY_GENETIC);
	export_constant(JOB_BABY_SHADOW_CHASER);

	export_constant(JOB_BABY_RUNE_KNIGHT2);
	export_constant(JOB_BABY_ROYAL_GUARD2);
	export_constant(JOB_BABY_RANGER2);
	export_constant(JOB_BABY_MECHANIC2);

	export_constant(JOB_SUPER_NOVICE_E);
	export_constant(JOB_SUPER_BABY_E);

	export_constant(JOB_KAGEROU);
	export_constant(JOB_OBORO);

	export_constant(JOB_REBELLION);

	export_constant(JOB_SUMMONER);

	export_constant(JOB_BABY_SUMMONER);

	export_constant(JOB_BABY_NINJA);
	export_constant(JOB_BABY_KAGEROU);
	export_constant(JOB_BABY_OBORO);
	export_constant(JOB_BABY_TAEKWON);
	export_constant(JOB_BABY_STAR_GLADIATOR);
	export_constant(JOB_BABY_SOUL_LINKER);
	export_constant(JOB_BABY_GUNSLINGER);
	export_constant(JOB_BABY_REBELLION);

	export_constant(JOB_BABY_STAR_GLADIATOR2);

	export_constant(JOB_STAR_EMPEROR);
	export_constant(JOB_SOUL_REAPER);
	export_constant(JOB_BABY_STAR_EMPEROR);
	export_constant(JOB_BABY_SOUL_REAPER);
	export_constant(JOB_STAR_EMPEROR2);
	export_constant(JOB_BABY_STAR_EMPEROR2);

	export_constant(JOB_DRAGON_KNIGHT);
	export_constant(JOB_MEISTER);
	export_constant(JOB_SHADOW_CROSS);
	export_constant(JOB_ARCH_MAGE);
	export_constant(JOB_CARDINAL);
	export_constant(JOB_WINDHAWK);
	export_constant(JOB_IMPERIAL_GUARD);
	export_constant(JOB_BIOLO);
	export_constant(JOB_ABYSS_CHASER);
	export_constant(JOB_ELEMENTAL_MASTER);
	export_constant(JOB_INQUISITOR);
	export_constant(JOB_TROUBADOUR);
	export_constant(JOB_TROUVERE);

	export_constant(JOB_WINDHAWK2);
	export_constant(JOB_MEISTER2);
	export_constant(JOB_DRAGON_KNIGHT2);
	export_constant(JOB_IMPERIAL_GUARD2);

	export_constant(JOB_SKY_EMPEROR);
	export_constant(JOB_SOUL_ASCETIC);
	export_constant(JOB_SHINKIRO);
	export_constant(JOB_SHIRANUI);
	export_constant(JOB_NIGHT_WATCH);
	export_constant(JOB_HYPER_NOVICE);
	export_constant(JOB_SPIRIT_HANDLER);

	export_constant(JOB_SKY_EMPEROR2);

	/* EA jobs */
	export_constant2("EAJL_2_1",JOBL_2_1);
	export_constant2("EAJL_2_2",JOBL_2_2);
	export_constant2("EAJL_2",JOBL_2);
	export_constant2("EAJL_UPPER",JOBL_UPPER);
	export_constant2("EAJL_BABY",JOBL_BABY);
	export_constant2("EAJL_THIRD",JOBL_THIRD);
	export_constant2("EAJL_FOURTH",JOBL_FOURTH);

	export_constant2("EAJ_BASEMASK",MAPID_BASEMASK);
	export_constant2("EAJ_UPPERMASK",MAPID_UPPERMASK);
	export_constant2("EAJ_THIRDMASK",MAPID_THIRDMASK);
	export_constant2("EAJ_FOURTHMASK",MAPID_FOURTHMASK);

	export_constant2("EAJ_NOVICE",MAPID_NOVICE);
	export_constant2("EAJ_SWORDMAN",MAPID_SWORDMAN);
	export_constant2("EAJ_MAGE",MAPID_MAGE);
	export_constant2("EAJ_ARCHER",MAPID_ARCHER);
	export_constant2("EAJ_ACOLYTE",MAPID_ACOLYTE);
	export_constant2("EAJ_MERCHANT",MAPID_MERCHANT);
	export_constant2("EAJ_THIEF",MAPID_THIEF);
	export_constant2("EAJ_TAEKWON",MAPID_TAEKWON);
	export_constant2("EAJ_GUNSLINGER",MAPID_GUNSLINGER);
	export_constant2("EAJ_NINJA",MAPID_NINJA);
	export_constant2("EAJ_GANGSI",MAPID_GANGSI);

	export_constant2("EAJ_KNIGHT",MAPID_KNIGHT);
	export_constant2("EAJ_WIZARD",MAPID_WIZARD);
	export_constant2("EAJ_HUNTER",MAPID_HUNTER);
	export_constant2("EAJ_PRIEST",MAPID_PRIEST);
	export_constant2("EAJ_BLACKSMITH",MAPID_BLACKSMITH);
	export_constant2("EAJ_ASSASSIN",MAPID_ASSASSIN);
	export_constant2("EAJ_STAR_GLADIATOR",MAPID_STAR_GLADIATOR);
	export_constant2("EAJ_STARGLADIATOR",MAPID_STAR_GLADIATOR);
	export_constant2("EAJ_REBELLION",MAPID_REBELLION);
	export_constant2("EAJ_KAGEROUOBORO",MAPID_KAGEROUOBORO);
	export_constant2("EAJ_DEATH_KNIGHT",MAPID_DEATH_KNIGHT);
	export_constant2("EAJ_DEATHKNIGHT",MAPID_DEATH_KNIGHT);

	export_constant2("EAJ_CRUSADER",MAPID_CRUSADER);
	export_constant2("EAJ_SAGE",MAPID_SAGE);
	export_constant2("EAJ_BARDDANCER",MAPID_BARDDANCER);
	export_constant2("EAJ_MONK",MAPID_MONK);
	export_constant2("EAJ_ALCHEMIST",MAPID_ALCHEMIST);
	export_constant2("EAJ_ROGUE",MAPID_ROGUE);
	export_constant2("EAJ_SOUL_LINKER",MAPID_SOUL_LINKER);
	export_constant2("EAJ_SOULLINKER",MAPID_SOUL_LINKER);
	export_constant2("EAJ_DARK_COLLECTOR",MAPID_DARK_COLLECTOR);
	export_constant2("EAJ_DARKCOLLECTOR",MAPID_DARK_COLLECTOR);

	export_constant2("EAJ_NOVICE_HIGH",MAPID_NOVICE_HIGH);
	export_constant2("EAJ_SWORDMAN_HIGH",MAPID_SWORDMAN_HIGH);
	export_constant2("EAJ_MAGE_HIGH",MAPID_MAGE_HIGH);
	export_constant2("EAJ_ARCHER_HIGH",MAPID_ARCHER_HIGH);
	export_constant2("EAJ_ACOLYTE_HIGH",MAPID_ACOLYTE_HIGH);
	export_constant2("EAJ_MERCHANT_HIGH",MAPID_MERCHANT_HIGH);
	export_constant2("EAJ_THIEF_HIGH",MAPID_THIEF_HIGH);

	export_constant2("EAJ_LORD_KNIGHT",MAPID_LORD_KNIGHT);
	export_constant2("EAJ_HIGH_WIZARD",MAPID_HIGH_WIZARD);
	export_constant2("EAJ_SNIPER",MAPID_SNIPER);
	export_constant2("EAJ_HIGH_PRIEST",MAPID_HIGH_PRIEST);
	export_constant2("EAJ_WHITESMITH",MAPID_WHITESMITH);
	export_constant2("EAJ_ASSASSIN_CROSS",MAPID_ASSASSIN_CROSS);

	export_constant2("EAJ_PALADIN",MAPID_PALADIN);
	export_constant2("EAJ_PROFESSOR",MAPID_PROFESSOR);
	export_constant2("EAJ_CLOWNGYPSY",MAPID_CLOWNGYPSY);
	export_constant2("EAJ_CHAMPION",MAPID_CHAMPION);
	export_constant2("EAJ_CREATOR",MAPID_CREATOR);
	export_constant2("EAJ_STALKER",MAPID_STALKER);

	export_constant2("EAJ_BABY",MAPID_BABY);
	export_constant2("EAJ_BABY_SWORDMAN",MAPID_BABY_SWORDMAN);
	export_constant2("EAJ_BABY_MAGE",MAPID_BABY_MAGE);
	export_constant2("EAJ_BABY_ARCHER",MAPID_BABY_ARCHER);
	export_constant2("EAJ_BABY_ACOLYTE",MAPID_BABY_ACOLYTE);
	export_constant2("EAJ_BABY_MERCHANT",MAPID_BABY_MERCHANT);
	export_constant2("EAJ_BABY_THIEF",MAPID_BABY_THIEF);
	export_constant2("EAJ_BABY_TAEKWON",MAPID_BABY_TAEKWON);
	export_constant2("EAJ_BABY_GUNSLINGER",MAPID_BABY_GUNSLINGER);
	export_constant2("EAJ_BABY_NINJA",MAPID_BABY_NINJA);
	export_constant2("EAJ_BABY_SUMMONER",MAPID_BABY_SUMMONER);

	export_constant2("EAJ_BABY_KNIGHT",MAPID_BABY_KNIGHT);
	export_constant2("EAJ_BABY_WIZARD",MAPID_BABY_WIZARD);
	export_constant2("EAJ_BABY_HUNTER",MAPID_BABY_HUNTER);
	export_constant2("EAJ_BABY_PRIEST",MAPID_BABY_PRIEST);
	export_constant2("EAJ_BABY_BLACKSMITH",MAPID_BABY_BLACKSMITH);
	export_constant2("EAJ_BABY_ASSASSIN",MAPID_BABY_ASSASSIN);
	export_constant2("EAJ_BABY_STAR_GLADIATOR",MAPID_BABY_STAR_GLADIATOR);
	export_constant2("EAJ_BABY_REBELLION",MAPID_BABY_REBELLION);
	export_constant2("EAJ_BABY_KAGEROUOBORO",MAPID_BABY_KAGEROUOBORO);

	export_constant2("EAJ_BABY_CRUSADER",MAPID_BABY_CRUSADER);
	export_constant2("EAJ_BABY_SAGE",MAPID_BABY_SAGE);
	export_constant2("EAJ_BABY_BARDDANCER",MAPID_BABY_BARDDANCER);
	export_constant2("EAJ_BABY_MONK",MAPID_BABY_MONK);
	export_constant2("EAJ_BABY_ALCHEMIST",MAPID_BABY_ALCHEMIST);
	export_constant2("EAJ_BABY_ROGUE",MAPID_BABY_ROGUE);
	export_constant2("EAJ_BABY_SOUL_LINKER",MAPID_BABY_SOUL_LINKER);

	export_constant2("EAJ_RUNE_KNIGHT",MAPID_RUNE_KNIGHT);
	export_constant2("EAJ_WARLOCK",MAPID_WARLOCK);
	export_constant2("EAJ_RANGER",MAPID_RANGER);
	export_constant2("EAJ_ARCH_BISHOP",MAPID_ARCH_BISHOP);
	export_constant2("EAJ_MECHANIC",MAPID_MECHANIC);
	export_constant2("EAJ_GUILLOTINE_CROSS",MAPID_GUILLOTINE_CROSS);
	export_constant2("EAJ_STAR_EMPEROR",MAPID_STAR_EMPEROR);

	export_constant2("EAJ_ROYAL_GUARD",MAPID_ROYAL_GUARD);
	export_constant2("EAJ_SORCERER",MAPID_SORCERER);
	export_constant2("EAJ_MINSTRELWANDERER",MAPID_MINSTRELWANDERER);
	export_constant2("EAJ_SURA",MAPID_SURA);
	export_constant2("EAJ_GENETIC",MAPID_GENETIC);
	export_constant2("EAJ_SHADOW_CHASER",MAPID_SHADOW_CHASER);
	export_constant2("EAJ_SOUL_REAPER",MAPID_SOUL_REAPER);

	export_constant2("EAJ_RUNE_KNIGHT_T",MAPID_RUNE_KNIGHT_T);
	export_constant2("EAJ_WARLOCK_T",MAPID_WARLOCK_T);
	export_constant2("EAJ_RANGER_T",MAPID_RANGER_T);
	export_constant2("EAJ_ARCH_BISHOP_T",MAPID_ARCH_BISHOP_T);
	export_constant2("EAJ_MECHANIC_T",MAPID_MECHANIC_T);
	export_constant2("EAJ_GUILLOTINE_CROSS_T",MAPID_GUILLOTINE_CROSS_T);

	export_constant2("EAJ_ROYAL_GUARD_T",MAPID_ROYAL_GUARD_T);
	export_constant2("EAJ_SORCERER_T",MAPID_SORCERER_T);
	export_constant2("EAJ_MINSTRELWANDERER_T",MAPID_MINSTRELWANDERER_T);
	export_constant2("EAJ_SURA_T",MAPID_SURA_T);
	export_constant2("EAJ_GENETIC_T",MAPID_GENETIC_T);
	export_constant2("EAJ_SHADOW_CHASER_T",MAPID_SHADOW_CHASER_T);

	export_constant2("EAJ_BABY_RUNE_KNIGHT",MAPID_BABY_RUNE_KNIGHT);
	export_constant2("EAJ_BABY_WARLOCK",MAPID_BABY_WARLOCK);
	export_constant2("EAJ_BABY_RANGER",MAPID_BABY_RANGER);
	export_constant2("EAJ_BABY_ARCH_BISHOP",MAPID_BABY_ARCH_BISHOP);
	export_constant2("EAJ_BABY_MECHANIC",MAPID_BABY_MECHANIC);
	export_constant2("EAJ_BABY_GUILLOTINE_CROSS",MAPID_BABY_GUILLOTINE_CROSS);
	export_constant2("EAJ_BABY_STAR_EMPEROR",MAPID_BABY_STAR_EMPEROR);

	export_constant2("EAJ_BABY_ROYAL_GUARD",MAPID_BABY_ROYAL_GUARD);
	export_constant2("EAJ_BABY_SORCERER",MAPID_BABY_SORCERER);
	export_constant2("EAJ_BABY_MINSTRELWANDERER",MAPID_BABY_MINSTRELWANDERER);
	export_constant2("EAJ_BABY_SURA",MAPID_BABY_SURA);
	export_constant2("EAJ_BABY_GENETIC",MAPID_BABY_GENETIC);
	export_constant2("EAJ_BABY_SHADOW_CHASER",MAPID_BABY_SHADOW_CHASER);
	export_constant2("EAJ_BABY_SOUL_REAPER",MAPID_BABY_SOUL_REAPER);

	export_constant2("EAJ_SUPER_NOVICE",MAPID_SUPER_NOVICE);
	export_constant2("EAJ_SUPERNOVICE",MAPID_SUPER_NOVICE);
	export_constant2("EAJ_SUPER_BABY",MAPID_SUPER_BABY);
	export_constant2("EAJ_SUPER_NOVICE_E",MAPID_SUPER_NOVICE_E);
	export_constant2("EAJ_SUPER_BABY_E",MAPID_SUPER_BABY_E);

	export_constant2("EAJ_SUMMONER",MAPID_SUMMONER);
	export_constant2("EAJ_SPIRIT_HANDLER", MAPID_SPIRIT_HANDLER);

	export_constant2("EAJ_HYPER_NOVICE", MAPID_HYPER_NOVICE);
	export_constant2("EAJ_DRAGON_KNIGHT",MAPID_DRAGON_KNIGHT);
	export_constant2("EAJ_ARCH_MAGE",MAPID_ARCH_MAGE);
	export_constant2("EAJ_WINDHAWK",MAPID_WINDHAWK);
	export_constant2("EAJ_CARDINAL",MAPID_CARDINAL);
	export_constant2("EAJ_MEISTER",MAPID_MEISTER);
	export_constant2("EAJ_SHADOW_CROSS",MAPID_SHADOW_CROSS);
	export_constant2("EAJ_SKY_EMPEROR", MAPID_SKY_EMPEROR);
	export_constant2("EAJ_NIGHT_WATCH", MAPID_NIGHT_WATCH);
	export_constant2("EAJ_SHINKIRO_SHIRANUI", MAPID_SHINKIRO_SHIRANUI);

	export_constant2("EAJ_IMPERIAL_GUARD",MAPID_IMPERIAL_GUARD);
	export_constant2("EAJ_ELEMENTAL_MASTER",MAPID_ELEMENTAL_MASTER);
	export_constant2("EAJ_TROUBADOURTROUVERE",MAPID_TROUBADOURTROUVERE);
	export_constant2("EAJ_INQUISITOR",MAPID_INQUISITOR);
	export_constant2("EAJ_BIOLO",MAPID_BIOLO);
	export_constant2("EAJ_ABYSS_CHASER",MAPID_ABYSS_CHASER);
	export_constant2("EAJ_SOUL_ASCETIC", MAPID_SOUL_ASCETIC);

	/* sex */
	export_constant(SEX_FEMALE);
	export_constant(SEX_MALE);
	export_constant(SEX_BOTH);

	/* broadcasts */
	export_constant(BC_ALL);
	export_constant(BC_MAP);
	export_constant(BC_AREA);
	export_constant(BC_SELF);
	export_constant(BC_PC);
	export_constant(BC_NPC);
	export_constant(BC_YELLOW);
	export_constant(BC_BLUE);
	export_constant(BC_WOE);

	/* mapflags */
	export_constant(MF_NOMEMO);
	export_constant(MF_NOTELEPORT);
	export_constant(MF_NOSAVE);
	export_constant(MF_NOBRANCH);
	export_constant(MF_NOPENALTY);
	export_constant(MF_NOZENYPENALTY);
	export_constant(MF_PVP);
	export_constant(MF_PVP_NOPARTY);
	export_constant(MF_PVP_NOGUILD);
	export_constant(MF_GVG);
	export_constant(MF_GVG_NOPARTY);
	export_constant(MF_NOTRADE);
	export_constant(MF_NOSKILL);
	export_constant(MF_NOWARP);
	export_constant(MF_PARTYLOCK);
	export_constant(MF_NOICEWALL);
	export_constant(MF_SNOW);
	export_constant(MF_FOG);
	export_constant(MF_SAKURA);
	export_constant(MF_LEAVES);
	// Intentionally disabled mf_rain because Ind removed it source side
	//export_constant(MF_RAIN);
	export_constant(MF_NOGO);
	export_constant(MF_CLOUDS);
	export_constant(MF_CLOUDS2);
	export_constant(MF_FIREWORKS);
	export_constant(MF_GVG_CASTLE);
	export_constant(MF_GVG_DUNGEON);
	export_constant(MF_NIGHTENABLED);
	export_constant(MF_NOBASEEXP);
	export_constant(MF_NOJOBEXP);
	export_constant(MF_NOMOBLOOT);
	export_constant(MF_NOMVPLOOT);
	export_constant(MF_NORETURN);
	export_constant(MF_NOWARPTO);
	export_constant(MF_PVP_NIGHTMAREDROP);
	export_constant(MF_RESTRICTED);
	export_constant(MF_NOCOMMAND);
	export_constant(MF_NODROP);
	export_constant(MF_JEXP);
	export_constant(MF_BEXP);
	export_constant(MF_NOVENDING);
	export_constant(MF_LOADEVENT);
	export_constant(MF_NOCHAT);
	export_constant(MF_NOEXPPENALTY);
	export_constant(MF_GUILDLOCK);
	export_constant(MF_TOWN);
	export_constant(MF_AUTOTRADE);
	export_constant(MF_ALLOWKS);
	export_constant(MF_MONSTER_NOTELEPORT);
	export_constant(MF_PVP_NOCALCRANK);
	export_constant(MF_BATTLEGROUND);
	export_constant(MF_RESET);
	export_constant(MF_NOMAPCHANNELAUTOJOIN);
	export_constant(MF_NOUSECART);
	export_constant(MF_NOITEMCONSUMPTION);
	export_constant(MF_NOSUNMOONSTARMIRACLE);
	export_constant(MF_FORCEMINEFFECT);
	export_constant(MF_NOLOCKON);
	export_constant(MF_NOTOMB);
	export_constant(MF_SKILL_DAMAGE);
	export_constant(MF_NOCOSTUME);
	export_constant(MF_GVG_TE_CASTLE);
	export_constant(MF_GVG_TE);
	export_constant(MF_HIDEMOBHPBAR);
	export_constant(MF_NOLOOT);
	export_constant(MF_NOEXP);
	export_constant(MF_PRIVATEAIRSHIP_SOURCE);
	export_constant(MF_PRIVATEAIRSHIP_DESTINATION);
	export_constant(MF_SKILL_DURATION);
	export_constant(MF_NOCASHSHOP);
	export_constant(MF_NORODEX);
	export_constant(MF_NORENEWALDROPPENALTY);
	export_constant(MF_NORENEWALEXPPENALTY);
	export_constant(MF_NOPETCAPTURE);
	export_constant(MF_NOBUYINGSTORE);
	export_constant(MF_NODYNAMICNPC);
	export_constant(MF_NOBANK);
	export_constant(MF_SPECIALPOPUP);

	/* setcell types */
	export_constant(CELL_WALKABLE);
	export_constant(CELL_SHOOTABLE);
	export_constant(CELL_WATER);
	export_constant(CELL_NPC);
	export_constant(CELL_BASILICA);
	export_constant(CELL_LANDPROTECTOR);
	export_constant(CELL_NOVENDING);
	export_constant(CELL_NOCHAT);
	export_constant(CELL_MAELSTROM);
	export_constant(CELL_ICEWALL);
	export_constant(CELL_NOBUYINGSTORE);

	/* getcell types */
	export_constant(CELL_CHKWALL);
	export_constant(CELL_CHKWATER);
	export_constant(CELL_CHKCLIFF);
	export_constant(CELL_CHKPASS);
	export_constant(CELL_CHKREACH);
	export_constant(CELL_CHKNOPASS);
	export_constant(CELL_CHKNOREACH);
	// TODO: Check why this was commented until now
	//export_constant(CELL_CHKSTACK);
	export_constant(CELL_CHKNPC);
	export_constant(CELL_CHKBASILICA);
	export_constant(CELL_CHKLANDPROTECTOR);
	export_constant(CELL_CHKNOVENDING);
	export_constant(CELL_CHKNOCHAT);
	export_constant(CELL_CHKMAELSTROM);
	export_constant(CELL_CHKICEWALL);
	export_constant(CELL_CHKNOBUYINGSTORE);

	/* parameters */
	export_parameter("StatusPoint",SP_STATUSPOINT);
	export_parameter("BaseLevel",SP_BASELEVEL);
	export_parameter("SkillPoint",SP_SKILLPOINT);
	export_parameter("TraitPoint",SP_TRAITPOINT);
	export_parameter("Class",SP_CLASS);
	export_parameter("Upper",SP_UPPER);
	export_parameter("Zeny",SP_ZENY);
	export_parameter("Sex",SP_SEX);
	export_parameter("Weight",SP_WEIGHT);
	export_parameter("MaxWeight",SP_MAXWEIGHT);
	export_parameter("JobLevel",SP_JOBLEVEL);
	export_parameter("BaseExp",SP_BASEEXP);
	export_parameter("JobExp",SP_JOBEXP);
	export_parameter("Karma",SP_KARMA);
	export_parameter("Manner",SP_MANNER);
	export_parameter("NextBaseExp",SP_NEXTBASEEXP);
	export_parameter("NextJobExp",SP_NEXTJOBEXP);
	export_parameter("Hp",SP_HP);
	export_parameter("MaxHp",SP_MAXHP);
	export_parameter("Sp",SP_SP);
	export_parameter("MaxSp",SP_MAXSP);
	export_parameter("Ap",SP_AP);
	export_parameter("MaxAp",SP_MAXAP);
	export_parameter("BaseJob",SP_BASEJOB);
	export_parameter("BaseClass",SP_BASECLASS);
	export_parameter("killerrid",SP_KILLERRID);
	export_parameter("killedrid",SP_KILLEDRID);
	export_parameter("killedgid",SP_KILLEDGID);
	export_parameter("Sitting",SP_SITTING);
	export_parameter("CharMoves",SP_CHARMOVE);
	export_parameter("CharRename",SP_CHARRENAME);
	export_parameter("Font",SP_CHARFONT);
	export_parameter("BankVault",SP_BANK_VAULT);
	export_parameter(ROULETTE_BRONZE_VAR,SP_ROULETTE_BRONZE);
	export_parameter(ROULETTE_SILVER_VAR,SP_ROULETTE_SILVER);
	export_parameter(ROULETTE_GOLD_VAR,SP_ROULETTE_GOLD);
	export_parameter(CASHPOINT_VAR, SP_CASHPOINTS);
	export_parameter(KAFRAPOINT_VAR, SP_KAFRAPOINTS);
	export_parameter(PCDIECOUNTER_VAR, SP_PCDIECOUNTER);
	export_parameter(COOKMASTERY_VAR, SP_COOKMASTERY);
	export_parameter(ACHIEVEMENTLEVEL, SP_ACHIEVEMENT_LEVEL);

	export_constant2("bMaxHP",SP_MAXHP);
	export_constant2("bMaxSP",SP_MAXSP);
	export_constant2("bMaxAP",SP_MAXAP);
	export_constant2("bStr",SP_STR);
	export_constant2("bAgi",SP_AGI);
	export_constant2("bVit",SP_VIT);
	export_constant2("bInt",SP_INT);
	export_constant2("bDex",SP_DEX);
	export_constant2("bLuk",SP_LUK);
	export_constant2("bPow",SP_POW);
	export_constant2("bSta",SP_STA);
	export_constant2("bWis",SP_WIS);
	export_constant2("bSpl",SP_SPL);
	export_constant2("bCon",SP_CON);
	export_constant2("bCrt",SP_CRT);
	export_constant2("bAtk",SP_ATK1);
	export_constant2("bAtk2",SP_ATK2);
	export_constant2("bDef",SP_DEF1);
	export_constant2("bDef2",SP_DEF2);
	export_constant2("bMdef",SP_MDEF1);
	export_constant2("bMdef2",SP_MDEF2);
	export_constant2("bHit",SP_HIT);
	export_constant2("bFlee",SP_FLEE1);
	export_constant2("bFlee2",SP_FLEE2);
	export_constant2("bCritical",SP_CRITICAL);
	export_constant2("bAspd",SP_ASPD);
	export_constant2("bFame",SP_FAME);
	export_constant2("bUnbreakable",SP_UNBREAKABLE);

	export_constant2("bPatk",SP_PATK);
	export_constant2("bSmatk",SP_SMATK);
	export_constant2("bHplus",SP_HPLUS);
	export_constant2("bCrate",SP_CRATE);
	export_constant2("bRes",SP_RES);
	export_constant2("bMres",SP_MRES);

	export_constant2("bAtkRange",SP_ATTACKRANGE);
	export_constant2("bAtkEle",SP_ATKELE);
	export_constant2("bDefEle",SP_DEFELE);
	export_constant2("bCastrate",SP_CASTRATE);
	export_constant2("bMaxHPrate",SP_MAXHPRATE);
	export_constant2("bMaxSPrate",SP_MAXSPRATE);
	export_constant2("bMaxAPrate", SP_MAXAPRATE);
	export_constant2("bUseSPrate",SP_SPRATE);
	export_constant2("bAddEle",SP_ADDELE);
	export_constant2("bAddRace",SP_ADDRACE);
	export_constant2("bAddSize",SP_ADDSIZE);
	export_constant2("bSubEle",SP_SUBELE);
	export_constant2("bSubRace",SP_SUBRACE);
	export_constant2("bAddEff",SP_ADDEFF);
	export_constant2("bResEff",SP_RESEFF);
	export_constant2("bBaseAtk",SP_BASE_ATK);
	export_constant2("bAspdRate",SP_ASPD_RATE);
	export_constant2("bHPrecovRate",SP_HP_RECOV_RATE);
	export_constant2("bSPrecovRate",SP_SP_RECOV_RATE);
	export_constant2("bSpeedRate",SP_SPEED_RATE);
	export_constant2("bCriticalDef",SP_CRITICAL_DEF);
	export_constant2("bNearAtkDef",SP_NEAR_ATK_DEF);
	export_constant2("bLongAtkDef",SP_LONG_ATK_DEF);
	export_constant2("bDoubleRate",SP_DOUBLE_RATE);
	export_constant2("bDoubleAddRate",SP_DOUBLE_ADD_RATE);
	export_constant2("bSkillHeal",SP_SKILL_HEAL);
	export_constant2("bMatkRate",SP_MATK_RATE);
	export_constant2("bWeaponMatkRate",SP_WEAPON_MATK_RATE);
	export_constant2("bIgnoreDefEle",SP_IGNORE_DEF_ELE);
	export_constant2("bIgnoreDefRace",SP_IGNORE_DEF_RACE);
	export_constant2("bAtkRate",SP_ATK_RATE);
	export_constant2("bWeaponAtkRate",SP_WEAPON_ATK_RATE);
	export_constant2("bSpeedAddRate",SP_SPEED_ADDRATE);
	export_constant2("bSPRegenRate",SP_SP_REGEN_RATE);
	export_constant2("bMagicAtkDef",SP_MAGIC_ATK_DEF);
	export_constant2("bMiscAtkDef",SP_MISC_ATK_DEF);
	export_constant2("bIgnoreMdefEle",SP_IGNORE_MDEF_ELE);
	export_constant2("bIgnoreMdefRace",SP_IGNORE_MDEF_RACE);
	export_constant2("bMagicAddEle",SP_MAGIC_ADDELE);
	export_constant2("bMagicAddRace",SP_MAGIC_ADDRACE);
	export_constant2("bMagicAddSize",SP_MAGIC_ADDSIZE);
	export_constant2("bPerfectHitRate",SP_PERFECT_HIT_RATE);
	export_constant2("bPerfectHitAddRate",SP_PERFECT_HIT_ADD_RATE);
	export_constant2("bCriticalRate",SP_CRITICAL_RATE);
	export_constant2("bGetZenyNum",SP_GET_ZENY_NUM);
	export_constant2("bAddGetZenyNum",SP_ADD_GET_ZENY_NUM);
	export_constant2("bAddDamageClass",SP_ADD_DAMAGE_CLASS);
	export_constant2("bAddMagicDamageClass",SP_ADD_MAGIC_DAMAGE_CLASS);
	export_constant2("bAddDefMonster",SP_ADD_DEF_MONSTER);
	export_constant2("bAddMdefMonster",SP_ADD_MDEF_MONSTER);
	export_constant2("bAddMonsterDropItem",SP_ADD_MONSTER_DROP_ITEM);
	export_constant2("bDefRatioAtkEle",SP_DEF_RATIO_ATK_ELE);
	export_constant2("bDefRatioAtkRace",SP_DEF_RATIO_ATK_RACE);
	export_constant2("bUnbreakableGarment",SP_UNBREAKABLE_GARMENT);
	export_constant2("bHitRate",SP_HIT_RATE);
	export_constant2("bFleeRate",SP_FLEE_RATE);
	export_constant2("bFlee2Rate",SP_FLEE2_RATE);
	export_constant2("bDefRate",SP_DEF_RATE);
	export_constant2("bDef2Rate",SP_DEF2_RATE);
	export_constant2("bMdefRate",SP_MDEF_RATE);
	export_constant2("bMdef2Rate",SP_MDEF2_RATE);
	export_constant2("bPAtkRate", SP_PATK_RATE);
	export_constant2("bSMatkRate", SP_SMATK_RATE);
	export_constant2("bResRate", SP_RES_RATE);
	export_constant2("bMResRate", SP_MRES_RATE);
	export_constant2("bHPlusRate", SP_HPLUS_RATE);
	export_constant2("bCRateRate", SP_CRATE_RATE);
	export_constant2("bSplashRange",SP_SPLASH_RANGE);
	export_constant2("bSplashAddRange",SP_SPLASH_ADD_RANGE);
	export_constant2("bAutoSpell",SP_AUTOSPELL);
	export_constant2("bHPDrainRate",SP_HP_DRAIN_RATE);
	export_constant2("bSPDrainRate",SP_SP_DRAIN_RATE);
	export_constant2("bShortWeaponDamageReturn",SP_SHORT_WEAPON_DAMAGE_RETURN);
	export_constant2("bLongWeaponDamageReturn",SP_LONG_WEAPON_DAMAGE_RETURN);
	export_constant2("bWeaponComaEle",SP_WEAPON_COMA_ELE);
	export_constant2("bWeaponComaRace",SP_WEAPON_COMA_RACE);
	export_constant2("bAddEff2",SP_ADDEFF2);
	export_constant2("bBreakWeaponRate",SP_BREAK_WEAPON_RATE);
	export_constant2("bBreakArmorRate",SP_BREAK_ARMOR_RATE);
	export_constant2("bAddStealRate",SP_ADD_STEAL_RATE);
	export_constant2("bMagicDamageReturn",SP_MAGIC_DAMAGE_RETURN);
	export_constant2("bAllStats",SP_ALL_STATS);
	export_constant2("bAllTraitStats", SP_ALL_TRAIT_STATS);
	export_constant2("bAgiVit",SP_AGI_VIT);
	export_constant2("bAgiDexStr",SP_AGI_DEX_STR);
	export_constant2("bPerfectHide",SP_PERFECT_HIDE);
	export_constant2("bNoKnockback",SP_NO_KNOCKBACK);
	export_constant2("bClassChange",SP_CLASSCHANGE);
	export_constant2("bHPDrainValue",SP_HP_DRAIN_VALUE);
	export_constant2("bSPDrainValue",SP_SP_DRAIN_VALUE);
	export_constant2("bWeaponAtk",SP_WEAPON_ATK);
	export_constant2("bWeaponDamageRate",SP_WEAPON_DAMAGE_RATE);
	export_constant2("bDelayrate",SP_DELAYRATE);
	export_constant2("bHPDrainValueRace",SP_HP_DRAIN_VALUE_RACE);
	export_constant2("bSPDrainValueRace",SP_SP_DRAIN_VALUE_RACE);
	export_constant2("bIgnoreMdefRaceRate",SP_IGNORE_MDEF_RACE_RATE);
	export_constant2("bIgnoreDefRaceRate",SP_IGNORE_DEF_RACE_RATE);
	export_constant2("bSkillHeal2",SP_SKILL_HEAL2);
	export_constant2("bAddEffOnSkill",SP_ADDEFF_ONSKILL);
	export_constant2("bHealPower",SP_ADD_HEAL_RATE);
	export_constant2("bHealPower2",SP_ADD_HEAL2_RATE);
	export_constant2("bIgnoreResRaceRate",SP_SP_IGNORE_RES_RACE_RATE);
	export_constant2("bIgnoreMResRaceRate",SP_SP_IGNORE_MRES_RACE_RATE);

	export_constant2("bRestartFullRecover",SP_RESTART_FULL_RECOVER);
	export_constant2("bNoCastCancel",SP_NO_CASTCANCEL);
	export_constant2("bNoSizeFix",SP_NO_SIZEFIX);
	export_constant2("bNoMagicDamage",SP_NO_MAGIC_DAMAGE);
	export_constant2("bNoWeaponDamage",SP_NO_WEAPON_DAMAGE);
	export_constant2("bNoGemStone",SP_NO_GEMSTONE);
	export_constant2("bNoCastCancel2",SP_NO_CASTCANCEL2);
	export_constant2("bNoMiscDamage",SP_NO_MISC_DAMAGE);
	export_constant2("bUnbreakableWeapon",SP_UNBREAKABLE_WEAPON);
	export_constant2("bUnbreakableArmor",SP_UNBREAKABLE_ARMOR);
	export_constant2("bUnbreakableHelm",SP_UNBREAKABLE_HELM);
	export_constant2("bUnbreakableShield",SP_UNBREAKABLE_SHIELD);
	export_constant2("bShortAtkRate",SP_SHORT_ATK_RATE);
	export_constant2("bLongAtkRate",SP_LONG_ATK_RATE);
	export_constant2("bCritAtkRate",SP_CRIT_ATK_RATE);
	export_constant2("bCriticalAddRace",SP_CRITICAL_ADDRACE);
	export_constant2("bNoRegen",SP_NO_REGEN);
	export_constant2("bAddEffWhenHit",SP_ADDEFF_WHENHIT);
	export_constant2("bAutoSpellWhenHit",SP_AUTOSPELL_WHENHIT);
	export_constant2("bSkillAtk",SP_SKILL_ATK);
	export_constant2("bUnstripable",SP_UNSTRIPABLE);
	export_constant2("bAutoSpellOnSkill",SP_AUTOSPELL_ONSKILL);
	export_constant2("bSPGainValue",SP_SP_GAIN_VALUE);
	export_constant2("bHPRegenRate",SP_HP_REGEN_RATE);
	export_constant2("bHPLossRate",SP_HP_LOSS_RATE);
	export_constant2("bAddRace2",SP_ADDRACE2);
	export_constant2("bHPGainValue",SP_HP_GAIN_VALUE);
	export_constant2("bSubSize",SP_SUBSIZE);
	export_constant2("bHPDrainValueClass",SP_HP_DRAIN_VALUE_CLASS);
	export_constant2("bAddItemHealRate",SP_ADD_ITEM_HEAL_RATE);
	export_constant2("bSPDrainValueClass",SP_SP_DRAIN_VALUE_CLASS);
	export_constant2("bExpAddRace",SP_EXP_ADDRACE);
	export_constant2("bSPGainRace",SP_SP_GAIN_RACE);
	export_constant2("bSubRace2",SP_SUBRACE2);
	export_constant2("bUnbreakableShoes",SP_UNBREAKABLE_SHOES);
	export_constant2("bUnstripableWeapon",SP_UNSTRIPABLE_WEAPON);
	export_constant2("bUnstripableArmor",SP_UNSTRIPABLE_ARMOR);
	export_constant2("bUnstripableHelm",SP_UNSTRIPABLE_HELM);
	export_constant2("bUnstripableShield",SP_UNSTRIPABLE_SHIELD);
	export_constant2("bIntravision",SP_INTRAVISION);
	export_constant2("bAddMonsterDropItemGroup",SP_ADD_MONSTER_DROP_ITEMGROUP);
	export_constant2("bSPLossRate",SP_SP_LOSS_RATE);
	export_constant2("bAddSkillBlow",SP_ADD_SKILL_BLOW);
	export_constant2("bSPVanishRate",SP_SP_VANISH_RATE);
	export_constant2("bMagicSPGainValue",SP_MAGIC_SP_GAIN_VALUE);
	export_constant2("bMagicHPGainValue",SP_MAGIC_HP_GAIN_VALUE);
	export_constant2("bAddMonsterIdDropItem",SP_ADD_MONSTER_ID_DROP_ITEM);
	export_constant2("bMatk",SP_EMATK);
	export_constant2("bComaClass",SP_COMA_CLASS);
	export_constant2("bComaRace",SP_COMA_RACE);
	export_constant2("bSkillUseSPrate",SP_SKILL_USE_SP_RATE);
	export_constant2("bSkillCooldown",SP_SKILL_COOLDOWN);
	export_constant2("bSkillFixedCast",SP_SKILL_FIXEDCAST);
	export_constant2("bSkillVariableCast",SP_SKILL_VARIABLECAST);
	export_constant2("bFixedCastrate",SP_FIXCASTRATE);
	export_constant2("bVariableCastrate",SP_VARCASTRATE);
	export_constant2("bSkillUseSP",SP_SKILL_USE_SP);
	export_constant2("bMagicAtkEle",SP_MAGIC_ATK_ELE);
	export_constant2("bFixedCast",SP_ADD_FIXEDCAST);
	export_constant2("bVariableCast",SP_ADD_VARIABLECAST);
	export_constant2("bSetDefRace",SP_SET_DEF_RACE);
	export_constant2("bSetMDefRace",SP_SET_MDEF_RACE);
	export_constant2("bHPVanishRate",SP_HP_VANISH_RATE);
	export_constant2("bIgnoreDefClass",SP_IGNORE_DEF_CLASS);
	export_constant2("bDefRatioAtkClass",SP_DEF_RATIO_ATK_CLASS);
	export_constant2("bAddClass",SP_ADDCLASS);
	export_constant2("bSubClass",SP_SUBCLASS);
	export_constant2("bMagicAddClass",SP_MAGIC_ADDCLASS);
	export_constant2("bWeaponComaClass",SP_WEAPON_COMA_CLASS);
	export_constant2("bIgnoreMdefClassRate",SP_IGNORE_MDEF_CLASS_RATE);
	export_constant2("bExpAddClass",SP_EXP_ADDCLASS);
	export_constant2("bAddClassDropItem",SP_ADD_CLASS_DROP_ITEM);
	export_constant2("bAddClassDropItemGroup",SP_ADD_CLASS_DROP_ITEMGROUP);
	export_constant2("bAddMaxWeight",SP_ADDMAXWEIGHT);
	export_constant2("bAddItemGroupHealRate",SP_ADD_ITEMGROUP_HEAL_RATE);
	export_constant2("bHPVanishRaceRate",SP_HP_VANISH_RACE_RATE);
	export_constant2("bSPVanishRaceRate",SP_SP_VANISH_RACE_RATE);
	export_constant2("bAbsorbDmgMaxHP",SP_ABSORB_DMG_MAXHP);
	export_constant2("bSubSkill",SP_SUB_SKILL);
	export_constant2("bSubDefEle",SP_SUBDEF_ELE);
	export_constant2("bStateNoRecoverRace",SP_STATE_NORECOVER_RACE);
	export_constant2("bCriticalLong",SP_CRITICAL_RANGEATK);
	export_constant2("bMagicAddRace2", SP_MAGIC_ADDRACE2);
	export_constant2("bIgnoreMdefRace2Rate", SP_IGNORE_MDEF_RACE2_RATE);
	export_constant2("bDropAddRace", SP_DROP_ADDRACE);
	export_constant2("bDropAddClass", SP_DROP_ADDCLASS);
	export_constant2("bNoMadoFuel", SP_NO_MADO_FUEL);
	export_constant2("bIgnoreDefClassRate", SP_IGNORE_DEF_CLASS_RATE);
	export_constant2("bRegenPercentHP", SP_REGEN_PERCENT_HP);
	export_constant2("bRegenPercentSP", SP_REGEN_PERCENT_SP);
	export_constant2("bSkillDelay",SP_SKILL_DELAY);
	export_constant2("bNoWalkDelay",SP_NO_WALK_DELAY);
	export_constant2("bLongSPGainValue",SP_LONG_SP_GAIN_VALUE);
	export_constant2("bLongHPGainValue",SP_LONG_HP_GAIN_VALUE);
	export_constant2("bMagicSubSize",SP_MAGIC_SUBSIZE);
	export_constant2("bCritDefRate",SP_CRIT_DEF_RATE);
	export_constant2("bMagicSubDefEle", SP_MAGIC_SUBDEF_ELE);
	export_constant2("bReduceDamageReturn",SP_REDUCE_DAMAGE_RETURN);
	export_constant2("bAbsorbDmgMaxHP2", SP_ABSORB_DMG_MAXHP2);
	export_constant2("bAddItemSPHealRate", SP_ADD_ITEM_SPHEAL_RATE);
	export_constant2("bAddItemGroupSPHealRate", SP_ADD_ITEMGROUP_SPHEAL_RATE);
	export_constant2("bWeaponSubSize", SP_WEAPON_SUBSIZE);

	/* equip indices */
	export_constant(EQI_COMPOUND_ON);
	export_constant(EQI_HEAD_TOP);
	export_constant(EQI_ARMOR);
	export_constant(EQI_HAND_L);
	export_constant(EQI_HAND_R);
	export_constant(EQI_GARMENT);
	export_constant(EQI_SHOES);
	export_constant(EQI_ACC_L);
	export_constant(EQI_ACC_R);
	export_constant(EQI_HEAD_MID);
	export_constant(EQI_HEAD_LOW);
	export_constant(EQI_COSTUME_HEAD_LOW);
	export_constant(EQI_COSTUME_HEAD_MID);
	export_constant(EQI_COSTUME_HEAD_TOP);
	export_constant(EQI_COSTUME_GARMENT);
	export_constant(EQI_AMMO);
	export_constant(EQI_SHADOW_ARMOR );
	export_constant(EQI_SHADOW_WEAPON);
	export_constant(EQI_SHADOW_SHIELD);
	export_constant(EQI_SHADOW_SHOES);
	export_constant(EQI_SHADOW_ACC_R);
	export_constant(EQI_SHADOW_ACC_L);
	export_constant(EQI_MAX);

	/* equip positions */
	export_constant(EQP_ACC_L);
	export_constant(EQP_ACC_R);
	export_constant(EQP_SHOES);
	export_constant(EQP_GARMENT);
	export_constant(EQP_HEAD_LOW);
	export_constant(EQP_HEAD_MID);
	export_constant(EQP_HEAD_TOP);
	export_constant(EQP_ARMOR);
	export_constant(EQP_HAND_L);
	export_constant(EQP_HAND_R);
	export_constant(EQP_COSTUME_HEAD_TOP);
	export_constant(EQP_COSTUME_HEAD_MID);
	export_constant(EQP_COSTUME_HEAD_LOW);
	export_constant(EQP_COSTUME_GARMENT);
	export_constant(EQP_AMMO);
	export_constant(EQP_SHADOW_ARMOR);
	export_constant(EQP_SHADOW_WEAPON);
	export_constant(EQP_SHADOW_SHIELD);
	export_constant(EQP_SHADOW_SHOES);
	export_constant(EQP_SHADOW_ACC_R);
	export_constant(EQP_SHADOW_ACC_L);
	export_constant(EQP_ACC_RL);
	export_constant(EQP_SHADOW_ACC_RL);

	export_constant2("EQP_Both_Hand", EQP_ARMS);
	export_constant2("EQP_Right_Hand", EQP_HAND_R);
	export_constant2("EQP_Left_Hand", EQP_HAND_L);
	export_constant2("EQP_Right_Accessory", EQP_ACC_R);
	export_constant2("EQP_Left_Accessory", EQP_ACC_L);
	export_constant2("EQP_Both_Accessory", EQP_ACC_RL);
	export_constant2("EQP_Shadow_Right_Accessory", EQP_SHADOW_ACC_R);
	export_constant2("EQP_Shadow_Left_Accessory", EQP_SHADOW_ACC_L);

	/* looks */
	export_constant(LOOK_BASE);
	export_constant(LOOK_HAIR);
	export_constant(LOOK_WEAPON);
	export_constant(LOOK_HEAD_BOTTOM);
	export_constant(LOOK_HEAD_TOP);
	export_constant(LOOK_HEAD_MID);
	export_constant(LOOK_HAIR_COLOR);
	export_constant(LOOK_CLOTHES_COLOR);
	export_constant(LOOK_SHIELD);
	export_constant(LOOK_SHOES);
	export_constant(LOOK_BODY);
	export_constant(LOOK_RESET_COSTUMES);
	export_constant(LOOK_ROBE);
	export_constant(LOOK_BODY2);
	// TODO: check why we didnt have floor and enable it
	//export_constant(LOOK_FLOOR);

	// For backwards compatability - might be removed in the near future
	export_constant2("VAR_HEAD",LOOK_HAIR);
	export_constant2("VAR_WEAPON",LOOK_WEAPON);
	export_constant2("VAR_HEAD_TOP",LOOK_HEAD_TOP); // This one was actually pointing to LOOK_HEAD_BOTTOM until now, so we might be safe to remove them anyway(since we got no bug report until today)
	export_constant2("VAR_HEAD_MID",LOOK_HEAD_MID); // This one was actually pointing to LOOK_HEAD_TOP until now, so we might be safe to remove them anyway(since we got no bug report until today)
	export_constant2("VAR_HEAD_BOTTOM",LOOK_HEAD_BOTTOM);  // This one was actually pointing to LOOK_HEAD_MID until now, so we might be safe to remove them anyway(since we got no bug report until today)
	export_constant2("VAR_HEADPALETTE",LOOK_HAIR_COLOR);
	export_constant2("VAR_BODYPALETTE",LOOK_CLOTHES_COLOR);
	export_constant2("VAR_SHIELD",LOOK_SHIELD);
	export_constant2("VAR_SHOES",LOOK_SHOES);

	/* status changes */
	export_constant2("Eff_Stone",SC_STONEWAIT);
	export_constant2("Eff_Freeze",SC_FREEZE);
	export_constant2("Eff_Stun",SC_STUN);
	export_constant2("Eff_Sleep",SC_SLEEP);
	export_constant2("Eff_Poison",SC_POISON);
	export_constant2("Eff_Curse",SC_CURSE);
	export_constant2("Eff_Silence",SC_SILENCE);
	export_constant2("Eff_Confusion",SC_CONFUSION);
	export_constant2("Eff_Blind",SC_BLIND);
	export_constant2("Eff_Bleeding",SC_BLEEDING);
	export_constant2("Eff_DPoison",SC_DPOISON);
	export_constant2("Eff_Fear",SC_FEAR);
	export_constant2("Eff_Burning",SC_BURNING);
	export_constant2("Eff_Crystalize",SC_CRYSTALIZE);
	export_constant2("Eff_Freezing",SC_FREEZING);
	export_constant2("Eff_Heat",SC_BURNT);
	export_constant2("Eff_Deepsleep",SC_DEEPSLEEP);
	export_constant2("Eff_WhiteImprison",SC_WHITEIMPRISON);
	export_constant2("Eff_Hallucination",SC_HALLUCINATION);

	export_constant2("SC_ALL",SC_NONE);

	export_constant(SC_NONE);
	export_constant(SC_STONE);
	export_constant(SC_FREEZE);
	export_constant(SC_STUN);
	export_constant(SC_SLEEP);
	export_constant(SC_POISON);
	export_constant(SC_CURSE);
	export_constant(SC_SILENCE);
	export_constant(SC_CONFUSION);
	export_constant(SC_BLIND);
	export_constant(SC_BLEEDING);
	export_constant(SC_DPOISON);
	export_constant(SC_STONEWAIT);
	export_constant(SC_PROVOKE);
	export_constant(SC_ENDURE);
	export_constant(SC_TWOHANDQUICKEN);
	export_constant(SC_CONCENTRATE);
	export_constant(SC_HIDING);
	export_constant(SC_CLOAKING);
	export_constant(SC_ENCPOISON);
	export_constant(SC_POISONREACT);
	export_constant(SC_QUAGMIRE);
	export_constant(SC_ANGELUS);
	export_constant(SC_BLESSING);
	export_constant(SC_SIGNUMCRUCIS);
	export_constant(SC_INCREASEAGI);
	export_constant(SC_DECREASEAGI);
	export_constant(SC_SLOWPOISON);
	export_constant(SC_IMPOSITIO);
	export_constant(SC_SUFFRAGIUM);
	export_constant(SC_ASPERSIO);
	export_constant(SC_BENEDICTIO);
	export_constant(SC_KYRIE);
	export_constant(SC_MAGNIFICAT);
	export_constant(SC_GLORIA);
	export_constant(SC_AETERNA);
	export_constant(SC_ADRENALINE);
	export_constant(SC_WEAPONPERFECTION);
	export_constant(SC_OVERTHRUST);
	export_constant(SC_MAXIMIZEPOWER);
	export_constant(SC_TRICKDEAD);
	export_constant(SC_LOUD);
	export_constant(SC_ENERGYCOAT);
	export_constant(SC_BROKENARMOR);
	export_constant(SC_BROKENWEAPON);
	export_constant(SC_HALLUCINATION);
	export_constant(SC_WEIGHT50);
	export_constant(SC_WEIGHT90);
	export_constant(SC_ASPDPOTION0);
	export_constant(SC_ASPDPOTION1);
	export_constant(SC_ASPDPOTION2);
	export_constant(SC_ASPDPOTION3);
	export_constant(SC_SPEEDUP0);
	export_constant(SC_SPEEDUP1);
	export_constant(SC_ATKPOTION);
	export_constant(SC_MATKPOTION);
	export_constant(SC_WEDDING);
	export_constant(SC_SLOWDOWN);
	export_constant(SC_ANKLE);
	export_constant(SC_KEEPING);
	export_constant(SC_BARRIER);
	export_constant(SC_STRIPWEAPON);
	export_constant(SC_STRIPSHIELD);
	export_constant(SC_STRIPARMOR);
	export_constant(SC_STRIPHELM);
	export_constant(SC_CP_WEAPON);
	export_constant(SC_CP_SHIELD);
	export_constant(SC_CP_ARMOR);
	export_constant(SC_CP_HELM);
	export_constant(SC_AUTOGUARD);
	export_constant(SC_REFLECTSHIELD);
	export_constant(SC_SPLASHER);
	export_constant(SC_PROVIDENCE);
	export_constant(SC_DEFENDER);
	export_constant(SC_MAGICROD);
	export_constant(SC_SPELLBREAKER);
	export_constant(SC_AUTOSPELL);
	export_constant(SC_SIGHTTRASHER);
	export_constant(SC_AUTOBERSERK);
	export_constant(SC_SPEARQUICKEN);
	export_constant(SC_AUTOCOUNTER);
	export_constant(SC_SIGHT);
	export_constant(SC_SAFETYWALL);
	export_constant(SC_RUWACH);
	export_constant(SC_EXTREMITYFIST);
	export_constant(SC_EXPLOSIONSPIRITS);
	export_constant(SC_COMBO);
	export_constant(SC_BLADESTOP_WAIT);
	export_constant(SC_BLADESTOP);
	export_constant(SC_FIREWEAPON);
	export_constant(SC_WATERWEAPON);
	export_constant(SC_WINDWEAPON);
	export_constant(SC_EARTHWEAPON);
	export_constant(SC_VOLCANO);
	export_constant(SC_DELUGE);
	export_constant(SC_VIOLENTGALE);
	export_constant(SC_WATK_ELEMENT);
	export_constant(SC_ARMOR);
	export_constant(SC_ARMOR_ELEMENT_WATER);
	export_constant(SC_NOCHAT);
	export_constant(SC_PROTECTEXP);
	export_constant(SC_AURABLADE);
	export_constant(SC_PARRYING);
	export_constant(SC_CONCENTRATION);
	export_constant(SC_TENSIONRELAX);
	export_constant(SC_BERSERK);
	export_constant(SC_FURY);
	export_constant(SC_GOSPEL);
	export_constant(SC_ASSUMPTIO);
	export_constant(SC_BASILICA);
	export_constant(SC_GUILDAURA);
	export_constant(SC_MAGICPOWER);
	export_constant(SC_EDP);
	export_constant(SC_TRUESIGHT);
	export_constant(SC_WINDWALK);
	export_constant(SC_MELTDOWN);
	export_constant(SC_CARTBOOST);
	export_constant(SC_CHASEWALK);
	export_constant(SC_REJECTSWORD);
	export_constant(SC_MARIONETTE);
	export_constant(SC_MARIONETTE2);
	export_constant(SC_CHANGEUNDEAD);
	export_constant(SC_JOINTBEAT);
	export_constant(SC_MINDBREAKER);
	export_constant(SC_MEMORIZE);
	export_constant(SC_FOGWALL);
	export_constant(SC_SPIDERWEB);
	export_constant(SC_DEVOTION);
	export_constant(SC_SACRIFICE);
	export_constant(SC_STEELBODY);
	export_constant(SC_ORCISH);
	export_constant(SC_READYSTORM);
	export_constant(SC_READYDOWN);
	export_constant(SC_READYTURN);
	export_constant(SC_READYCOUNTER);
	export_constant(SC_DODGE);
	export_constant(SC_RUN);
	export_constant(SC_SHADOWWEAPON);
	export_constant(SC_ADRENALINE2);
	export_constant(SC_GHOSTWEAPON);
	export_constant(SC_KAIZEL);
	export_constant(SC_KAAHI);
	export_constant(SC_KAUPE);
	export_constant(SC_ONEHAND);
	export_constant(SC_PRESERVE);
	export_constant(SC_BATTLEORDERS);
	export_constant(SC_REGENERATION);
	export_constant(SC_DOUBLECAST);
	export_constant(SC_GRAVITATION);
	export_constant(SC_MAXOVERTHRUST);
	export_constant(SC_LONGING);
	export_constant(SC_HERMODE);
	export_constant(SC_SHRINK);
	export_constant(SC_SIGHTBLASTER);
	export_constant(SC_WINKCHARM);
	export_constant(SC_CLOSECONFINE);
	export_constant(SC_CLOSECONFINE2);
	export_constant(SC_DANCING);
	export_constant(SC_ELEMENTALCHANGE);
	export_constant(SC_RICHMANKIM);
	export_constant(SC_ETERNALCHAOS);
	export_constant(SC_DRUMBATTLE);
	export_constant(SC_NIBELUNGEN);
	export_constant(SC_ROKISWEIL);
	export_constant(SC_INTOABYSS);
	export_constant(SC_SIEGFRIED);
	export_constant(SC_WHISTLE);
	export_constant(SC_ASSNCROS);
	export_constant(SC_POEMBRAGI);
	export_constant(SC_APPLEIDUN);
	export_constant(SC_MODECHANGE);
	export_constant(SC_HUMMING);
	export_constant(SC_DONTFORGETME);
	export_constant(SC_FORTUNE);
	export_constant(SC_SERVICE4U);
	export_constant(SC_STOP);
	export_constant(SC_SPURT);
	export_constant(SC_SPIRIT);
	export_constant(SC_COMA);
	export_constant(SC_INTRAVISION);
	export_constant(SC_INCALLSTATUS);
	export_constant(SC_INCSTR);
	export_constant(SC_INCAGI);
	export_constant(SC_INCVIT);
	export_constant(SC_INCINT);
	export_constant(SC_INCDEX);
	export_constant(SC_INCLUK);
	export_constant(SC_INCHIT);
	export_constant(SC_INCHITRATE);
	export_constant(SC_INCFLEE);
	export_constant(SC_INCFLEERATE);
	export_constant(SC_INCMHPRATE);
	export_constant(SC_INCMSPRATE);
	export_constant(SC_INCATKRATE);
	export_constant(SC_INCMATKRATE);
	export_constant(SC_INCDEFRATE);
	export_constant(SC_STRFOOD);
	export_constant(SC_AGIFOOD);
	export_constant(SC_VITFOOD);
	export_constant(SC_INTFOOD);
	export_constant(SC_DEXFOOD);
	export_constant(SC_LUKFOOD);
	export_constant(SC_HITFOOD);
	export_constant(SC_FLEEFOOD);
	export_constant(SC_BATKFOOD);
	export_constant(SC_WATKFOOD);
	export_constant(SC_MATKFOOD);
	export_constant(SC_SCRESIST);
	export_constant(SC_XMAS);
	export_constant(SC_WARM);
	export_constant(SC_SUN_COMFORT);
	export_constant(SC_MOON_COMFORT);
	export_constant(SC_STAR_COMFORT);
	export_constant(SC_FUSION);
	export_constant(SC_SKILLRATE_UP);
	export_constant(SC_SKE);
	export_constant(SC_KAITE);
	export_constant(SC_SWOO);
	export_constant(SC_SKA);
	export_constant(SC_EARTHSCROLL);
	export_constant(SC_MIRACLE);
	export_constant(SC_MADNESSCANCEL);
	export_constant(SC_ADJUSTMENT);
	export_constant(SC_INCREASING);
	export_constant(SC_GATLINGFEVER);
	export_constant(SC_TATAMIGAESHI);
	export_constant(SC_UTSUSEMI);
	export_constant(SC_BUNSINJYUTSU);
	export_constant(SC_KAENSIN);
	export_constant(SC_SUITON);
	export_constant(SC_NEN);
	export_constant(SC_KNOWLEDGE);
	export_constant(SC_SMA);
	export_constant(SC_FLING);
	export_constant(SC_AVOID);
	export_constant(SC_CHANGE);
	export_constant(SC_BLOODLUST);
	export_constant(SC_FLEET);
	export_constant(SC_SPEED);
	export_constant(SC_DEFENCE);
	export_constant(SC_INCASPDRATE);
	export_constant(SC_INCFLEE2);
	export_constant(SC_JAILED);
	export_constant(SC_ENCHANTARMS);
	export_constant(SC_MAGICALATTACK);
	export_constant(SC_ARMORCHANGE);
	export_constant(SC_CRITICALWOUND);
	export_constant(SC_MAGICMIRROR);
	export_constant(SC_SLOWCAST);
	export_constant(SC_SUMMER);
	export_constant(SC_EXPBOOST);
	export_constant(SC_ITEMBOOST);
	export_constant(SC_BOSSMAPINFO);
	export_constant(SC_LIFEINSURANCE);
	export_constant(SC_INCCRI);
	//export_constant(SC_INCDEF);
	//export_constant(SC_INCBASEATK);
	//export_constant(SC_FASTCAST);
	export_constant(SC_MDEF_RATE);
	//export_constant(SC_HPREGEN);
	export_constant(SC_INCHEALRATE);
	export_constant(SC_PNEUMA);
	export_constant(SC_AUTOTRADE);
	export_constant(SC_KSPROTECTED);
	export_constant(SC_ARMOR_RESIST);
	export_constant(SC_SPCOST_RATE);
	export_constant(SC_COMMONSC_RESIST);
	export_constant(SC_SEVENWIND);
	export_constant(SC_DEF_RATE);
	//export_constant(SC_SPREGEN);
	export_constant(SC_WALKSPEED);
	export_constant(SC_MERC_FLEEUP);
	export_constant(SC_MERC_ATKUP);
	export_constant(SC_MERC_HPUP);
	export_constant(SC_MERC_SPUP);
	export_constant(SC_MERC_HITUP);
	export_constant(SC_MERC_QUICKEN);
	export_constant(SC_REBIRTH);
	//export_constant(SC_SKILLCASTRATE);
	//export_constant(SC_DEFRATIOATK);
	//export_constant(SC_HPDRAIN);
	//export_constant(SC_SKILLATKBONUS);
	export_constant(SC_ITEMSCRIPT);
	export_constant(SC_S_LIFEPOTION);
	export_constant(SC_L_LIFEPOTION);
	export_constant(SC_JEXPBOOST);
	//export_constant(SC_IGNOREDEF);
	export_constant(SC_HELLPOWER);
	export_constant(SC_INVINCIBLE);
	//export_constant(SC_INVINCIBLEOFF);
	export_constant(SC_MANU_ATK);
	export_constant(SC_MANU_DEF);
	export_constant(SC_SPL_ATK);
	export_constant(SC_SPL_DEF);
	export_constant(SC_MANU_MATK);
	export_constant(SC_SPL_MATK);
	export_constant(SC_FOOD_STR_CASH);
	export_constant(SC_FOOD_AGI_CASH);
	export_constant(SC_FOOD_VIT_CASH);
	export_constant(SC_FOOD_DEX_CASH);
	export_constant(SC_FOOD_INT_CASH);
	export_constant(SC_FOOD_LUK_CASH);
	export_constant(SC_FEAR);
	export_constant(SC_BURNING);
	export_constant(SC_FREEZING);
	export_constant(SC_ENCHANTBLADE);
	export_constant(SC_DEATHBOUND);
	export_constant(SC_MILLENNIUMSHIELD);
	export_constant(SC_CRUSHSTRIKE);
	export_constant(SC_REFRESH);
	export_constant(SC_REUSE_REFRESH);
	export_constant(SC_GIANTGROWTH);
	export_constant(SC_STONEHARDSKIN);
	export_constant(SC_VITALITYACTIVATION);
	export_constant(SC_STORMBLAST);
	export_constant(SC_FIGHTINGSPIRIT);
	export_constant(SC_ABUNDANCE);
	export_constant(SC_ADORAMUS);
	export_constant(SC_EPICLESIS);
	export_constant(SC_ORATIO);
	export_constant(SC_LAUDAAGNUS);
	export_constant(SC_LAUDARAMUS);
	export_constant(SC_RENOVATIO);
	export_constant(SC_EXPIATIO);
	export_constant(SC_DUPLELIGHT);
	export_constant(SC_SECRAMENT);
	export_constant(SC_WHITEIMPRISON);
	export_constant(SC_MARSHOFABYSS);
	export_constant(SC_RECOGNIZEDSPELL);
	export_constant(SC_STASIS);
	export_constant(SC_SPHERE_1);
	export_constant(SC_SPHERE_2);
	export_constant(SC_SPHERE_3);
	export_constant(SC_SPHERE_4);
	export_constant(SC_SPHERE_5);
	export_constant(SC_READING_SB);
	export_constant(SC_FREEZE_SP);
	export_constant(SC_FEARBREEZE);
	export_constant(SC_ELECTRICSHOCKER);
	export_constant(SC_WUGDASH);
	export_constant(SC_BITE);
	export_constant(SC_CAMOUFLAGE);
	export_constant(SC_ACCELERATION);
	export_constant(SC_HOVERING);
	export_constant(SC_SHAPESHIFT);
	export_constant(SC_INFRAREDSCAN);
	export_constant(SC_ANALYZE);
	export_constant(SC_MAGNETICFIELD);
	export_constant(SC_NEUTRALBARRIER);
	export_constant(SC_NEUTRALBARRIER_MASTER);
	export_constant(SC_STEALTHFIELD);
	export_constant(SC_STEALTHFIELD_MASTER);
	export_constant(SC_OVERHEAT);
	export_constant(SC_OVERHEAT_LIMITPOINT);
	export_constant(SC_VENOMIMPRESS);
	export_constant(SC_POISONINGWEAPON);
	export_constant(SC_WEAPONBLOCKING);
	export_constant(SC_CLOAKINGEXCEED);
	export_constant(SC_HALLUCINATIONWALK);
	export_constant(SC_HALLUCINATIONWALK_POSTDELAY);
	export_constant(SC_ROLLINGCUTTER);
	export_constant(SC_TOXIN);
	export_constant(SC_PARALYSE);
	export_constant(SC_VENOMBLEED);
	export_constant(SC_MAGICMUSHROOM);
	export_constant(SC_DEATHHURT);
	export_constant(SC_PYREXIA);
	export_constant(SC_OBLIVIONCURSE);
	export_constant(SC_LEECHESEND);
	export_constant(SC_REFLECTDAMAGE);
	export_constant(SC_FORCEOFVANGUARD);
	export_constant(SC_SHIELDSPELL_HP);
	export_constant(SC_SHIELDSPELL_SP);
	export_constant(SC_SHIELDSPELL_ATK);
	export_constant(SC_EXEEDBREAK);
	export_constant(SC_PRESTIGE);
	export_constant(SC_BANDING);
	export_constant(SC_BANDING_DEFENCE);
	export_constant(SC_EARTHDRIVE);
	export_constant(SC_INSPIRATION);
	export_constant(SC_SPELLFIST);
	export_constant(SC_CRYSTALIZE);
	export_constant(SC_STRIKING);
	export_constant(SC_WARMER);
	export_constant(SC_VACUUM_EXTREME);
	export_constant(SC_PROPERTYWALK);
	export_constant(SC_SWINGDANCE);
	export_constant(SC_SYMPHONYOFLOVER);
	export_constant(SC_MOONLITSERENADE);
	export_constant(SC_RUSHWINDMILL);
	export_constant(SC_ECHOSONG);
	export_constant(SC_HARMONIZE);
	export_constant(SC_VOICEOFSIREN);
	export_constant(SC_DEEPSLEEP);
	export_constant(SC_SIRCLEOFNATURE);
	export_constant(SC_GLOOMYDAY);
	export_constant(SC_GLOOMYDAY_SK);
	export_constant(SC_SONGOFMANA);
	export_constant(SC_DANCEWITHWUG);
	export_constant(SC_SATURDAYNIGHTFEVER);
	export_constant(SC_LERADSDEW);
	export_constant(SC_MELODYOFSINK);
	export_constant(SC_BEYONDOFWARCRY);
	export_constant(SC_UNLIMITEDHUMMINGVOICE);
	export_constant(SC_SITDOWN_FORCE);
	export_constant(SC_NETHERWORLD);
	export_constant(SC_CRESCENTELBOW);
	export_constant(SC_CURSEDCIRCLE_ATKER);
	export_constant(SC_CURSEDCIRCLE_TARGET);
	export_constant(SC_LIGHTNINGWALK);
	export_constant(SC_RAISINGDRAGON);
	export_constant(SC_GT_ENERGYGAIN);
	export_constant(SC_GT_CHANGE);
	export_constant(SC_GT_REVITALIZE);
	export_constant(SC_GN_CARTBOOST);
	export_constant(SC_THORNSTRAP);
	export_constant(SC_BLOODSUCKER);
	export_constant(SC_SMOKEPOWDER);
	export_constant(SC_TEARGAS);
	export_constant(SC_MANDRAGORA);
	export_constant(SC_STOMACHACHE);
	export_constant(SC_MYSTERIOUS_POWDER);
	export_constant(SC_MELON_BOMB);
	export_constant(SC_BANANA_BOMB);
	export_constant(SC_BANANA_BOMB_SITDOWN);
	export_constant(SC_SAVAGE_STEAK);
	export_constant(SC_COCKTAIL_WARG_BLOOD);
	export_constant(SC_MINOR_BBQ);
	export_constant(SC_SIROMA_ICE_TEA);
	export_constant(SC_DROCERA_HERB_STEAMED);
	export_constant(SC_PUTTI_TAILS_NOODLES);
	export_constant(SC_BOOST500);
	export_constant(SC_FULL_SWING_K);
	export_constant(SC_MANA_PLUS);
	export_constant(SC_MUSTLE_M);
	export_constant(SC_LIFE_FORCE_F);
	export_constant(SC_EXTRACT_WHITE_POTION_Z);
	export_constant(SC_VITATA_500);
	export_constant(SC_EXTRACT_SALAMINE_JUICE);
	export_constant(SC__REPRODUCE);
	export_constant(SC__AUTOSHADOWSPELL);
	export_constant(SC__SHADOWFORM);
	export_constant(SC__BODYPAINT);
	export_constant(SC__INVISIBILITY);
	export_constant(SC__DEADLYINFECT);
	export_constant(SC__ENERVATION);
	export_constant(SC__GROOMY);
	export_constant(SC__IGNORANCE);
	export_constant(SC__LAZINESS);
	export_constant(SC__UNLUCKY);
	export_constant(SC__WEAKNESS);
	export_constant(SC__STRIPACCESSORY);
	export_constant(SC__MANHOLE);
	export_constant(SC__BLOODYLUST);
	export_constant(SC_CIRCLE_OF_FIRE);
	export_constant(SC_CIRCLE_OF_FIRE_OPTION);
	export_constant(SC_FIRE_CLOAK);
	export_constant(SC_FIRE_CLOAK_OPTION);
	export_constant(SC_WATER_SCREEN);
	export_constant(SC_WATER_SCREEN_OPTION);
	export_constant(SC_WATER_DROP);
	export_constant(SC_WATER_DROP_OPTION);
	export_constant(SC_WATER_BARRIER);
	export_constant(SC_WIND_STEP);
	export_constant(SC_WIND_STEP_OPTION);
	export_constant(SC_WIND_CURTAIN);
	export_constant(SC_WIND_CURTAIN_OPTION);
	export_constant(SC_ZEPHYR);
	export_constant(SC_SOLID_SKIN);
	export_constant(SC_SOLID_SKIN_OPTION);
	export_constant(SC_STONE_SHIELD);
	export_constant(SC_STONE_SHIELD_OPTION);
	export_constant(SC_POWER_OF_GAIA);
	export_constant(SC_PYROTECHNIC);
	export_constant(SC_PYROTECHNIC_OPTION);
	export_constant(SC_HEATER);
	export_constant(SC_HEATER_OPTION);
	export_constant(SC_TROPIC);
	export_constant(SC_TROPIC_OPTION);
	export_constant(SC_AQUAPLAY);
	export_constant(SC_AQUAPLAY_OPTION);
	export_constant(SC_COOLER);
	export_constant(SC_COOLER_OPTION);
	export_constant(SC_CHILLY_AIR);
	export_constant(SC_CHILLY_AIR_OPTION);
	export_constant(SC_GUST);
	export_constant(SC_GUST_OPTION);
	export_constant(SC_BLAST);
	export_constant(SC_BLAST_OPTION);
	export_constant(SC_WILD_STORM);
	export_constant(SC_WILD_STORM_OPTION);
	export_constant(SC_PETROLOGY);
	export_constant(SC_PETROLOGY_OPTION);
	export_constant(SC_CURSED_SOIL);
	export_constant(SC_CURSED_SOIL_OPTION);
	export_constant(SC_UPHEAVAL);
	export_constant(SC_UPHEAVAL_OPTION);
	export_constant(SC_TIDAL_WEAPON);
	export_constant(SC_TIDAL_WEAPON_OPTION);
	export_constant(SC_ROCK_CRUSHER);
	export_constant(SC_ROCK_CRUSHER_ATK);
	export_constant(SC_LEADERSHIP);
	export_constant(SC_GLORYWOUNDS);
	export_constant(SC_SOULCOLD);
	export_constant(SC_HAWKEYES);
	export_constant(SC_ODINS_POWER);
	export_constant(SC_RAID);
	export_constant(SC_FIRE_INSIGNIA);
	export_constant(SC_WATER_INSIGNIA);
	export_constant(SC_WIND_INSIGNIA);
	export_constant(SC_EARTH_INSIGNIA);
	export_constant(SC_PUSH_CART);
	export_constant(SC_SPELLBOOK1);
	export_constant(SC_SPELLBOOK2);
	export_constant(SC_SPELLBOOK3);
	export_constant(SC_SPELLBOOK4);
	export_constant(SC_SPELLBOOK5);
	export_constant(SC_SPELLBOOK6);
	export_constant(SC_MAXSPELLBOOK);
	export_constant(SC_INCMHP);
	export_constant(SC_INCMSP);
	export_constant(SC_PARTYFLEE);
	export_constant(SC_MEIKYOUSISUI);
	export_constant(SC_JYUMONJIKIRI);
	export_constant(SC_KYOUGAKU);
	export_constant(SC_IZAYOI);
	export_constant(SC_ZENKAI);
	export_constant(SC_KAGEHUMI);
	export_constant(SC_KYOMU);
	export_constant(SC_KAGEMUSYA);
	export_constant(SC_ZANGETSU);
	export_constant(SC_GENSOU);
	export_constant(SC_AKAITSUKI);
	export_constant(SC_STYLE_CHANGE);
	export_constant(SC_TINDER_BREAKER);
	export_constant(SC_TINDER_BREAKER2);
	export_constant(SC_CBC);
	export_constant(SC_EQC);
	export_constant(SC_GOLDENE_FERSE);
	export_constant(SC_ANGRIFFS_MODUS);
	export_constant(SC_OVERED_BOOST);
	export_constant(SC_LIGHT_OF_REGENE);
	export_constant(SC_ASH);
	export_constant(SC_GRANITIC_ARMOR);
	export_constant(SC_MAGMA_FLOW);
	export_constant(SC_PYROCLASTIC);
	export_constant(SC_PARALYSIS);
	export_constant(SC_PAIN_KILLER);
	export_constant(SC_HANBOK);
	export_constant(SC_DEFSET);
	export_constant(SC_MDEFSET);
	export_constant(SC_DARKCROW);
	export_constant(SC_FULL_THROTTLE);
	export_constant(SC_REBOUND);
	export_constant(SC_UNLIMIT);
	export_constant(SC_KINGS_GRACE);
	export_constant(SC_TELEKINESIS_INTENSE);
	export_constant(SC_OFFERTORIUM);
	export_constant(SC_FRIGG_SONG);
	export_constant(SC_MONSTER_TRANSFORM);
	export_constant(SC_ANGEL_PROTECT);
	export_constant(SC_ILLUSIONDOPING);
	export_constant(SC_FLASHCOMBO);
	export_constant(SC_MOONSTAR);
	export_constant(SC_SUPER_STAR);
	export_constant(SC_HEAT_BARREL);
	export_constant(SC_MAGICALBULLET);
	export_constant(SC_P_ALTER);
	export_constant(SC_E_CHAIN);
	export_constant(SC_C_MARKER);
	export_constant(SC_ANTI_M_BLAST);
	export_constant(SC_B_TRAP);
	export_constant(SC_H_MINE);
	export_constant(SC_QD_SHOT_READY);
	export_constant(SC_MTF_ASPD);
	export_constant(SC_MTF_RANGEATK);
	export_constant(SC_MTF_MATK);
	export_constant(SC_MTF_MLEATKED);
	export_constant(SC_MTF_CRIDAMAGE);
	export_constant(SC_OKTOBERFEST);
	export_constant(SC_STRANGELIGHTS);
	export_constant(SC_DECORATION_OF_MUSIC);
	export_constant(SC_QUEST_BUFF1);
	export_constant(SC_QUEST_BUFF2);
	export_constant(SC_QUEST_BUFF3);
	export_constant(SC_ALL_RIDING);
	export_constant(SC_TEARGAS_SOB);
	export_constant(SC__FEINTBOMB);
	export_constant(SC__CHAOS);
	export_constant(SC_CHASEWALK2);
	export_constant(SC_VACUUM_EXTREME_POSTDELAY);
	export_constant(SC_MTF_ASPD2);
	export_constant(SC_MTF_RANGEATK2);
	export_constant(SC_MTF_MATK2);
	export_constant(SC_2011RWC_SCROLL);
	export_constant(SC_JP_EVENT04);
	export_constant(SC_MTF_MHP);
	export_constant(SC_MTF_MSP);
	export_constant(SC_MTF_PUMPKIN);
	export_constant(SC_MTF_HITFLEE);
	export_constant(SC_CRIFOOD);
	export_constant(SC_ATTHASTE_CASH);
	export_constant(SC_REUSE_LIMIT_A);
	export_constant(SC_REUSE_LIMIT_B);
	export_constant(SC_REUSE_LIMIT_C);
	export_constant(SC_REUSE_LIMIT_D);
	export_constant(SC_REUSE_LIMIT_E);
	export_constant(SC_REUSE_LIMIT_F);
	export_constant(SC_REUSE_LIMIT_G);
	export_constant(SC_REUSE_LIMIT_H);
	export_constant(SC_REUSE_LIMIT_MTF);
	export_constant(SC_REUSE_LIMIT_ASPD_POTION);
	export_constant(SC_REUSE_MILLENNIUMSHIELD);
	export_constant(SC_REUSE_CRUSHSTRIKE);
	export_constant(SC_REUSE_STORMBLAST);
	export_constant(SC_ALL_RIDING_REUSE_LIMIT);
	export_constant(SC_REUSE_LIMIT_ECL);
	export_constant(SC_REUSE_LIMIT_RECALL);
	export_constant(SC_PROMOTE_HEALTH_RESERCH);
	export_constant(SC_ENERGY_DRINK_RESERCH);
	export_constant(SC_NORECOVER_STATE);
	export_constant(SC_SUHIDE);
	export_constant(SC_SU_STOOP);
	export_constant(SC_SPRITEMABLE);
	export_constant(SC_CATNIPPOWDER);
	export_constant(SC_SV_ROOTTWIST);
	export_constant(SC_BITESCAR);
	export_constant(SC_ARCLOUSEDASH);
	export_constant(SC_TUNAPARTY);
	export_constant(SC_SHRIMP);
	export_constant(SC_FRESHSHRIMP);
	export_constant(SC_ACTIVE_MONSTER_TRANSFORM);
	export_constant(SC_LJOSALFAR);
	export_constant(SC_MERMAID_LONGING);
	export_constant(SC_HAT_EFFECT);
	export_constant(SC_FLOWERSMOKE);
	export_constant(SC_FSTONE);
	export_constant(SC_HAPPINESS_STAR);
	export_constant(SC_MAPLE_FALLS);
	export_constant(SC_TIME_ACCESSORY);
	export_constant(SC_MAGICAL_FEATHER);
	export_constant(SC_GVG_GIANT);
	export_constant(SC_GVG_GOLEM);
	export_constant(SC_GVG_STUN);
	export_constant(SC_GVG_STONE);
	export_constant(SC_GVG_FREEZ);
	export_constant(SC_GVG_SLEEP);
	export_constant(SC_GVG_CURSE);
	export_constant(SC_GVG_SILENCE);
	export_constant(SC_GVG_BLIND);
	export_constant(SC_CLAN_INFO);
	export_constant(SC_SWORDCLAN);
	export_constant(SC_ARCWANDCLAN);
	export_constant(SC_GOLDENMACECLAN);
	export_constant(SC_CROSSBOWCLAN);
	export_constant(SC_JUMPINGCLAN);
	export_constant(SC_TAROTCARD);
	export_constant(SC_GEFFEN_MAGIC1);
	export_constant(SC_GEFFEN_MAGIC2);
	export_constant(SC_GEFFEN_MAGIC3);
	export_constant(SC_MAXPAIN);
	export_constant(SC_ARMOR_ELEMENT_EARTH);
	export_constant(SC_ARMOR_ELEMENT_FIRE);
	export_constant(SC_ARMOR_ELEMENT_WIND);
	export_constant(SC_DAILYSENDMAILCNT);
	export_constant(SC_DORAM_BUF_01);
	export_constant(SC_DORAM_BUF_02);
	export_constant(SC_HISS);
	export_constant(SC_NYANGGRASS);
	export_constant(SC_GROOMING);
	export_constant(SC_SHRIMPBLESSING);
	export_constant(SC_CHATTERING);
	export_constant(SC_DORAM_WALKSPEED);
	export_constant(SC_DORAM_MATK);
	export_constant(SC_DORAM_FLEE2);
	export_constant(SC_DORAM_SVSP);
	export_constant(SC_FALLEN_ANGEL);
	export_constant(SC_CHEERUP);
	export_constant(SC_DRESSUP);
	export_constant(SC_GLASTHEIM_ATK);
	export_constant(SC_GLASTHEIM_DEF);
	export_constant(SC_GLASTHEIM_HEAL);
	export_constant(SC_GLASTHEIM_HIDDEN);
	export_constant(SC_GLASTHEIM_STATE);
	export_constant(SC_GLASTHEIM_ITEMDEF);
	export_constant(SC_GLASTHEIM_HPSP);
	export_constant(SC_LHZ_DUN_N1);
	export_constant(SC_LHZ_DUN_N2);
	export_constant(SC_LHZ_DUN_N3);
	export_constant(SC_LHZ_DUN_N4);
	export_constant(SC_ANCILLA);
	export_constant(SC_EARTHSHAKER);
	export_constant(SC_WEAPONBLOCK_ON);
	export_constant(SC_SPORE_EXPLOSION);
	export_constant(SC_ENTRY_QUEUE_APPLY_DELAY);
	export_constant(SC_ENTRY_QUEUE_NOTIFY_ADMISSION_TIME_OUT);
	export_constant(SC_ADAPTATION);
	export_constant(SC_BASILICA_CELL);
	export_constant(SC_LIGHTOFMOON);
	export_constant(SC_LIGHTOFSUN);
	export_constant(SC_LIGHTOFSTAR);
	export_constant(SC_LUNARSTANCE);
	export_constant(SC_UNIVERSESTANCE);
	export_constant(SC_SUNSTANCE);
	export_constant(SC_FLASHKICK);
	export_constant(SC_NEWMOON);
	export_constant(SC_STARSTANCE);
	export_constant(SC_DIMENSION);
	export_constant(SC_DIMENSION1);
	export_constant(SC_DIMENSION2);
	export_constant(SC_CREATINGSTAR);
	export_constant(SC_FALLINGSTAR);
	export_constant(SC_NOVAEXPLOSING);
	export_constant(SC_GRAVITYCONTROL);
	export_constant(SC_SOULCOLLECT);
	export_constant(SC_SOULREAPER);
	export_constant(SC_SOULUNITY);
	export_constant(SC_SOULSHADOW);
	export_constant(SC_SOULFAIRY);
	export_constant(SC_SOULFALCON);
	export_constant(SC_SOULGOLEM);
	export_constant(SC_SOULDIVISION);
	export_constant(SC_SOULENERGY);
	export_constant(SC_USE_SKILL_SP_SPA);
	export_constant(SC_USE_SKILL_SP_SHA);
	export_constant(SC_SP_SHA);
	export_constant(SC_SOULCURSE);
	export_constant(SC_HELLS_PLANT);
	export_constant(SC_INCREASE_MAXHP);
	export_constant(SC_INCREASE_MAXSP);
	export_constant(SC_HELPANGEL);
	export_constant(SC_REF_T_POTION);
	export_constant(SC_ADD_ATK_DAMAGE);
	export_constant(SC_ADD_MATK_DAMAGE);
	export_constant(SC_SOUNDOFDESTRUCTION);
	export_constant(SC_LUXANIMA);
	export_constant(SC_REUSE_LIMIT_LUXANIMA);
	export_constant(SC_ENSEMBLEFATIGUE);
	export_constant(SC_MISTY_FROST);
	export_constant(SC_MAGIC_POISON);
	export_constant(SC_EP16_2_BUFF_SS);
	export_constant(SC_EP16_2_BUFF_SC);
	export_constant(SC_EP16_2_BUFF_AC);
	export_constant(SC_EMERGENCY_MOVE);
	export_constant(SC_MADOGEAR);
	export_constant(SC_NPC_HALLUCINATIONWALK);
	export_constant(SC_OVERBRANDREADY);
	export_constant(SC_POISON_MIST);
	export_constant(SC_STONE_WALL);
	export_constant(SC_CLOUD_POISON);
	export_constant(SC_HOMUN_TIME);
	export_constant(SC_PACKING_ENVELOPE1);
	export_constant(SC_PACKING_ENVELOPE2);
	export_constant(SC_PACKING_ENVELOPE3);
	export_constant(SC_PACKING_ENVELOPE4);
	export_constant(SC_PACKING_ENVELOPE5);
	export_constant(SC_PACKING_ENVELOPE6);
	export_constant(SC_PACKING_ENVELOPE7);
	export_constant(SC_PACKING_ENVELOPE8);
	export_constant(SC_PACKING_ENVELOPE9);
	export_constant(SC_PACKING_ENVELOPE10);
	export_constant(SC_SOULATTACK);
	export_constant(SC_WIDEWEB);
	export_constant(SC_BURNT);
	export_constant(SC_CHILL);
	export_constant(SC_HANDICAPSTATE_DEEPBLIND);
	export_constant(SC_HANDICAPSTATE_DEEPSILENCE);
	export_constant(SC_HANDICAPSTATE_LASSITUDE);
	export_constant(SC_HANDICAPSTATE_FROSTBITE);
	export_constant(SC_HANDICAPSTATE_SWOONING);
	export_constant(SC_HANDICAPSTATE_LIGHTNINGSTRIKE);
	export_constant(SC_HANDICAPSTATE_CRYSTALLIZATION);
	export_constant(SC_HANDICAPSTATE_CONFLAGRATION);
	export_constant(SC_HANDICAPSTATE_MISFORTUNE);
	export_constant(SC_HANDICAPSTATE_DEADLYPOISON);
	export_constant(SC_HANDICAPSTATE_DEPRESSION);
	export_constant(SC_HANDICAPSTATE_HOLYFLAME);
	export_constant(SC_SERVANTWEAPON);
	export_constant(SC_SERVANT_SIGN);
	export_constant(SC_CHARGINGPIERCE);
	export_constant(SC_CHARGINGPIERCE_COUNT);
	export_constant(SC_DRAGONIC_AURA);
	export_constant(SC_VIGOR);
	export_constant(SC_DEADLY_DEFEASANCE);
	export_constant(SC_CLIMAX_DES_HU);
	export_constant(SC_CLIMAX);
	export_constant(SC_CLIMAX_EARTH);
	export_constant(SC_CLIMAX_BLOOM);
	export_constant(SC_CLIMAX_CRYIMP);
	export_constant(SC_WINDSIGN);
	export_constant(SC_CRESCIVEBOLT);
	export_constant(SC_CALAMITYGALE);
	export_constant(SC_MEDIALE);
	export_constant(SC_A_VITA);
	export_constant(SC_A_TELUM);
	export_constant(SC_PRE_ACIES);
	export_constant(SC_COMPETENTIA);
	export_constant(SC_RELIGIO);
	export_constant(SC_BENEDICTUM);
	export_constant(SC_AXE_STOMP);
	export_constant(SC_A_MACHINE);
	export_constant(SC_D_MACHINE);
	export_constant(SC_ABR_BATTLE_WARIOR);
	export_constant(SC_ABR_DUAL_CANNON);
	export_constant(SC_ABR_MOTHER_NET);
	export_constant(SC_ABR_INFINITY);
	export_constant(SC_SHADOW_EXCEED);
	export_constant(SC_DANCING_KNIFE);
	export_constant(SC_POTENT_VENOM);
	export_constant(SC_SHADOW_SCAR);
	export_constant(SC_E_SLASH_COUNT);
	export_constant(SC_SHADOW_WEAPON);
	export_constant(SC_GUARD_STANCE);
	export_constant(SC_ATTACK_STANCE);
	export_constant(SC_GUARDIAN_S);
	export_constant(SC_REBOUND_S);
	export_constant(SC_HOLY_S);
	export_constant(SC_ULTIMATE_S);
	export_constant(SC_SPEAR_SCAR);
	export_constant(SC_SHIELD_POWER);
	export_constant(SC_SPELL_ENCHANTING);
	export_constant(SC_SUMMON_ELEMENTAL_ARDOR);
	export_constant(SC_SUMMON_ELEMENTAL_DILUVIO);
	export_constant(SC_SUMMON_ELEMENTAL_PROCELLA);
	export_constant(SC_SUMMON_ELEMENTAL_TERREMOTUS);
	export_constant(SC_SUMMON_ELEMENTAL_SERPENS);
	export_constant(SC_ELEMENTAL_VEIL);
	export_constant(SC_MYSTIC_SYMPHONY);
	export_constant(SC_KVASIR_SONATA);
	export_constant(SC_SOUNDBLEND);
	export_constant(SC_GEF_NOCTURN);
	export_constant(SC_AIN_RHAPSODY);
	export_constant(SC_MUSICAL_INTERLUDE);
	export_constant(SC_JAWAII_SERENADE);
	export_constant(SC_PRON_MARCH);
	export_constant(SC_ROSEBLOSSOM);
	export_constant(SC_POWERFUL_FAITH);
	export_constant(SC_SINCERE_FAITH);
	export_constant(SC_FIRM_FAITH);
	export_constant(SC_HOLY_OIL);
	export_constant(SC_FIRST_BRAND);
	export_constant(SC_SECOND_BRAND);
	export_constant(SC_SECOND_JUDGE);
	export_constant(SC_THIRD_EXOR_FLAME);
	export_constant(SC_FIRST_FAITH_POWER);
	export_constant(SC_MASSIVE_F_BLASTER);
	export_constant(SC_PROTECTSHADOWEQUIP);
	export_constant(SC_RESEARCHREPORT);
	export_constant(SC_BO_HELL_DUSTY);
	export_constant(SC_BIONIC_WOODENWARRIOR);
	export_constant(SC_BIONIC_WOODEN_FAIRY);
	export_constant(SC_BIONIC_CREEPER);
	export_constant(SC_BIONIC_HELLTREE);
	export_constant(SC_SHADOW_STRIP);
	export_constant(SC_ABYSS_DAGGER);
	export_constant(SC_ABYSSFORCEWEAPON);
	export_constant(SC_ABYSS_SLAYER);
	export_constant(SC_FLAMETECHNIC);
	export_constant(SC_FLAMETECHNIC_OPTION);
	export_constant(SC_FLAMEARMOR);
	export_constant(SC_FLAMEARMOR_OPTION);
	export_constant(SC_COLD_FORCE);
	export_constant(SC_COLD_FORCE_OPTION);
	export_constant(SC_CRYSTAL_ARMOR);
	export_constant(SC_CRYSTAL_ARMOR_OPTION);
	export_constant(SC_GRACE_BREEZE);
	export_constant(SC_GRACE_BREEZE_OPTION);
	export_constant(SC_EYES_OF_STORM);
	export_constant(SC_EYES_OF_STORM_OPTION);
	export_constant(SC_EARTH_CARE);
	export_constant(SC_EARTH_CARE_OPTION);
	export_constant(SC_STRONG_PROTECTION);
	export_constant(SC_STRONG_PROTECTION_OPTION);
	export_constant(SC_DEEP_POISONING);
	export_constant(SC_DEEP_POISONING_OPTION);
	export_constant(SC_POISON_SHIELD);
	export_constant(SC_POISON_SHIELD_OPTION);
	export_constant(SC_SUB_WEAPONPROPERTY);
	export_constant(SC_M_LIFEPOTION);
	export_constant(SC_S_MANAPOTION);
	export_constant(SC_ALMIGHTY);
	export_constant(SC_ULTIMATECOOK);
	export_constant(SC_M_DEFSCROLL);
	export_constant(SC_INFINITY_DRINK);
	export_constant(SC_MENTAL_POTION);
	export_constant(SC_LIMIT_POWER_BOOSTER);
	export_constant(SC_COMBAT_PILL);
	export_constant(SC_COMBAT_PILL2);
	export_constant(SC_MYSTICPOWDER);
	export_constant(SC_SPARKCANDY);
	export_constant(SC_MAGICCANDY);
	export_constant(SC_ACARAJE);
	export_constant(SC_POPECOOKIE);
	export_constant(SC_VITALIZE_POTION);
	export_constant(SC_CUP_OF_BOZA);
	export_constant(SC_SKF_MATK);
	export_constant(SC_SKF_ATK);
	export_constant(SC_SKF_ASPD);
	export_constant(SC_SKF_CAST);
	export_constant(SC_BEEF_RIB_STEW);
	export_constant(SC_PORK_RIB_STEW);
	export_constant(SC_WEAPONBREAKER);
	export_constant(SC_TOXIN_OF_MANDARA);
	export_constant(SC_GOLDENE_TONE);
	export_constant(SC_TEMPERING);
	export_constant(SC_GRADUAL_GRAVITY);
	export_constant(SC_ALL_STAT_DOWN);
	export_constant(SC_KILLING_AURA);
	export_constant(SC_DAMAGE_HEAL);
	export_constant(SC_IMMUNE_PROPERTY_NOTHING);
	export_constant(SC_IMMUNE_PROPERTY_WATER);
	export_constant(SC_IMMUNE_PROPERTY_GROUND);
	export_constant(SC_IMMUNE_PROPERTY_FIRE);
	export_constant(SC_IMMUNE_PROPERTY_WIND);
	export_constant(SC_IMMUNE_PROPERTY_POISON);
	export_constant(SC_IMMUNE_PROPERTY_SAINT);
	export_constant(SC_IMMUNE_PROPERTY_DARKNESS);
	export_constant(SC_IMMUNE_PROPERTY_TELEKINESIS);
	export_constant(SC_IMMUNE_PROPERTY_UNDEAD);
	export_constant(SC_RELIEVE_ON);
	export_constant(SC_RELIEVE_OFF);
	export_constant(SC_RUSH_QUAKE1);
	export_constant(SC_RUSH_QUAKE2);
	export_constant(SC_G_LIFEPOTION);
	export_constant(SC_HNNOWEAPON);
	export_constant(SC_SHIELDCHAINRUSH);
	export_constant(SC_MISTYFROST);
	export_constant(SC_GROUNDGRAVITY);
	export_constant(SC_BREAKINGLIMIT);
	export_constant(SC_RULEBREAK);
	export_constant(SC_INTENSIVE_AIM);
	export_constant(SC_INTENSIVE_AIM_COUNT);
	export_constant(SC_GRENADE_FRAGMENT_1);
	export_constant(SC_GRENADE_FRAGMENT_2);
	export_constant(SC_GRENADE_FRAGMENT_3);
	export_constant(SC_GRENADE_FRAGMENT_4);
	export_constant(SC_GRENADE_FRAGMENT_5);
	export_constant(SC_GRENADE_FRAGMENT_6);
	export_constant(SC_AUTO_FIRING_LAUNCHER);
	export_constant(SC_HIDDEN_CARD);
	export_constant(SC_PERIOD_RECEIVEITEM_2ND);
	export_constant(SC_PERIOD_PLUSEXP_2ND);
	export_constant(SC_POWERUP);
	export_constant(SC_AGIUP);
	export_constant(SC_PROTECTION);
	export_constant(SC_BATH_FOAM_A);
	export_constant(SC_BATH_FOAM_B);
	export_constant(SC_BATH_FOAM_C);
	export_constant(SC_BUCHEDENOEL);
	export_constant(SC_EP16_DEF);
	export_constant(SC_STR_SCROLL);
	export_constant(SC_INT_SCROLL);
	export_constant(SC_CONTENTS_1);
	export_constant(SC_CONTENTS_2);
	export_constant(SC_CONTENTS_3);
	export_constant(SC_CONTENTS_4);
	export_constant(SC_CONTENTS_5);
	export_constant(SC_CONTENTS_6);
	export_constant(SC_CONTENTS_7);
	export_constant(SC_CONTENTS_8);
	export_constant(SC_CONTENTS_9);
	export_constant(SC_CONTENTS_10);
	export_constant(SC_MYSTERY_POWDER);

/// Do not modify code below this, until the end of the API hook, since it will be automatically generated again
/// @APIHOOK_START(EFST_CONST)
	export_constant(EFST_BLANK);
	export_constant(EFST_PROVOKE);
	export_constant(EFST_ENDURE);
	export_constant(EFST_TWOHANDQUICKEN);
	export_constant(EFST_CONCENTRATION);
	export_constant(EFST_HIDING);
	export_constant(EFST_CLOAKING);
	export_constant(EFST_ENCHANTPOISON);
	export_constant(EFST_POISONREACT);
	export_constant(EFST_QUAGMIRE);
	export_constant(EFST_ANGELUS);
	export_constant(EFST_BLESSING);
	export_constant(EFST_CRUCIS);
	export_constant(EFST_INC_AGI);
	export_constant(EFST_DEC_AGI);
	export_constant(EFST_SLOWPOISON);
	export_constant(EFST_IMPOSITIO);
	export_constant(EFST_SUFFRAGIUM);
	export_constant(EFST_ASPERSIO);
	export_constant(EFST_BENEDICTIO);
	export_constant(EFST_KYRIE);
	export_constant(EFST_MAGNIFICAT);
	export_constant(EFST_GLORIA);
	export_constant(EFST_LEXAETERNA);
	export_constant(EFST_ADRENALINE);
	export_constant(EFST_WEAPONPERFECT);
	export_constant(EFST_OVERTHRUST);
	export_constant(EFST_MAXIMIZE);
	export_constant(EFST_RIDING);
	export_constant(EFST_FALCON);
	export_constant(EFST_TRICKDEAD);
	export_constant(EFST_SHOUT);
	export_constant(EFST_ENERGYCOAT);
	export_constant(EFST_BROKENARMOR);
	export_constant(EFST_BROKENWEAPON);
	export_constant(EFST_ILLUSION);
	export_constant(EFST_WEIGHTOVER50);
	export_constant(EFST_WEIGHTOVER90);
	export_constant(EFST_ATTHASTE_POTION1);
	export_constant(EFST_ATTHASTE_POTION2);
	export_constant(EFST_ATTHASTE_POTION3);
	export_constant(EFST_ATTHASTE_INFINITY);
	export_constant(EFST_MOVHASTE_POTION);
	export_constant(EFST_MOVHASTE_INFINITY);
	export_constant(EFST_AUTOCOUNTER);
	export_constant(EFST_SPLASHER);
	export_constant(EFST_ANKLESNARE);
	export_constant(EFST_POSTDELAY);
	export_constant(EFST_NOACTION);
	export_constant(EFST_IMPOSSIBLEPICKUP);
	export_constant(EFST_BARRIER);
	export_constant(EFST_NOEQUIPWEAPON);
	export_constant(EFST_NOEQUIPSHIELD);
	export_constant(EFST_NOEQUIPARMOR);
	export_constant(EFST_NOEQUIPHELM);
	export_constant(EFST_PROTECTWEAPON);
	export_constant(EFST_PROTECTSHIELD);
	export_constant(EFST_PROTECTARMOR);
	export_constant(EFST_PROTECTHELM);
	export_constant(EFST_AUTOGUARD);
	export_constant(EFST_REFLECTSHIELD);
	export_constant(EFST_DEVOTION);
	export_constant(EFST_PROVIDENCE);
	export_constant(EFST_DEFENDER);
	export_constant(EFST_MAGICROD);
	export_constant(EFST_WEAPONPROPERTY);
	export_constant(EFST_AUTOSPELL);
	export_constant(EFST_SPECIALZONE);
	export_constant(EFST_MASK);
	export_constant(EFST_SPEARQUICKEN);
	export_constant(EFST_BDPLAYING);
	export_constant(EFST_WHISTLE);
	export_constant(EFST_ASSASSINCROSS);
	export_constant(EFST_POEMBRAGI);
	export_constant(EFST_APPLEIDUN);
	export_constant(EFST_HUMMING);
	export_constant(EFST_DONTFORGETME);
	export_constant(EFST_FORTUNEKISS);
	export_constant(EFST_SERVICEFORYOU);
	export_constant(EFST_RICHMANKIM);
	export_constant(EFST_ETERNALCHAOS);
	export_constant(EFST_DRUMBATTLEFIELD);
	export_constant(EFST_RINGNIBELUNGEN);
	export_constant(EFST_ROKISWEIL);
	export_constant(EFST_INTOABYSS);
	export_constant(EFST_SIEGFRIED);
	export_constant(EFST_BLADESTOP);
	export_constant(EFST_EXPLOSIONSPIRITS);
	export_constant(EFST_STEELBODY);
	export_constant(EFST_EXTREMITYFIST);
	export_constant(EFST_COMBOATTACK);
	export_constant(EFST_PROPERTYFIRE);
	export_constant(EFST_PROPERTYWATER);
	export_constant(EFST_PROPERTYWIND);
	export_constant(EFST_PROPERTYGROUND);
	export_constant(EFST_MAGICATTACK);
	export_constant(EFST_STOP);
	export_constant(EFST_WEAPONBRAKER);
	export_constant(EFST_PROPERTYUNDEAD);
	export_constant(EFST_POWERUP);
	export_constant(EFST_AGIUP);
	export_constant(EFST_SIEGEMODE);
	export_constant(EFST_INVISIBLE);
	export_constant(EFST_STATUSONE);
	export_constant(EFST_AURABLADE);
	export_constant(EFST_PARRYING);
	export_constant(EFST_LKCONCENTRATION);
	export_constant(EFST_TENSIONRELAX);
	export_constant(EFST_BERSERK);
	export_constant(EFST_SACRIFICE);
	export_constant(EFST_GOSPEL);
	export_constant(EFST_ASSUMPTIO);
	export_constant(EFST_BASILICA);
	export_constant(EFST_GROUNDMAGIC);
	export_constant(EFST_MAGICPOWER);
	export_constant(EFST_EDP);
	export_constant(EFST_TRUESIGHT);
	export_constant(EFST_WINDWALK);
	export_constant(EFST_MELTDOWN);
	export_constant(EFST_CARTBOOST);
	export_constant(EFST_CHASEWALK);
	export_constant(EFST_SWORDREJECT);
	export_constant(EFST_MARIONETTE_MASTER);
	export_constant(EFST_MARIONETTE);
	export_constant(EFST_MOON);
	export_constant(EFST_BLOODING);
	export_constant(EFST_JOINTBEAT);
	export_constant(EFST_MINDBREAKER);
	export_constant(EFST_MEMORIZE);
	export_constant(EFST_FOGWALL);
	export_constant(EFST_SPIDERWEB);
	export_constant(EFST_PROTECTEXP);
	export_constant(EFST_SUB_WEAPONPROPERTY);
	export_constant(EFST_AUTOBERSERK);
	export_constant(EFST_RUN);
	export_constant(EFST_TING);
	export_constant(EFST_STORMKICK_ON);
	export_constant(EFST_STORMKICK_READY);
	export_constant(EFST_DOWNKICK_ON);
	export_constant(EFST_DOWNKICK_READY);
	export_constant(EFST_TURNKICK_ON);
	export_constant(EFST_TURNKICK_READY);
	export_constant(EFST_COUNTER_ON);
	export_constant(EFST_COUNTER_READY);
	export_constant(EFST_DODGE_ON);
	export_constant(EFST_DODGE_READY);
	export_constant(EFST_STRUP);
	export_constant(EFST_PROPERTYDARK);
	export_constant(EFST_ADRENALINE2);
	export_constant(EFST_PROPERTYTELEKINESIS);
	export_constant(EFST_SOULLINK);
	export_constant(EFST_PLUSATTACKPOWER);
	export_constant(EFST_PLUSMAGICPOWER);
	export_constant(EFST_DEVIL1);
	export_constant(EFST_KAITE);
	export_constant(EFST_SWOO);
	export_constant(EFST_STAR2);
	export_constant(EFST_KAIZEL);
	export_constant(EFST_KAAHI);
	export_constant(EFST_KAUPE);
	export_constant(EFST_SMA_READY);
	export_constant(EFST_SKE);
	export_constant(EFST_ONEHANDQUICKEN);
	export_constant(EFST_FRIEND);
	export_constant(EFST_FRIENDUP);
	export_constant(EFST_SG_WARM);
	export_constant(EFST_SG_SUN_WARM);
	export_constant(EFST_SG_MOON_WARM);
	export_constant(EFST_SG_STAR_WARM);
	export_constant(EFST_EMOTION);
	export_constant(EFST_SUN_COMFORT);
	export_constant(EFST_MOON_COMFORT);
	export_constant(EFST_STAR_COMFORT);
	export_constant(EFST_EXPUP);
	export_constant(EFST_GDSKILL_BATTLEORDER);
	export_constant(EFST_GDSKILL_REGENERATION);
	export_constant(EFST_GDSKILL_POSTDELAY);
	export_constant(EFST_RESISTHANDICAP);
	export_constant(EFST_MAXHPPERCENT);
	export_constant(EFST_MAXSPPERCENT);
	export_constant(EFST_DEFENCE);
	export_constant(EFST_SLOWDOWN);
	export_constant(EFST_PRESERVE);
	export_constant(EFST_CHASEWALK2);
	export_constant(EFST_NOT_EXTREMITYFIST);
	export_constant(EFST_CLAIRVOYANCE);
	export_constant(EFST_MOVESLOW_POTION);
	export_constant(EFST_DOUBLECASTING);
	export_constant(EFST_GRAVITATION);
	export_constant(EFST_OVERTHRUSTMAX);
	export_constant(EFST_LONGING);
	export_constant(EFST_HERMODE);
	export_constant(EFST_TAROTCARD);
	export_constant(EFST_HLIF_AVOID);
	export_constant(EFST_HFLI_FLEET);
	export_constant(EFST_HFLI_SPEED);
	export_constant(EFST_HLIF_CHANGE);
	export_constant(EFST_HAMI_BLOODLUST);
	export_constant(EFST_CR_SHRINK);
	export_constant(EFST_WZ_SIGHTBLASTER);
	export_constant(EFST_DC_WINKCHARM);
	export_constant(EFST_RG_CCONFINE_M);
	export_constant(EFST_RG_CCONFINE_S);
	export_constant(EFST_DISABLEMOVE);
	export_constant(EFST_GS_MADNESSCANCEL);
	export_constant(EFST_GS_GATLINGFEVER);
	export_constant(EFST_EARTHSCROLL);
	export_constant(EFST_NJ_UTSUSEMI);
	export_constant(EFST_NJ_BUNSINJYUTSU);
	export_constant(EFST_NJ_NEN);
	export_constant(EFST_GS_ADJUSTMENT);
	export_constant(EFST_GS_ACCURACY);
	export_constant(EFST_NJ_SUITON);
	export_constant(EFST_PET);
	export_constant(EFST_MENTAL);
	export_constant(EFST_EXPMEMORY);
	export_constant(EFST_PERFORMANCE);
	export_constant(EFST_GAIN);
	export_constant(EFST_GRIFFON);
	export_constant(EFST_DRIFT);
	export_constant(EFST_WALLSHIFT);
	export_constant(EFST_REINCARNATION);
	export_constant(EFST_PATTACK);
	export_constant(EFST_PSPEED);
	export_constant(EFST_PDEFENSE);
	export_constant(EFST_PCRITICAL);
	export_constant(EFST_RANKING);
	export_constant(EFST_PTRIPLE);
	export_constant(EFST_DENERGY);
	export_constant(EFST_WAVE1);
	export_constant(EFST_WAVE2);
	export_constant(EFST_WAVE3);
	export_constant(EFST_WAVE4);
	export_constant(EFST_DAURA);
	export_constant(EFST_DFREEZER);
	export_constant(EFST_DPUNISH);
	export_constant(EFST_DBARRIER);
	export_constant(EFST_DWARNING);
	export_constant(EFST_MOUSEWHEEL);
	export_constant(EFST_DGAUGE);
	export_constant(EFST_DACCEL);
	export_constant(EFST_DBLOCK);
	export_constant(EFST_FOOD_STR);
	export_constant(EFST_FOOD_AGI);
	export_constant(EFST_FOOD_VIT);
	export_constant(EFST_FOOD_DEX);
	export_constant(EFST_FOOD_INT);
	export_constant(EFST_FOOD_LUK);
	export_constant(EFST_FOOD_BASICAVOIDANCE);
	export_constant(EFST_FOOD_BASICHIT);
	export_constant(EFST_FOOD_CRITICALSUCCESSVALUE);
	export_constant(EFST_CASH_PLUSEXP);
	export_constant(EFST_CASH_DEATHPENALTY);
	export_constant(EFST_CASH_RECEIVEITEM);
	export_constant(EFST_CASH_BOSS_ALARM);
	export_constant(EFST_DA_ENERGY);
	export_constant(EFST_DA_FIRSTSLOT);
	export_constant(EFST_DA_HEADDEF);
	export_constant(EFST_DA_SPACE);
	export_constant(EFST_DA_TRANSFORM);
	export_constant(EFST_DA_ITEMREBUILD);
	export_constant(EFST_DA_ILLUSION);
	export_constant(EFST_DA_DARKPOWER);
	export_constant(EFST_DA_EARPLUG);
	export_constant(EFST_DA_CONTRACT);
	export_constant(EFST_DA_BLACK);
	export_constant(EFST_DA_MAGICCART);
	export_constant(EFST_CRYSTAL);
	export_constant(EFST_DA_REBUILD);
	export_constant(EFST_DA_EDARKNESS);
	export_constant(EFST_DA_EGUARDIAN);
	export_constant(EFST_DA_TIMEOUT);
	export_constant(EFST_FOOD_STR_CASH);
	export_constant(EFST_FOOD_AGI_CASH);
	export_constant(EFST_FOOD_VIT_CASH);
	export_constant(EFST_FOOD_DEX_CASH);
	export_constant(EFST_FOOD_INT_CASH);
	export_constant(EFST_FOOD_LUK_CASH);
	export_constant(EFST_MER_FLEE);
	export_constant(EFST_MER_ATK);
	export_constant(EFST_MER_HP);
	export_constant(EFST_MER_SP);
	export_constant(EFST_MER_HIT);
	export_constant(EFST_SLOWCAST);
	export_constant(EFST_MAGICMIRROR);
	export_constant(EFST_STONESKIN);
	export_constant(EFST_ANTIMAGIC);
	export_constant(EFST_CRITICALWOUND);
	export_constant(EFST_NPC_DEFENDER);
	export_constant(EFST_NOACTION_WAIT);
	export_constant(EFST_MOVHASTE_HORSE);
	export_constant(EFST_PROTECT_DEF);
	export_constant(EFST_PROTECT_MDEF);
	export_constant(EFST_HEALPLUS);
	export_constant(EFST_S_LIFEPOTION);
	export_constant(EFST_L_LIFEPOTION);
	export_constant(EFST_CRITICALPERCENT);
	export_constant(EFST_PLUSAVOIDVALUE);
	export_constant(EFST_ATKER_ASPD);
	export_constant(EFST_TARGET_ASPD);
	export_constant(EFST_ATKER_MOVESPEED);
	export_constant(EFST_ATKER_BLOOD);
	export_constant(EFST_TARGET_BLOOD);
	export_constant(EFST_ARMOR_PROPERTY);
	export_constant(EFST_REUSE_LIMIT_A);
	export_constant(EFST_HELLPOWER);
	export_constant(EFST_STEAMPACK);
	export_constant(EFST_REUSE_LIMIT_B);
	export_constant(EFST_REUSE_LIMIT_C);
	export_constant(EFST_REUSE_LIMIT_D);
	export_constant(EFST_REUSE_LIMIT_E);
	export_constant(EFST_REUSE_LIMIT_F);
	export_constant(EFST_INVINCIBLE);
	export_constant(EFST_CASH_PLUSONLYJOBEXP);
	export_constant(EFST_PARTYFLEE);
	export_constant(EFST_ANGEL_PROTECT);
	export_constant(EFST_ENDURE_MDEF);
	export_constant(EFST_ENCHANTBLADE);
	export_constant(EFST_DEATHBOUND);
	export_constant(EFST_REFRESH);
	export_constant(EFST_GIANTGROWTH);
	export_constant(EFST_STONEHARDSKIN);
	export_constant(EFST_VITALITYACTIVATION);
	export_constant(EFST_FIGHTINGSPIRIT);
	export_constant(EFST_ABUNDANCE);
	export_constant(EFST_REUSE_MILLENNIUMSHIELD);
	export_constant(EFST_REUSE_CRUSHSTRIKE);
	export_constant(EFST_REUSE_REFRESH);
	export_constant(EFST_REUSE_STORMBLAST);
	export_constant(EFST_VENOMIMPRESS);
	export_constant(EFST_EPICLESIS);
	export_constant(EFST_ORATIO);
	export_constant(EFST_LAUDAAGNUS);
	export_constant(EFST_LAUDARAMUS);
	export_constant(EFST_CLOAKINGEXCEED);
	export_constant(EFST_HALLUCINATIONWALK);
	export_constant(EFST_HALLUCINATIONWALK_POSTDELAY);
	export_constant(EFST_RENOVATIO);
	export_constant(EFST_WEAPONBLOCKING);
	export_constant(EFST_WEAPONBLOCKING_POSTDELAY);
	export_constant(EFST_ROLLINGCUTTER);
	export_constant(EFST_EXPIATIO);
	export_constant(EFST_POISONINGWEAPON);
	export_constant(EFST_TOXIN);
	export_constant(EFST_PARALYSE);
	export_constant(EFST_VENOMBLEED);
	export_constant(EFST_MAGICMUSHROOM);
	export_constant(EFST_DEATHHURT);
	export_constant(EFST_PYREXIA);
	export_constant(EFST_OBLIVIONCURSE);
	export_constant(EFST_LEECHESEND);
	export_constant(EFST_DUPLELIGHT);
	export_constant(EFST_FROSTMISTY);
	export_constant(EFST_FEARBREEZE);
	export_constant(EFST_ELECTRICSHOCKER);
	export_constant(EFST_MARSHOFABYSS);
	export_constant(EFST_RECOGNIZEDSPELL);
	export_constant(EFST_STASIS);
	export_constant(EFST_WUGRIDER);
	export_constant(EFST_WUGDASH);
	export_constant(EFST_WUGBITE);
	export_constant(EFST_CAMOUFLAGE);
	export_constant(EFST_ACCELERATION);
	export_constant(EFST_HOVERING);
	export_constant(EFST_SUMMON1);
	export_constant(EFST_SUMMON2);
	export_constant(EFST_SUMMON3);
	export_constant(EFST_SUMMON4);
	export_constant(EFST_SUMMON5);
	export_constant(EFST_MVPCARD_TAOGUNKA);
	export_constant(EFST_MVPCARD_MISTRESS);
	export_constant(EFST_MVPCARD_ORCHERO);
	export_constant(EFST_MVPCARD_ORCLORD);
	export_constant(EFST_OVERHEAT_LIMITPOINT);
	export_constant(EFST_OVERHEAT);
	export_constant(EFST_SHAPESHIFT);
	export_constant(EFST_INFRAREDSCAN);
	export_constant(EFST_MAGNETICFIELD);
	export_constant(EFST_NEUTRALBARRIER);
	export_constant(EFST_NEUTRALBARRIER_MASTER);
	export_constant(EFST_STEALTHFIELD);
	export_constant(EFST_STEALTHFIELD_MASTER);
	export_constant(EFST_MANU_ATK);
	export_constant(EFST_MANU_DEF);
	export_constant(EFST_SPL_ATK);
	export_constant(EFST_SPL_DEF);
	export_constant(EFST_REPRODUCE);
	export_constant(EFST_MANU_MATK);
	export_constant(EFST_SPL_MATK);
	export_constant(EFST_STR_SCROLL);
	export_constant(EFST_INT_SCROLL);
	export_constant(EFST_LG_REFLECTDAMAGE);
	export_constant(EFST_FORCEOFVANGUARD);
	export_constant(EFST_BUCHEDENOEL);
	export_constant(EFST_AUTOSHADOWSPELL);
	export_constant(EFST_SHADOWFORM);
	export_constant(EFST_RAID);
	export_constant(EFST_SHIELDSPELL_DEF);
	export_constant(EFST_SHIELDSPELL_MDEF);
	export_constant(EFST_SHIELDSPELL_REF);
	export_constant(EFST_BODYPAINT);
	export_constant(EFST_EXEEDBREAK);
	export_constant(EFST_ADORAMUS);
	export_constant(EFST_PRESTIGE);
	export_constant(EFST_INVISIBILITY);
	export_constant(EFST_DEADLYINFECT);
	export_constant(EFST_BANDING);
	export_constant(EFST_EARTHDRIVE);
	export_constant(EFST_INSPIRATION);
	export_constant(EFST_ENERVATION);
	export_constant(EFST_GROOMY);
	export_constant(EFST_RAISINGDRAGON);
	export_constant(EFST_IGNORANCE);
	export_constant(EFST_LAZINESS);
	export_constant(EFST_LIGHTNINGWALK);
	export_constant(EFST_ACARAJE);
	export_constant(EFST_UNLUCKY);
	export_constant(EFST_CURSEDCIRCLE_ATKER);
	export_constant(EFST_CURSEDCIRCLE_TARGET);
	export_constant(EFST_WEAKNESS);
	export_constant(EFST_CRESCENTELBOW);
	export_constant(EFST_NOEQUIPACCESSARY);
	export_constant(EFST_STRIPACCESSARY);
	export_constant(EFST_MANHOLE);
	export_constant(EFST_POPECOOKIE);
	export_constant(EFST_FALLENEMPIRE);
	export_constant(EFST_GENTLETOUCH_ENERGYGAIN);
	export_constant(EFST_GENTLETOUCH_CHANGE);
	export_constant(EFST_GENTLETOUCH_REVITALIZE);
	export_constant(EFST_BLOODYLUST);
	export_constant(EFST_SWING);
	export_constant(EFST_SYMPHONY_LOVE);
	export_constant(EFST_PROPERTYWALK);
	export_constant(EFST_SPELLFIST);
	export_constant(EFST_NETHERWORLD);
	export_constant(EFST_SIREN);
	export_constant(EFST_DEEP_SLEEP);
	export_constant(EFST_SIRCLEOFNATURE);
	export_constant(EFST_COLD);
	export_constant(EFST_GLOOMYDAY);
	export_constant(EFST_SONG_OF_MANA);
	export_constant(EFST_CLOUD_KILL);
	export_constant(EFST_DANCE_WITH_WUG);
	export_constant(EFST_RUSH_WINDMILL);
	export_constant(EFST_ECHOSONG);
	export_constant(EFST_HARMONIZE);
	export_constant(EFST_STRIKING);
	export_constant(EFST_WARMER);
	export_constant(EFST_MOONLIT_SERENADE);
	export_constant(EFST_SATURDAY_NIGHT_FEVER);
	export_constant(EFST_SITDOWN_FORCE);
	export_constant(EFST_ANALYZE);
	export_constant(EFST_LERADS_DEW);
	export_constant(EFST_MELODYOFSINK);
	export_constant(EFST_BEYOND_OF_WARCRY);
	export_constant(EFST_UNLIMITED_HUMMING_VOICE);
	export_constant(EFST_SPELLBOOK1);
	export_constant(EFST_SPELLBOOK2);
	export_constant(EFST_SPELLBOOK3);
	export_constant(EFST_FREEZE_SP);
	export_constant(EFST_GN_TRAINING_SWORD);
	export_constant(EFST_GN_REMODELING_CART);
	export_constant(EFST_GN_CARTBOOST);
	export_constant(EFST_FIXEDCASTINGTM_REDUCE);
	export_constant(EFST_THORNS_TRAP);
	export_constant(EFST_BLOOD_SUCKER);
	export_constant(EFST_SPORE_EXPLOSION);
	export_constant(EFST_DEMONIC_FIRE);
	export_constant(EFST_FIRE_EXPANSION_SMOKE_POWDER);
	export_constant(EFST_FIRE_EXPANSION_TEAR_GAS);
	export_constant(EFST_BLOCKING_PLAY);
	export_constant(EFST_MANDRAGORA);
	export_constant(EFST_ACTIVATE);
	export_constant(EFST_AB_SECRAMENT);
	export_constant(EFST_ASSUMPTIO2);
	export_constant(EFST_TK_SEVENWIND);
	export_constant(EFST_LIMIT_ODINS_RECALL);
	export_constant(EFST_STOMACHACHE);
	export_constant(EFST_MYSTERIOUS_POWDER);
	export_constant(EFST_MELON_BOMB);
	export_constant(EFST_BANANA_BOMB_SITDOWN_POSTDELAY);
	export_constant(EFST_PROMOTE_HEALTH_RESERCH);
	export_constant(EFST_ENERGY_DRINK_RESERCH);
	export_constant(EFST_EXTRACT_WHITE_POTION_Z);
	export_constant(EFST_VITATA_500);
	export_constant(EFST_EXTRACT_SALAMINE_JUICE);
	export_constant(EFST_BOOST500);
	export_constant(EFST_FULL_SWING_K);
	export_constant(EFST_MANA_PLUS);
	export_constant(EFST_MUSTLE_M);
	export_constant(EFST_LIFE_FORCE_F);
	export_constant(EFST_VACUUM_EXTREME);
	export_constant(EFST_SAVAGE_STEAK);
	export_constant(EFST_COCKTAIL_WARG_BLOOD);
	export_constant(EFST_MINOR_BBQ);
	export_constant(EFST_SIROMA_ICE_TEA);
	export_constant(EFST_DROCERA_HERB_STEAMED);
	export_constant(EFST_PUTTI_TAILS_NOODLES);
	export_constant(EFST_BANANA_BOMB);
	export_constant(EFST_SUMMON_AGNI);
	export_constant(EFST_SPELLBOOK4);
	export_constant(EFST_SPELLBOOK5);
	export_constant(EFST_SPELLBOOK6);
	export_constant(EFST_SPELLBOOK7);
	export_constant(EFST_ELEMENTAL_AGGRESSIVE);
	export_constant(EFST_RETURN_TO_ELDICASTES);
	export_constant(EFST_BANDING_DEFENCE);
	export_constant(EFST_SKELSCROLL);
	export_constant(EFST_DISTRUCTIONSCROLL);
	export_constant(EFST_ROYALSCROLL);
	export_constant(EFST_IMMUNITYSCROLL);
	export_constant(EFST_MYSTICSCROLL);
	export_constant(EFST_BATTLESCROLL);
	export_constant(EFST_ARMORSCROLL);
	export_constant(EFST_FREYJASCROLL);
	export_constant(EFST_SOULSCROLL);
	export_constant(EFST_CIRCLE_OF_FIRE);
	export_constant(EFST_CIRCLE_OF_FIRE_OPTION);
	export_constant(EFST_FIRE_CLOAK);
	export_constant(EFST_FIRE_CLOAK_OPTION);
	export_constant(EFST_WATER_SCREEN);
	export_constant(EFST_WATER_SCREEN_OPTION);
	export_constant(EFST_WATER_DROP);
	export_constant(EFST_WATER_DROP_OPTION);
	export_constant(EFST_WIND_STEP);
	export_constant(EFST_WIND_STEP_OPTION);
	export_constant(EFST_WIND_CURTAIN);
	export_constant(EFST_WIND_CURTAIN_OPTION);
	export_constant(EFST_WATER_BARRIER);
	export_constant(EFST_ZEPHYR);
	export_constant(EFST_SOLID_SKIN);
	export_constant(EFST_SOLID_SKIN_OPTION);
	export_constant(EFST_STONE_SHIELD);
	export_constant(EFST_STONE_SHIELD_OPTION);
	export_constant(EFST_POWER_OF_GAIA);
	export_constant(EFST_EL_WAIT);
	export_constant(EFST_EL_PASSIVE);
	export_constant(EFST_EL_DEFENSIVE);
	export_constant(EFST_EL_OFFENSIVE);
	export_constant(EFST_EL_COST);
	export_constant(EFST_PYROTECHNIC);
	export_constant(EFST_PYROTECHNIC_OPTION);
	export_constant(EFST_HEATER);
	export_constant(EFST_HEATER_OPTION);
	export_constant(EFST_TROPIC);
	export_constant(EFST_TROPIC_OPTION);
	export_constant(EFST_AQUAPLAY);
	export_constant(EFST_AQUAPLAY_OPTION);
	export_constant(EFST_COOLER);
	export_constant(EFST_COOLER_OPTION);
	export_constant(EFST_CHILLY_AIR);
	export_constant(EFST_CHILLY_AIR_OPTION);
	export_constant(EFST_GUST);
	export_constant(EFST_GUST_OPTION);
	export_constant(EFST_BLAST);
	export_constant(EFST_BLAST_OPTION);
	export_constant(EFST_WILD_STORM);
	export_constant(EFST_WILD_STORM_OPTION);
	export_constant(EFST_PETROLOGY);
	export_constant(EFST_PETROLOGY_OPTION);
	export_constant(EFST_CURSED_SOIL);
	export_constant(EFST_CURSED_SOIL_OPTION);
	export_constant(EFST_UPHEAVAL);
	export_constant(EFST_UPHEAVAL_OPTION);
	export_constant(EFST_TIDAL_WEAPON);
	export_constant(EFST_TIDAL_WEAPON_OPTION);
	export_constant(EFST_ROCK_CRUSHER);
	export_constant(EFST_ROCK_CRUSHER_ATK);
	export_constant(EFST_FIRE_INSIGNIA);
	export_constant(EFST_WATER_INSIGNIA);
	export_constant(EFST_WIND_INSIGNIA);
	export_constant(EFST_EARTH_INSIGNIA);
	export_constant(EFST_EQUIPED_FLOOR);
	export_constant(EFST_GUARDIAN_RECALL);
	export_constant(EFST_MORA_BUFF);
	export_constant(EFST_REUSE_LIMIT_G);
	export_constant(EFST_REUSE_LIMIT_H);
	export_constant(EFST_NEEDLE_OF_PARALYZE);
	export_constant(EFST_PAIN_KILLER);
	export_constant(EFST_G_LIFEPOTION);
	export_constant(EFST_VITALIZE_POTION);
	export_constant(EFST_LIGHT_OF_REGENE);
	export_constant(EFST_OVERED_BOOST);
	export_constant(EFST_SILENT_BREEZE);
	export_constant(EFST_ODINS_POWER);
	export_constant(EFST_STYLE_CHANGE);
	export_constant(EFST_SONIC_CLAW_POSTDELAY);
	export_constant(EFST_SILVERVEIN_RUSH_POSTDELAY);
	export_constant(EFST_MIDNIGHT_FRENZY_POSTDELAY);
	export_constant(EFST_GOLDENE_FERSE);
	export_constant(EFST_ANGRIFFS_MODUS);
	export_constant(EFST_TINDER_BREAKER);
	export_constant(EFST_TINDER_BREAKER_POSTDELAY);
	export_constant(EFST_CBC);
	export_constant(EFST_CBC_POSTDELAY);
	export_constant(EFST_EQC);
	export_constant(EFST_MAGMA_FLOW);
	export_constant(EFST_GRANITIC_ARMOR);
	export_constant(EFST_PYROCLASTIC);
	export_constant(EFST_VOLCANIC_ASH);
	export_constant(EFST_SPIRITS_SAVEINFO1);
	export_constant(EFST_SPIRITS_SAVEINFO2);
	export_constant(EFST_MAGIC_CANDY);
	export_constant(EFST_SEARCH_STORE_INFO);
	export_constant(EFST_ALL_RIDING);
	export_constant(EFST_ALL_RIDING_REUSE_LIMIT);
	export_constant(EFST_MACRO);
	export_constant(EFST_MACRO_POSTDELAY);
	export_constant(EFST_BEER_BOTTLE_CAP);
	export_constant(EFST_OVERLAPEXPUP);
	export_constant(EFST_PC_IZ_DUN05);
	export_constant(EFST_CRUSHSTRIKE);
	export_constant(EFST_MONSTER_TRANSFORM);
	export_constant(EFST_SIT);
	export_constant(EFST_ONAIR);
	export_constant(EFST_MTF_ASPD);
	export_constant(EFST_MTF_RANGEATK);
	export_constant(EFST_MTF_MATK);
	export_constant(EFST_MTF_MLEATKED);
	export_constant(EFST_MTF_CRIDAMAGE);
	export_constant(EFST_REUSE_LIMIT_MTF);
	export_constant(EFST_MACRO_PERMIT);
	export_constant(EFST_MACRO_PLAY);
	export_constant(EFST_SKF_CAST);
	export_constant(EFST_SKF_ASPD);
	export_constant(EFST_SKF_ATK);
	export_constant(EFST_SKF_MATK);
	export_constant(EFST_REWARD_PLUSONLYJOBEXP);
	export_constant(EFST_HANDICAPSTATE_NORECOVER);
	export_constant(EFST_SET_NUM_DEF);
	export_constant(EFST_SET_NUM_MDEF);
	export_constant(EFST_SET_PER_DEF);
	export_constant(EFST_SET_PER_MDEF);
	export_constant(EFST_PARTYBOOKING_SEARCH_DEALY);
	export_constant(EFST_PARTYBOOKING_REGISTER_DEALY);
	export_constant(EFST_PERIOD_TIME_CHECK_DETECT_SKILL);
	export_constant(EFST_KO_JYUMONJIKIRI);
	export_constant(EFST_MEIKYOUSISUI);
	export_constant(EFST_ATTHASTE_CASH);
	export_constant(EFST_EQUIPPED_DIVINE_ARMOR);
	export_constant(EFST_EQUIPPED_HOLY_ARMOR);
	export_constant(EFST_2011RWC);
	export_constant(EFST_KYOUGAKU);
	export_constant(EFST_IZAYOI);
	export_constant(EFST_ZENKAI);
	export_constant(EFST_KG_KAGEHUMI);
	export_constant(EFST_KYOMU);
	export_constant(EFST_KAGEMUSYA);
	export_constant(EFST_ZANGETSU);
	export_constant(EFST_PHI_DEMON);
	export_constant(EFST_GENSOU);
	export_constant(EFST_AKAITSUKI);
	export_constant(EFST_TETANY);
	export_constant(EFST_GM_BATTLE);
	export_constant(EFST_GM_BATTLE2);
	export_constant(EFST_2011RWC_SCROLL);
	export_constant(EFST_ACTIVE_MONSTER_TRANSFORM);
	export_constant(EFST_MYSTICPOWDER);
	export_constant(EFST_ECLAGE_RECALL);
	export_constant(EFST_ENTRY_QUEUE_APPLY_DELAY);
	export_constant(EFST_REUSE_LIMIT_ECL);
	export_constant(EFST_M_LIFEPOTION);
	export_constant(EFST_ENTRY_QUEUE_NOTIFY_ADMISSION_TIME_OUT);
	export_constant(EFST_UNKNOWN_NAME);
	export_constant(EFST_ON_PUSH_CART);
	export_constant(EFST_HAT_EFFECT);
	export_constant(EFST_FLOWER_LEAF);
	export_constant(EFST_RAY_OF_PROTECTION);
	export_constant(EFST_GLASTHEIM_ATK);
	export_constant(EFST_GLASTHEIM_DEF);
	export_constant(EFST_GLASTHEIM_HEAL);
	export_constant(EFST_GLASTHEIM_HIDDEN);
	export_constant(EFST_GLASTHEIM_STATE);
	export_constant(EFST_GLASTHEIM_ITEMDEF);
	export_constant(EFST_GLASTHEIM_HPSP);
	export_constant(EFST_HOMUN_SKILL_POSTDELAY);
	export_constant(EFST_ALMIGHTY);
	export_constant(EFST_GVG_GIANT);
	export_constant(EFST_GVG_GOLEM);
	export_constant(EFST_GVG_STUN);
	export_constant(EFST_GVG_STONE);
	export_constant(EFST_GVG_FREEZ);
	export_constant(EFST_GVG_SLEEP);
	export_constant(EFST_GVG_CURSE);
	export_constant(EFST_GVG_SILENCE);
	export_constant(EFST_GVG_BLIND);
	export_constant(EFST_CLIENT_ONLY_EQUIP_ARROW);
	export_constant(EFST_CLAN_INFO);
	export_constant(EFST_JP_EVENT01);
	export_constant(EFST_JP_EVENT02);
	export_constant(EFST_JP_EVENT03);
	export_constant(EFST_JP_EVENT04);
	export_constant(EFST_TELEPORT_FIXEDCASTINGDELAY);
	export_constant(EFST_GEFFEN_MAGIC1);
	export_constant(EFST_GEFFEN_MAGIC2);
	export_constant(EFST_GEFFEN_MAGIC3);
	export_constant(EFST_QUEST_BUFF1);
	export_constant(EFST_QUEST_BUFF2);
	export_constant(EFST_QUEST_BUFF3);
	export_constant(EFST_REUSE_LIMIT_RECALL);
	export_constant(EFST_SAVEPOSITION);
	export_constant(EFST_HANDICAPSTATE_ICEEXPLO);
	export_constant(EFST_FENRIR_CARD);
	export_constant(EFST_REUSE_LIMIT_ASPD_POTION);
	export_constant(EFST_MAXPAIN);
	export_constant(EFST_PC_STOP);
	export_constant(EFST_FRIGG_SONG);
	export_constant(EFST_OFFERTORIUM);
	export_constant(EFST_TELEKINESIS_INTENSE);
	export_constant(EFST_MOONSTAR);
	export_constant(EFST_STRANGELIGHTS);
	export_constant(EFST_FULL_THROTTLE);
	export_constant(EFST_REBOUND);
	export_constant(EFST_UNLIMIT);
	export_constant(EFST_KINGS_GRACE);
	export_constant(EFST_ITEM_ATKMAX);
	export_constant(EFST_ITEM_ATKMIN);
	export_constant(EFST_ITEM_MATKMAX);
	export_constant(EFST_ITEM_MATKMIN);
	export_constant(EFST_SUPER_STAR);
	export_constant(EFST_HIGH_RANKER);
	export_constant(EFST_DARKCROW);
	export_constant(EFST_2013_VALENTINE1);
	export_constant(EFST_2013_VALENTINE2);
	export_constant(EFST_2013_VALENTINE3);
	export_constant(EFST_ILLUSIONDOPING);
	export_constant(EFST_WIDEWEB);
	export_constant(EFST_CHILL);
	export_constant(EFST_BURNT);
	export_constant(EFST_PCCAFE_PLAY_TIME);
	export_constant(EFST_TWISTED_TIME);
	export_constant(EFST_FLASHCOMBO);
	export_constant(EFST_JITTER_BUFF1);
	export_constant(EFST_JITTER_BUFF2);
	export_constant(EFST_JITTER_BUFF3);
	export_constant(EFST_JITTER_BUFF4);
	export_constant(EFST_JITTER_BUFF5);
	export_constant(EFST_JITTER_BUFF6);
	export_constant(EFST_JITTER_BUFF7);
	export_constant(EFST_JITTER_BUFF8);
	export_constant(EFST_JITTER_BUFF9);
	export_constant(EFST_JITTER_BUFF10);
	export_constant(EFST_CUP_OF_BOZA);
	export_constant(EFST_B_TRAP);
	export_constant(EFST_E_CHAIN);
	export_constant(EFST_E_QD_SHOT_READY);
	export_constant(EFST_C_MARKER);
	export_constant(EFST_H_MINE);
	export_constant(EFST_H_MINE_SPLASH);
	export_constant(EFST_P_ALTER);
	export_constant(EFST_HEAT_BARREL);
	export_constant(EFST_ANTI_M_BLAST);
	export_constant(EFST_SLUGSHOT);
	export_constant(EFST_SWORDCLAN);
	export_constant(EFST_ARCWANDCLAN);
	export_constant(EFST_GOLDENMACECLAN);
	export_constant(EFST_CROSSBOWCLAN);
	export_constant(EFST_PACKING_ENVELOPE1);
	export_constant(EFST_PACKING_ENVELOPE2);
	export_constant(EFST_PACKING_ENVELOPE3);
	export_constant(EFST_PACKING_ENVELOPE4);
	export_constant(EFST_PACKING_ENVELOPE5);
	export_constant(EFST_PACKING_ENVELOPE6);
	export_constant(EFST_PACKING_ENVELOPE7);
	export_constant(EFST_PACKING_ENVELOPE8);
	export_constant(EFST_PACKING_ENVELOPE9);
	export_constant(EFST_PACKING_ENVELOPE10);
	export_constant(EFST_GLASTHEIM_TRANS);
	export_constant(EFST_ZONGZI_POUCH_TRANS);
	export_constant(EFST_HEAT_BARREL_AFTER);
	export_constant(EFST_DECORATION_OF_MUSIC);
	export_constant(EFST_OVERSEAEXPUP);
	export_constant(EFST_CLOWN_N_GYPSY_CARD);
	export_constant(EFST_OPEN_NPC_MARKET);
	export_constant(EFST_BEEF_RIB_STEW);
	export_constant(EFST_PORK_RIB_STEW);
	export_constant(EFST_CHUSEOK_MONDAY);
	export_constant(EFST_CHUSEOK_TUESDAY);
	export_constant(EFST_CHUSEOK_WEDNESDAY);
	export_constant(EFST_CHUSEOK_THURSDAY);
	export_constant(EFST_CHUSEOK_FRIDAY);
	export_constant(EFST_CHUSEOK_WEEKEND);
	export_constant(EFST_ALL_LIGHTGUARD);
	export_constant(EFST_ALL_LIGHTGUARD_COOL_TIME);
	export_constant(EFST_MTF_MHP);
	export_constant(EFST_MTF_MSP);
	export_constant(EFST_MTF_PUMPKIN);
	export_constant(EFST_MTF_HITFLEE);
	export_constant(EFST_MTF_CRIDAMAGE2);
	export_constant(EFST_MTF_SPDRAIN);
	export_constant(EFST_ACUO_MINT_GUM);
	export_constant(EFST_S_HEALPOTION);
	export_constant(EFST_REUSE_LIMIT_S_HEAL_POTION);
	export_constant(EFST_PLAYTIME_STATISTICS);
	export_constant(EFST_GN_CHANGEMATERIAL_OPERATOR);
	export_constant(EFST_GN_MIX_COOKING_OPERATOR);
	export_constant(EFST_GN_MAKEBOMB_OPERATOR);
	export_constant(EFST_GN_S_PHARMACY_OPERATOR);
	export_constant(EFST_SO_EL_ANALYSIS_DISASSEMBLY_OPERATOR);
	export_constant(EFST_SO_EL_ANALYSIS_COMBINATION_OPERATOR);
	export_constant(EFST_NC_MAGICDECOY_OPERATOR);
	export_constant(EFST_GUILD_STORAGE);
	export_constant(EFST_GC_POISONINGWEAPON_OPERATOR);
	export_constant(EFST_WS_WEAPONREFINE_OPERATOR);
	export_constant(EFST_BS_REPAIRWEAPON_OPERATOR);
	export_constant(EFST_GET_MAILBOX);
	export_constant(EFST_JUMPINGCLAN);
	export_constant(EFST_JP_OTP);
	export_constant(EFST_HANDICAPTOLERANCE_LEVELGAP);
	export_constant(EFST_MTF_RANGEATK2);
	export_constant(EFST_MTF_ASPD2);
	export_constant(EFST_MTF_MATK2);
	export_constant(EFST_SHOW_NPCHPBAR);
	export_constant(EFST_FLOWERSMOKE);
	export_constant(EFST_FSTONE);
	export_constant(EFST_DAILYSENDMAILCNT);
	export_constant(EFST_QSCARABA);
	export_constant(EFST_LJOSALFAR);
	export_constant(EFST_PAD_READER_KNIGHT);
	export_constant(EFST_PAD_READER_CRUSADER);
	export_constant(EFST_PAD_READER_BLACKSMITH);
	export_constant(EFST_PAD_READER_ALCHEMIST);
	export_constant(EFST_PAD_READER_ASSASSIN);
	export_constant(EFST_PAD_READER_ROGUE);
	export_constant(EFST_PAD_READER_WIZARD);
	export_constant(EFST_PAD_READER_SAGE);
	export_constant(EFST_PAD_READER_PRIEST);
	export_constant(EFST_PAD_READER_MONK);
	export_constant(EFST_PAD_READER_HUNTER);
	export_constant(EFST_PAD_READER_BARD);
	export_constant(EFST_PAD_READER_DANCER);
	export_constant(EFST_PAD_READER_TAEKWON);
	export_constant(EFST_PAD_READER_NINJA);
	export_constant(EFST_PAD_READER_GUNSLINGER);
	export_constant(EFST_PAD_READER_SUPERNOVICE);
	export_constant(EFST_ESSENCE_OF_TIME);
	export_constant(EFST_MINIGAME_ROULETTE);
	export_constant(EFST_MINIGAME_GOLD_POINT);
	export_constant(EFST_MINIGAME_SILVER_POINT);
	export_constant(EFST_MINIGAME_BRONZE_POINT);
	export_constant(EFST_HAPPINESS_STAR);
	export_constant(EFST_SUMMEREVENT01);
	export_constant(EFST_SUMMEREVENT02);
	export_constant(EFST_SUMMEREVENT03);
	export_constant(EFST_SUMMEREVENT04);
	export_constant(EFST_SUMMEREVENT05);
	export_constant(EFST_MINIGAME_ROULETTE_BONUS_ITEM);
	export_constant(EFST_DRESS_UP);
	export_constant(EFST_MAPLE_FALLS);
	export_constant(EFST_ALL_NIFLHEIM_RECALL);
	export_constant(EFST_MARKING_USE_CHANGEMONSTER);
	export_constant(EFST_MTF_MARIONETTE);
	export_constant(EFST_MTF_LUDE);
	export_constant(EFST_MTF_CRUISER);
	export_constant(EFST_MERMAID_LONGING);
	export_constant(EFST_MAGICAL_FEATHER);
	export_constant(EFST_DRACULA_CARD);
	export_constant(EFST_ALL_PRONTERA_RECALL);
	export_constant(EFST_LIMIT_POWER_BOOSTER);
	export_constant(EFST_GIFT_OF_SNOW);
	export_constant(EFST_NPC_HALLUCINATIONWALK);
	export_constant(EFST_NPC_HALLUCINATIONWALK_POSTDELAY);
	export_constant(EFST_NPC_XXXWALK);
	export_constant(EFST_TIME_ACCESSORY);
	export_constant(EFST_EP16_DEF);
	export_constant(EFST_NORMAL_ATKED_SP);
	export_constant(EFST_BODYSTATE_STONECURSE);
	export_constant(EFST_BODYSTATE_FREEZING);
	export_constant(EFST_BODYSTATE_STUN);
	export_constant(EFST_BODYSTATE_SLEEP);
	export_constant(EFST_BODYSTATE_UNDEAD);
	export_constant(EFST_BODYSTATE_STONECURSE_ING);
	export_constant(EFST_BODYSTATE_BURNNING);
	export_constant(EFST_BODYSTATE_IMPRISON);
	export_constant(EFST_HEALTHSTATE_POISON);
	export_constant(EFST_HEALTHSTATE_CURSE);
	export_constant(EFST_HEALTHSTATE_SILENCE);
	export_constant(EFST_HEALTHSTATE_CONFUSION);
	export_constant(EFST_HEALTHSTATE_BLIND);
	export_constant(EFST_HEALTHSTATE_ANGELUS);
	export_constant(EFST_HEALTHSTATE_BLOODING);
	export_constant(EFST_HEALTHSTATE_HEAVYPOISON);
	export_constant(EFST_HEALTHSTATE_FEAR);
	export_constant(EFST_CHERRY_BLOSSOM_CAKE);
	export_constant(EFST_SU_STOOP);
	export_constant(EFST_CATNIPPOWDER);
	export_constant(EFST_HEAD_EQUIPMENT_EFFECT);
	export_constant(EFST_SV_ROOTTWIST);
	export_constant(EFST_ATTACK_PROPERTY_NOTHING);
	export_constant(EFST_ATTACK_PROPERTY_WATER);
	export_constant(EFST_ATTACK_PROPERTY_GROUND);
	export_constant(EFST_ATTACK_PROPERTY_FIRE);
	export_constant(EFST_ATTACK_PROPERTY_WIND);
	export_constant(EFST_ATTACK_PROPERTY_POISON);
	export_constant(EFST_ATTACK_PROPERTY_SAINT);
	export_constant(EFST_ATTACK_PROPERTY_DARKNESS);
	export_constant(EFST_ATTACK_PROPERTY_TELEKINESIS);
	export_constant(EFST_ATTACK_PROPERTY_UNDEAD);
	export_constant(EFST_RESIST_PROPERTY_NOTHING);
	export_constant(EFST_RESIST_PROPERTY_WATER);
	export_constant(EFST_RESIST_PROPERTY_GROUND);
	export_constant(EFST_RESIST_PROPERTY_FIRE);
	export_constant(EFST_RESIST_PROPERTY_WIND);
	export_constant(EFST_RESIST_PROPERTY_POISON);
	export_constant(EFST_RESIST_PROPERTY_SAINT);
	export_constant(EFST_RESIST_PROPERTY_DARKNESS);
	export_constant(EFST_RESIST_PROPERTY_TELEKINESIS);
	export_constant(EFST_RESIST_PROPERTY_UNDEAD);
	export_constant(EFST_BITESCAR);
	export_constant(EFST_ARCLOUSEDASH);
	export_constant(EFST_TUNAPARTY);
	export_constant(EFST_SHRIMP);
	export_constant(EFST_FRESHSHRIMP);
	export_constant(EFST_PERIOD_RECEIVEITEM);
	export_constant(EFST_PERIOD_PLUSEXP);
	export_constant(EFST_PERIOD_PLUSJOBEXP);
	export_constant(EFST_RUNEHELM);
	export_constant(EFST_HELM_VERKANA);
	export_constant(EFST_HELM_RHYDO);
	export_constant(EFST_HELM_TURISUS);
	export_constant(EFST_HELM_HAGALAS);
	export_constant(EFST_HELM_ISIA);
	export_constant(EFST_HELM_ASIR);
	export_constant(EFST_HELM_URJ);
	export_constant(EFST_SUHIDE);
	export_constant(EFST_REUSE_LIMIT_MG);
	export_constant(EFST_DORAM_BUF_01);
	export_constant(EFST_DORAM_BUF_02);
	export_constant(EFST_SPRITEMABLE);
	export_constant(EFST_AID_PERIOD_RECEIVEITEM);
	export_constant(EFST_AID_PERIOD_PLUSEXP);
	export_constant(EFST_AID_PERIOD_PLUSJOBEXP);
	export_constant(EFST_AID_PERIOD_DEADPENALTY);
	export_constant(EFST_AID_PERIOD_ADDSTOREITEMCOUNT);
	export_constant(EFST_ALL_GLASTHEIM_RECALL);
	export_constant(EFST_REUSE_LIMIT_PEPO_MD);
	export_constant(EFST_ALL_THANATOS_RECALL);
	export_constant(EFST_KAFRA_STORE);
	export_constant(EFST_REUSE_ABBYS);
	export_constant(EFST_MAGICSTONE_OF_GRACE_SET);
	export_constant(EFST_PRIVATE_AIRPLANE);
	export_constant(EFST_HISS);
	export_constant(EFST_HISS_AVOID);
	export_constant(EFST_NYANGGRASS);
	export_constant(EFST_CHATTERING);
	export_constant(EFST_CHATTERING_OPT_ATK_MATK);
	export_constant(EFST_CHATTERING_OPT_HASTE);
	export_constant(EFST_SPIRITOFLAND_STEMSPEAR);
	export_constant(EFST_SPIRITOFLAND_ROOTTWIST);
	export_constant(EFST_SPIRITOFLAND_POWDERING);
	export_constant(EFST_SPIRITOFLAND_METEOR);
	export_constant(EFST_SPIRITOFLAND_NYANGGRASS);
	export_constant(EFST_GROOMING);
	export_constant(EFST_PROTECTIONOFSHRIMP);
	export_constant(EFST_EP16_2_BUFF_SS);
	export_constant(EFST_EP16_2_BUFF_SC);
	export_constant(EFST_EP16_2_BUFF_AC);
	export_constant(EFST_GS_MAGICAL_BULLET);
	export_constant(EFST_FALLEN_ANGEL);
	export_constant(EFST_REUSE_LIMIT_MOVEPOINT);
	export_constant(EFST_MACRO_DETECTOR_ANSWER_WAITING);
	export_constant(EFST_BLAZE_BEAD);
	export_constant(EFST_FROZEN_BEAD);
	export_constant(EFST_BREEZE_BEAD);
	export_constant(EFST_SOULATTACK);
	export_constant(EFST_AID_PERIOD_RECEIVEITEM_2ND);
	export_constant(EFST_AID_PERIOD_PLUSEXP_2ND);
	export_constant(EFST_AID_PERIOD_PLUSJOBEXP_2ND);
	export_constant(EFST_PRONTERA_JP);
	export_constant(EFST_ASSISTANT_VENDING);
	export_constant(EFST_GLOOM_CARD);
	export_constant(EFST_PHARAOH_CARD);
	export_constant(EFST_KIEL_CARD);
	export_constant(EFST_ASSISTANT_BUYING);
	export_constant(EFST_CHEERUP);
	export_constant(EFST_GET_CNT_UNREAD_RODEX_CHARDB);
	export_constant(EFST_GET_CNT_UNREAD_RODEX_GLOBALDB);
	export_constant(EFST_S_MANAPOTION);
	export_constant(EFST_M_DEFSCROLL);
	export_constant(EFST_OPEN_REFINING_UI);
	export_constant(EFST_ALL_LIGHTHALZEN_RECALL);
	export_constant(EFST_SWAP_EQUIPITEM);
	export_constant(EFST_AS_RAGGED_GOLEM_CARD);
	export_constant(EFST_LHZ_DUN_N1);
	export_constant(EFST_LHZ_DUN_N2);
	export_constant(EFST_LHZ_DUN_N3);
	export_constant(EFST_LHZ_DUN_N4);
	export_constant(EFST_TAEKWON_MISSION);
	export_constant(EFST_SUN_PLACE);
	export_constant(EFST_MOON_PLACE);
	export_constant(EFST_STAR_PLACE);
	export_constant(EFST_SUN_MONSTER);
	export_constant(EFST_MOON_MONSTER);
	export_constant(EFST_STAR_MONSTER);
	export_constant(EFST_AL_WARP_ADDSLOT);
	export_constant(EFST_ALL_STAT_DOWN);
	export_constant(EFST_GRADUAL_GRAVITY);
	export_constant(EFST_DAMAGE_HEAL);
	export_constant(EFST_IMMUNE_PROPERTY_NOTHING);
	export_constant(EFST_IMMUNE_PROPERTY_WATER);
	export_constant(EFST_IMMUNE_PROPERTY_GROUND);
	export_constant(EFST_IMMUNE_PROPERTY_FIRE);
	export_constant(EFST_IMMUNE_PROPERTY_WIND);
	export_constant(EFST_IMMUNE_PROPERTY_POISON);
	export_constant(EFST_IMMUNE_PROPERTY_SAINT);
	export_constant(EFST_IMMUNE_PROPERTY_DARKNESS);
	export_constant(EFST_IMMUNE_PROPERTY_TELEKINESIS);
	export_constant(EFST_IMMUNE_PROPERTY_UNDEAD);
	export_constant(EFST_REUSE_LIMIT_NP);
	export_constant(EFST_SPECIALCOOKIE);
	export_constant(EFST_DAMAGE_HEAL2);
	export_constant(EFST_DAMAGE_HEAL3);
	export_constant(EFST_GLORY_OF_RETURN);
	export_constant(EFST_ATK_POPCORN);
	export_constant(EFST_MATK_POPCORN);
	export_constant(EFST_ASPD_POPCORN);
	export_constant(EFST_ULTIMATECOOK);
	export_constant(EFST_LIGHTOFMOON);
	export_constant(EFST_LIGHTOFSUN);
	export_constant(EFST_LIGHTOFSTAR);
	export_constant(EFST_LUNARSTANCE);
	export_constant(EFST_UNIVERSESTANCE);
	export_constant(EFST_SUNSTANCE);
	export_constant(EFST_FLASHKICK);
	export_constant(EFST_NEWMOON);
	export_constant(EFST_STARSTANCE);
	export_constant(EFST_DIMENSION);
	export_constant(EFST_DIMENSION1);
	export_constant(EFST_DIMENSION2);
	export_constant(EFST_CREATINGSTAR);
	export_constant(EFST_FALLINGSTAR);
	export_constant(EFST_NOVAEXPLOSING);
	export_constant(EFST_GRAVITYCONTROL);
	export_constant(XXX_EFST_WORLDSTORE_ACTIVE);
	export_constant(EFST_WORLDSTORE_ITEMMOVEINFO_SENDCOMPLETE);
	export_constant(EFST_SOULCOLLECT);
	export_constant(EFST_SOULREAPER);
	export_constant(EFST_SOULUNITY);
	export_constant(EFST_SOULSHADOW);
	export_constant(EFST_SOULFAIRY);
	export_constant(EFST_SOULFALCON);
	export_constant(EFST_SOULGOLEM);
	export_constant(EFST_SOULDIVISION);
	export_constant(EFST_SOULENERGY);
	export_constant(EFST_USE_SKILL_SP_SPA);
	export_constant(EFST_USE_SKILL_SP_SHA);
	export_constant(EFST_SP_SHA);
	export_constant(EFST_INFINITY_DRINK);
	export_constant(EFST_ABYSS_001);
	export_constant(EFST_ABYSS_002);
	export_constant(EFST_ABYSS_003);
	export_constant(EFST_ABYSS_004);
	export_constant(EFST_ABYSS_005);
	export_constant(EFST_ABYSS_006);
	export_constant(EFST_ABYSS_007);
	export_constant(EFST_ABYSS_008);
	export_constant(EFST_REUSE_LIMIT_THM);
	export_constant(EFST_REUSE_LIMIT_TLI);
	export_constant(EFST_REUSE_LIMIT_TKC);
	export_constant(EFST_REUSE_LIMIT_TRP);
	export_constant(EFST_REUSE_LIMIT_TBG);
	export_constant(EFST_REUSE_LIMIT_TBM);
	export_constant(EFST_YGGDRASIL_BLESS);
	export_constant(EFST_USE_SKILL_SP_SWHOO);
	export_constant(EFST_HUNTING_EVENT);
	export_constant(EFST_PERIOD_RECEIVEITEM_2ND);
	export_constant(EFST_PERIOD_PLUSEXP_2ND);
	export_constant(EFST_EXPDROPUP);
	export_constant(EFST_TW_NEWYEAR_EVENT);
	export_constant(EFST_ENSEMBLEFATIGUE);
	export_constant(EFST_ADAPTATION);
	export_constant(EFST_DANCINGLESSON);
	export_constant(EFST_MUSICALLESSON);
	export_constant(EFST_REUSE_LIMIT_RC);
	export_constant(EFST_DANCINGLESSON_EQUIPPED);
	export_constant(EFST_MUSICALLESSON_EQUIPPED);
	export_constant(EFST_ANCILLA);
	export_constant(EFST_REUSE_LIMIT_POTION_A);
	export_constant(EFST_REUSE_LIMIT_POTION_B);
	export_constant(EFST_REUSE_LIMIT_POTION_C);
	export_constant(EFST_REUSE_LIMIT_POTION_D);
	export_constant(EFST_REUSE_LIMIT_POTION_E);
	export_constant(EFST_REUSE_LIMIT_POTION_F);
	export_constant(EFST_BRAVESET);
	export_constant(EFST_MACEMASTERY_EQUIPPED);
	export_constant(EFST_FESTIVE_ENERGY);
	export_constant(EFST_TEST_KR01);
	export_constant(EFST_STARFISH_JP);
	export_constant(EFST_WEAPONBLOCK_ON);
	export_constant(EFST_CRI_DAMAGE);
	export_constant(EFST_DEF_POWER);
	export_constant(EFST_DEF_IGNORE);
	export_constant(EFST_BOW_ATK_POWER);
	export_constant(EFST_RED_ORG_POTION);
	export_constant(EFST_CAST_TIME);
	export_constant(EFST_BLADESTOPREADY);
	export_constant(EFST_TELEPORT_BR);
	export_constant(EFST_SA_WEAPON_PROPERTY);
	export_constant(EFST_LEAPIMPAIRED);
	export_constant(EFST_SENDING_ITEMLIST);
	export_constant(EFST_EXCLUSIVE_RECEIVEITEM);
	export_constant(EFST_EXCLUSIVE_PLUSEXP);
	export_constant(EFST_ASSUMPTIO_BUFF);
	export_constant(EFST_BASILICA_BUFF);
	export_constant(EFST_OVERLAPEXPUP2);
	export_constant(EFST_STOPMOVE_IMMEDIATELY);
	export_constant(EFST_SOULCURSE);
	export_constant(EFST_SOUND_OF_DESTRUCTION);
	export_constant(EFST_DF_MANAPLUS);
	export_constant(EFST_DF_FULLSWINGK);
	export_constant(EFST_NV_BREAKTHROUGH);
	export_constant(EFST_HELPANGEL);
	export_constant(EFST_NV_TRANSCENDENCE);
	export_constant(EFST_SWEETSFAIR_ATK);
	export_constant(EFST_SWEETSFAIR_MATK);
	export_constant(EFST_REUSE_SKILL);
	export_constant(EFST_FLOWER_LEAF2);
	export_constant(EFST_FLOWER_LEAF3);
	export_constant(EFST_FLOWER_LEAF4);
	export_constant(EFST_CHARM_BOOST);
	export_constant(EFST_EARTHSHAKER);
	export_constant(EFST_PERIOD_USE_WORLDMAP);
	export_constant(EFST_MISTY_FROST);
	export_constant(EFST_MAGIC_POISON);
	export_constant(EFST_MOVE_AGIT);
	export_constant(EFST_REUSE_JPNONLY_LIMIT_I);
	export_constant(EFST_REUSE_JPNONLY_LIMIT_J);
	export_constant(EFST_REUSE_JPNONLY_LIMIT_K);
	export_constant(EFST_JPNONLY_TACTICS);
	export_constant(EFST_PRISON);
	export_constant(EFST_MADOGEAR_TYPE);
	export_constant(EFST_DEADLY_DEFEASANCE);
	export_constant(EFST_CLIMAX_DES_HU);
	export_constant(EFST_CLIMAX);
	export_constant(EFST_FEINTBOMB);
	export_constant(EFST_LUXANIMA);
	export_constant(EFST_BATH_FOAM_A);
	export_constant(EFST_BATH_FOAM_B);
	export_constant(EFST_BATH_FOAM_C);
	export_constant(EFST_AROMA_OIL);
	export_constant(EFST_REUSE_LIMIT_LUXANIMA);
	export_constant(EFST_POWERFUL_FAITH);
	export_constant(EFST_SINCERE_FAITH);
	export_constant(EFST_FIRM_FAITH);
	export_constant(EFST_AIRSHIP_PIPE);
	export_constant(EFST_PIECES_OF_SHADOW);
	export_constant(EFST_HELLS_PLANT_ARMOR);
	export_constant(EFST_RELIEVE_DAMAGE);
	export_constant(EFST_LOCKON_LASER);
	export_constant(EFST_GRADE_ENCHANT_UI_OPEN);
	export_constant(EFST_REF_T_POTION);
	export_constant(EFST_ADD_ATK_DAMAGE);
	export_constant(EFST_ADD_MATK_DAMAGE);
	export_constant(EFST_SERVANTWEAPON);
	export_constant(EFST_SERVANT_SIGN);
	export_constant(EFST_CHARGINGPIERCE);
	export_constant(EFST_CHARGINGPIERCE_COUNT);
	export_constant(EFST_DRAGONIC_AURA);
	export_constant(EFST_BIG_SCAR);
	export_constant(EFST_VIGOR);
	export_constant(EFST_WILL_OF_FAITH);
	export_constant(EFST_PRESSURE);
	export_constant(EFST_SA_DRAGONOLOGY);
	export_constant(EFST_CLIMAX_EARTH);
	export_constant(EFST_CLIMAX_BLOOM);
	export_constant(EFST_CLIMAX_CRYIMP);
	export_constant(EFST_MD_ME_POTION);
	export_constant(EFST_MD_MA_POTION);
	export_constant(EFST_MD_TA_POTION);
	export_constant(EFST_MD_RA_POTION);
	export_constant(EFST_REUSE_MEGAPHONE);
	export_constant(EFST_HOLY_OIL);
	export_constant(EFST_CRYSTAL_IMPACT);
	export_constant(EFST_SHADOW_EXCEED);
	export_constant(EFST_DANCING_KNIFE);
	export_constant(EFST_POTENT_VENOM);
	export_constant(EFST_SHADOW_SCAR);
	export_constant(EFST_E_SLASH_COUNT);
	export_constant(EFST_MEDIALE);
	export_constant(EFST_A_VITA);
	export_constant(EFST_A_TELUM);
	export_constant(EFST_PRE_ACIES);
	export_constant(EFST_COMPETENTIA);
	export_constant(EFST_GUARD_STANCE);
	export_constant(EFST_ATTACK_STANCE);
	export_constant(EFST_GUARDIAN_S);
	export_constant(EFST_HANDICAPSTATE_DEEPBLIND);
	export_constant(EFST_HANDICAPSTATE_DEEPSILENCE);
	export_constant(EFST_HANDICAPSTATE_LASSITUDE);
	export_constant(EFST_HANDICAPSTATE_FROSTBITE);
	export_constant(EFST_HANDICAPSTATE_SWOONING);
	export_constant(EFST_HANDICAPSTATE_LIGHTNINGSTRIKE);
	export_constant(EFST_HANDICAPSTATE_CRYSTALLIZATION);
	export_constant(EFST_HANDICAPSTATE_CONFLAGRATION);
	export_constant(EFST_HANDICAPSTATE_MISFORTUNE);
	export_constant(EFST_HANDICAPSTATE_DEADLYPOISON);
	export_constant(EFST_HANDICAPSTATE_DEPRESSION);
	export_constant(EFST_HANDICAPSTATE_HOLYFLAME);
	export_constant(EFST_REBOUND_S);
	export_constant(EFST_SHIELD_MASTERY);
	export_constant(EFST_SPEAR_SWORD_M);
	export_constant(EFST_HOLY_S);
	export_constant(EFST_ULTIMATE_S);
	export_constant(EFST_SPEAR_SCAR);
	export_constant(EFST_SHIELD_POWER);
	export_constant(EFST_FIDUS_ANIMUS);
	export_constant(EFST_MACE_BOOK_M);
	export_constant(EFST_SHADOW_WEAPON);
	export_constant(EFST_RELIGIO);
	export_constant(EFST_BENEDICTUM);
	export_constant(EFST_MVPCARD_KIEL);
	export_constant(EFST_FIRST_BRAND);
	export_constant(EFST_SECOND_BRAND);
	export_constant(EFST_SECOND_JUDGE);
	export_constant(EFST_THIRD_EXOR_FLAME);
	export_constant(EFST_FIRST_FAITH_POWER);
	export_constant(EFST_AXE_STOMP);
	export_constant(EFST_A_MACHINE);
	export_constant(EFST_D_MACHINE);
	export_constant(EFST_MT_M_MACHINE_OPERATOR);
	export_constant(EFST_TWOAXEDEF);
	export_constant(EFST_DAGGER_AND_BOW_M);
	export_constant(EFST_MAGIC_SWORD_M);
	export_constant(EFST_SHADOW_STRIP);
	export_constant(EFST_ABYSS_DAGGER);
	export_constant(EFST_ABYSSFORCEWEAPON);
	export_constant(EFST_ABYSS_SLAYER);
	export_constant(EFST_TWOHANDDEF);
	export_constant(EFST_PROTECTSHADOWEQUIP);
	export_constant(EFST_RESEARCHREPORT);
	export_constant(EFST_BO_HELL_DUSTY);
	export_constant(EFST_WINDSIGN);
	export_constant(EFST_CRESCIVEBOLT);
	export_constant(EFST_CALAMITYGALE);
	export_constant(EFST_CRESCIVEBOLT3);
	export_constant(EFST_STAGE_MANNER);
	export_constant(EFST_RETROSPECTION);
	export_constant(EFST_MYSTIC_SYMPHONY);
	export_constant(EFST_KVASIR_SONATA);
	export_constant(EFST_SOUNDBLEND);
	export_constant(EFST_GEF_NOCTURN);
	export_constant(EFST_AIN_RHAPSODY);
	export_constant(EFST_MUSICAL_INTERLUDE);
	export_constant(EFST_JAWAII_SERENADE);
	export_constant(EFST_PRON_MARCH);
	export_constant(EFST_ROSEBLOSSOM);
	export_constant(EFST_BO_BIONIC_PHARMACY_OPERATOR);
	export_constant(EFST_ACIDIFIED_ZONE_WATER);
	export_constant(EFST_ACIDIFIED_ZONE_GROUND);
	export_constant(EFST_ACIDIFIED_ZONE_WIND);
	export_constant(EFST_ACIDIFIED_ZONE_FIRE);
	export_constant(EFST_MAGIC_BOOK_M);
	export_constant(EFST_SPELL_ENCHANTING);
	export_constant(EFST_SUMMON_ELEMENTAL_ARDOR);
	export_constant(EFST_SUMMON_ELEMENTAL_DILUVIO);
	export_constant(EFST_SUMMON_ELEMENTAL_PROCELLA);
	export_constant(EFST_SUMMON_ELEMENTAL_TERREMOTUS);
	export_constant(EFST_SUMMON_ELEMENTAL_SERPENS);
	export_constant(EFST_FLAMETECHNIC);
	export_constant(EFST_FLAMETECHNIC_OPTION);
	export_constant(EFST_FLAMEARMOR);
	export_constant(EFST_FLAMEARMOR_OPTION);
	export_constant(EFST_COLD_FORCE);
	export_constant(EFST_COLD_FORCE_OPTION);
	export_constant(EFST_CRYSTAL_ARMOR);
	export_constant(EFST_CRYSTAL_ARMOR_OPTION);
	export_constant(EFST_GRACE_BREEZE);
	export_constant(EFST_GRACE_BREEZE_OPTION);
	export_constant(EFST_EYES_OF_STORM);
	export_constant(EFST_EYES_OF_STORM_OPTION);
	export_constant(EFST_EARTH_CARE);
	export_constant(EFST_EARTH_CARE_OPTION);
	export_constant(EFST_STRONG_PROTECTION);
	export_constant(EFST_STRONG_PROTECTION_OPTION);
	export_constant(EFST_DEEP_POISONING);
	export_constant(EFST_DEEP_POISONING_OPTION);
	export_constant(EFST_POISON_SHIELD);
	export_constant(EFST_POISON_SHIELD_OPTION);
	export_constant(EFST_ABR_BATTLE_WARIOR);
	export_constant(EFST_ABR_DUAL_CANNON);
	export_constant(EFST_ABR_MOTHER_NET);
	export_constant(EFST_ABR_INFINITY);
	export_constant(EFST_ELEMENTAL_VEIL);
	export_constant(EFST_RENOVATIO_EXT);
	export_constant(EFST_HOMUN_TIME);
	export_constant(EFST_POWER_ACCELERATION);
	export_constant(EFST_MAX_HP_SP_AVOID);
	export_constant(EFST_ADD_ALL_STATE);
	export_constant(EFST_AID_PERIOD_POWER_ACCELERATION);
	export_constant(EFST_AID_PERIOD_MAX_HP_SP_AVOID);
	export_constant(EFST_AID_PERIOD_ADD_ALL_STATE);
	export_constant(EFST_POISON_MIST);
	export_constant(EFST_HACKANDSLASHER);
	export_constant(EFST_GET_CNT_UNREAD_RETURN_RODEX_CHARDB);
	export_constant(EFST_STONE_WALL);
	export_constant(EFST_REUSE_LIMIT_I);
	export_constant(EFST_OVERBRANDREADY);
	export_constant(EFST_SHIELDSPELL);
	export_constant(EFST_AUTOSHADOWSPELL_CHECK2);
	export_constant(EFST_CLOUD_POISON);
	export_constant(EFST_SPORE_EXPLOSION_DEBUFF);
	export_constant(EFST_DEFSCROLL);
	export_constant(EFST_MASSIVE_F_BLASTER);
	export_constant(EFST_NOEQUIPWEAPON2);
	export_constant(EFST_NOEQUIPARMOR2);
	export_constant(EFST_NOEQUIPSHIELD2);
	export_constant(EFST_NOEQUIPSHOES2);
	export_constant(EFST_NOEQUIPPENDANT2);
	export_constant(EFST_NOEQUIPEARING2);
	export_constant(EFST_NOEQUIPFULL2);
	export_constant(EFST_CURSE_R_CUBE);
	export_constant(EFST_CURSE_B_CUBE);
	export_constant(EFST_KILLING_AURA);
	export_constant(EFST_TOXIN_OF_MANDARA);
	export_constant(EFST_GOLDENE_TONE);
	export_constant(EFST_TEMPERING);
	export_constant(EFST_NW_P_F_I);
	export_constant(EFST_INTENSIVE_AIM);
	export_constant(EFST_INTENSIVE_AIM_COUNT);
	export_constant(EFST_GRENADE_FRAGMENT_1);
	export_constant(EFST_GRENADE_FRAGMENT_2);
	export_constant(EFST_GRENADE_FRAGMENT_3);
	export_constant(EFST_GRENADE_FRAGMENT_4);
	export_constant(EFST_GRENADE_FRAGMENT_5);
	export_constant(EFST_GRENADE_FRAGMENT_6);
	export_constant(EFST_AUTO_FIRING_LAUNCHEREFST);
	export_constant(EFST_HIDDEN_CARD);
	export_constant(EFST_NW_GRENADE_MASTERY);
	export_constant(EFST_TALISMAN_OF_PROTECTION);
	export_constant(EFST_TALISMAN_OF_WARRIOR);
	export_constant(EFST_TALISMAN_OF_MAGICIAN);
	export_constant(EFST_TALISMAN_OF_FIVE_ELEMENTS);
	export_constant(EFST_T_FIRST_GOD);
	export_constant(EFST_T_SECOND_GOD);
	export_constant(EFST_T_THIRD_GOD);
	export_constant(EFST_T_FOURTH_GOD);
	export_constant(EFST_T_FIVETH_GOD);
	export_constant(EFST_HEAVEN_AND_EARTH);
	export_constant(EFST_HOGOGONG);
	export_constant(EFST_MARINE_FESTIVAL);
	export_constant(EFST_SANDY_FESTIVAL);
	export_constant(EFST_KI_SUL_RAMPAGE);
	export_constant(EFST_COLORS_OF_HYUN_ROK_1);
	export_constant(EFST_COLORS_OF_HYUN_ROK_2);
	export_constant(EFST_COLORS_OF_HYUN_ROK_3);
	export_constant(EFST_COLORS_OF_HYUN_ROK_4);
	export_constant(EFST_COLORS_OF_HYUN_ROK_5);
	export_constant(EFST_COLORS_OF_HYUN_ROK_6);
	export_constant(EFST_COLORS_OF_HYUN_ROK_BUFF);
	export_constant(EFST_TEMPORARY_COMMUNION);
	export_constant(EFST_BLESSING_OF_M_CREATURES);
	export_constant(EFST_BLESSING_OF_M_C_DEBUFF);
	export_constant(EFST_SHIELDCHAINRUSH);
	export_constant(EFST_MISTYFROST);
	export_constant(EFST_GROUNDGRAVITY);
	export_constant(EFST_BREAKINGLIMIT);
	export_constant(EFST_RULEBREAK);
	export_constant(EFST_RISING_SUN);
	export_constant(EFST_NOON_SUN);
	export_constant(EFST_SUNSET_SUN);
	export_constant(EFST_RISING_MOON);
	export_constant(EFST_MIDNIGHT_MOON);
	export_constant(EFST_DAWN_MOON);
	export_constant(EFST_STAR_BURST);
	export_constant(EFST_SKY_ENCHANT);
	export_constant(EFST_SHADOW_CLOCK);
	export_constant(EFST_SHINKIROU_CALL);
	export_constant(EFST_NIGHTMARE);
	export_constant(EFST_NOODLE_FES_1);
	export_constant(EFST_NOODLE_FES_2);
	export_constant(EFST_NOODLE_FES_3);
	export_constant(EFST_NOODLE_FES_4);
	export_constant(EFST_NOODLE_FES_5);
	export_constant(EFST_RUSH_QUAKE1);
	export_constant(EFST_RUSH_QUAKE2);
	export_constant(EFST_SBUNSHIN);
	export_constant(EFST_MTP_W_POTION_100);
	export_constant(EFST_CHANGE_SIZE);
	export_constant(EFST_CHANGE_SIZE_MONSTER);
	export_constant(EFST_SHOW_EFFECT1);
	export_constant(EFST_SHOW_EFFECT2);
	export_constant(EFST_SHOW_EFFECT3);
	export_constant(EFST_VR_SPEED);
	export_constant(EFST_VR_ASPD);
	export_constant(EFST_VR_MHP);
	export_constant(EFST_VR_MSP);
	export_constant(EFST_VR_HIT);
	export_constant(EFST_VR_DEF);
	export_constant(EFST_VR_MDEF);
	export_constant(EFST_VR_BOOK001);
	export_constant(EFST_VR_BOOK002);
	export_constant(EFST_VR_BOOK003);
	export_constant(EFST_VR_BOOK004);
	export_constant(EFST_REUSE_LIMIT_VR_BOOK);
	export_constant(EFST_VR_BOOK005);
	export_constant(EFST_VR_BOOK006);
	export_constant(EFST_VR_BOOK007);
	export_constant(EFST_VR_BOOK008);
	export_constant(EFST_VR_BOOK009);
	export_constant(EFST_ALL_T_STAT);
	export_constant(EFST_P_ATK_PLUS);
	export_constant(EFST_S_MATK_PLUS);
	export_constant(EFST_C_RATE_PLUS);
	export_constant(EFST_RESIST_PLUS);
	export_constant(EFST_PVP_DUN_BUFF);
	export_constant(EFST_TARGET_MARKER);
	export_constant(EFST_BLOCK_SEAL);
	export_constant(EFST_FROST_STORM);
	export_constant(EFST_GROGGY);
	export_constant(EFST_WARM_SHIELD);
	export_constant(EFST_CONTENTS_1);
	export_constant(EFST_CONTENTS_2);
	export_constant(EFST_CONTENTS_3);
	export_constant(EFST_CONTENTS_4);
	export_constant(EFST_CONTENTS_5);
	export_constant(EFST_CONTENTS_6);
	export_constant(EFST_CONTENTS_7);
	export_constant(EFST_CONTENTS_8);
	export_constant(EFST_CONTENTS_9);
	export_constant(EFST_CONTENTS_10);
	export_constant(EFST_CONTENTS_11);
	export_constant(EFST_CONTENTS_12);
	export_constant(EFST_CONTENTS_13);
	export_constant(EFST_CONTENTS_14);
	export_constant(EFST_CONTENTS_15);
	export_constant(EFST_CONTENTS_16);
	export_constant(EFST_CONTENTS_17);
	export_constant(EFST_CONTENTS_18);
	export_constant(EFST_CONTENTS_19);
	export_constant(EFST_CONTENTS_20);
	export_constant(EFST_CONTENTS_21);
	export_constant(EFST_CONTENTS_22);
	export_constant(EFST_CONTENTS_23);
	export_constant(EFST_CONTENTS_24);
	export_constant(EFST_CONTENTS_25);
	export_constant(EFST_C_BUFF_1);
	export_constant(EFST_C_BUFF_2);
	export_constant(EFST_CHASING);
	export_constant(EFST_MYSTERY_POWDER);
	export_constant(EFST_FIRE_CHARM_POWER);
	export_constant(EFST_WATER_CHARM_POWER);
	export_constant(EFST_WIND_CHARM_POWER);
	export_constant(EFST_GROUND_CHARM_POWER);
/// @APIHOOK_END
/// Do not modify code above this, since it will be automatically generated by the API again
	export_constant(EFST_MAX);

	/* elements */
	export_constant(ELE_NEUTRAL);
	export_constant(ELE_WATER);
	export_constant(ELE_EARTH);
	export_constant(ELE_FIRE);
	export_constant(ELE_WIND);
	export_constant(ELE_POISON);
	export_constant(ELE_HOLY);
	export_constant(ELE_DARK);
	export_constant(ELE_GHOST);
	export_constant(ELE_UNDEAD);
	export_constant(ELE_ALL);
	export_constant(ELE_WEAPON);
	export_constant(ELE_ENDOWED);
	export_constant(ELE_RANDOM);

	/* races */
	export_constant(RC_FORMLESS);
	export_constant(RC_UNDEAD);
	export_constant(RC_BRUTE);
	export_constant(RC_PLANT);
	export_constant(RC_INSECT);
	export_constant(RC_FISH);
	export_constant(RC_DEMON);
	export_constant(RC_DEMIHUMAN);
	export_constant(RC_ANGEL);
	export_constant(RC_DRAGON);
	export_constant(RC_PLAYER_HUMAN);
	export_constant(RC_PLAYER_DORAM);
	export_constant(RC_ALL);

	export_constant(RC2_NONE);
	export_constant(RC2_GOBLIN);
	export_constant(RC2_KOBOLD);
	export_constant(RC2_ORC);
	export_constant(RC2_GOLEM);
	export_constant(RC2_NINJA);
	export_constant(RC2_GVG);
	export_constant(RC2_TREASURE);
	export_constant(RC2_BIOLAB);
	export_constant(RC2_MANUK);
	export_constant(RC2_SPLENDIDE);
	export_constant(RC2_SCARABA);
	export_constant(RC2_OGH_ATK_DEF);
	export_constant(RC2_OGH_HIDDEN);
	export_constant(RC2_BIO5_SWORDMAN_THIEF);
	export_constant(RC2_BIO5_ACOLYTE_MERCHANT);
	export_constant(RC2_BIO5_MAGE_ARCHER);
	export_constant(RC2_BIO5_MVP);
	export_constant(RC2_CLOCKTOWER);
	export_constant(RC2_THANATOS);
	export_constant(RC2_FACEWORM);
	export_constant(RC2_HEARTHUNTER);
	export_constant(RC2_ROCKRIDGE);
	export_constant(RC2_WERNER_LAB);
	export_constant(RC2_TEMPLE_DEMON);
	export_constant(RC2_ILLUSION_VAMPIRE);
	export_constant(RC2_MALANGDO);
	export_constant(RC2_EP172ALPHA);
	export_constant(RC2_EP172BETA);
	export_constant(RC2_EP172BATH);
	export_constant(RC2_ILLUSION_TURTLE);
	export_constant(RC2_RACHEL_SANCTUARY);
	export_constant(RC2_ILLUSION_LUANDA);
	export_constant(RC2_ILLUSION_FROZEN);
	export_constant(RC2_ILLUSION_MOONLIGHT);
	export_constant(RC2_EP16_DEF);
	export_constant(RC2_EDDA_ARUNAFELTZ);
	export_constant(RC2_MAX);

	/* monster ai */
	export_constant(MONSTER_TYPE_01);
	export_constant(MONSTER_TYPE_02);
	export_constant(MONSTER_TYPE_03);
	export_constant(MONSTER_TYPE_04);
	export_constant(MONSTER_TYPE_05);
	export_constant(MONSTER_TYPE_06);
	export_constant(MONSTER_TYPE_07);
	export_constant(MONSTER_TYPE_08);
	export_constant(MONSTER_TYPE_09);
	export_constant(MONSTER_TYPE_10);
	export_constant(MONSTER_TYPE_11);
	export_constant(MONSTER_TYPE_12);
	export_constant(MONSTER_TYPE_13);
	export_constant(MONSTER_TYPE_17);
	export_constant(MONSTER_TYPE_19);
	export_constant(MONSTER_TYPE_20);
	export_constant(MONSTER_TYPE_21);
	export_constant(MONSTER_TYPE_24);
	export_constant(MONSTER_TYPE_25);
	export_constant(MONSTER_TYPE_26);
	export_constant(MONSTER_TYPE_27);

	/* classes */
	export_constant(CLASS_NONE);
	export_constant(CLASS_NORMAL);
	export_constant(CLASS_BOSS);
	export_constant(CLASS_GUARDIAN);
	export_constant(CLASS_BATTLEFIELD);
	export_constant(CLASS_EVENT);
	export_constant(CLASS_ALL);
	export_constant(CLASS_MAX);

	/* sizes */
	export_constant2("Size_Small",SZ_SMALL);
	export_constant2("Size_Medium",SZ_MEDIUM);
	export_constant2("Size_Large",SZ_BIG);
	export_constant2("Size_All",SZ_ALL);

	/* ai */
	export_constant(AI_NONE);
	export_constant(AI_ATTACK);
	export_constant(AI_SPHERE);
	export_constant(AI_FLORA);
	export_constant(AI_ZANZOU);
	export_constant(AI_LEGION);
	export_constant(AI_FAW);
	export_constant(AI_GUILD);
	export_constant(AI_WAVEMODE);
	export_constant(AI_ABR);
	export_constant(AI_BIONIC);

	/* battle flags */
	export_constant(BF_NONE);
	export_constant(BF_WEAPON);
	export_constant(BF_MAGIC);
	export_constant(BF_MISC);
	export_constant(BF_SHORT);
	export_constant(BF_LONG);
	export_constant(BF_SKILL);
	export_constant(BF_NORMAL);

	/* auto trigger flags */
	export_constant(ATF_SELF);
	export_constant(ATF_TARGET);
	export_constant(ATF_SHORT);
	export_constant(ATF_LONG);
	export_constant(ATF_WEAPON);
	export_constant(ATF_MAGIC);
	export_constant(ATF_MISC);
	// TODO: Check why this was in const.yml, but not on source side
	export_constant2("ATF_SKILL",ATF_MAGIC|ATF_MISC);

	/* emoticons */
	export_constant(ET_SURPRISE);
	export_constant(ET_QUESTION);
	export_constant(ET_DELIGHT);
	export_constant(ET_THROB);
	export_constant(ET_SWEAT);
	export_constant(ET_AHA);
	export_constant(ET_FRET);
	export_constant(ET_ANGER);
	export_constant(ET_MONEY);
	export_constant(ET_THINK);
	export_constant(ET_SCISSOR);
	export_constant(ET_ROCK);
	export_constant(ET_WRAP);
	export_constant(ET_FLAG);
	export_constant(ET_BIGTHROB);
	export_constant(ET_THANKS);
	export_constant(ET_KEK);
	export_constant(ET_SORRY);
	export_constant(ET_SMILE);
	export_constant(ET_PROFUSELY_SWEAT);
	export_constant(ET_SCRATCH);
	export_constant(ET_BEST);
	export_constant(ET_STARE_ABOUT);
	export_constant(ET_HUK);
	export_constant(ET_O);
	export_constant(ET_X);
	export_constant(ET_HELP);
	export_constant(ET_GO);
	export_constant(ET_CRY);
	export_constant(ET_KIK);
	export_constant(ET_CHUP);
	export_constant(ET_CHUPCHUP);
	export_constant(ET_HNG);
	export_constant(ET_OK);
	export_constant(ET_CHAT_PROHIBIT);
	export_constant(ET_INDONESIA_FLAG);
	export_constant(ET_STARE);
	export_constant(ET_HUNGRY);
	export_constant(ET_COOL);
	export_constant(ET_MERONG);
	export_constant(ET_SHY);
	export_constant(ET_GOODBOY);
	export_constant(ET_SPTIME);
	export_constant(ET_SEXY);
	export_constant(ET_COMEON);
	export_constant(ET_SLEEPY);
	export_constant(ET_CONGRATULATION);
	export_constant(ET_HPTIME);
	export_constant(ET_PH_FLAG);
	export_constant(ET_MY_FLAG);
	export_constant(ET_SI_FLAG);
	export_constant(ET_BR_FLAG);
	export_constant(ET_SPARK);
	export_constant(ET_CONFUSE);
	export_constant(ET_OHNO);
	export_constant(ET_HUM);
	export_constant(ET_BLABLA);
	export_constant(ET_OTL);
	export_constant(ET_DICE1);
	export_constant(ET_DICE2);
	export_constant(ET_DICE3);
	export_constant(ET_DICE4);
	export_constant(ET_DICE5);
	export_constant(ET_DICE6);
	export_constant(ET_INDIA_FLAG);
	export_constant(ET_LUV);
	export_constant(ET_FLAG8);
	export_constant(ET_FLAG9);
	export_constant(ET_MOBILE);
	export_constant(ET_MAIL);
	export_constant(ET_ANTENNA0);
	export_constant(ET_ANTENNA1);
	export_constant(ET_ANTENNA2);
	export_constant(ET_ANTENNA3);
	export_constant(ET_HUM2);
	export_constant(ET_ABS);
	export_constant(ET_OOPS);
	export_constant(ET_SPIT);
	export_constant(ET_ENE);
	export_constant(ET_PANIC);
	export_constant(ET_WHISP);
	export_constant(ET_YUT1);
	export_constant(ET_YUT2);
	export_constant(ET_YUT3);
	export_constant(ET_YUT4);
	export_constant(ET_YUT5);
	export_constant(ET_YUT6);
	export_constant(ET_YUT7);

	/* send targets */
	export_constant(ALL_CLIENT);
	export_constant(ALL_SAMEMAP);
	export_constant(AREA);
	export_constant(AREA_WOS);
	export_constant(AREA_WOC);
	export_constant(AREA_WOSC);
	export_constant(AREA_CHAT_WOC);
	export_constant(CHAT);
	export_constant(CHAT_WOS);
	export_constant(PARTY);
	export_constant(PARTY_WOS);
	export_constant(PARTY_SAMEMAP);
	export_constant(PARTY_SAMEMAP_WOS);
	export_constant(PARTY_AREA);
	export_constant(PARTY_AREA_WOS);
	export_constant(GUILD);
	export_constant(GUILD_WOS);
	export_constant(GUILD_SAMEMAP);
	export_constant(GUILD_SAMEMAP_WOS);
	export_constant(GUILD_AREA);
	export_constant(GUILD_AREA_WOS);
	export_constant(GUILD_NOBG);
	export_constant(DUEL);
	export_constant(DUEL_WOS);
	export_constant(SELF);
	export_constant(BG);
	export_constant(BG_WOS);
	export_constant(BG_SAMEMAP);
	export_constant(BG_SAMEMAP_WOS);
	export_constant(BG_AREA);
	export_constant(BG_AREA_WOS);
	export_constant(CLAN);

	/* mercenary guilds */
	export_constant(ARCH_MERC_GUILD);
	export_constant(SPEAR_MERC_GUILD);
	export_constant(SWORD_MERC_GUILD);

	/* item types */
	export_constant(IT_HEALING);
	export_constant(IT_USABLE);
	export_constant(IT_ETC);
	export_constant(IT_ARMOR);
	export_constant(IT_WEAPON);
	export_constant(IT_CARD);
	export_constant(IT_PETEGG);
	export_constant(IT_PETARMOR);
	export_constant(IT_AMMO);
	export_constant(IT_DELAYCONSUME);
	export_constant(IT_SHADOWGEAR);
	export_constant(IT_CASH);

	/* weapon types */
	export_constant(W_FIST);
	export_constant(W_DAGGER);
	export_constant(W_1HSWORD);
	export_constant(W_2HSWORD);
	export_constant(W_1HSPEAR);
	export_constant(W_2HSPEAR);
	export_constant(W_1HAXE);
	export_constant(W_2HAXE);
	export_constant(W_MACE);
	export_constant(W_2HMACE);
	export_constant(W_STAFF);
	export_constant(W_BOW);
	export_constant(W_KNUCKLE);
	export_constant(W_MUSICAL);
	export_constant(W_WHIP);
	export_constant(W_BOOK);
	export_constant(W_KATAR);
	export_constant(W_REVOLVER);
	export_constant(W_RIFLE);
	export_constant(W_GATLING);
	export_constant(W_SHOTGUN);
	export_constant(W_GRENADE);
	export_constant(W_HUUMA);
	export_constant(W_2HSTAFF);
	export_constant(MAX_WEAPON_TYPE);
	export_constant(W_DOUBLE_DD);
	export_constant(W_DOUBLE_SS);
	export_constant(W_DOUBLE_AA);
	export_constant(W_DOUBLE_DS);
	export_constant(W_DOUBLE_DA);
	export_constant(W_DOUBLE_SA);
	export_constant(MAX_WEAPON_TYPE_ALL);
	export_constant(W_SHIELD);

	/* ammunition types */
	export_constant(AMMO_ARROW);
	export_constant(AMMO_DAGGER);
	export_constant(AMMO_BULLET);
	export_constant(AMMO_SHELL);
	export_constant(AMMO_GRENADE);
	export_constant(AMMO_SHURIKEN);
	export_constant(AMMO_KUNAI);
	export_constant(AMMO_CANNONBALL);
	export_constant(AMMO_THROWWEAPON);
	export_constant(MAX_AMMO_TYPE);

	/* card subtypes */
	export_constant(CARD_NORMAL);
	export_constant(CARD_ENCHANT);

	/* monsterinfo types */
	export_constant(MOB_NAME);
	export_constant(MOB_LV);
	export_constant(MOB_MAXHP);
	export_constant(MOB_BASEEXP);
	export_constant(MOB_JOBEXP);
	export_constant(MOB_ATK1);
	export_constant(MOB_ATK2);
	export_constant(MOB_DEF);
	export_constant(MOB_MDEF);
	export_constant(MOB_RES);
	export_constant(MOB_MRES);
	export_constant(MOB_STR);
	export_constant(MOB_AGI);
	export_constant(MOB_VIT);
	export_constant(MOB_INT);
	export_constant(MOB_DEX);
	export_constant(MOB_LUK);
	export_constant(MOB_RANGE);
	export_constant(MOB_RANGE2);
	export_constant(MOB_RANGE3);
	export_constant(MOB_SIZE);
	export_constant(MOB_RACE);
	export_constant(MOB_ELEMENT);
	export_constant(MOB_MODE);
	export_constant(MOB_MVPEXP);
	export_constant(MOB_ID);

	/* petinfo types */
	export_constant(PETINFO_ID);
	export_constant(PETINFO_CLASS);
	export_constant(PETINFO_NAME);
	export_constant(PETINFO_INTIMATE);
	export_constant(PETINFO_HUNGRY);
	export_constant(PETINFO_RENAMED);
	export_constant(PETINFO_LEVEL);
	export_constant(PETINFO_BLOCKID);
	export_constant(PETINFO_EGGID);
	export_constant(PETINFO_FOODID);

	// For backwards compatability - might be removed in the near future
	export_constant2("PET_ID",PETINFO_ID);
	export_constant2("PET_CLASS",PETINFO_CLASS);
	export_constant2("PET_NAME",PETINFO_NAME);
	export_constant2("PET_INTIMATE",PETINFO_INTIMATE);
	export_constant2("PET_HUNGRY",PETINFO_HUNGRY);
	export_constant2("PET_RENAMED",PETINFO_RENAMED);
	export_constant2("PET_LEVEL",PETINFO_LEVEL);

	/* questinfo types */
	export_constant(QTYPE_QUEST);
	export_constant(QTYPE_QUEST2);
	export_constant(QTYPE_JOB);
	export_constant(QTYPE_JOB2);
	export_constant(QTYPE_EVENT);
	export_constant(QTYPE_EVENT2);
	export_constant(QTYPE_WARG);
	export_constant(QTYPE_CLICKME);
	export_constant(QTYPE_DAILYQUEST);
	export_constant(QTYPE_WARG2);
	export_constant(QTYPE_EVENT3);
	export_constant(QTYPE_JOBQUEST);
	export_constant(QTYPE_JUMPING_PORING);
	export_constant(QTYPE_NONE);

	/* questinfo Map Mark Color */
	export_constant(QMARK_NONE);
	export_constant(QMARK_YELLOW);
	export_constant(QMARK_GREEN);
	export_constant(QMARK_PURPLE);

	/* font weight types */
	export_constant(FW_DONTCARE);
	export_constant(FW_THIN);
	export_constant(FW_EXTRALIGHT);
	export_constant(FW_LIGHT);
	export_constant(FW_NORMAL);
	export_constant(FW_MEDIUM);
	export_constant(FW_SEMIBOLD);
	export_constant(FW_BOLD);
	export_constant(FW_EXTRABOLD);
	export_constant(FW_HEAVY);

	/* add skill types */
	export_constant2("SKILL_PERM",ADDSKILL_PERMANENT);
	export_constant2("SKILL_TEMP",ADDSKILL_TEMP);
	export_constant2("SKILL_TEMPLEVEL",ADDSKILL_TEMP_ADDLEVEL);
	export_constant2("SKILL_PERM_GRANT",ADDSKILL_PERMANENT_GRANTED);

	/* bonus script flags */
	export_constant(BSF_REM_ON_DEAD);
	export_constant(BSF_REM_ON_DISPELL);
	export_constant(BSF_REM_ON_CLEARANCE);
	export_constant(BSF_REM_ON_LOGOUT);
	export_constant(BSF_REM_ON_BANISHING_BUSTER);
	export_constant(BSF_REM_ON_REFRESH);
	export_constant(BSF_REM_ON_LUXANIMA);
	export_constant(BSF_REM_ON_MADOGEAR);
	export_constant(BSF_REM_ON_DAMAGED);
	export_constant(BSF_PERMANENT);
	export_constant(BSF_FORCE_REPLACE);
	export_constant(BSF_FORCE_DUPLICATE);

	/* bindings */
	export_constant(BOUND_NONE);
	export_constant(BOUND_ACCOUNT);
	export_constant(BOUND_GUILD);
	export_constant(BOUND_PARTY);
	export_constant(BOUND_CHAR);

	/* quest check types */
	export_constant(HAVEQUEST);
	export_constant(PLAYTIME);
	export_constant(HUNTING);

	/* status options */
	export_constant(OPTION_NOTHING);
	export_constant(OPTION_SIGHT);
	export_constant(OPTION_HIDE);
	export_constant(OPTION_CLOAK);
	export_constant(OPTION_CART1);
	export_constant(OPTION_FALCON);
	export_constant(OPTION_RIDING);
	export_constant(OPTION_INVISIBLE);
	export_constant(OPTION_CART2);
	export_constant(OPTION_CART3);
	export_constant(OPTION_CART4);
	export_constant(OPTION_CART5);
	export_constant(OPTION_ORCISH);
	export_constant(OPTION_WEDDING);
	export_constant(OPTION_RUWACH);
	export_constant(OPTION_CHASEWALK);
	export_constant(OPTION_FLYING);
	export_constant(OPTION_XMAS);
	export_constant(OPTION_TRANSFORM);
	export_constant(OPTION_SUMMER);
	export_constant(OPTION_DRAGON1);
	export_constant(OPTION_WUG);
	export_constant(OPTION_WUGRIDER);
	export_constant(OPTION_MADOGEAR);
	export_constant(OPTION_DRAGON2);
	export_constant(OPTION_DRAGON3);
	export_constant(OPTION_DRAGON4);
	export_constant(OPTION_DRAGON5);
	export_constant(OPTION_HANBOK);
	export_constant(OPTION_OKTOBERFEST);
	export_constant(OPTION_SUMMER2);

	/* status option compounds */
	export_constant(OPTION_DRAGON);
	export_constant(OPTION_COSTUME);

	/* sc_start flags */
	export_constant(SCSTART_NONE);
	export_constant(SCSTART_NOAVOID);
	export_constant(SCSTART_NOTICKDEF);
	export_constant(SCSTART_LOADED);
	export_constant(SCSTART_NORATEDEF);
	export_constant(SCSTART_NOICON);

	/* unit control - mob */
	export_constant(UMOB_SIZE);
	export_constant(UMOB_LEVEL);
	export_constant(UMOB_HP);
	export_constant(UMOB_MAXHP);
	export_constant(UMOB_MASTERAID);
	export_constant(UMOB_MAPID);
	export_constant(UMOB_X);
	export_constant(UMOB_Y);
	export_constant(UMOB_SPEED);
	export_constant(UMOB_MODE);
	export_constant(UMOB_AI);
	export_constant(UMOB_SCOPTION);
	export_constant(UMOB_SEX);
	export_constant(UMOB_CLASS);
	export_constant(UMOB_HAIRSTYLE);
	export_constant(UMOB_HAIRCOLOR);
	export_constant(UMOB_HEADBOTTOM);
	export_constant(UMOB_HEADMIDDLE);
	export_constant(UMOB_HEADTOP);
	export_constant(UMOB_CLOTHCOLOR);
	export_constant(UMOB_SHIELD);
	export_constant(UMOB_WEAPON);
	export_constant(UMOB_LOOKDIR);
	export_constant(UMOB_CANMOVETICK);
	export_constant(UMOB_STR);
	export_constant(UMOB_AGI);
	export_constant(UMOB_VIT);
	export_constant(UMOB_INT);
	export_constant(UMOB_DEX);
	export_constant(UMOB_LUK);
	export_constant(UMOB_SLAVECPYMSTRMD);
	export_constant(UMOB_DMGIMMUNE);
	export_constant(UMOB_ATKRANGE);
	export_constant(UMOB_ATKMIN);
	export_constant(UMOB_ATKMAX);
	export_constant(UMOB_MATKMIN);
	export_constant(UMOB_MATKMAX);
	export_constant(UMOB_DEF);
	export_constant(UMOB_MDEF);
	export_constant(UMOB_HIT);
	export_constant(UMOB_FLEE);
	export_constant(UMOB_PDODGE);
	export_constant(UMOB_CRIT);
	export_constant(UMOB_RACE);
	export_constant(UMOB_ELETYPE);
	export_constant(UMOB_ELELEVEL);
	export_constant(UMOB_AMOTION);
	export_constant(UMOB_ADELAY);
	export_constant(UMOB_DMOTION);
	export_constant(UMOB_TARGETID);
	export_constant(UMOB_ROBE);
	export_constant(UMOB_BODY2);
	export_constant(UMOB_GROUP_ID);
	export_constant(UMOB_IGNORE_CELL_STACK_LIMIT);
	export_constant(UMOB_RES);
	export_constant(UMOB_MRES);
	export_constant(UMOB_DAMAGETAKEN);

	/* unit control - homunculus */
	export_constant(UHOM_SIZE);
	export_constant(UHOM_LEVEL);
	export_constant(UHOM_HP);
	export_constant(UHOM_MAXHP);
	export_constant(UHOM_SP);
	export_constant(UHOM_MAXSP);
	export_constant(UHOM_MASTERCID);
	export_constant(UHOM_MAPID);
	export_constant(UHOM_X);
	export_constant(UHOM_Y);
	export_constant(UHOM_HUNGER);
	export_constant(UHOM_INTIMACY);
	export_constant(UHOM_SPEED);
	export_constant(UHOM_LOOKDIR);
	export_constant(UHOM_CANMOVETICK);
	export_constant(UHOM_STR);
	export_constant(UHOM_AGI);
	export_constant(UHOM_VIT);
	export_constant(UHOM_INT);
	export_constant(UHOM_DEX);
	export_constant(UHOM_LUK);
	export_constant(UHOM_DMGIMMUNE);
	export_constant(UHOM_ATKRANGE);
	export_constant(UHOM_ATKMIN);
	export_constant(UHOM_ATKMAX);
	export_constant(UHOM_MATKMIN);
	export_constant(UHOM_MATKMAX);
	export_constant(UHOM_DEF);
	export_constant(UHOM_MDEF);
	export_constant(UHOM_HIT);
	export_constant(UHOM_FLEE);
	export_constant(UHOM_PDODGE);
	export_constant(UHOM_CRIT);
	export_constant(UHOM_RACE);
	export_constant(UHOM_ELETYPE);
	export_constant(UHOM_ELELEVEL);
	export_constant(UHOM_AMOTION);
	export_constant(UHOM_ADELAY);
	export_constant(UHOM_DMOTION);
	export_constant(UHOM_TARGETID);
	export_constant(UHOM_GROUP_ID);

	/* unit control - pet */
	export_constant(UPET_SIZE);
	export_constant(UPET_LEVEL);
	export_constant(UPET_HP);
	export_constant(UPET_MAXHP);
	export_constant(UPET_MASTERAID);
	export_constant(UPET_MAPID);
	export_constant(UPET_X);
	export_constant(UPET_Y);
	export_constant(UPET_HUNGER);
	export_constant(UPET_INTIMACY);
	export_constant(UPET_SPEED);
	export_constant(UPET_LOOKDIR);
	export_constant(UPET_CANMOVETICK);
	export_constant(UPET_STR);
	export_constant(UPET_AGI);
	export_constant(UPET_VIT);
	export_constant(UPET_INT);
	export_constant(UPET_DEX);
	export_constant(UPET_LUK);
	export_constant(UPET_DMGIMMUNE);
	export_constant(UPET_ATKRANGE);
	export_constant(UPET_ATKMIN);
	export_constant(UPET_ATKMAX);
	export_constant(UPET_MATKMIN);
	export_constant(UPET_MATKMAX);
	export_constant(UPET_DEF);
	export_constant(UPET_MDEF);
	export_constant(UPET_HIT);
	export_constant(UPET_FLEE);
	export_constant(UPET_PDODGE);
	export_constant(UPET_CRIT);
	export_constant(UPET_RACE);
	export_constant(UPET_ELETYPE);
	export_constant(UPET_ELELEVEL);
	export_constant(UPET_AMOTION);
	export_constant(UPET_ADELAY);
	export_constant(UPET_DMOTION);
	export_constant(UPET_GROUP_ID);

	/* unit control - mercenary */
	export_constant(UMER_SIZE);
	export_constant(UMER_HP);
	export_constant(UMER_MAXHP);
	export_constant(UMER_MASTERCID);
	export_constant(UMER_MAPID);
	export_constant(UMER_X);
	export_constant(UMER_Y);
	export_constant(UMER_KILLCOUNT);
	export_constant(UMER_LIFETIME);
	export_constant(UMER_SPEED);
	export_constant(UMER_LOOKDIR);
	export_constant(UMER_CANMOVETICK);
	export_constant(UMER_STR);
	export_constant(UMER_AGI);
	export_constant(UMER_VIT);
	export_constant(UMER_INT);
	export_constant(UMER_DEX);
	export_constant(UMER_LUK);
	export_constant(UMER_DMGIMMUNE);
	export_constant(UMER_ATKRANGE);
	export_constant(UMER_ATKMIN);
	export_constant(UMER_ATKMAX);
	export_constant(UMER_MATKMIN);
	export_constant(UMER_MATKMAX);
	export_constant(UMER_DEF);
	export_constant(UMER_MDEF);
	export_constant(UMER_HIT);
	export_constant(UMER_FLEE);
	export_constant(UMER_PDODGE);
	export_constant(UMER_CRIT);
	export_constant(UMER_RACE);
	export_constant(UMER_ELETYPE);
	export_constant(UMER_ELELEVEL);
	export_constant(UMER_AMOTION);
	export_constant(UMER_ADELAY);
	export_constant(UMER_DMOTION);
	export_constant(UMER_TARGETID);
	export_constant(UMER_GROUP_ID);

	/* unit control - elemental */
	export_constant(UELE_SIZE);
	export_constant(UELE_HP);
	export_constant(UELE_MAXHP);
	export_constant(UELE_SP);
	export_constant(UELE_MAXSP);
	export_constant(UELE_MASTERCID);
	export_constant(UELE_MAPID);
	export_constant(UELE_X);
	export_constant(UELE_Y);
	export_constant(UELE_LIFETIME);
	export_constant(UELE_MODE);
	export_constant(UELE_SPEED);
	export_constant(UELE_LOOKDIR);
	export_constant(UELE_CANMOVETICK);
	export_constant(UELE_STR);
	export_constant(UELE_AGI);
	export_constant(UELE_VIT);
	export_constant(UELE_INT);
	export_constant(UELE_DEX);
	export_constant(UELE_LUK);
	export_constant(UELE_DMGIMMUNE);
	export_constant(UELE_ATKRANGE);
	export_constant(UELE_ATKMIN);
	export_constant(UELE_ATKMAX);
	export_constant(UELE_MATKMIN);
	export_constant(UELE_MATKMAX);
	export_constant(UELE_DEF);
	export_constant(UELE_MDEF);
	export_constant(UELE_HIT);
	export_constant(UELE_FLEE);
	export_constant(UELE_PDODGE);
	export_constant(UELE_CRIT);
	export_constant(UELE_RACE);
	export_constant(UELE_ELETYPE);
	export_constant(UELE_ELELEVEL);
	export_constant(UELE_AMOTION);
	export_constant(UELE_ADELAY);
	export_constant(UELE_DMOTION);
	export_constant(UELE_TARGETID);
	export_constant(UELE_GROUP_ID);

	/* unit control - NPC */
	export_constant(UNPC_LEVEL);
	export_constant(UNPC_HP);
	export_constant(UNPC_MAXHP);
	export_constant(UNPC_MAPID);
	export_constant(UNPC_X);
	export_constant(UNPC_Y);
	export_constant(UNPC_LOOKDIR);
	export_constant(UNPC_STR);
	export_constant(UNPC_AGI);
	export_constant(UNPC_VIT);
	export_constant(UNPC_INT);
	export_constant(UNPC_DEX);
	export_constant(UNPC_LUK);
	export_constant(UNPC_PLUSALLSTAT);
	export_constant(UNPC_DMGIMMUNE);
	export_constant(UNPC_ATKRANGE);
	export_constant(UNPC_ATKMIN);
	export_constant(UNPC_ATKMAX);
	export_constant(UNPC_MATKMIN);
	export_constant(UNPC_MATKMAX);
	export_constant(UNPC_DEF);
	export_constant(UNPC_MDEF);
	export_constant(UNPC_HIT);
	export_constant(UNPC_FLEE);
	export_constant(UNPC_PDODGE);
	export_constant(UNPC_CRIT);
	export_constant(UNPC_RACE);
	export_constant(UNPC_ELETYPE);
	export_constant(UNPC_ELELEVEL);
	export_constant(UNPC_AMOTION);
	export_constant(UNPC_ADELAY);
	export_constant(UNPC_DMOTION);
	export_constant(UNPC_SEX);
	export_constant(UNPC_CLASS);
	export_constant(UNPC_HAIRSTYLE);
	export_constant(UNPC_HAIRCOLOR);
	export_constant(UNPC_HEADBOTTOM);
	export_constant(UNPC_HEADMIDDLE);
	export_constant(UNPC_HEADTOP);
	export_constant(UNPC_CLOTHCOLOR);
	export_constant(UNPC_SHIELD);
	export_constant(UNPC_WEAPON);
	export_constant(UNPC_ROBE);
	export_constant(UNPC_BODY2);
	export_constant(UNPC_DEADSIT);
	export_constant(UNPC_GROUP_ID);

	export_constant(NAV_NONE);
	export_constant(NAV_AIRSHIP_ONLY);
	export_constant(NAV_SCROLL_ONLY);
	export_constant(NAV_AIRSHIP_AND_SCROLL);
	export_constant(NAV_KAFRA_ONLY);
	export_constant(NAV_KAFRA_AND_AIRSHIP);
	export_constant(NAV_KAFRA_AND_SCROLL);
	export_constant(NAV_ALL);

	export_constant(ADOPT_ALLOWED);
	export_constant(ADOPT_ALREADY_ADOPTED);
	export_constant(ADOPT_MARRIED_AND_PARTY);
	export_constant(ADOPT_EQUIP_RINGS);
	export_constant(ADOPT_NOT_NOVICE);
	export_constant(ADOPT_CHARACTER_NOT_FOUND);
	export_constant(ADOPT_MORE_CHILDREN);
	export_constant(ADOPT_LEVEL_70);
	export_constant(ADOPT_MARRIED);
	
	/* directions */
	export_constant(DIR_NORTH);
	export_constant(DIR_NORTHWEST);
	export_constant(DIR_WEST);
	export_constant(DIR_SOUTHWEST);
	export_constant(DIR_SOUTH);
	export_constant(DIR_SOUTHEAST);
	export_constant(DIR_EAST);
	export_constant(DIR_NORTHEAST);

	/* instance modes */
	export_constant(IM_NONE);
	export_constant(IM_CHAR);
	export_constant(IM_PARTY);
	export_constant(IM_GUILD);
	export_constant(IM_CLAN);

	/* mob random groups */
	export_constant(MOBG_BRANCH_OF_DEAD_TREE);
	export_constant(MOBG_PORING_BOX);
	export_constant(MOBG_BLOODY_DEAD_BRANCH);
	export_constant(MOBG_RED_POUCH_OF_SURPRISE);
	export_constant(MOBG_CLASSCHANGE);
	export_constant(MOBG_TAEKWON_MISSION);

	/* mob random groups flags */
	export_constant(RMF_NONE);
	export_constant(RMF_DB_RATE);
	export_constant(RMF_CHECK_MOB_LV);
	export_constant(RMF_MOB_NOT_BOSS);
	export_constant(RMF_MOB_NOT_SPAWN);
	export_constant(RMF_MOB_NOT_PLANT);
	export_constant(RMF_ALL);

	/* random option attributes */
	export_constant(ROA_ID);
	export_constant(ROA_VALUE);
	export_constant(ROA_PARAM);

	/* special card flags */
	export_constant(CARD0_FORGE);
	export_constant(CARD0_CREATE);
	export_constant(CARD0_PET);

	/* Channel System */
	export_constant(CHAN_TYPE_PUBLIC);
	export_constant(CHAN_TYPE_PRIVATE);
	export_constant(CHAN_TYPE_MAP);
	export_constant(CHAN_TYPE_ALLY);
	export_constant(CHAN_OPT_BASE);
	export_constant(CHAN_OPT_ANNOUNCE_SELF);
	export_constant(CHAN_OPT_ANNOUNCE_JOIN);
	export_constant(CHAN_OPT_ANNOUNCE_LEAVE);
	export_constant(CHAN_OPT_MSG_DELAY);
	export_constant(CHAN_OPT_COLOR_OVERRIDE);
	export_constant(CHAN_OPT_CAN_CHAT);
	export_constant(CHAN_OPT_CAN_LEAVE);
	export_constant(CHAN_OPT_AUTOJOIN);

	export_constant(STOR_MODE_NONE);
	export_constant(STOR_MODE_GET);
	export_constant(STOR_MODE_PUT);
	export_constant(STOR_MODE_ALL);

	/* instance enter */
	export_constant(IE_OK);
	export_constant(IE_NOMEMBER);
	export_constant(IE_NOINSTANCE);
	export_constant(IE_OTHER);
	
	/* months */
	export_constant(JANUARY);
	export_constant(FEBRUARY);
	export_constant(MARCH);
	export_constant(APRIL);
	export_constant(MAY);
	export_constant(JUNE);
	export_constant(JULY);
	export_constant(AUGUST);
	export_constant(SEPTEMBER);
	export_constant(OCTOBER);
	export_constant(NOVEMBER);
	export_constant(DECEMBER);
	
	/* days of the week */
	export_constant(SUNDAY);
	export_constant(MONDAY);
	export_constant(TUESDAY);
	export_constant(WEDNESDAY);
	export_constant(THURSDAY);
	export_constant(FRIDAY);
	export_constant(SATURDAY);
	
	/* date types */
	export_constant(DT_SECOND);
	export_constant(DT_MINUTE);
	export_constant(DT_HOUR);
	export_constant(DT_DAYOFWEEK);
	export_constant(DT_DAYOFMONTH);
	export_constant(DT_MONTH);
	export_constant(DT_YEAR);
	export_constant(DT_DAYOFYEAR);
	export_constant(DT_YYYYMMDD);

	/* instance info */
	export_constant(IIT_ID);
	export_constant(IIT_TIME_LIMIT);
	export_constant(IIT_IDLE_TIMEOUT);
	export_constant(IIT_ENTER_MAP);
	export_constant(IIT_ENTER_X);
	export_constant(IIT_ENTER_Y);
	export_constant(IIT_MAPCOUNT);
	export_constant(IIT_MAP);

	/* instance live info */
	export_constant(ILI_NAME);
	export_constant(ILI_MODE);
	export_constant(ILI_OWNER);

	/* VIP status */
	export_constant(VIP_STATUS_ACTIVE);
	export_constant(VIP_STATUS_EXPIRE);
	export_constant(VIP_STATUS_REMAINING);

	/* item groups */
	export_constant(IG_BLUEBOX);
	export_constant(IG_VIOLETBOX);
	export_constant(IG_CARDALBUM);
	export_constant(IG_GIFTBOX);
	export_constant(IG_SCROLLBOX);
	export_constant(IG_FINDINGORE);
	export_constant(IG_COOKIEBAG);
	export_constant(IG_FIRSTAID);
	export_constant(IG_HERB);
	export_constant(IG_FRUIT);
	export_constant(IG_MEAT);
	export_constant(IG_CANDY);
	export_constant(IG_JUICE);
	export_constant(IG_FISH);
	export_constant(IG_BOX);
	export_constant(IG_GEMSTONE);
	export_constant(IG_RESIST);
	export_constant(IG_ORE);
	export_constant(IG_FOOD);
	export_constant(IG_RECOVERY);
	export_constant(IG_MINERAL);
	export_constant(IG_TAMING);
	export_constant(IG_SCROLL);
	export_constant(IG_QUIVER);
	export_constant(IG_MASK);
	export_constant(IG_ACCESORY);
	export_constant(IG_JEWEL);
	export_constant(IG_GIFTBOX_1);
	export_constant(IG_GIFTBOX_2);
	export_constant(IG_GIFTBOX_3);
	export_constant(IG_GIFTBOX_4);
	export_constant(IG_EGGBOY);
	export_constant(IG_EGGGIRL);
	export_constant(IG_GIFTBOXCHINA);
	export_constant(IG_LOTTOBOX);
	export_constant(IG_FOODBAG);
	export_constant(IG_POTION);
	export_constant(IG_REDBOX_2);
	export_constant(IG_BLEUBOX);
	export_constant(IG_REDBOX);
	export_constant(IG_GREENBOX);
	export_constant(IG_YELLOWBOX);
	export_constant(IG_OLDGIFTBOX);
	export_constant(IG_MAGICCARDALBUM);
	export_constant(IG_HOMETOWNGIFT);
	export_constant(IG_MASQUERADE);
	export_constant(IG_TRESURE_BOX_WOE);
	export_constant(IG_MASQUERADE_2);
	export_constant(IG_EASTER_SCROLL);
	export_constant(IG_PIERRE_TREASUREBOX);
	export_constant(IG_CHERISH_BOX);
	export_constant(IG_CHERISH_BOX_ORI);
	export_constant(IG_LOUISE_COSTUME_BOX);
	export_constant(IG_XMAS_GIFT);
	export_constant(IG_FRUIT_BASKET);
	export_constant(IG_IMPROVED_COIN_BAG);
	export_constant(IG_INTERMEDIATE_COIN_BAG);
	export_constant(IG_MINOR_COIN_BAG);
	export_constant(IG_S_GRADE_COIN_BAG);
	export_constant(IG_A_GRADE_COIN_BAG);
	export_constant(IG_ADVANCED_WEAPONS_BOX);
	export_constant(IG_SPLENDID_BOX);
	export_constant(IG_SPLENDID_BOX2);
	export_constant(IG_CARDALBUM_ARMOR);
	export_constant(IG_CARDALBUM_HELM);
	export_constant(IG_CARDALBUM_ACC);
	export_constant(IG_CARDALBUM_SHOES);
	export_constant(IG_CARDALBUM_SHIELD);
	export_constant(IG_CARDALBUM_WEAPON);
	export_constant(IG_CARDALBUM_GARMENT);
	export_constant(IG_FLAMEL_CARD);
	export_constant(IG_SPECIAL_BOX);
	export_constant(IG_RWC_PARTI_BOX);
	export_constant(IG_RWC_FINAL_COMP_BOX);
	export_constant(IG_GIFT_BUNDLE);
	export_constant(IG_CARACAS_RING_BOX);
	export_constant(IG_CRUMPLED_PAPER);
	export_constant(IG_SOLO_GIFT_BASKET);
	export_constant(IG_COUPLE_EVENT_BASKET);
	export_constant(IG_GM_WARP_BOX);
	export_constant(IG_FORTUNE_COOKIE1);
	export_constant(IG_FORTUNE_COOKIE2);
	export_constant(IG_FORTUNE_COOKIE3);
	export_constant(IG_NEW_GIFT_ENVELOPE);
	export_constant(IG_PASSION_FB_HAT_BOX);
	export_constant(IG_COOL_FB_HAT_BOX);
	export_constant(IG_VICTORY_FB_HAT_BOX);
	export_constant(IG_GLORY_FB_HAT_BOX);
	export_constant(IG_PASSION_HAT_BOX2);
	export_constant(IG_COOL_HAT_BOX2);
	export_constant(IG_VICTORY_HAT_BOX2);
	export_constant(IG_ASPERSIO_5_SCROLL_BOX);
	export_constant(IG_PET_EGG_SCROLL_BOX1);
	export_constant(IG_PET_EGG_SCROLL_BOX2);
	export_constant(IG_PET_EGG_SCROLL1);
	export_constant(IG_PET_EGG_SCROLL2);
	export_constant(IG_PET_EGG_SCROLL_BOX3);
	export_constant(IG_PET_EGG_SCROLL_BOX4);
	export_constant(IG_PET_EGG_SCROLL_BOX5);
	export_constant(IG_PET_EGG_SCROLL3);
	export_constant(IG_PET_EGG_SCROLL4);
	export_constant(IG_PET_EGG_SCROLL5);
	export_constant(IG_INFILTRATOR_BOX);
	export_constant(IG_MURAMASA_BOX);
	export_constant(IG_EXCALIBUR_BOX);
	export_constant(IG_COMBAT_KNIFE_BOX);
	export_constant(IG_COUNTER_DAGGER_BOX);
	export_constant(IG_KAISER_KNUCKLE_BOX);
	export_constant(IG_POLE_AXE_BOX);
	export_constant(IG_MIGHTY_STAFF_BOX);
	export_constant(IG_RIGHT_EPSILON_BOX);
	export_constant(IG_BALISTAR_BOX);
	export_constant(IG_DIARY_OF_GREAT_SAGE_BOX);
	export_constant(IG_ASURA_BOX);
	export_constant(IG_APPLE_OF_ARCHER_BOX);
	export_constant(IG_BUNNY_BAND_BOX);
	export_constant(IG_SAHKKAT_BOX);
	export_constant(IG_LORD_CIRCLET_BOX);
	export_constant(IG_ELVEN_EARS_BOX);
	export_constant(IG_STEEL_FLOWER_BOX);
	export_constant(IG_CRITICAL_RING_BOX);
	export_constant(IG_EARRING_BOX);
	export_constant(IG_RING_BOX);
	export_constant(IG_NECKLACE_BOX);
	export_constant(IG_GLOVE_BOX);
	export_constant(IG_BROOCH_BOX);
	export_constant(IG_ROSARY_BOX);
	export_constant(IG_SAFETY_RING_BOX);
	export_constant(IG_VESPER_CORE01_BOX);
	export_constant(IG_VESPER_CORE02_BOX);
	export_constant(IG_VESPER_CORE03_BOX);
	export_constant(IG_VESPER_CORE04_BOX);
	export_constant(IG_PET_EGG_SCROLL_BOX6);
	export_constant(IG_PET_EGG_SCROLL_BOX7);
	export_constant(IG_PET_EGG_SCROLL_BOX8);
	export_constant(IG_PET_EGG_SCROLL_BOX9);
	export_constant(IG_PET_EGG_SCROLL_BOX10);
	export_constant(IG_PET_EGG_SCROLL_BOX11);
	export_constant(IG_PET_EGG_SCROLL6);
	export_constant(IG_PET_EGG_SCROLL7);
	export_constant(IG_PET_EGG_SCROLL8);
	export_constant(IG_PET_EGG_SCROLL9);
	export_constant(IG_PET_EGG_SCROLL10);
	export_constant(IG_PET_EGG_SCROLL11);
	export_constant(IG_CP_HELM_SCROLL_BOX);
	export_constant(IG_CP_SHIELD_SCROLL_BOX);
	export_constant(IG_CP_ARMOR_SCROLL_BOX);
	export_constant(IG_CP_WEAPON_SCROLL_BOX);
	export_constant(IG_REPAIR_SCROLL_BOX);
	export_constant(IG_SUPER_PET_EGG1);
	export_constant(IG_SUPER_PET_EGG2);
	export_constant(IG_SUPER_PET_EGG3);
	export_constant(IG_SUPER_PET_EGG4);
	export_constant(IG_SUPER_CARD_PET_EGG1);
	export_constant(IG_SUPER_CARD_PET_EGG2);
	export_constant(IG_SUPER_CARD_PET_EGG3);
	export_constant(IG_SUPER_CARD_PET_EGG4);
	export_constant(IG_VIGORGRA_PACKAGE1);
	export_constant(IG_VIGORGRA_PACKAGE2);
	export_constant(IG_VIGORGRA_PACKAGE3);
	export_constant(IG_VIGORGRA_PACKAGE4);
	export_constant(IG_VIGORGRA_PACKAGE5);
	export_constant(IG_VIGORGRA_PACKAGE6);
	export_constant(IG_VIGORGRA_PACKAGE7);
	export_constant(IG_VIGORGRA_PACKAGE8);
	export_constant(IG_VIGORGRA_PACKAGE9);
	export_constant(IG_VIGORGRA_PACKAGE10);
	export_constant(IG_VIGORGRA_PACKAGE11);
	export_constant(IG_VIGORGRA_PACKAGE12);
	export_constant(IG_PET_EGG_SCROLL12);
	export_constant(IG_PET_EGG_SCROLL13);
	export_constant(IG_PET_EGG_SCROLL14);
	export_constant(IG_SUPER_PET_EGG5);
	export_constant(IG_SUPER_PET_EGG6);
	export_constant(IG_SUPER_PET_EGG7);
	export_constant(IG_SUPER_PET_EGG8);
	export_constant(IG_PET_EGG_SCROLL_E);
	export_constant(IG_RAMEN_HAT_BOX);
	export_constant(IG_MYSTERIOUS_TRAVEL_SACK1);
	export_constant(IG_MYSTERIOUS_TRAVEL_SACK2);
	export_constant(IG_MYSTERIOUS_TRAVEL_SACK3);
	export_constant(IG_MYSTERIOUS_TRAVEL_SACK4);
	export_constant(IG_MAGICIAN_CARD_BOX);
	export_constant(IG_ACOLYTE_CARD_BOX);
	export_constant(IG_ARCHER_CARD_BOX);
	export_constant(IG_SWORDMAN_CARD_BOX);
	export_constant(IG_THIEF_CARD_BOX);
	export_constant(IG_MERCHANT_CARD_BOX);
	export_constant(IG_HARD_CORE_SET_BOX);
	export_constant(IG_KITTY_SET_BOX);
	export_constant(IG_SOFT_CORE_SET_BOX);
	export_constant(IG_DEVIRUCHI_SET_BOX);
	export_constant(IG_MVP_HUNT_BOX);
	export_constant(IG_BREWING_BOX);
	export_constant(IG_XMAS_PET_SCROLL);
	export_constant(IG_LUCKY_SCROLL08);
	export_constant(IG_BR_SWORDPACKAGE);
	export_constant(IG_BR_MAGEPACKAGE);
	export_constant(IG_BR_ACOLPACKAGE);
	export_constant(IG_BR_ARCHERPACKAGE);
	export_constant(IG_BR_MERPACKAGE);
	export_constant(IG_BR_THIEFPACKAGE);
	export_constant(IG_ACIDBOMB_10_BOX);
	export_constant(IG_BASIC_SIEGE_SUPPLY_BOX);
	export_constant(IG_ADV_SIEGE_SUPPLY_BOX);
	export_constant(IG_ELITE_SIEGE_SUPPLY_BOX);
	export_constant(IG_SAKURA_SCROLL);
	export_constant(IG_BEHOLDER_RING_BOX);
	export_constant(IG_HALLOW_RING_BOX);
	export_constant(IG_CLAMOROUS_RING_BOX);
	export_constant(IG_CHEMICAL_RING_BOX);
	export_constant(IG_INSECTICIDE_RING_BOX);
	export_constant(IG_FISHER_RING_BOX);
	export_constant(IG_DECUSSATE_RING_BOX);
	export_constant(IG_BLOODY_RING_BOX);
	export_constant(IG_SATANIC_RING_BOX);
	export_constant(IG_DRAGOON_RING_BOX);
	export_constant(IG_ANGEL_SCROLL);
	export_constant(IG_DEVIL_SCROLL);
	export_constant(IG_SURPRISE_SCROLL);
	export_constant(IG_JULY7_SCROLL);
	export_constant(IG_BACSOJIN_SCROLL);
	export_constant(IG_ANIMAL_SCROLL);
	export_constant(IG_HEART_SCROLL);
	export_constant(IG_NEW_YEAR_SCROLL);
	export_constant(IG_VALENTINE_PLEDGE_BOX);
	export_constant(IG_OX_TAIL_SCROLL);
	export_constant(IG_BUDDAH_SCROLL);
	export_constant(IG_EVIL_INCARNATION);
	export_constant(IG_CLOVER_BOX_MOUTH);
	export_constant(IG_MOUTH_BUBBLE_GUM_BOX);
	export_constant(IG_CLOVER_BOX_MOUTH2);
	export_constant(IG_CLOVER_BOX_MOUTH4);
	export_constant(IG_BGUM_BOX_IN_MOUTH2);
	export_constant(IG_BGUM_BOX_IN_MOUTH4);
	export_constant(IG_TW_OCTOBER_SCROLL);
	export_constant(IG_MY_SCROLL1);
	export_constant(IG_TW_NOV_SCROLL);
	export_constant(IG_MY_SCROLL2);
	export_constant(IG_PR_RESET_STONE_BOX);
	export_constant(IG_FPR_RESET_STONE_BOX);
	export_constant(IG_MAJESTIC_DEVIL_SCROLL);
	export_constant(IG_LIFE_RIBBON_BOX);
	export_constant(IG_LIFE_RIBBON_BOX2);
	export_constant(IG_LIFE_RIBBON_BOX3);
	export_constant(IG_MAGIC_CANDY_BOX10);
	export_constant(IG_RWC2010_SUITCASEA);
	export_constant(IG_RWC2010_SUITCASEB);
	export_constant(IG_SAGITTARIUS_SCROLL);
	export_constant(IG_SAGITTARIUS_SCR_BOX);
	export_constant(IG_SAGITTAR_DIADEM_SCROLL);
	export_constant(IG_SAGITTAR_DI_SCROLL_BOX);
	export_constant(IG_CAPRI_CROWN_SCROLL);
	export_constant(IG_CAPRI_CROWN_SCROLL_BOX);
	export_constant(IG_CAPRICON_DI_SCROLL);
	export_constant(IG_CAPRICON_DI_SCROLL_BOX);
	export_constant(IG_AQUARIUS_DIADEM_SCROLL);
	export_constant(IG_AQUARIUS_DI_SCROLL_BOX);
	export_constant(IG_LOVELY_AQUARIUS_SCROLL);
	export_constant(IG_LOVELY_AQUARIUS_BOX);
	export_constant(IG_PISCES_DIADEM_SCROLL);
	export_constant(IG_PISCES_DIADEM_BOX);
	export_constant(IG_ENERGETIC_PISCES_SCROLL);
	export_constant(IG_ENERGETIC_PISCES_BOX);
	export_constant(IG_ARIES_SCROLL);
	export_constant(IG_ARIES_SCROLL_BOX);
	export_constant(IG_BOARDING_HALTER_BOX);
	export_constant(IG_TAURUS_DIADEM_SCROLL);
	export_constant(IG_TAURUS_DI_SCROLL_BOX);
	export_constant(IG_UMBALA_SPIRIT_BOX2);
	export_constant(IG_F_UMBALA_SPIRIT_BOX2);
	export_constant(IG_TAURUS_CROWN_SCROLL);
	export_constant(IG_TAURUS_CROWN_SCROLL_BOX);
	export_constant(IG_GEMI_DIADEM_SCROLL);
	export_constant(IG_GEMI_DIADEM_SCROLL_BOX);
	export_constant(IG_SUPER_PET_EGG1_2);
	export_constant(IG_SUPER_PET_EGG4_2);
	export_constant(IG_FIRE_BRAND_BOX);
	export_constant(IG_BR_INDEPENDENCE_SCROLL);
	export_constant(IG_ALL_IN_ONE_RING_BOX);
	export_constant(IG_GEMI_CROWN_SCROLL);
	export_constant(IG_GEMI_CROWN_SCROLL_BOX);
	export_constant(IG_RWC_SPECIAL_SCROLL);
	export_constant(IG_RWC_LIMITED_SCROLL);
	export_constant(IG_ASGARD_SCROLL);
	export_constant(IG_MS_CANCER_SCROLL);
	export_constant(IG_RWC_SUPER_SCROLL);
	export_constant(IG_LEO_SCROLL);
	export_constant(IG_MS_VIRGO_SCROLL);
	export_constant(IG_LUCKY_EGG_C6);
	export_constant(IG_LIBRA_SCROLL);
	export_constant(IG_HALLO_SCROLL);
	export_constant(IG_MS_SCORPIO_SCROLL);
	export_constant(IG_TCG_CARD_SCROLL);
	export_constant(IG_BOITATA_SCROLL);
	export_constant(IG_LUCKY_EGG_C2);
	export_constant(IG_LUCKY_EGG_C6_);
	export_constant(IG_LUCKY_EGG_C9);
	export_constant(IG_LUCKY_EGG_C7);
	export_constant(IG_LUCKY_EGG_C8);
	export_constant(IG_LUCKY_EGG_C10);
	export_constant(IG_WIND_TYPE_SCROLL);
	export_constant(IG_LUCKY_EGG_C3);
	export_constant(IG_LUCKY_EGG_C4);
	export_constant(IG_LUCKY_EGG_C5);
	export_constant(IG_WEATHER_REPORT_BOX);
	export_constant(IG_COMIN_ACTOR_BOX);
	export_constant(IG_HEN_SET_BOX);
	export_constant(IG_LUCKY_EGG_C);
	export_constant(IG_WATER_TYPE_SCROLL);
	export_constant(IG_EARTH_TYPE_SCROLL);
	export_constant(IG_EARTH_TYPE_SCROLL_);
	export_constant(IG_SPLASH_SCROLL);
	export_constant(IG_VOCATION_SCROLL);
	export_constant(IG_WISDOM_SCROLL);
	export_constant(IG_PATRON_SCROLL);
	export_constant(IG_HEAVEN_SCROLL);
	export_constant(IG_TW_AUG_SCROLL);
	export_constant(IG_TW_NOV_SCROLL2);
	export_constant(IG_ILLUSION_NOTHING);
	export_constant(IG_TW_SEP_SCROLL);
	export_constant(IG_FLAME_LIGHT);
	export_constant(IG_TW_RAINBOW_SCROLL);
	export_constant(IG_TW_RED_SCROLL);
	export_constant(IG_TW_ORANGE_SCROLL);
	export_constant(IG_TW_YELLOW_SCROLL);
	export_constant(IG_SCROLL_OF_DEATH);
	export_constant(IG_SCROLL_OF_LIFE);
	export_constant(IG_SCROLL_OF_MAGIC);
	export_constant(IG_SCROLL_OF_THEWS);
	export_constant(IG_SCROLL_OF_DARKNESS);
	export_constant(IG_SCROLL_OF_HOLINESS);
	export_constant(IG_HORNED_SCROLL);
	export_constant(IG_MERCURY_SCROLL);
	export_constant(IG_CHALLENGE_KIT);
	export_constant(IG_TW_APRIL_SCROLL);
	export_constant(IG_TW_OCTOBER_SCROLL_);
	export_constant(IG_SUMMER_SCROLL3);
	export_constant(IG_C_WING_OF_FLY_3DAY_BOX);
	export_constant(IG_RWC_2012_SET_BOX);
	export_constant(IG_EX_DEF_POTION_BOX);
	export_constant(IG_RWC_SCROLL_2012);
	export_constant(IG_OLD_COIN_POCKET);
	export_constant(IG_HIGH_COIN_POCKET);
	export_constant(IG_MID_COIN_POCKET);
	export_constant(IG_LOW_COIN_POCKET);
	export_constant(IG_SGRADE_POCKET);
	export_constant(IG_AGRADE_POCKET);
	export_constant(IG_BGRADE_POCKET);
	export_constant(IG_CGRADE_POCKET);
	export_constant(IG_DGRADE_POCKET);
	export_constant(IG_EGRADE_POCKET);
	export_constant(IG_PTOTECTION_SEAGOD_BOX);
	export_constant(IG_HAIRTAIL_BOX1);
	export_constant(IG_HAIRTAIL_BOX2);
	export_constant(IG_SPEARFISH_BOX1);
	export_constant(IG_SPEARFISH_BOX2);
	export_constant(IG_SAUREL_BOX1);
	export_constant(IG_SAUREL_BOX2);
	export_constant(IG_TUNA_BOX1);
	export_constant(IG_TUNA_BOX2);
	export_constant(IG_MALANG_CRAB_BOX1);
	export_constant(IG_MALANG_CRAB_BOX2);
	export_constant(IG_BRINDLE_EEL_BOX1);
	export_constant(IG_BRINDLE_EEL_BOX2);
	export_constant(IG_PTOTECTION_SEAGOD_BOX2);
	export_constant(IG_PTOTECTION_SEAGOD_BOX3);
	export_constant(IG_OCTO_HSTICK_BOX);
	export_constant(IG_OCTO_HSTICK_BOX2);
	export_constant(IG_OCTO_HSTICK_BOX3);
	export_constant(IG_SILVERVINE_FRUIT_BOX10);
	export_constant(IG_SILVERVINE_FRUIT_BOX40);
	export_constant(IG_SILVERVINE_FRUIT_BOX4);
	export_constant(IG_MALANG_WOE_ENCARD_BOX);
	export_constant(IG_XMAS_BLESS);
	export_constant(IG_FIRE_TYPE_SCROLL);
	export_constant(IG_BLUE_SCROLL);
	export_constant(IG_GOOD_STUDENT_GIFT_BOX);
	export_constant(IG_BAD_STUDENT_GIFT_BOX);
	export_constant(IG_INDIGO_SCROLL);
	export_constant(IG_VIOLET_SCROLL);
	export_constant(IG_BI_HWANG_SCROLL);
	export_constant(IG_JUNG_BI_SCROLL);
	export_constant(IG_JE_UN_SCROLL);
	export_constant(IG_YONG_KWANG_SCROLL);
	export_constant(IG_HALLOWEEN_G_BOX);
	export_constant(IG_SOLO_CHRISTMAS_GIFT);
	export_constant(IG_SG_WEAPON_SUPPLY_BOX);
	export_constant(IG_CANDY_HOLDER);
	export_constant(IG_LUCKY_BAG);
	export_constant(IG_HOLY_EGG_2);
	export_constant(IG_ADVENTURER_RETURNS_SUPPORT_BOX);
	export_constant(IG_SUPPORT_PACKAGE);
	export_constant(IG_SUPPORT_PACKAGE_10);
	export_constant(IG_EVENT_ALMIGHTY_BOX);
	export_constant(IG_EVENT_ALMIGHTY_BOX_100);
	export_constant(IG_LOTTOBOX1);
	export_constant(IG_LOTTOBOX2);
	export_constant(IG_LOTTOBOX3);
	export_constant(IG_LOTTOBOX4);
	export_constant(IG_LOTTOBOX5);
	export_constant(IG_SUPPORT_PACKAGE_III);
	export_constant(IG_SUPPORT_PACKAGE_III_10);
	export_constant(IG_UNLIMITED_BOX);
	export_constant(IG_UNLIMITED_BOX_10);
	export_constant(IG_UNLIMITED_BOX_II);
	export_constant(IG_UNLIMITED_BOX_II_10);
	export_constant(IG_THREE_MASTER_PACKAGE_III);
	export_constant(IG_THREE_MASTER_PACKAGE_III_10);
	export_constant(IG_2013_RWC_SCROLL);
	export_constant(IG_SUPPORT_PACKAGE_II);
	export_constant(IG_SUPPORT_PACKAGE_II_10);
	export_constant(IG_LEVEL_UP_BOX100);
	export_constant(IG_LEVEL_UP_BOX120);
	export_constant(IG_LEVEL_UP_BOX130);
	export_constant(IG_LEVEL_UP_BOX140);
	export_constant(IG_LEVEL_UP_BOX150);
	export_constant(IG_LEVEL_UP_BOX160);
	export_constant(IG_GIFT_BUFF_SET);
	export_constant(IG_LUCKY_SILVERVINE_FRUIT_BOX_III10);
	export_constant(IG_LUCKY_SILVERVINE_FRUIT_BOX_III110);
	export_constant(IG_OLD_ORE_BOX);
	export_constant(IG_BLESSING_LUCKY_SCROLL);
	export_constant(IG_SOGRAT_LUCKY_SCROLL);
	export_constant(IG_GARNET_LUCKY_SCROLL);
	export_constant(IG_AMORA_LUCKY_SCROLL);
	export_constant(IG_VENUS_LUCKY_SCROLL);
	export_constant(IG_ERZULIE_LUCKY_SCROLL);
	export_constant(IG_MAJESTIC_LUCKY_SCROLL);
	export_constant(IG_EPIC_HEROES_LUCKY_EGG);
	export_constant(IG_HERO_MIDGARD_EGG);
	export_constant(IG_IMORTAL_MIDGARD_SCROLL);
	export_constant(IG_TW_13Y_LUCKY_EGG_06);
	export_constant(IG_HAPPY_TIME_SCROLL);
	export_constant(IG_TIME_TRAVEL_SCROLL);
	export_constant(IG_SOLARIS_FESTIVAL_SCROLL);
	export_constant(IG_MIDGARD_FES_SCROLL);
	export_constant(IG_MIDGARD_SCROLL);
	export_constant(IG_SWEET_MIDGARD_SCROLL);
	export_constant(IG_WINTER_MIDGARD_SCROLL);
	export_constant(IG_SPRING_FESTIVAL_SCROLL);
	export_constant(IG_IDRO10TH_SCROLL);
	export_constant(IG_REQUIEM_SCROLL);
	export_constant(IG_HOLY_SPIRIT_SCROLL);
	export_constant(IG_GARUDA_SCROLL);
	export_constant(IG_THANKS_GIVING_SCROLL);
	export_constant(IG_IDN_LEGEND_HERO_SCROLL);
	export_constant(IG_BLESSING_MIDGARD_SCROLL);
	export_constant(IG_CHRONOSIAN_LUCKY_SCROLL);
	export_constant(IG_SANCTUARY_LUCKY_SCROLL);
	export_constant(IG_CYBORG_LUCKY_SCROLL);
	export_constant(IG_UNDINE_LUCKY_SCROLL);
	export_constant(IG_GOD_MATERIAL_BOX);
	export_constant(IG_COSTAMA_EGG18);
	export_constant(IG_COSTAMA_EGG19);
	export_constant(IG_FLOWER_BLOSSOM_SCROLL);
	export_constant(IG_COSTAMA_EGG24);
	export_constant(IG_SMITHY_LUCKY_SCROLL);
	export_constant(IG_GANYMEDE_LUCKY_SCROLL);
	export_constant(IG_LASTANGEL_LUCKYSCROLL);
	export_constant(IG_VALKYRIE_LUCKY_SCROLL);
	export_constant(IG_SPLASH_RAINBOW_LUCKY_SCROLL);
	export_constant(IG_SHAPESHIFTER_COSTUME);
	export_constant(IG_JULY_LUCKY_SCROLL);
	export_constant(IG_COSTAMA_EGG23);
	export_constant(IG_COSTAMA_EGG28);
	export_constant(IG_MIDGARD_LUCKY_SCROLL);
	export_constant(IG_BLESSING_SCARLET_SCROLL);
	export_constant(IG_COSTAMA_EGG29);
	export_constant(IG_INK_BALL);
	export_constant(IG_SOMETHING_CANDY_HOLDER);
	export_constant(IG_SHINING_EGG);
	export_constant(IG_AGUST_LUCKY_SCROLL);
	export_constant(IG_ELEMENT);
	export_constant(IG_POISON);
	export_constant(IG_CASH_FOOD);
	export_constant(IG_BOMB);
	export_constant(IG_THROWABLE);
	export_constant(IG_MERCENARY);
	export_constant(IG_NOIVE_BOX);
	export_constant(IG_VALERIAN_SCROLL);
	export_constant(IG_IMMORTAL_EGG);
	export_constant(IG_SAPPHIRE_EGG);
	export_constant(IG_IDN_HEART_SCROLL);
	export_constant(IG_IDN_WISDOM_EGG);
	export_constant(IG_CHRISTMAS_BOX);
	export_constant(IG_SPECIAL_CHRISTMAS_BOX);
	export_constant(IG_SANTA_GIFT);
	export_constant(IG_PRIZEOFHERO);
	export_constant(IG_PRIVATE_AIRSHIP);
	export_constant(IG_TOKEN_OF_SIEGFRIED);
	export_constant(IG_ENCHANT_STONE_BOX);
	export_constant(IG_ENCHANT_STONE_BOX2);
	export_constant(IG_ENCHANT_STONE_BOX3);
	export_constant(IG_ENCHANT_STONE_BOX4);
	export_constant(IG_ENCHANT_STONE_BOX5);
	export_constant(IG_ENCHANT_STONE_BOX6);
	export_constant(IG_ENCHANT_STONE_BOX7);
	export_constant(IG_ENCHANT_STONE_BOX8);
	export_constant(IG_ENCHANT_STONE_BOX9);
	export_constant(IG_ENCHANT_STONE_BOX10);
	export_constant(IG_ENCHANT_STONE_BOX11);
	export_constant(IG_ENCHANT_STONE_BOX12);
	export_constant(IG_ENCHANT_STONE_BOX13);
	export_constant(IG_ENCHANT_STONE_BOX14);
	export_constant(IG_ENCHANT_STONE_BOX15);
	export_constant(IG_ENCHANT_STONE_BOX16);
	export_constant(IG_ENCHANT_STONE_BOX17);
	export_constant(IG_ENCHANT_STONE_BOX18);
	export_constant(IG_ENCHANT_STONE_BOX19);
	export_constant(IG_ENCHANT_STONE_BOX20);
	export_constant(IG_ENCHANT_STONE_BOX21);
	export_constant(IG_XMAS_PACKAGE_14);
	export_constant(IG_EASTER_EGG);
	export_constant(IG_PITAPAT_BOX);
	export_constant(IG_HAPPY_BOX_J);
	export_constant(IG_CLASS_SHADOW_CUBE);
	export_constant(IG_SEALED_SCROLL);
	export_constant(IG_SQUAD_PRIZE1);
	export_constant(IG_SQUAD_PRIZE2);
	export_constant(IG_LI_NYANGVINE_BOX1_26);
	export_constant(IG_LI_NYANGVINE_BOX2_26);
	export_constant(IG_LI_NYANGVINE_BOX3_26);
	export_constant(IG_ENCHANT_STONE_BOX26);
	export_constant(IG_THIRD_JOB_STONE_GARMENT_BOX);
	export_constant(IG_THIRD_JOB_STONE_GARMENT_BOX2);
	export_constant(IG_THIRD_JOB_STONE_TOP_BOX);
	export_constant(IG_THIRD_JOB_STONE_TOP_BOX2);
	export_constant(IG_THIRD_JOB_STONE_MIDDLE_BOX);
	export_constant(IG_THIRD_JOB_STONE_MIDDLE_BOX2);
	export_constant(IG_THIRD_JOB_STONE_BOTTOM_BOX);
	export_constant(IG_THIRD_JOB_STONE_BOTTOM_BOX2);
	export_constant(IG_SHADOW_EXCHANGE_BOX);
	export_constant(IG_GUNSLINGER_ENCHANT);
	export_constant(IG_ENCHANTSTONE_RECIPE);
	export_constant(IG_PET_EGG_BOX);
	export_constant(IG_COSTUME_EXCHANGE_BOX);
	export_constant(IG_FAN_UPGRADE_KIT);
	export_constant(IG_SUIT_UPGRADE_KIT);
	export_constant(IG_SCROLL_OF_FALLEN_ANGEL_WINGS);
	export_constant(IG_CLASS_SHADOW_BOX_WEAPON);
	export_constant(IG_CLASS_SHADOW_BOX_ARMOR);
	export_constant(IG_CLASS_SHADOW_BOX_SHOES);
	export_constant(IG_CLASS_SHADOW_BOX_SHIELD);
	export_constant(IG_CLASS_SHADOW_BOX_PENDANT);
	export_constant(IG_CLASS_SHADOW_BOX_EARRING);
	export_constant(IG_STATUSSHADOW_MIX);
	export_constant(IG_GEMSTONESHADOW_MIX);
	export_constant(IG_BEARERSSHADOW_MIX);
	export_constant(IG_COMPOSESHADOW_MIX);
	export_constant(IG_RACESHADOW_MIX);
	export_constant(IG_CANDY_BAG_SCROLL_MELEE);
	export_constant(IG_CANDY_BAG_SCROLL_RANGE);
	export_constant(IG_CANDY_BAG_SCROLL_MAGIC);
	export_constant(IG_BOOSTER_AMPLIFIER);
	export_constant(IG_MAGICAL_CAT_HAND);
	export_constant(IG_INFINITYSHADOW_MIX);
	export_constant(IG_SILVER_STATUE);
	export_constant(IG_PHYSICALMAGICAL_MIX);
	export_constant(IG_IMMUNEDATHENA_MIX);
	export_constant(IG_HARDCHAMPTION_MIX);
	export_constant(IG_KINGBIRDANCIENT_MIX);
	export_constant(IG_CRITICALHIT_MIX);
	export_constant(IG_BS_ITEM_M_S_2);
	export_constant(IG_BS_ITEM_M_S_8);
	export_constant(IG_BS_ITEM_M_S_10);
	export_constant(IG_BS_ITEM_M_S_11);
	export_constant(IG_BS_ITEM_M_S_34);
	export_constant(IG_BS_ITEM_M_S_41);
	export_constant(IG_BS_ITEM_M_S_42);
	export_constant(IG_BS_ITEM_M_S_43);
	export_constant(IG_BS_ITEM_M_S_44);
	export_constant(IG_BS_SHA_M_S_1);
	export_constant(IG_BS_SHA_M_S_17);
	export_constant(IG_BS_SHA_M_S_18);
	export_constant(IG_BS_SHA_M_S_19);
	export_constant(IG_BS_SHA_M_S_20);
	export_constant(IG_BS_ITEM_M_S_4);
	export_constant(IG_BS_ITEM_M_S_6);
	export_constant(IG_BS_ITEM_M_S_7);
	export_constant(IG_BS_ITEM_M_S_12);
	export_constant(IG_BS_ITEM_M_S_13);
	export_constant(IG_BS_ITEM_M_S_15);
	export_constant(IG_BS_ITEM_M_S_28);
	export_constant(IG_BS_ITEM_M_S_29);
	export_constant(IG_BS_ITEM_M_S_31);
	export_constant(IG_BS_ITEM_M_S_32);
	export_constant(IG_BS_ITEM_M_S_33);
	export_constant(IG_BS_ITEM_M_S_36);
	export_constant(IG_BS_ITEM_M_S_37);
	export_constant(IG_BS_ITEM_M_S_38);
	export_constant(IG_BS_ITEM_M_S_39);
	export_constant(IG_BS_ITEM_M_S_40);
	export_constant(IG_BS_ITEM_M_S_45);
	export_constant(IG_BS_ITEM_M_S_46);
	export_constant(IG_BS_ITEM_M_S_47);
	export_constant(IG_BS_ITEM_M_S_48);
	export_constant(IG_BS_ITEM_M_S_49);
	export_constant(IG_BS_ITEM_M_S_50);
	export_constant(IG_BS_SHA_M_S_5);
	export_constant(IG_BS_SHA_M_S_6);
	export_constant(IG_BS_SHA_M_S_7);
	export_constant(IG_BS_SHA_M_S_8);
	export_constant(IG_BS_SHA_M_S_13);
	export_constant(IG_BS_SHA_M_S_15);
	export_constant(IG_BS_SHA_M_S_16);
	export_constant(IG_BS_SHA_M_S_23);
	export_constant(IG_BS_ITEM_M_S_5);
	export_constant(IG_BS_ITEM_M_S_9);
	export_constant(IG_BS_ITEM_M_S_14);
	export_constant(IG_BS_ITEM_M_S_16);
	export_constant(IG_BS_ITEM_M_S_17);
	export_constant(IG_BS_ITEM_M_S_19);
	export_constant(IG_BS_ITEM_M_S_27);
	export_constant(IG_BS_ITEM_M_S_35);
	export_constant(IG_BS_SHA_M_S_9);
	export_constant(IG_BS_SHA_M_S_10);
	export_constant(IG_BS_SHA_M_S_11);
	export_constant(IG_BS_SHA_M_S_21);
	export_constant(IG_BS_ITEM_M_S_1);
	export_constant(IG_BS_ITEM_M_S_3);
	export_constant(IG_BS_ITEM_M_S_18);
	export_constant(IG_BS_ITEM_M_S_20);
	export_constant(IG_BS_ITEM_M_S_21);
	export_constant(IG_BS_ITEM_M_S_22);
	export_constant(IG_BS_ITEM_M_S_23);
	export_constant(IG_BS_ITEM_M_S_24);
	export_constant(IG_BS_ITEM_M_S_25);
	export_constant(IG_BS_ITEM_M_S_26);
	export_constant(IG_BS_ITEM_M_S_30);
	export_constant(IG_BS_SHA_M_S_3);
	export_constant(IG_BS_SHA_M_S_4);
	export_constant(IG_BS_SHA_M_S_12);
	export_constant(IG_BS_SHA_M_S_14);
	export_constant(IG_BS_SHA_M_S_24);
	export_constant(IG_BS_SHA_M_S_25);
	export_constant(IG_BS_ITEM_M_S_51);
	export_constant(IG_ENCHANTSTONE_RECIPE_9M);
	export_constant(IG_IDTEST_SPECIAL);
	export_constant(IG_PERFECTSIZE_MIX);
	export_constant(IG_MAGICPIERCING_MIX);
	export_constant(IG_PIERCING_MIX);
	export_constant(IG_HASTY_MIX);
	export_constant(IG_ENCHANTSTONE_RECIPE_4M);
	export_constant(IG_SHADOW_CUBE);
	export_constant(IG_SHADOW_CUBE_PENDANT);
	export_constant(IG_SHADOW_CUBE_EARING);
	export_constant(IG_ANGELPORING_BOX);
	export_constant(IG_HELM_OF_FAITH_BOX);
	export_constant(IG_2022_LUNARNEWYEARS_BOX);
	export_constant(IG_2020_REWARD_BOX);
	export_constant(IG_COSTUME_MILE_PACK_26_1);
	export_constant(IG_COSTUME_MILE_PACK_26_2);
	export_constant(IG_COSTUME_MILE_PACK_26_3);
	export_constant(IG_EP17_1_SPC01);
	export_constant(IG_EP17_1_SPC02);
	export_constant(IG_EP17_1_SPC03);
	export_constant(IG_EP17_1_SPC04);
	export_constant(IG_STABILITYSHADOW_MIX);
	export_constant(IG_BS_SHA_M_S_2);
	export_constant(IG_BS_SHA_M_S_22);
	export_constant(IG_SLD_CARD_RECIPE);
	export_constant(IG_R_BEARERSSHADOW_MIX);
	export_constant(IG_M_BLITZSHADOW_MIX);
	export_constant(IG_RELOADSHADOW_MIX);
	export_constant(IG_SPELLCASTERSHADOW_MIX);
	export_constant(IG_MAGICALSHADOW_MIX);
	export_constant(IG_PHYSICALSHADOW_MIX);
	export_constant(IG_MAJORAUTOSPELL_MIX);
	export_constant(IG_ABSORBSHADOW_MIX);
	export_constant(IG_TRUE_GEMSHADOW_MIX);
	export_constant(IG_MAMMOTH_MIX);
	export_constant(IG_FULLTEMPSHADOW_MIX);
	export_constant(IG_FULLPENESHADOW_MIX);
	export_constant(IG_REMODEL_HERO_BOOTS);
	export_constant(IG_ORIENTAL_SWORD_CUBE);
	export_constant(IG_DRAGONIC_SLAYER_CUBE);
	export_constant(IG_SHIVER_KATAR_K_CUBE);
	export_constant(IG_BLADE_KATAR_CUBE);
	export_constant(IG_SWORD_OF_BLUEFIRE_CUBE);
	export_constant(IG_SLATE_SWORD_CUBE);
	export_constant(IG_NARCIS_BOW_CUBE);
	export_constant(IG_TRUMPET_SHELL_K_CUBE);
	export_constant(IG_BARB_WIRE_K_CUBE);
	export_constant(IG_AVENGER_CUBE);
	export_constant(IG_METEOR_STRIKER_CUBE);
	export_constant(IG_MAGIC_SWORD_CUBE);
	export_constant(IG_FATALIST_CUBE);
	export_constant(IG_ROYAL_BOW_K_CUBE);
	export_constant(IG_SCALET_DRAGON_L_CUBE);
	export_constant(IG_SHADOW_STAFF_K_CUBE);
	export_constant(IG_FREEZING_ROD_CUBE);
	export_constant(IG_IRON_NAIL_K_CUBE);
	export_constant(IG_RAY_KNUCKLE_CUBE);
	export_constant(IG_UNDINE_SPEAR_K_CUBE);
	export_constant(IG_LIGHT_BLADE_CUBE);
	export_constant(IG_IRON_STAFF_CUBE);
	export_constant(IG_BLUE_CRYSTAL_STAFF_CUBE);
	export_constant(IG_DEMON_HUNT_BIBLE_CUBE);
	export_constant(IG_SAINT_HALL_CUBE);
	export_constant(IG_MEAWFOXTAIL_CUBE);
	export_constant(IG_FOG_DEW_SWORD_CUBE);
	export_constant(IG_HUMMA_CLEAR_CUBE);
	export_constant(IG_THOUSAND_SUN_CUBE);
	export_constant(IG_SPIRIT_PENDULUM_CUBE);
	export_constant(IG_CRIMSON_ROSE_CUBE);
	export_constant(IG_MASTER_SOUL_RIFLE_CUBE);
	export_constant(IG_GOLDEN_LORD_LAUNCHER_CUBE);
	export_constant(IG_THE_BLACK_CUBE);
	export_constant(IG_DEMON_SLAYER_SHOT_CUBE);
	export_constant(IG_RUNE_CRAFT_MATERIALS);
	export_constant(IG_ELEMENTAL_CONVERTER);
	export_constant(IG_POISONS);
	export_constant(IG_BLACKSMITH);
	export_constant(IG_POTION_CRAFT_MATERIALS);
	export_constant(IG_KUNAI_BOX);
	export_constant(IG_BULLET_CASE);
	export_constant(IG_SOUL_LINKER);
	export_constant(IG_ELEMENTAL_STONES);
	export_constant(IG_SHADOW_CUBE_ARMOR);
	export_constant(IG_SHADOW_CUBE_SHIELD);
	export_constant(IG_SHADOW_CUBE_SHOES);
	export_constant(IG_SHADOW_CUBE_WEAPON);
	export_constant(IG_AUTOMATIC_MODULE_MIX);
	export_constant(IG_EPIC_MODULE_MIX);
	export_constant(IG_AUTO_M_I_BOX_A);
	export_constant(IG_AUTO_M_I_BOX_B);
	export_constant(IG_ILLUSION_MODULE_MIX);
	export_constant(IG_ENCHANT_STONE_BOX22);
	export_constant(IG_ENCHANT_STONE_BOX23);
	export_constant(IG_ENCHANT_STONE_BOX24);
	export_constant(IG_ENCHANT_STONE_BOX25);
	export_constant(IG_ENCHANT_STONE_BOX27);
	export_constant(IG_ANCIENT_HERO_BOX_1);
	export_constant(IG_3LV_9REFINE_WEAPON_7GU);
	export_constant(IG_3LV_10REFINE_WEAPON_8GU);
	export_constant(IG_3LV_11REFINE_WEAPON_9GU);
	export_constant(IG_3LV_12REFINE_WEAPON_10G);
	export_constant(IG_4LV_9REFINE_WEAPON_8GU);
	export_constant(IG_4LV_10REFINE_WEAPON_9GU);
	export_constant(IG_4LV_11REFINE_WEAPON_10G);
	export_constant(IG_BS_ITEM_M_S_52);
	export_constant(IG_BS_ITEM_M_S_53);
	export_constant(IG_BS_ITEM_M_S_54);
	export_constant(IG_BS_ITEM_M_S_55);
	export_constant(IG_BS_ITEM_M_S_56);
	export_constant(IG_ENCHANT_STONE_BOX28);
	export_constant(IG_S_FULLPENE_EARRING);
	export_constant(IG_S_FULLPENE_PENDANT);
	export_constant(IG_S_FULLPENE_ARMOR);
	export_constant(IG_S_FULLPENE_SHOES);
	export_constant(IG_S_FULLTEMP_EARRING);
	export_constant(IG_S_FULLTEMP_PENDANT);
	export_constant(IG_S_FULLTEMP_ARMOR);
	export_constant(IG_S_FULLTEMP_SHOES);
	export_constant(IG_S_DURABLE_WEAPON);
	export_constant(IG_S_DURABLE_SHIELD);
	export_constant(IG_S_CLEVER_WEAPON);
	export_constant(IG_S_CLEVER_SHIELD);
	export_constant(IG_S_ALLMIGHTY_EARRING);
	export_constant(IG_S_ALLMIGHTY_PENDANT);
	export_constant(IG_S_TRUEGEM_EARRING);
	export_constant(IG_S_TRUEGEM_PENDANT);
	export_constant(IG_S_TRUEGEM_SHOES);
	export_constant(IG_S_TRUEGEM_ARMOR);
	export_constant(IG_S_PERFECTSIZE_WEAPON);
	export_constant(IG_S_PERFECTSIZE_ARMOR);
	export_constant(IG_S_M_MAMMOTH_EARRING);
	export_constant(IG_S_M_MAMMOTH_PENDANT);
	export_constant(IG_S_M_MAMMOTH_ARMOR);
	export_constant(IG_S_M_MAMMOTH_SHOES);
	export_constant(IG_S_SPELLCASTER_EARRING);
	export_constant(IG_S_SPELLCASTER_PENDANT);
	export_constant(IG_S_SPELLCASTER_ARMOR);
	export_constant(IG_S_SPELLCASTER_SHOES);
	export_constant(IG_S_ABSORB_WEAPON);
	export_constant(IG_S_ABSORB_SHIELD);
	export_constant(IG_PORINGSPRECIOUSBOX);
	export_constant(IG_ENCHANT_STONE_BOX29);
	export_constant(IG_EIN_1HITEMBOX);
	export_constant(IG_EIN_UNDIUM);
	export_constant(IG_PC_COSTUME_BOX);
	export_constant(IG_WET_SEALED_CARD);
	export_constant(IG_2019_SSTARR_TBOX);
	export_constant(IG_E_LIFE_POTION_PACK);
	export_constant(IG_E_DEF_SCROLL_BOX);
	export_constant(IG_E_ALMIGHTY_BOX);
	export_constant(IG_E_LIMITPOWERBOOSTER);
	export_constant(IG_ROYAL_SECRET_BOX);
	export_constant(IG_SEASON_EVT_REWARD_2);
	export_constant(IG_HERO_HAMMER_PACKAGE_5);
	export_constant(IG_FLIPPACKAGE);
	export_constant(IG_POPE_SCROLL);
	export_constant(IG_MYSTERIOUS_EGG2);
	export_constant(IG_GUILDSMAN_RECRUITER_BOX);
	export_constant(IG_PARTY_RECRUITER_HAT_BOX);
	export_constant(IG_BF_RECRUITER_HAT_BOX);
	export_constant(IG_FRIEND_RECR_HAT_BOX);
	export_constant(IG_GF_RECRUITER_HAT_BOX);
	export_constant(IG_MARCHER_HAT_BOX);
	export_constant(IG_F_GUILDSMAN_RECR_BOX);
	export_constant(IG_F_PARTY_RECR_HAT_BOX);
	export_constant(IG_FBF_RECRUITER_HAT_BOX);
	export_constant(IG_F_FRIEND_RECR_HAT_BOX);
	export_constant(IG_FGF_RECRUITER_HAT_BOX);
	export_constant(IG_BONUS_BOX01);
	export_constant(IG_BONUS_BOX02);
	export_constant(IG_BONUS_BOX03);
	export_constant(IG_BONUS_BOX04);
	export_constant(IG_BONUS_BOX05);
	export_constant(IG_BONUS_BOX06);
	export_constant(IG_BONUS_BOX07);
	export_constant(IG_BONUS_BOX08);
	export_constant(IG_BONUS_BOX09);
	export_constant(IG_BONUS_BOX10);
	export_constant(IG_F_BONUS_BOX01);
	export_constant(IG_F_BONUS_BOX02);
	export_constant(IG_F_BONUS_BOX03);
	export_constant(IG_F_BONUS_BOX04);
	export_constant(IG_F_BONUS_BOX05);
	export_constant(IG_F_BONUS_BOX06);
	export_constant(IG_F_BONUS_BOX07);
	export_constant(IG_F_BONUS_BOX08);
	export_constant(IG_F_BONUS_BOX09);
	export_constant(IG_F_BONUS_BOX10);
	export_constant(IG_FUGIN_EGG01);
	export_constant(IG_FUGIN_EGG02);
	export_constant(IG_PUMP_OF_SPIRIT_SCROLL);
	export_constant(IG_HAPPY_BALLOON_SCROLL);
	export_constant(IG_ANGRY_MOUTH_C_BOX);
	export_constant(IG_KRO_LUCKY_BOX);
	export_constant(IG_CLAYMORE_C_BOX);
	export_constant(IG_JAMADHAR_C_BOX);
	export_constant(IG_TWO_HANDED_AXE_C_BOX);
	export_constant(IG_LANCE_C_BOX);
	export_constant(IG_HUUMA_GIANT_WHEEL_C_BOX);
	export_constant(IG_ORCISH_AXE_C_BOX);
	export_constant(IG_PIKE_C_BOX);
	export_constant(IG_ENCYCLOPEDIA_C_BOX);
	export_constant(IG_FIST_C_BOX);
	export_constant(IG_GUITAR_C_BOX);
	export_constant(IG_RANTE_C_BOX);
	export_constant(IG_DAMASCUS_C_BOX);
	export_constant(IG_FLAMBERGE_C_BOX);
	export_constant(IG_STUNNER_C_BOX);
	export_constant(IG_F_KRO_LUCKY_BOX);
	export_constant(IG_F_CLAYMORE_C_BOX);
	export_constant(IG_F_JAMADHAR_C_BOX);
	export_constant(IG_F_TWO_HANDED_AXE_C_BOX);
	export_constant(IG_F_LANCE_C_BOX);
	export_constant(IG_F_HUUMA_GIANT_C_BOX);
	export_constant(IG_F_ORCISH_AXE_C_BOX);
	export_constant(IG_F_PIKE_C_BOX);
	export_constant(IG_F_ENCYCLOPEDIA_C_BOX);
	export_constant(IG_F_FIST_C_BOX);
	export_constant(IG_F_GUITAR_C_BOX);
	export_constant(IG_F_RANTE_C_BOX);
	export_constant(IG_F_DAMASCUS_C_BOX);
	export_constant(IG_F_FLAMBERGE_C_BOX);
	export_constant(IG_F_STUNNER_C_BOX);
	export_constant(IG_F_ANGRY_MOUTH_C_BOX);
	export_constant(IG_MARIONETTE_C_BOX);
	export_constant(IG_WHISPER_C_BOX);
	export_constant(IG_INCUBUS_C_BOX);
	export_constant(IG_F_MARIONETTE_C_BOX);
	export_constant(IG_F_WHISPER_C_BOX);
	export_constant(IG_F_INCUBUS_C_BOX);
	export_constant(IG_F_ACTI_POTION_BOX);
	export_constant(IG_RO_DS_HEADGEAR_BOX);
	export_constant(IG_HOCKEY_MASK_BOX1);
	export_constant(IG_OBSERVER_BOX1);
	export_constant(IG_ALL_IN_ONE_RING_BOX1);
	export_constant(IG_SPRITUAL_TUNIC_BOX1);
	export_constant(IG_RECUPERATIVE_ARMOR_BOX1);
	export_constant(IG_SHELTER_RESIST_BOX1);
	export_constant(IG_SYLPHID_MANTEAU_BOX1);
	export_constant(IG_REFRESH_SHOES_BOX1);
	export_constant(IG_WELL_BAKED_TOAST_BOX1);
	export_constant(IG_WASTELAND_OUTLAW_BOX1);
	export_constant(IG_LEVER_ACT_RIFLE_BOX1);
	export_constant(IG_HEALING_STAFF_BOX1);
	export_constant(IG_PRAXINUS_BOX1);
	export_constant(IG_GUILD_RECRUIT_BOX1);
	export_constant(IG_PARTY_RECRUIT_HAT_BOX1);
	export_constant(IG_BF_RECRUIT_HAT_BOX1);
	export_constant(IG_GF_RECRUIT_HAT_BOX1);
	export_constant(IG_FRIEND_RECRUIT_HAT_BOX1);
	export_constant(IG_CLAYMORE_C_BOX1);
	export_constant(IG_TWO_HANDED_AXE_C_BOX1);
	export_constant(IG_LANCE_C_BOX1);
	export_constant(IG_JAMADHAR_C_BOX1);
	export_constant(IG_HUUMA_GIANT_C_BOX1);
	export_constant(IG_ORCISH_AXE_C_BOX1);
	export_constant(IG_PIKE_C_BOX1);
	export_constant(IG_ENCYCLOPEDIA_C_BOX1);
	export_constant(IG_FIST_C_BOX1);
	export_constant(IG_GUITAR_C_BOX1);
	export_constant(IG_RANTE_C_BOX1);
	export_constant(IG_DAMASCUS_C_BOX1);
	export_constant(IG_FLAMBERGE_C_BOX1);
	export_constant(IG_STUNNER_C_BOX1);
	export_constant(IG_ANGRY_MOUTH_C_BOX1);
	export_constant(IG_SHOOTING_STAR_C_BOX);
	export_constant(IG_BLOODY_FEAR_C_BOX);
	export_constant(IG_AHLSPIESS_C_BOX);
	export_constant(IG_STAFF_OF_HEALING_C_BOX);
	export_constant(IG_ANTI_DEMON_SHIELD_C_BOX);
	export_constant(IG_F_SHOOTING_STAR_C_BOX);
	export_constant(IG_F_BLOODY_FEAR_C_BOX);
	export_constant(IG_F_AHLSPIESS_C_BOX);
	export_constant(IG_F_S_HEALING_C_BOX);
	export_constant(IG_F_A_DEMON_SHIELD_C_BOX);
	export_constant(IG_MBL_PET_RANDOM_BOX);
	export_constant(IG_7TH_ANNI_RANDOM_BOX);
	export_constant(IG_FREYJA_RING_BOX);
	export_constant(IG_F_FREYJA_RING_BOX);
	export_constant(IG_F_CLOVER_BOX_MOUTH);
	export_constant(IG_F_BGUM_BOX_IN_MOUTH);
	export_constant(IG_F_CLOVER_BOX_MOUTH2);
	export_constant(IG_F_CLOVER_BOX_MOUTH4);
	export_constant(IG_F_BGUM_BOX_IN_MOUTH2);
	export_constant(IG_F_BGUM_BOX_IN_MOUTH4);
	export_constant(IG_FREYJA_RING_BOX2);
	export_constant(IG_F_FREYJA_RING_BOX2);
	export_constant(IG_BM_PACK_BOX_A);
	export_constant(IG_F_BM_PACK_BOX_A);
	export_constant(IG_BM_PACK_BOX_B);
	export_constant(IG_F_BM_PACK_BOX_B);
	export_constant(IG_XMAS_CARD_BOX);
	export_constant(IG_F_XMAS_CARD_BOX);
	export_constant(IG_XMAS_CARD_BOX2);
	export_constant(IG_F_XMAS_CARD_BOX2);
	export_constant(IG_E_BUNNY_BAND_BOX);
	export_constant(IG_SUMMER_SCROLL2);
	export_constant(IG_F_ACTI_POTION_BOX2);
	export_constant(IG_HALF_MEGIN_BOX);
	export_constant(IG_HALF_BRYSING_BOX);
	export_constant(IG_SPIKED_SCARF_BOX2);
	export_constant(IG_RAINBOW_SCARF_BOX2);
	export_constant(IG_SPIKED_SCARF_BOX3);
	export_constant(IG_RAINBOW_SCARF_BOX3);
	export_constant(IG_F_SPIKED_SCARF_BOX);
	export_constant(IG_F_RAINBOW_SCARF_BOX);
	export_constant(IG_F_SPIKED_SCARF_BOX2);
	export_constant(IG_F_RAINBOW_SCARF_BOX2);
	export_constant(IG_F_SPIKED_SCARF_BOX3);
	export_constant(IG_F_RAINBOW_SCARF_BOX3);
	export_constant(IG_F_RIBBON_OF_LIFE_BOX);
	export_constant(IG_F_RIBBON_OF_LIFE_BOX2);
	export_constant(IG_F_RIBBON_OF_LIFE_BOX3);
	export_constant(IG_F_RAPID_LIFE_WATER_BOX);
	export_constant(IG_F_MAGIC_CANDY_BOX10);
	export_constant(IG_UMBALA_SPIRIT_BOX);
	export_constant(IG_F_UMBALA_SPIRIT_BOX);
	export_constant(IG_UMBALA_SPIRIT_BOX_7DAY);
	export_constant(IG_C_REPAIR_SCROLL_BOX);
	export_constant(IG_C_REPAIR_SCROLL_BOX10);
	export_constant(IG_C_UMBALA_SPIRIT_BOX2);
	export_constant(IG_C_MURAMASA_BOX);
	export_constant(IG_C_EXCALIBUR_BOX);
	export_constant(IG_C_COMBAT_KNIFE_BOX);
	export_constant(IG_C_COUNTER_DAGGER_BOX);
	export_constant(IG_C_MIGHTY_STAFF_BOX);
	export_constant(IG_C_RIGHT_EPSILON_BOX);
	export_constant(IG_C_BALISTAR_BOX);
	export_constant(IG_C_D_GREAT_SAGE_BOX);
	export_constant(IG_C_ASURA_BOX);
	export_constant(IG_C_BROOCH_BOX);
	export_constant(IG_C_SAFETY_RING_BOX);
	export_constant(IG_C_PECOPECO_HAIRBAND_BOX);
	export_constant(IG_C_NAGAN_BOX);
	export_constant(IG_C_SKEWER_BOX);
	export_constant(IG_C_QUADRILLE_BOX);
	export_constant(IG_C_FIRE_BRAND_BOX);
	export_constant(IG_C_MASQUERADE_BOX);
	export_constant(IG_C_ORC_HERO_HELM_BOX);
	export_constant(IG_C_KRO_D_KITTY_BOX);
	export_constant(IG_C_BLOODY_IRON_BALL_BOX);
	export_constant(IG_C_HOCKEY_MASK_BOX);
	export_constant(IG_C_OBSERVER_BOX);
	export_constant(IG_C_ALL_IN_ONE_RING_BOX);
	export_constant(IG_C_SPIRITUAL_TUNIC_BOX);
	export_constant(IG_C_RECUP_ARMOR_BOX);
	export_constant(IG_C_SHELTER_RESIST_BOX);
	export_constant(IG_C_SYLPHID_MANTEAU_BOX);
	export_constant(IG_C_REFRESH_SHOES_BOX);
	export_constant(IG_C_WASTELAND_OUTLAW_BOX);
	export_constant(IG_C_LEVER_ACT_RIFLE_BOX);
	export_constant(IG_C_CLAYMORE_C_BOX);
	export_constant(IG_C_JAMADHAR_C_BOX);
	export_constant(IG_C_TWO_HANDED_AXE_C_BOX);
	export_constant(IG_C_LANCE_C_BOX);
	export_constant(IG_C_ORCISH_AXE_C_BOX);
	export_constant(IG_C_ENCYCLOPEDIA_C_BOX);
	export_constant(IG_C_PIKE_C_BOX);
	export_constant(IG_C_FIST_C_BOX);
	export_constant(IG_C_DAMASCUS_C_BOX);
	export_constant(IG_C_FLAMBERGE_C_BOX);
	export_constant(IG_C_STUNNER_C_BOX);
	export_constant(IG_C_SHOOTING_STAR_C_BOX);
	export_constant(IG_C_BLOODY_FEAR_C_BOX);
	export_constant(IG_C_STAFF_HEALING_C_BOX);
	export_constant(IG_C_CLOVER_BOX_MOUTH);
	export_constant(IG_C_CLOVER_BOX_MOUTH2);
	export_constant(IG_C_CLOVER_BOX_MOUTH4);
	export_constant(IG_C_BGUM_BOX_IN_MOUTH);
	export_constant(IG_C_BGUM_BOX_IN_MOUTH2);
	export_constant(IG_C_BGUM_BOX_IN_MOUTH4);
	export_constant(IG_C_SPIKED_SCARF_BOX);
	export_constant(IG_C_SPIKED_SCARF_BOX2);
	export_constant(IG_C_SPIKED_SCARF_BOX3);
	export_constant(IG_C_RAINBOW_SCARF_BOX);
	export_constant(IG_C_RAINBOW_SCARF_BOX2);
	export_constant(IG_C_RAINBOW_SCARF_BOX3);
	export_constant(IG_C_RIBBON_OF_LIFE_BOX);
	export_constant(IG_C_RIBBON_OF_LIFE_BOX2);
	export_constant(IG_C_RIBBON_OF_LIFE_BOX3);
	export_constant(IG_C_LOVE_ANGEL_BOX);
	export_constant(IG_C_LOVE_ANGEL_BOX_1M);
	export_constant(IG_C_SQUIRREL_BOX);
	export_constant(IG_C_SQUIRREL_BOX_1M);
	export_constant(IG_C_PICTURE_DIARY_BOX);
	export_constant(IG_C_PICTURE_DIARY_BOX_1M);
	export_constant(IG_C_MINI_HEART_BOX);
	export_constant(IG_C_MINI_HEART_BOX_1M);
	export_constant(IG_C_NEWCOMER_BOX);
	export_constant(IG_C_NEWCOMER_BOX_1M);
	export_constant(IG_C_KID_BOX);
	export_constant(IG_C_KID_BOX_1M);
	export_constant(IG_C_MAGIC_CASTLE_BOX);
	export_constant(IG_C_MAGIC_CASTLE_BOX_1M);
	export_constant(IG_C_BULGING_HEAD_BOX);
	export_constant(IG_C_BULGING_HEAD_BOX_1M);
	export_constant(IG_REFINE_ORE_BOX);
	export_constant(IG_ATTEND_C_BOX);
	export_constant(IG_TRANS_A_SET);
	export_constant(IG_TRANS_B_SET);
	export_constant(IG_TRANS_C_SET);
	export_constant(IG_MADE_DISH_SET);
	export_constant(IG_MADE_DISH_BOX);
	export_constant(IG_RED_BOOSTER_BOX20_2);
	export_constant(IG_MYSTIC_POWDER_BOX30_2);
	export_constant(IG_EC_BATTLE_MANUAL_BOX);
	export_constant(IG_EC_JOB_MANUAL25_BOX10);
	export_constant(IG_GLOBAL_HAT_FES_BOX);
	export_constant(IG_GLOBAL_HAT_FES_5_BOX);
	export_constant(IG_GLOBAL_HAT_FES_BOX2);
	export_constant(IG_MADE_DISH_BOX1);
	export_constant(IG_MYSTERIOUS_WATER_BOX50);
	export_constant(IG_MYSTERIOUS_WATER_BOX50_);
	export_constant(IG_REFINE_ORE_BOX2);
	export_constant(IG_RED_POTION_RG_BOX);
	export_constant(IG_BLUE_POTION_RG_BOX);
	export_constant(IG_GOLDENAPPLE_P_RG_BOX);
	export_constant(IG_GOLDENAPPLE_RG_BOX);
	export_constant(IG_GOLDEN_POTION_RG_BOX);
	export_constant(IG_SPECIAL_PO_BOX);
	export_constant(IG_BATTLE_MANUAL_LIMIT_BOX);
	export_constant(IG_UNLIMITED_20_BOX);
	export_constant(IG_CUSTOMIZING_BOX);
	export_constant(IG_NYANGVINE_BOX10_);
	export_constant(IG_NYANGVINE_BOX100);
	export_constant(IG_SERVICE30_M_01_BOX);
	export_constant(IG_SERVICE30_F_01_BOX);
	export_constant(IG_3_LIFE_POTION_PACK6);
	export_constant(IG_3_LIFE_POTION_10PACK6);
	export_constant(IG_REFINE_ORE_BOX10);
	export_constant(IG_REFINE_ORE_BOX10_SET10);
	export_constant(IG_SERVICE30P_M_01_BOX);
	export_constant(IG_SERVICE30P_F_01_BOX);
	export_constant(IG_VIGORGRA_PACKAGE_V5);
	export_constant(IG_VIGORGRA_PACKAGE_SET_V5);
	export_constant(IG_C_GREED_1HOUR_BOX);
	export_constant(IG_C_CATPAW_1DAY_BOX);
	export_constant(IG_UNLIMITED_BOX4);
	export_constant(IG_UNLIMITED_10_BOX4);
	export_constant(IG_C_GIANT_FLY_1DAY_BOX);
	export_constant(IG_REFINE_ORE_BOX11);
	export_constant(IG_REFINE_ORE_BOX11_SET10);
	export_constant(IG_3_LIFE_POTION_PACK7);
	export_constant(IG_3_LIFE_POTION_10PACK7);
	export_constant(IG_ALMIGHTY_PLUS_BOX);
	export_constant(IG_ALMIGHTY100_PLUSBOX);
	export_constant(IG_LIMIT_POWER_BOOSTER2);
	export_constant(IG_LIMITPOWERBOOSTER2_100);
	export_constant(IG_LC_BOARDING_HALTER_BOX);
	export_constant(IG_REFINE_ORE_BOX12);
	export_constant(IG_REFINE_ORE_BOX12_SET10);
	export_constant(IG_VIGORGRA_PLUS_PACKAGE);
	export_constant(IG_VIGORGRA_PLUS_SET);
	export_constant(IG_3_LIFE_POTION_PACK8);
	export_constant(IG_3_LIFE_POTION_10PACK8);
	export_constant(IG_UNLIMITED_BOX5);
	export_constant(IG_UNLIMITED_10_BOX5);
	export_constant(IG_REFINE_ORE_BOX13);
	export_constant(IG_REFINE_ORE_BOX13_SET10);
	export_constant(IG_HD_REFINE_ORE_BOX);
	export_constant(IG_NYANGVINE_BOX10_2);
	export_constant(IG_NYANGVINE_BOX100_2);
	export_constant(IG_VIGORGRA_PLUS_PACKAGE2);
	export_constant(IG_VIGORGRA_PLUS_SET2);
	export_constant(IG_3_LIFE_POTION_PACK9);
	export_constant(IG_3_LIFE_POTION_10PACK9);
	export_constant(IG_REFINE_ORE_BOX14);
	export_constant(IG_REFINE_ORE_BOX14_SET10);
	export_constant(IG_HD_REFINE_ORE_BOX2);
	export_constant(IG_ALMIGHTY_PLUS_BOX2);
	export_constant(IG_ALMIGHTY100_PLUSBOX2);
	export_constant(IG_DEF_SCROLL_BOX);
	export_constant(IG_DEF_SCROLL_BOX_SET);
	export_constant(IG_LIMIT_POWER_BOOSTER3);
	export_constant(IG_LIMITPOWERBOOSTER3_100);
	export_constant(IG_HD_HIGH_REFINE_BOX);
	export_constant(IG_REFINE_ORE_BOX15_SET10);
	export_constant(IG_REFINE_ORE_BOX15);
	export_constant(IG_HD_REFINE_ORE_BOX3);
	export_constant(IG_VIGORGRA_PLUS_PACKAGE3);
	export_constant(IG_VIGORGRA_PLUS_SET3);
	export_constant(IG_C_CATPAW_7DAY_BOX);
	export_constant(IG_ALMIGHTY_PLUS_BOX3);
	export_constant(IG_ALMIGHTY100_PLUSBOX3);
	export_constant(IG_3_LIFE_POTION_PACK10);
	export_constant(IG_3_LIFE_POTION_10PACK10);
	export_constant(IG_UNLIMITED_10_BOX6);
	export_constant(IG_UNLIMITED_BOX6);
	export_constant(IG_REFINE_ORE_BOX16);
	export_constant(IG_REFINE_ORE_BOX16_SET10);
	export_constant(IG_HD_REFINE_ORE_BOX4);
	export_constant(IG_HD_HIGH_REFINE_BOX2);
	export_constant(IG_DEF_SCROLL_BOX2);
	export_constant(IG_DEF_SCROLL_BOX_SET2);
	export_constant(IG_3_LIFE_POTION_PACK11);
	export_constant(IG_3_LIFE_POTION_10PACK11);
	export_constant(IG_RTC_ANNIV_BOX);
	export_constant(IG_REFINE_ORE_BOX17_SET10);
	export_constant(IG_REFINE_ORE_BOX17);
	export_constant(IG_HD_REFINE_ORE_BOX5);
	export_constant(IG_HD_HIGH_REFINE_BOX3);
	export_constant(IG_INFINITY_BOX);
	export_constant(IG_INFINITY_10_BOX);
	export_constant(IG_NEW_VIGORGRA_PACKAGE);
	export_constant(IG_NEW_VIGORGRA_SET);
	export_constant(IG_LIMITPOWERBOOSTER4_100);
	export_constant(IG_LIMIT_POWER_BOOSTER4);
	export_constant(IG_2017_GSTAR_COSTUMEBOX);
	export_constant(IG_ZERO_MERCHANT_BELL_BOX);
	export_constant(IG_ZERO_KAFRA_BELL_BOX);
	export_constant(IG_REFINE_ORE_BOX18);
	export_constant(IG_REFINE_ORE_BOX18_SET10);
	export_constant(IG_HD_REFINE_ORE_BOX6);
	export_constant(IG_HD_HIGH_REFINE_BOX4);
	export_constant(IG_NEW_3_POTION_PACK);
	export_constant(IG_NEW_3_POTION_10PACK);
	export_constant(IG_NYANGVINE_BOX10_3);
	export_constant(IG_NYANGVINE_BOX100_3);
	export_constant(IG_ALMIGHTY_PLUS_BOX4);
	export_constant(IG_ALMIGHTY100_PLUSBOX4);
	export_constant(IG_REFINE_ORE_BOX19_SET10);
	export_constant(IG_REFINE_ORE_BOX19);
	export_constant(IG_HD_REFINE_ORE_BOX7);
	export_constant(IG_HD_HIGH_REFINE_BOX5);
	export_constant(IG_DEF_SCROLL_BOX3);
	export_constant(IG_DEF_SCROLL_BOX_SET3);
	export_constant(IG_3_LIFE_POTION_PACK12);
	export_constant(IG_3_LIFE_POTION_10PACK12);
	export_constant(IG_INFINITY_BOX2);
	export_constant(IG_INFINITY_10_BOX2);
	export_constant(IG_A_VIGORGRA_SET);
	export_constant(IG_A_VIGORGRA_PACKAGE);
	export_constant(IG_A_ALMIGHTY100_BOX);
	export_constant(IG_A_ALMIGHTY_BOX);
	export_constant(IG_A_REFINE_ORE_BOX_SET);
	export_constant(IG_A_REFINE_ORE_BOX);
	export_constant(IG_A_HD_REFINE_ORE_BOX);
	export_constant(IG_A_HD_HIGH_REFINE_BOX);
	export_constant(IG_A_LIMITPOWERBOOSTER_100);
	export_constant(IG_A_LIMITPOWERBOOSTER);
	export_constant(IG_A_DEF_SCROLL_BOX_SET);
	export_constant(IG_A_DEF_SCROLL_BOX);
	export_constant(IG_A_UNLIMITED_10_BOX);
	export_constant(IG_A_UNLIMITED_BOX);
	export_constant(IG_MADE_DISH_BOX2);
	export_constant(IG_COSTUME_SET1_KR);
	export_constant(IG_SEALED_SCROLL3);
	export_constant(IG_STATUS_DECREASE_SCROLL);
	export_constant(IG_MAD_BUNNY_SCROLL);
	export_constant(IG_SEALED_HAT_BOX);
	export_constant(IG_SEALED_HAT_BOX2);
	export_constant(IG_IMPROVED_NOMALBOX);
	export_constant(IG_IMPROVED_WOODENBOX);
	export_constant(IG_IMPROVED_GOLDENBOX);
	export_constant(IG_IMPROVED_PLATINUMBOX);
	export_constant(IG_13THCELEBRATEBOX);
	export_constant(IG_CROSSEVENTBOX);
	export_constant(IG_PIAMETTE_SCROLL);
	export_constant(IG_COWLICK_BOX);
	export_constant(IG_STRAIGHT_PONY_BOX);
	export_constant(IG_LOOSE_WAVE_TWIN_BOX);
	export_constant(IG_INVISIBLE_SCROLL);
	export_constant(IG_NEW_HAT_SCROLL);
	export_constant(IG_NEW_HAT_BOX);
	export_constant(IG_COKINGOPENBOX);
	export_constant(IG_2015_SPECIAL_SCROLL);
	export_constant(IG_2015_SPECIAL_BOX);
	export_constant(IG_2015_ANGEL_SCROLL);
	export_constant(IG_DECEMBERGIFTBOX_2016);
	export_constant(IG_NOVEMBERGIFTBOX_2016);
	export_constant(IG_PORING_SCROLL);
	export_constant(IG_MOBI_SUPPORT_BOX);
	export_constant(IG_TIME_GUARDIAN_BOX2);
	export_constant(IG_ASSORTED_SHDOWBOX);
	export_constant(IG_AMISTR_SCROLL);
	export_constant(IG_AMISTR_BOX);
	export_constant(IG_SHADOW_SCROLL);
	export_constant(IG_SPIRIT_SCROLL);
	export_constant(IG_SEALED_HAT_BOX3);
	export_constant(IG_CACHUA_WEAPON);
	export_constant(IG_CACHUA_ROBE);
	export_constant(IG_CACHUA_MAIL);
	export_constant(IG_CACHUA_SHOES);
	export_constant(IG_CACHUA_SHIELD);
	export_constant(IG_CACHUA_HELM);
	export_constant(IG_BALLOON_SCROLL);
	export_constant(IG_PORING_BALLOON_BOX);
	export_constant(IG_RIBEL_JUMPING_BOX);
	export_constant(IG_GUNSLINGER_SCROLL);
	export_constant(IG_GREEN_SCROLL_K);
	export_constant(IG_KAFRA_SCROLL);
	export_constant(IG_SIGRUN_SCROLL);
	export_constant(IG_PREMIUMWOODENBOX);
	export_constant(IG_PREMIUMGOLDENBOX);
	export_constant(IG_PREMIUMPLATINUMBOX);
	export_constant(IG_PREMIUMNOMALBOX);
	export_constant(IG_NEW_HAT_SCROLL2);
	export_constant(IG_NEW_HAT_BOX2);
	export_constant(IG_2016_SPECIAL_SCROLL);
	export_constant(IG_2016_SPECIAL_BOX);
	export_constant(IG_BISCUIT_STICK_2SET);
	export_constant(IG_RACING_EXCHANGE);
	export_constant(IG_CANDLELIGHT_SCROLL);
	export_constant(IG_LAPINE_SCROLL);
	export_constant(IG_LI_LAPINE_DDUKDDAKBOX);
	export_constant(IG_HAIR_BUN_BOX);
	export_constant(IG_ROLL_TWIN_BOX);
	export_constant(IG_LONG_PONY_BOX);
	export_constant(IG_1LVUP);
	export_constant(IG_10LVUP);
	export_constant(IG_20LVUP);
	export_constant(IG_30LVUP);
	export_constant(IG_40LVUP);
	export_constant(IG_50LVUP);
	export_constant(IG_60LVUP);
	export_constant(IG_70LVUP);
	export_constant(IG_90LVUP);
	export_constant(IG_175LVUP);
	export_constant(IG_BISCUIT_STICK_2SET_);
	export_constant(IG_LOVE_SCROLL);
	export_constant(IG_LOVELY_EGG_BOX);
	export_constant(IG_C_CATPAW_1DAY_PARA);
	export_constant(IG_C_WING_OF_FLY_1DAY_PARA);
	export_constant(IG_CAT_SCROLL);
	export_constant(IG_MAGICAL_BOOSTER_BOX);
	export_constant(IG_CAT_HEAD_DRESS_BASKET);
	export_constant(IG_CHEMICALS_BAG);
	export_constant(IG_SHADOW_SCROLL2);
	export_constant(IG_C_WING_OF_FLY_3DAY_BOX_);
	export_constant(IG_MOBILE_NOVICE_BOX);
	export_constant(IG_C_WING_OF_FLY_5DAY_BOX_);
	export_constant(IG_C_GIANT_FLY_1DAY_BOX_);
	export_constant(IG_C_WING_OF_FLY_BOX_);
	export_constant(IG_MAY_GOLD_SCROLL);
	export_constant(IG_NEW_HAT_BOX3);
	export_constant(IG_EXSHADOW_DDUKDDAKBOX);
	export_constant(IG_MATERIAL_SHADOW_CUBE);
	export_constant(IG_MYSTERIOUS_MEDAL_BOX);
	export_constant(IG_VEND_ARBEIT1_1LV);
	export_constant(IG_VEND_ARBEIT1_2LV);
	export_constant(IG_VEND_ARBEIT1_3LV);
	export_constant(IG_BUY_ARBEIT1_1LV);
	export_constant(IG_BUY_ARBEIT1_2LV);
	export_constant(IG_BUY_ARBEIT1_3LV);
	export_constant(IG_VEND_ARBEIT3_1LV);
	export_constant(IG_VEND_ARBEIT3_2LV);
	export_constant(IG_VEND_ARBEIT3_3LV);
	export_constant(IG_BUY_ARBEIT3_1LV);
	export_constant(IG_BUY_ARBEIT3_2LV);
	export_constant(IG_BUY_ARBEIT3_3LV);
	export_constant(IG_CRYPTURA_GIFTBOX);
	export_constant(IG_GENERAL_SCROLL);
	export_constant(IG_GREEN_SCROLL_K2);
	export_constant(IG_NEW_SHADOW_CUBE);
	export_constant(IG_SENTIMENTAL_SCROLL);
	export_constant(IG_JULY_HAIR_BOX);
	export_constant(IG_INFINITY_SCROLL);
	export_constant(IG_BLOODY_SCROLL);
	export_constant(IG_SNOW_FESTA_BOX);
	export_constant(IG_SNOW_FESTA_CARDPACK);
	export_constant(IG_2017_SPECIAL_SCROLL);
	export_constant(IG_2017_SPECIAL_BOX);
	export_constant(IG_ICE_SCROLL);
	export_constant(IG_2018_NEW_YEAR_SCROLL);
	export_constant(IG_2018_YEAR_SHADOW_CUBE);
	export_constant(IG_2018_MATERIAL_CUBE);
	export_constant(IG_2018_LAPINE_DDUKDDAKBOX);
	export_constant(IG_SWEETS_EVT_BOX);
	export_constant(IG_EVT_JAN02KR);
	export_constant(IG_2018_VISIONARY_CARD);
	export_constant(IG_LUNAR_NEW_YEAR_SCROLL);
	export_constant(IG_FEBRUARY_HAIR_BOX);
	export_constant(IG_2018_SPRING_SCROLL);
	export_constant(IG_2018_SAKURA_SCROLL);
	export_constant(IG_SEALED_CARD2);
	export_constant(IG_CELEBRATE_EGG);
	export_constant(IG_NOODLE_FESTA_CAN);
	export_constant(IG_COMP_AID_BUFF_BOX);
	export_constant(IG_COMP_BOX);
	export_constant(IG_COMP_ALL_RING_BOX);
	export_constant(IG_MYSTERIOUS_EGG3);
	export_constant(IG_COMP_BOX2);
	export_constant(IG_MAY_RAINBOW_SCROLL);
	export_constant(IG_SWEET_CANDY_BOX);
	export_constant(IG_PUMP_OF_SPIRIT_SCROLL2);
	export_constant(IG_SPIRIT_HAT_BOX);
	export_constant(IG_HERO_WEAPON_BOX);
	export_constant(IG_STARSOUL_SCROLL);
	export_constant(IG_COMP_CONNECTERROR);
	export_constant(IG_2018_JUMP_THX_BOX);
	export_constant(IG_TIME_OVERLOAD_BOX);
	export_constant(IG_110LVUP);
	export_constant(IG_SEASON_EVT_REWARD_3);
	export_constant(IG_SEASON_EVT_REWARD_4);
	export_constant(IG_SEASON_EVT_REWARD_5);
	export_constant(IG_JOB_ENCHANT_STONE_BOX);
	export_constant(IG_MAIN_LUCKY_BOX);
	export_constant(IG_SEASON_EVT_REWARD);
	export_constant(IG_CANDY_BOX);
	export_constant(IG_PORING_SUNGLASSES_BOX);
	export_constant(IG_SIGRUN_SHADOW_BOX);
	export_constant(IG_MAD_BUNNY_BOX);
	export_constant(IG_LEVEL_ACHIEVEMENT_BOX);
	export_constant(IG_ABYSS_ITEMBOX);
	export_constant(IG_ODIN_ITEMBOX);
	export_constant(IG_BIO_W_BOX);
	export_constant(IG_BIO_DOCU_BOX);
	export_constant(IG_BIO_REACTANT_BOX);
	export_constant(IG_PAYPROMOTION_BOX);
	export_constant(IG_E_BCRYSTAL_BOX);
	export_constant(IG_E_MCRYSTAL_BOX);
	export_constant(IG_E_SCRYSTAL_BOX);
	export_constant(IG_BOOSTER_PACK_1);
	export_constant(IG_BOOSTER_PACK_15);
	export_constant(IG_BOOSTER_PACK_30);
	export_constant(IG_BOOSTER_PACK_45);
	export_constant(IG_BOOSTER_PACK_60);
	export_constant(IG_BOOSTER_PACK_75);
	export_constant(IG_BOOSTER_PACK_90);
	export_constant(IG_BOOSTER_PACK_100);
	export_constant(IG_BOOSTER_PACK_115);
	export_constant(IG_BOOSTER_PACK_130);
	export_constant(IG_BOOSTER_PACK_145);
	export_constant(IG_BOOSTER_PACK_160);
	export_constant(IG_BOOSTER_PACK_175);
	export_constant(IG_STATER_A_BOX);
	export_constant(IG_BOOST_ATK_BOX);
	export_constant(IG_BOOST_RAN_BOX);
	export_constant(IG_BOOST_ELE_BOX);
	export_constant(IG_BOOST_DEFN_BOX);
	export_constant(IG_GOAL_GIFT_BOX);
	export_constant(IG_BOOSTER_PACK_PREORDER);
	export_constant(IG_TIME_OVER_S_BOX);
	export_constant(IG_BOARDING_HALTER_BOX30_Z);
	export_constant(IG_TEMPORAL_MANTEAU_BOX);
	export_constant(IG_LAPINE_DDUKDDAKBOX2);
	export_constant(IG_KR_B_SPECIAL02);
	export_constant(IG_GOLDPCBANG_SHIELDBOX);
	export_constant(IG_SET_OF_TAIMING_ITEM2);
	export_constant(IG_GOLDPCBANG_MILEAGEBOX);
	export_constant(IG_SKILL_SHADOW_CUBE);
	export_constant(IG_SHADOWDECON_ORE_BOX);
	export_constant(IG_ZELUNIUM_ORE_BOX);
	export_constant(IG_GSTAR2019BOX);
	export_constant(IG_EXOTIC_BOB_BOX);
	export_constant(IG_RUNEKNIGHT_S_CUBE);
	export_constant(IG_GUILLOTINECROSS_S_CUBE);
	export_constant(IG_ARCHBISHOP_S_CUBE);
	export_constant(IG_SURA_S_CUBE);
	export_constant(IG_2019_CHRISMAS_PRESENT);
	export_constant(IG_BOOSTER_PACK_190);
	export_constant(IG_BOOSTER_PACK_200);
	export_constant(IG_2020_GOAL_GIFT_BOX);
	export_constant(IG_RANGER_S_CUBE);
	export_constant(IG_WARLOCK_S_CUBE);
	export_constant(IG_SORCERER_S_CUBE);
	export_constant(IG_WANDERMINS_S_CUBE);
	export_constant(IG_ROYALGUARD_S_CUBE);
	export_constant(IG_SHADOWCHASER_S_CUBE);
	export_constant(IG_MECHANIC_S_CUBE);
	export_constant(IG_GENETIC_S_CUBE);
	export_constant(IG_SIGNON_PRIN_WAVE_BOX);
	export_constant(IG_HERO_WEAPON_CUBE);
	export_constant(IG_NEW_S_WEAPON_CUBE);
	export_constant(IG_NEW_S_SHIELD_CUBE);
	export_constant(IG_NEW_S_ARMOR_CUBE);
	export_constant(IG_NEW_S_SHOES_CUBE);
	export_constant(IG_NEW_S_EARRING_CUBE);
	export_constant(IG_NEW_S_PENDANT_CUBE);
	export_constant(IG_MD_AIRBOAT_REWARD);
	export_constant(IG_OS_HELM_BOX);
	export_constant(IG_FAMOUS_HAT_BOX);
	export_constant(IG_POENETENTIA_BOX1);
	export_constant(IG_POENETENTIA_BOX2);
	export_constant(IG_EX_SKILL_SHADOW_CUBE);
	export_constant(IG_CACHUA_COSTUME_BOX);
	export_constant(IG_KR_B_SPECIAL03);
	export_constant(IG_BIOWEAPON_HELM_BOX);
	export_constant(IG_TREE_OF_SPROUT_BOX);
	export_constant(IG_SPECIAL_COSTUME_BOX);
	export_constant(IG_SPECIAL_COSTUME_BOX_);
	export_constant(IG_RAG_INVEN_BOX);
	export_constant(IG_THANATOS_PENDANT_BOX);
	export_constant(IG_LAPINE_DDUKDDAKBOX3);
	export_constant(IG_AUCTION_PROMOTION);
	export_constant(IG_BLUE_PRINTS_SCROLL);
	export_constant(IG_MATERIAL_SHADOW_CUBEII);
	export_constant(IG_ANCIENT_HERO_WILL);
	export_constant(IG_MAMMOTH_SHADOW_BOX);
	export_constant(IG_SHADOW_R_M_BOX);
	export_constant(IG_ALL_SHADOW_CUBE);
	export_constant(IG_FLUFFY_SEMI_LONG_BOX);
	export_constant(IG_BOOSTER_PACK_215);
	export_constant(IG_BOOSTER_PACK_230);
	export_constant(IG_ANGELPORINGJEWEL_BOX);
	export_constant(IG_UP_HERO_WEAPON_BOX);
	export_constant(IG_HIGH_REFINE_GUARANTEE);
	export_constant(IG_REFINE_GUARANTEE);
	export_constant(IG_SPECIAL_REFINE_CUBE);
	export_constant(IG_AUTOSPELL_SHADOW_BOX);
	export_constant(IG_BROADCASTBOX_);
	export_constant(IG_S_ENCHANT_STONE_BOX);
	export_constant(IG_C_GIANT_FLY_1DAY_BOX__);
	export_constant(IG_C_WING_OF_FLY_3DAY_B__);
	export_constant(IG_PHYMAG_SHADOW_BOX);
	export_constant(IG_S_DUAL_STONE_BOX);
	export_constant(IG_S_COSTUME_BOX);
	export_constant(IG_GM_LOST_BAGPACK);
	export_constant(IG_E_POTION_BOX);
	export_constant(IG_BUFF_SCROLL_BOX);
	export_constant(IG_SEASON_EVT_REWARD_9);
	export_constant(IG_S_IGNITION_CUBE);
	export_constant(IG_LI_HD_ORIDECON_BOX2);
	export_constant(IG_LI_HD_ELUNIUM_BOX2);
	export_constant(IG_LI_HD_BRADIUMBOX2);
	export_constant(IG_LI_HD_CARNIUMBOX2);
	export_constant(IG_LI_NYANGVINE_BOX100);
	export_constant(IG_LI_A_3_POTION_PACK);
	export_constant(IG_STONE_COIN_PACKAGEI);
	export_constant(IG_STONE_COIN_PACKAGEII);
	export_constant(IG_STONE_COIN_PACKAGEIII);
	export_constant(IG_A_HD_ELUNIUM_BOX);
	export_constant(IG_A_HD_ORIDECON_BOX);
	export_constant(IG_A_HD_CARNIUM_BOX);
	export_constant(IG_A_HD_BRADIUM_BOX);
	export_constant(IG_L_BATTLE_MANUAL_PACK);
	export_constant(IG_LI_MANA_POTION_BOX);
	export_constant(IG_LI_NYANGVINE_BOX_II);
	export_constant(IG_LI_NYANGVINE_BOX_III);
	export_constant(IG_LI_HD_ORIDECON_BOX3);
	export_constant(IG_LI_HD_ELUNIUM_BOX3);
	export_constant(IG_LI_NYANGVINE_STONE_BOX);
	export_constant(IG_LI_A_REFINE_ORE_BOX);
	export_constant(IG_LI_A_HD_ELUNIUM_BOX);
	export_constant(IG_LI_A_HD_ORIDECON_BOX);
	export_constant(IG_LI_A_HD_CARNIUM_BOX);
	export_constant(IG_LI_A_HD_BRADIUM_BOX);
	export_constant(IG_THANOS_UPGRADE_PACKAGE);
	export_constant(IG_HERO_UP_PACKAGE_1);
	export_constant(IG_HERO_UP_PACKAGE_2);
	export_constant(IG_HERO_HAMMER_PACKAGE_1);
	export_constant(IG_HERO_HAMMER_PACKAGE_2);
	export_constant(IG_HERO_UP_PACKAGE_3);
	export_constant(IG_HERO_HAMMER_PACKAGE_3);
	export_constant(IG_EXP_DROP_UP_BOX);
	export_constant(IG_HERO_HAMMER_PACKAGE_4);
	export_constant(IG_HERO_UP_PACKAGE_4);
	export_constant(IG_LI_NYANGVINE_STONE_BOX2);
	export_constant(IG_HERO_UP_PACKAGE_5);
	export_constant(IG_COSTUMEMILEAGE_PACKAGE1);
	export_constant(IG_COSTUMEMILEAGE_PACKAGE2);
	export_constant(IG_COSTUMEMILEAGE_PACKAGE3);
	export_constant(IG_COMP_TRANS_SCROLL);
	export_constant(IG_MINUS_STATUS_BOX);
	export_constant(IG_S_W_BREATH_CUBE);
	export_constant(IG_S_F_BREATH_CUBE);
	export_constant(IG_S_SONIC_CUBE);
	export_constant(IG_S_STRAIN_CUBE);
	export_constant(IG_S_JACK_CUBE);
	export_constant(IG_S_CHAIN_CUBE);
	export_constant(IG_S_CRIMSON_CUBE);
	export_constant(IG_S_VULCAN_CUBE);
	export_constant(IG_S_BOOMERANG_CUBE);
	export_constant(IG_S_ARMS_CUBE);
	export_constant(IG_S_TORNADO_CUBE);
	export_constant(IG_S_DUPLELIGHT_CUBE);
	export_constant(IG_S_MAGNUS_CUBE);
	export_constant(IG_S_ADORAMUS_CUBE);
	export_constant(IG_S_JUDEX_CUBE);
	export_constant(IG_S_ROLLING_CUBE);
	export_constant(IG_S_RIPPER_CUBE);
	export_constant(IG_S_SLASH_CUBE);
	export_constant(IG_S_KATAR_CUBE);
	export_constant(IG_S_SHOOTING_CUBE);
	export_constant(IG_S_ARROW_CUBE);
	export_constant(IG_S_AIMED_CUBE);
	export_constant(IG_S_CLUSTER_CUBE);
	export_constant(IG_S_BANISH_CANNON_CUBE);
	export_constant(IG_S_BRAND_CUBE);
	export_constant(IG_S_GENESIS_CUBE);
	export_constant(IG_S_CHAIN_PRESS_CUBE);
	export_constant(IG_S_GRAVE_CUBE);
	export_constant(IG_S_DUST_CUBE);
	export_constant(IG_S_VARETYR_CUBE);
	export_constant(IG_S_PSYCHIC_CUBE);
	export_constant(IG_S_SPORE_BOMB_CUBE);
	export_constant(IG_S_CANNON_CART_CUBE);
	export_constant(IG_S_CRAZY_CUBE);
	export_constant(IG_S_CART_TORNADO_CUBE);
	export_constant(IG_S_KNUCKLEARROW_CUBE);
	export_constant(IG_S_SKYNETBLOW_CUBE);
	export_constant(IG_S_RAMPAGE_CUBE);
	export_constant(IG_S_TIGERCANNON_CUBE);
	export_constant(IG_S_MENACE_CUBE);
	export_constant(IG_S_SHADOWSPELL_CUBE);
	export_constant(IG_S_TRIANGLE_CUBE);
	export_constant(IG_S_PAINT_CUBE);
	export_constant(IG_S_RAINSTORM_CUBE);
	export_constant(IG_S_METALIC_CUBE);
	export_constant(IG_S_ARROWVULCAN_CUBE);
	export_constant(IG_S_REVERBERATION_CUBE);
	export_constant(IG_S_MOONLIGHT_CUBE);
	export_constant(IG_S_SUNSHINE_CUBE);
	export_constant(IG_S_STARDUST_CUBE);
	export_constant(IG_S_S_CUBE);
	export_constant(IG_S_EVILCURSE_CUBE);
	export_constant(IG_S_SYURIKEN_CUBE);
	export_constant(IG_S_KUNAI_CUBE);
	export_constant(IG_S_HUUSOUKA_CUBE);
	export_constant(IG_S_KAMAENRAKU_CUBE);
	export_constant(IG_S_GOD_HAMMER_CUBE);
	export_constant(IG_S_SHATTER_BUSTER_CUBE);
	export_constant(IG_S_TAIL_DRAGON_CUBE);
	export_constant(IG_S_TRIP_CUBE);
	export_constant(IG_S_FLARE_DANCE_CUBE);
	export_constant(IG_S_SUPER_MAGIC_CUBE);
	export_constant(IG_S_SUPER_POWER_CUBE);
	export_constant(IG_S_SILVERVINE_CUBE);
	export_constant(IG_S_CATNIP_CUBE);
	export_constant(IG_S_SAVAGERABBIT_CUBE);
	export_constant(IG_S_PICKYRUSH_CUBE);
	export_constant(IG_S_RUNEKNIGHT_CUBE);
	export_constant(IG_S_ROYALGUARD_CUBE);
	export_constant(IG_S_WARLOCK_CUBE);
	export_constant(IG_S_SORCERER_CUBE);
	export_constant(IG_S_MECHANIC_CUBE);
	export_constant(IG_S_GENERIC_CUBE);
	export_constant(IG_S_ARCHBISHOP_CUBE);
	export_constant(IG_S_SURA_CUBE);
	export_constant(IG_S_GUILLOTINECROSS_CUBE);
	export_constant(IG_S_SHADOWCHASER_CUBE);
	export_constant(IG_S_RANGER_CUBE);
	export_constant(IG_S_WANDERER_CUBE);
	export_constant(IG_S_MINSTREL_CUBE);
	export_constant(IG_S_STAR_EMPEROR_CUBE);
	export_constant(IG_S_SOUL_REAPER_CUBE);
	export_constant(IG_S_KAGEROU_CUBE);
	export_constant(IG_S_OBORO_CUBE);
	export_constant(IG_S_REBELLION_CUBE);
	export_constant(IG_S_SUPERNOVICE_CUBE);
	export_constant(IG_S_DORAM_CUBE);
	export_constant(IG_S_MAMMOTH_CUBE);
	export_constant(IG_S_GEMSTONE_CUBE);
	export_constant(IG_S_PENE1_CUBE);
	export_constant(IG_S_PENE2_CUBE);
	export_constant(IG_S_TEMP1_CUBE);
	export_constant(IG_S_TEMP2_CUBE);
	export_constant(IG_BLACKSMITH_BLESS_BOX_3);
	export_constant(IG_SHADOW_HAMMER_BOX_3);
	export_constant(IG_EDP);
	export_constant(IG_MF_NOTELEPORT);
	export_constant(IG_MF_NORETURN);
	export_constant(IG_GIANT_FLY_WING);
	export_constant(IG_CLASS_SHADOW_WP_CUBE);
	export_constant(IG_CLASS_SHADOW_AM_CUBE);
	export_constant(IG_CLASS_SHADOW_SU_CUBE);
	export_constant(IG_CLASS_SHADOW_SD_CUBE);
	export_constant(IG_CLASS_SHADOW_PD_CUBE);
	export_constant(IG_CLASS_SHADOW_EA_CUBE);
	export_constant(IG_ENCHANT_STONE_BOX30);
	export_constant(IG_ENCHANT_STONE_BOX31);
	export_constant(IG_ENCHANT_STONE_BOX32);
	export_constant(IG_ANCIENT_HERO_BOX_2);
	export_constant(IG_ANCIENT_HERO_BOX_3);
	export_constant(IG_INTAKE_HAIR_BOX);
	export_constant(IG_PONYTAIL_HAIR_BOX);
	export_constant(IG_ALCHEMIST_BOX);
	export_constant(IG_GIANT_FLY_WING_2500);
	export_constant(IG_C_GIANT_FLY_WING_BOX);
	export_constant(IG_C_SIEGE_SCROLL_BOX1_10);
	export_constant(IG_C_SIEGE_SCROLL_BOX2_30);
	export_constant(IG_A_3_LIFE_POTION_10PACK);
	export_constant(IG_A_3_LIFE_POTION_PACK);
	export_constant(IG_A_INFINITY_10_BOX);
	export_constant(IG_A_INFINITY_BOX);
	export_constant(IG_C_ACID_B_50BOX);
	export_constant(IG_C_ACID_B_500_BOX);
	export_constant(IG_FIRST_AID_KIT_B);
	export_constant(IG_BOARDING_HALTER_BOX7);
	export_constant(IG_COSTAMA_EGG21);
	export_constant(IG_CRYSTAL_OF_GRUDGE);
	export_constant(IG_WING_OF_BAALZEBUB_BOX);
	export_constant(IG_POROROCA_SHOES_BUNDLE_A);
	export_constant(IG_LIAN_BUNDLE_B);
	export_constant(IG_SPRINT_BUNDLE_A);
	export_constant(IG_ETRAN_BUNDLE_A);
	export_constant(IG_ROSE_BUNDLE_A);
	export_constant(IG_ORLEANS_BUNDLE_A);
	export_constant(IG_BLACK_SHIBA_BUNDLE_A);
	export_constant(IG_VALKYRIE_BUNDLE_A);
	export_constant(IG_KARDUI_BUNDLE_A);
	export_constant(IG_CLOSEDMIND_BOX);
	export_constant(IG_COOKIE_BAG_B);
	export_constant(IG_SHADOW_BOX2);
	export_constant(IG_SHADOW_BOX);
	export_constant(IG_PHYSICAL_S_PACKAGE);
	export_constant(IG_MAGICAL_S_PACKAGE);
	export_constant(IG_POWER_BOX2);
	export_constant(IG_POWER_BOX1);
	export_constant(IG_MAIL_BREAKER_BOX1);
	export_constant(IG_HARDBACK_BOX1);
	export_constant(IG_SWORD_BREAKER_BOX1);
	export_constant(IG_BOW_OF_RUDRA_BOX1);
	export_constant(IG_BLOODY_ROAR_BOX1);
	export_constant(IG_BLOODY_IRON_BALL_BOX1);
	export_constant(IG_SIEGE_SUPPLY_BOX);
	export_constant(IG_PC_BANG_COIN_BOX1);
	export_constant(IG_ACIDBOMB_BOX50);
	export_constant(IG_PC_BANG_COIN_BOX2);
	export_constant(IG_PC_BANG_COIN_BOX4);
	export_constant(IG_FOOD_BOX_LV1);
	export_constant(IG_FOOD_BOX_LV2);
	export_constant(IG_FOOD_BOX_LV3);
	export_constant(IG_TRIAL_BOX);
	export_constant(IG_REPAIR_SCROLL_BOX10);
	export_constant(IG_HOCKEY_MASK_BOX);
	export_constant(IG_CLOCK_TOWER_CARD_BOX);
	export_constant(IG_GEFFENIA_CARD_BOX);
	export_constant(IG_OWL_CARD_BOX);
	export_constant(IG_GHOST_CARD_BOX);
	export_constant(IG_NIGHTMARE_CARD_BOX);
	export_constant(IG_STARTER_PACK);
	export_constant(IG_LOVE_ANGEL_BOX);
	export_constant(IG_SQUIRREL_BOX);
	export_constant(IG_GOGO_BOX);
	export_constant(IG_CRUSADER_CARD_BOX);
	export_constant(IG_ALCHEMIST_CARD_BOX);
	export_constant(IG_ROGUE_CARD_BOX);
	export_constant(IG_BARD_DANCER_CARD_BOX);
	export_constant(IG_SAGE_CARD_BOX);
	export_constant(IG_MONK_CARD_BOX);
	export_constant(IG_TW_VALENTINE_SCROLL);
	export_constant(IG_LOVE_ANGEL_BOX_1M);
	export_constant(IG_SQUIRREL_BOX_1M);
	export_constant(IG_GOGO_BOX_1M);
	export_constant(IG_WASTELAND_OUTLAW_BOX);
	export_constant(IG_LEVER_ACTION_RIFLE_BOX);
	export_constant(IG_SPIRITUAL_TUNIC_BOX);
	export_constant(IG_RECUPERATIVE_ARMOR_BOX);
	export_constant(IG_SHELTER_RESISTANCE_BOX);
	export_constant(IG_SYLPHID_MANTEAU_BOX);
	export_constant(IG_REFRESH_SHOES_BOX);
	export_constant(IG_TOAST_BOX);
	export_constant(IG_BUBBLEGUM_LOWER_BOX);
	export_constant(IG_TW_SCROLL01);
	export_constant(IG_PICTURE_DIARY_BOX);
	export_constant(IG_MINI_HEART_BOX);
	export_constant(IG_NEWCOMER_BOX);
	export_constant(IG_KID_BOX);
	export_constant(IG_MAGIC_CASTLE_BOX);
	export_constant(IG_BULGING_HEAD_BOX);
	export_constant(IG_PICTURE_DIARY_BOX_1M);
	export_constant(IG_MINI_HEART_BOX_1M);
	export_constant(IG_NEWCOMER_BOX_1M);
	export_constant(IG_KID_BOX_1M);
	export_constant(IG_MAGIC_CASTLE_BOX_1M);
	export_constant(IG_BULGING_HEAD_BOX_1M);
	export_constant(IG_F_LOVE_ANGEL_BOX);
	export_constant(IG_F_SQUIRREL_BOX);
	export_constant(IG_F_GOGO_BOX);
	export_constant(IG_F_LOVE_ANGEL_BOX_1M);
	export_constant(IG_F_SQUIRREL_BOX_1M);
	export_constant(IG_F_GOGO_BOX_1M);
	export_constant(IG_F_WASTELAND_OUTLAW_BOX);
	export_constant(IG_F_ALL_IN_ONE_RING_BOX);
	export_constant(IG_F_SPRITUAL_TUNIC_BOX);
	export_constant(IG_F_RECUPERATIVE_BOX);
	export_constant(IG_F_SHELTER_RESIST_BOX);
	export_constant(IG_F_SYLPHID_MANTEAU_BOX);
	export_constant(IG_F_TOAST_BOX);
	export_constant(IG_F_REPAIR_SCROLL_BOX);
	export_constant(IG_F_REPAIR_SCROLL_BOX10);
	export_constant(IG_F_HOCKEY_MASK_BOX);
	export_constant(IG_F_OBSERVER_BOX);
	export_constant(IG_F_NAGAN_BOX);
	export_constant(IG_F_SKEWER_BOX);
	export_constant(IG_F_SURVIVAL_ROD_BOX);
	export_constant(IG_F_QUADRILLE_BOX);
	export_constant(IG_F_GREAT_AXE_BOX);
	export_constant(IG_F_BLOODY_ROAR_BOX);
	export_constant(IG_F_HARDBACK_BOX);
	export_constant(IG_F_FIRE_BRAND_BOX);
	export_constant(IG_F_IMMATERIAL_SWORD_BOX);
	export_constant(IG_F_UNHOLY_TOUCH_BOX);
	export_constant(IG_F_CLACK_OF_SERVIVAL_BOX);
	export_constant(IG_F_MASQUERADE_BOX);
	export_constant(IG_F_ORC_HERO_HELM_BOX);
	export_constant(IG_F_EAR_OF_DEVIL_WING_BOX);
	export_constant(IG_F_DARK_BLINDFOLD_BOX);
	export_constant(IG_F_K_DROOPING_KITTY_BOX);
	export_constant(IG_F_CORSAIR_BOX);
	export_constant(IG_F_BLOODY_IRON_BALL_BOX);
	export_constant(IG_F_SPIRITUAL_RING_BOX);
	export_constant(IG_F_INFILTRATOR_BOX);
	export_constant(IG_F_MURAMASA_BOX);
	export_constant(IG_F_EXCALIBUR_BOX);
	export_constant(IG_F_COMBAT_KNIFE_BOX);
	export_constant(IG_F_COUNTER_DAGGER_BOX);
	export_constant(IG_F_KAISER_KNUCKLE_BOX);
	export_constant(IG_F_MIGHTY_STAFF_BOX);
	export_constant(IG_F_RIGHT_EPSILON_BOX);
	export_constant(IG_F_BALISTAR_BOX);
	export_constant(IG_F_DIARY_OF_GREAT_SAGE);
	export_constant(IG_F_ASURA_BOX);
	export_constant(IG_F_APPLE_OF_ARCHER_BOX);
	export_constant(IG_F_BUNNY_BAND_BOX);
	export_constant(IG_F_SAHKKAT_BOX);
	export_constant(IG_F_LORD_CIRCLET_BOX);
	export_constant(IG_F_ELVEN_EARS_BOX);
	export_constant(IG_F_STEEL_FLOWER_BOX);
	export_constant(IG_F_CRITICAL_RING_BOX);
	export_constant(IG_F_EARRING_BOX);
	export_constant(IG_F_RING_BOX);
	export_constant(IG_F_NECKLACE_BOX);
	export_constant(IG_F_GLOVE_BOX);
	export_constant(IG_F_BROOCH_BOX);
	export_constant(IG_F_ROSARY_BOX);
	export_constant(IG_F_SAFETY_RING_BOX);
	export_constant(IG_F_VESPER_CORE_BOX01);
	export_constant(IG_F_VESPER_CORE_BOX02);
	export_constant(IG_F_VESPER_CORE_BOX03);
	export_constant(IG_F_VESPER_CORE_BOX04);
	export_constant(IG_F_VIGORGRA_PACKAGE1);
	export_constant(IG_F_VIGORGRA_PACKAGE2);
	export_constant(IG_F_VIGORGRA_PACKAGE5);
	export_constant(IG_F_VIGORGRA_PACKAGE6);
	export_constant(IG_F_VIGORGRA_PACKAGE7);
	export_constant(IG_F_VIGORGRA_PACKAGE8);
	export_constant(IG_F_VIGORGRA_PACKAGE9);
	export_constant(IG_F_VIGORGRA_PACKAGE10);
	export_constant(IG_F_VIGORGRA_PACKAGE11);
	export_constant(IG_F_VIGORGRA_PACKAGE12);
	export_constant(IG_F_ASPERSIO_5_SCROLL_BOX);
	export_constant(IG_F_ASPERSIO_5_BOX30);
	export_constant(IG_F_ASPERSIO_5_BOX50);
	export_constant(IG_HEALING_STAFF_BOX);
	export_constant(IG_PRAXINUS_BOX);
	export_constant(IG_F_PET_EGG_SCROLL9);
	export_constant(IG_F_MAGESTIC_GOAT_BOX);
	export_constant(IG_F_PET_EGG_SCROLL3);
	export_constant(IG_F_EXECUTIONER_BOX);
	export_constant(IG_F_CUTLAS_BOX);
	export_constant(IG_F_MOONLIGHT_SWORD_BOX);
	export_constant(IG_F_SPANNER_BOX);
	export_constant(IG_F_SOLAR_SWORD_BOX);
	export_constant(IG_F_TOMAHAWK_BOX);
	export_constant(IG_F_BOW_OF_RUDRA_BOX);
	export_constant(IG_F_POLE_AXE_BOX);
	export_constant(IG_THOUGHTFUL_HAT_BOX);
	export_constant(IG_F_THOUGHTFUL_HAT_BOX);
	export_constant(IG_E_THOUGHTFUL_HAT_BOX);
	export_constant(IG_ZODIAC_DIADEM_PACK);
	export_constant(IG_ZODIAC_CROWN_PACK);
	export_constant(IG_DUN_VOUCHER_BOX1);
	export_constant(IG_DUN_VOUCHER_BOX2);
	export_constant(IG_BLUEBOXOFQUESTIONS);
	export_constant(IG_ENCHANT_STONE_BOX33);
	export_constant(IG_PC_BANG_COIN_BOX3);
	export_constant(IG_PCBANG_GIFT_BOX);
	export_constant(IG_PCBANG_COUPON_BOX2);
	export_constant(IG_PCBANG_COUPON_BOX3);
	export_constant(IG_CHANCE_BOX);
	export_constant(IG_ATTEND_3DAY_BOX);
	export_constant(IG_ATTEND_7DAY_BOX);
	export_constant(IG_ATTEND_10DAY_BOX);
	export_constant(IG_ATTEND_15DAY_BOX);
	export_constant(IG_ATTEND_20DAY_BOX);
	export_constant(IG_ATTEND_25DAY_BOX);
	export_constant(IG_GOLDPC_FIRST_BOX);
	export_constant(IG_TICKET_GIFT_BOX);
	export_constant(IG_TICKET_GIFT_BOX2);
	export_constant(IG_ASSORTED_SCROLL_BOX);
	export_constant(IG_DROOPING_KITTY_BOX);
	export_constant(IG_MAGESTIC_GOAT_BOX);
	export_constant(IG_DEVIRUCHI_CAP_BOX);
	export_constant(IG_EXECUTIONER_BOX);
	export_constant(IG_BROOD_AXE_BOX);
	export_constant(IG_TOMAHAWK_BOX);
	export_constant(IG_BOW_OF_RUDRA_BOX);
	export_constant(IG_CUTLAS_BOX);
	export_constant(IG_SOLAR_SWORD_BOX);
	export_constant(IG_SWORD_BREAKER_BOX);
	export_constant(IG_MAIL_BREAKER_BOX);
	export_constant(IG_MOONLIGHT_SWORD_BOX);
	export_constant(IG_SPANNER_BOX);
	export_constant(IG_WEAPON_CARD_SCROLL);
	export_constant(IG_ARMOR_CARD_SCROLL);
	export_constant(IG_HELMET_CARD_SCROLL);
	export_constant(IG_HOOD_CARD_SCROLL);
	export_constant(IG_HOOD_CARD_SCROLL2);
	export_constant(IG_SHOES_CARD_SCROLL);
	export_constant(IG_ACCY_CARD_SCROLL);
	export_constant(IG_WEAPON_CARD_SCROLL2);
	export_constant(IG_WEAPON_CARD_SCROLL3);
	export_constant(IG_ARMOR_CARD_SCROLL2);
	export_constant(IG_ACCY_CARD_SCROLL2);
	export_constant(IG_ASPERSIO_5_BOX30);
	export_constant(IG_ASPERSIO_5_BOX50);
	export_constant(IG_HANDCUFF_BOX);
	export_constant(IG_INFILTRATOR_BOX1);
	export_constant(IG_MURAMASA_BOX1);
	export_constant(IG_EXCALIBUR_BOX1);
	export_constant(IG_COMBAT_KNIFE_BOX1);
	export_constant(IG_COUNTER_DAGGER_BOX1);
	export_constant(IG_KAISER_KNUCKLE_BOX1);
	export_constant(IG_POLE_AXE_BOX1);
	export_constant(IG_MIGHTY_STAFF_BOX1);
	export_constant(IG_RIGHT_EPSILON_BOX1);
	export_constant(IG_BALISTAR_BOX1);
	export_constant(IG_DIARY_OF_SAGE_BOX1);
	export_constant(IG_ASURA_BOX1);
	export_constant(IG_APPLE_OF_ARCHER_BOX1);
	export_constant(IG_BUNNY_BAND_BOX1);
	export_constant(IG_SAHKKAT_BOX1);
	export_constant(IG_LORD_CIRCLET_BOX1);
	export_constant(IG_ELVEN_EARS_BOX1);
	export_constant(IG_STEEL_FLOWER_BOX1);
	export_constant(IG_CRITICAL_RING_BOX1);
	export_constant(IG_EARRING_BOX1);
	export_constant(IG_RING_BOX1);
	export_constant(IG_NECKLACE_BOX1);
	export_constant(IG_GLOVE_BOX1);
	export_constant(IG_BROOCH_BOX1);
	export_constant(IG_ROSARY_BOX1);
	export_constant(IG_SAFETY_RING_BOX1);
	export_constant(IG_VESPER_CORE01_BOX1);
	export_constant(IG_VESPER_CORE02_BOX1);
	export_constant(IG_VESPER_CORE03_BOX1);
	export_constant(IG_VESPER_CORE04_BOX1);
	export_constant(IG_DROOPING_KITTY_BOX1);
	export_constant(IG_MAGESTIC_GOAT_BOX1);
	export_constant(IG_DEVIRUCHI_CAP_BOX1);
	export_constant(IG_EXECUTIONER_BOX1);
	export_constant(IG_BROOD_AXE_BOX1);
	export_constant(IG_TOMAHAWK_BOX1);
	export_constant(IG_CUTLAS_BOX1);
	export_constant(IG_SOLAR_SWORD_BOX1);
	export_constant(IG_MOONLIGHT_SWORD_BOX1);
	export_constant(IG_SPANNER_BOX1);
	export_constant(IG_FREYJA_OVERCOAT_BOX);
	export_constant(IG_FREYJA_BOOTS_BOX);
	export_constant(IG_FREYJA_CAPE_BOX);
	export_constant(IG_FREYJA_CROWN_BOX);
	export_constant(IG_BRO_PACKAGE1);
	export_constant(IG_PECOPECO_HAIRBAND_BOX);
	export_constant(IG_RED_GLASSES_BOX);
	export_constant(IG_WHISPER_MASK_BOX);
	export_constant(IG_GOLD_BOX_);
	export_constant(IG_SILVER_BOX_);
	export_constant(IG_PECOPECO_HAIRBAND_BOX1);
	export_constant(IG_RED_GLASSES_BOX1);
	export_constant(IG_WHISPER_MASK_BOX1);
	export_constant(IG_RAMEN_HAT_BOX1);
	export_constant(IG_5_ANNIVERSARY_COIN_BOX);
	export_constant(IG_CERTIFICATE_TW_BOX);
	export_constant(IG_NAGAN_BOX);
	export_constant(IG_SKEWER_BOX);
	export_constant(IG_SURVIVAL_ROD_BOX);
	export_constant(IG_QUADRILLE_BOX);
	export_constant(IG_GREAT_AXE_BOX);
	export_constant(IG_BLOODY_ROAR_BOX);
	export_constant(IG_HARDBACK_BOX);
	export_constant(IG_IMMATERIAL_SWORD_BOX);
	export_constant(IG_UNHOLY_TOUCH_BOX);
	export_constant(IG_CLOAK_OF_SURVIVAL_BOX);
	export_constant(IG_MASQUERADE_BOX);
	export_constant(IG_ORC_HERO_HELM_BOX);
	export_constant(IG_EVIL_WING_EARS_BOX);
	export_constant(IG_DARK_BLINDFOLD_BOX);
	export_constant(IG_KRO_DROOPING_KITTY_BOX);
	export_constant(IG_CORSAIR_BOX);
	export_constant(IG_BLOODY_IRON_BALL_BOX);
	export_constant(IG_SPIRITUAL_RING_BOX);
	export_constant(IG_NAGAN_BOX1);
	export_constant(IG_SKEWER_BOX1);
	export_constant(IG_SURVIVAL_ROD_BOX1);
	export_constant(IG_QUADRILLE_BOX1);
	export_constant(IG_GREAT_AXE_BOX1);
	export_constant(IG_FIRE_BRAND_BOX1);
	export_constant(IG_IMMATERIAL_SWORD_BOX1);
	export_constant(IG_UNHOLY_TOUCH_BOX1);
	export_constant(IG_CLOAK_OF_SURVIVAL_BOX1);
	export_constant(IG_MASQUERADE_BOX1);
	export_constant(IG_ORC_HERO_HELM_BOX1);
	export_constant(IG_EVIL_WING_EARS_BOX1);
	export_constant(IG_DARK_BLINDFOLD_BOX1);
	export_constant(IG_KRO_DROOPING_KITTY_BOX1);
	export_constant(IG_CORSAIR_BOX1);
	export_constant(IG_SPIRITUAL_RING_BOX1);
	export_constant(IG_INDONESIA_BOX);
	export_constant(IG_GREEN_BOX_);
	export_constant(IG_RESIST_BOX1);
	export_constant(IG_RESIST_BOX2);
	export_constant(IG_STAT_BOOST1);
	export_constant(IG_STAT_BOOST2);
	export_constant(IG_STAT_BOOST3);
	export_constant(IG_STAT_BOOST4);
	export_constant(IG_OBSERVER_BOX);
	export_constant(IG_LUCKY_CLIP_BOX);
	export_constant(IG_F_LEVER_ACTION_RIFLE_BO);
	export_constant(IG_F_REFRESH_SHOES_BOX);
	export_constant(IG_F_PECOPECO_HAIRBAND_BOX);
	export_constant(IG_F_RED_GLASSES_BOX);
	export_constant(IG_F_WHISPER_MASK_BOX);
	export_constant(IG_F_RAMEN_HAT_BOX);
	export_constant(IG_F_VIGORGRA_PACKAGE3);
	export_constant(IG_F_VIGORGRA_PACKAGE4);
	export_constant(IG_NOVICE_SET_BOX);
	export_constant(IG_BEHOLDER_RING_BOX2);
	export_constant(IG_HALLOW_RING_BOX2);
	export_constant(IG_CLAMOROUS_RING_BOX2);
	export_constant(IG_CHEMICAL_RING_BOX2);
	export_constant(IG_INSECTICIDE_RING_BOX2);
	export_constant(IG_FISHER_RING_BOX2);
	export_constant(IG_DECUSSATE_RING_BOX2);
	export_constant(IG_BLOODY_RING_BOX2);
	export_constant(IG_SATANIC_RING_BOX2);
	export_constant(IG_DRAGOON_RING_BOX2);
	export_constant(IG_FPICTURE_DIARY_BOX);
	export_constant(IG_FMINI_HEART_BOX);
	export_constant(IG_FNEWCOMER_BOX);
	export_constant(IG_FKID_BOX);
	export_constant(IG_FMAGIC_CASTLE_BOX);
	export_constant(IG_FBULGING_HEAD_BOX);
	export_constant(IG_FPICTURE_DIARY_BOX_1M);
	export_constant(IG_FMINI_HEART_BOX_1M);
	export_constant(IG_FNEWCOMER_BOX_1M);
	export_constant(IG_FKID_BOX_1M);
	export_constant(IG_FMAGIC_CASTLE_BOX_1M);
	export_constant(IG_FBULGING_HEAD_BOX_1M);
	export_constant(IG_FHEALING_STAFF_BOX);
	export_constant(IG_FPRAXINUS_BOX);
	export_constant(IG_MUFFLER_C_BOX);
	export_constant(IG_VALKYRJA_S_SHIELD_C_BOX);
	export_constant(IG_SKUL_RING_C_BOX);
	export_constant(IG_S_BARRICADE_REPAIR_KIT);
	export_constant(IG_S_GSTONE_REPAIR_KIT);
	export_constant(IG_ARDOR_SCROLL);
	export_constant(IG_HOLY_SABER_BOX);
	export_constant(IG_BOOK_OF_PRAYER_BOX);
	export_constant(IG_PHENOMENA_WHIP_BOX);
	export_constant(IG_STAFF_OF_DARKNESS_BOX);
	export_constant(IG_MONK_KNUCKLE_BOX);
	export_constant(IG_MACE_OF_MADNESS_BOX);
	export_constant(IG_SPEAR_OF_EXCELLENT_BOX);
	export_constant(IG_BOW_OF_EVIL_BOX);
	export_constant(IG_KATAR_OF_SPEED_BOX);
	export_constant(IG_SS_REVOLVER_BOX);
	export_constant(IG_XMAS_SCROLL);
	export_constant(IG_FORTUNE_SWORD_BOX_I);
	export_constant(IG_HOUSE_AUGER_BOX_I);
	export_constant(IG_KAMAITACHI_BOX_I);
	export_constant(IG_BERSERK_GUITAR_BOX_I);
	export_constant(IG_DOOM_SLAYER_BOX_I);
	export_constant(IG_HUUMA_BLAZE_BOX_I);
	export_constant(IG_ODIN_S_BLESSING_BOX_I);
	export_constant(IG_RING_OF_F_LORD_BOX_I);
	export_constant(IG_RING_OF_RESON_BOX_I);
	export_constant(IG_BOY_S_CAP_BOX_I);
	export_constant(IG_ULLE_CAP_BOX_I);
	export_constant(IG_SPINX_HELM_BOX_I);
	export_constant(IG_POWER_OF_THOR_BOX);
	export_constant(IG_ACTI_POTION_BOX);
	export_constant(IG_ACTI_POTION_BOX2);
	export_constant(IG_HALF_ASPRIKA_BOX);
	export_constant(IG_HALF_BRYNHILD_BOX);
	export_constant(IG_SPIKED_SCARF_BOX);
	export_constant(IG_RAINBOW_SCARF_BOX);
	export_constant(IG_3D_GLASSES_BOX);
	export_constant(IG_CHEER_SCARF_BOX);
	export_constant(IG_CHEER_SCARF2_BOX);
	export_constant(IG_CHEER_SCARF3_BOX);
	export_constant(IG_CHEER_SCARF4_BOX);
	export_constant(IG_CHEER_SCARF6_BOX);
	export_constant(IG_CHEER_SCARF8_BOX);
	export_constant(IG_CHEER_SCARF10_BOX);
	export_constant(IG_CHEER_SCARF10_BOX2);
	export_constant(IG_RING_OF_VALKYRIE_BOX);
	export_constant(IG_RAPID_LIFE_WATER_BOX);
	export_constant(IG_LOLLI_POP_BOX);
	export_constant(IG_SPECIAL_BOX1);
	export_constant(IG_SPECIAL_BOX2);
	export_constant(IG_SPECIAL_BOX3);
	export_constant(IG_SPECIAL_BOX4);
	export_constant(IG_SPECIAL_BOX5);
	export_constant(IG_PCBANG_COUPON_BOX);
	export_constant(IG_B_HALTER_BOX_30DAYS);
	export_constant(IG_PCBANG_COUPON_BOX4);
	export_constant(IG_OLD_HAT_BOX);
	export_constant(IG_SAPA_FEAT_CERT_PACK);
	export_constant(IG_ARCHANGEL_WING_BOX);
	export_constant(IG_TRANS_BOX_DEVI);
	export_constant(IG_TRANS_BOX_RAY_ARCH);
	export_constant(IG_TRANS_BOX_MAVKA);
	export_constant(IG_TRANS_BOX_MARDUK);
	export_constant(IG_TRANS_BOX_BANSHEE);
	export_constant(IG_TRANS_BOX_GOLEM);
	export_constant(IG_UPG_REVOLVER_BOX2);
	export_constant(IG_UPG_TWOHAND_SWORD_BOX2);
	export_constant(IG_UPG_KATAR_BOX2);
	export_constant(IG_UPG_TWO_HANDED_AXE_BOX2);
	export_constant(IG_UPG_LANCE_BOX2);
	export_constant(IG_UPG_BOOK_BOX2);
	export_constant(IG_UPG_STAFF_BOX2);
	export_constant(IG_UPG_DAGGER_BOX2);
	export_constant(IG_UPG_MACE_BOX2);
	export_constant(IG_UPG_BOW_BOX2);
	export_constant(IG_GRYPHON_EGG_SCROLL);
	export_constant(IG_ASPD_POTION_BOX10);
	export_constant(IG_DRAGON_EGG_SCROLL);
	export_constant(IG_2011_RWC_SCROLL_KR);
	export_constant(IG_CHANGE_NAME_CARD_BOX2);
	export_constant(IG_PCBANG_COUPON_BOX5);
	export_constant(IG_CRU_SCROLL);
	export_constant(IG_EVENT_GIFT_BOX);
	export_constant(IG_EVENT_GIFT_BOX_);
	export_constant(IG_TIME_GUARDIAN_BOX);
	export_constant(IG_BEGINNER_KIT_BOX);
	export_constant(IG_MOTHER_LOVE_BOX);
	export_constant(IG_OLD_ORE_BOX_);
	export_constant(IG_BOARDING_HALTER_BOX3);
	export_constant(IG_UNDEAD_EGG);
	export_constant(IG_GIRLS_HEART);
	export_constant(IG_C_CENTER_POT_BOX);
	export_constant(IG_C_AWAKENING_POT_BOX);
	export_constant(IG_C_BERSERK_POT_BOX);
	export_constant(IG_C_WING_OF_FLY_BOX);
	export_constant(IG_REFINE_ORE_BOX3);
	export_constant(IG_GUARANTEE7_BOX);
	export_constant(IG_WOLFKING_SCROLL);
	export_constant(IG_ALMIGHTY_BOX2);
	export_constant(IG_HD_ELUNIUM_BOX30);
	export_constant(IG_HD_ORIDECON_BOX30);
	export_constant(IG_KINGS_GIFT);
	export_constant(IG_C_CENTER_POT_3D_BOX);
	export_constant(IG_C_AWAKENING_POT_3D_BOX);
	export_constant(IG_C_BERSERK_POT_3D_BOX);
	export_constant(IG_BM_LIMIT_PACK);
	export_constant(IG_GOLDENTREASUREBOX);
	export_constant(IG_UNLIMITED_10_BOX);
	export_constant(IG_XMAX_EGG_KR);
	export_constant(IG_C_FESTIVAL_TICKET);
	export_constant(IG_REFINE_ORE_BOX4);
	export_constant(IG_REFINE_ORE_BOX4_SET10);
	export_constant(IG_REFINE_ORE_BOX4_SET20);
	export_constant(IG_NEW_YEAR_GIFT_BOX);
	export_constant(IG_PCBANG_COUPON_BOX6);
	export_constant(IG_SEALED_D_LORD_SCROLL);
	export_constant(IG_STEALFIGHTER_20LV);
	export_constant(IG_STEALFIGHTER_25LV);
	export_constant(IG_KINGS_GIFT2);
	export_constant(IG_HAPPY_CALL_BOX);
	export_constant(IG_SEALED_KNIGHT_WS_SCROLL);
	export_constant(IG_C_WING_OF_FLY_1DAY_BOX);
	export_constant(IG_SILVERVINE_BOX10_);
	export_constant(IG_SILVERVINE_BOX110);
	export_constant(IG_SEALED_BERZ_SCROLL);
	export_constant(IG_3_LIFE_POTION_PACK);
	export_constant(IG_3_LIFE_POTION_10PACK);
	export_constant(IG_CLEARBOX_S);
	export_constant(IG_SEALED_KIEL_SCROLL);
	export_constant(IG_SEALED_GLOOM_SCROLL);
	export_constant(IG_REFINE_ORE_BOX5);
	export_constant(IG_REFINE_ORE_BOX5_SET10);
	export_constant(IG_ANGELING_PACKAGE);
	export_constant(IG_DEVILING_PACKAGE);
	export_constant(IG_OLD_HAT_BOX_);
	export_constant(IG_MEMORIAL_BOX);
	export_constant(IG_WET_CARDALBUM);
	export_constant(IG_GOLDEN_CARD);
	export_constant(IG_SHADOW_BOX3);
	export_constant(IG_11TH_S_PACKAGE);
	export_constant(IG_SILVERVINE_BOX10_2);
	export_constant(IG_SILVERVINE_BOX110_2);
	export_constant(IG_GEMSTONE_SHADOW_BOX);
	export_constant(IG_SEALED_F_BISHOP_SCROLL);
	export_constant(IG_HANGULDAY_BOX);
	export_constant(IG_3_LIFE_POTION_PACK2);
	export_constant(IG_3_LIFE_POTION_10PACK2);
	export_constant(IG_SEALED_IFRIT_SCROLL);
	export_constant(IG_BISCUIT_STICK_SET);
	export_constant(IG_PREMIUM_BOOK_BOX);
	export_constant(IG_LI_EMPELIUM_BOX);
	export_constant(IG_LI_UPG_BUCKLER_BOX);
	export_constant(IG_REFINE_ORE_BOX6);
	export_constant(IG_REFINE_ORE_BOX6_SET10);
	export_constant(IG_SEALED_TURTLEG_SCROLL);
	export_constant(IG_SEALED_BACSOJIN_SCROLL);
	export_constant(IG_GREED_SHADOW_BOX);
	export_constant(IG_HEAL_SHADOW_BOX);
	export_constant(IG_HIDING_SHADOW_BOX);
	export_constant(IG_CLOAKING_SHADOW_BOX);
	export_constant(IG_COSTUME_FESTIVAL_BOX2);
	export_constant(IG_C_WING_OF_FLY_5DAY_BOX);
	export_constant(IG_TELEPORT_SHADOW_BOX);
	export_constant(IG_STEAL_SHADOW_BOX);
	export_constant(IG_SEALED_PHARAOH_SCROLL);
	export_constant(IG_QUESTION_BOX);
	export_constant(IG_SEALED_M_FLOWER_SCROLL);
	export_constant(IG_SEALED_B_YGNIZEM_SCROLL);
	export_constant(IG_REFINE_ORE_BOX7);
	export_constant(IG_REFINE_ORE_BOX7_SET10);
	export_constant(IG_SEALED_APO_H_SCROLL);
	export_constant(IG_PC_NOMALBOX);
	export_constant(IG_PC_WOODENBOX);
	export_constant(IG_PC_GOLDENBOX);
	export_constant(IG_PC_PLATINUMBOX);
	export_constant(IG_3_LIFE_POTION_PACK4);
	export_constant(IG_3_LIFE_POTION_10PACK4);
	export_constant(IG_SEALED_DRACULA_SCROLL);
	export_constant(IG_BEARERS_SHADOW_BOX);
	export_constant(IG_VIGORGRA_PACKAGE_V4);
	export_constant(IG_VIGORGRA_PACKAGE_SET_V4);
	export_constant(IG_SEALED_B_SHECIL_SCROLL);
	export_constant(IG_NYANGVINE_BOX4);
	export_constant(IG_NYANGVINE_BOX10);
	export_constant(IG_NYANGVINE_BOX40);
	export_constant(IG_REFINE_ORE_BOX8);
	export_constant(IG_REFINE_ORE_BOX8_SET10);
	export_constant(IG_SEALED_CARD);
	export_constant(IG_LI_HD_ELUNIUM_BOX30);
	export_constant(IG_LI_HD_ORIDECON_BOX30);
	export_constant(IG_UNLIMITED_BOX3);
	export_constant(IG_UNLIMITED_10_BOX3);
	export_constant(IG_GUARANTEE_RELAX_SCROLL);
	export_constant(IG_LIMIT_MANUAL_BOX);
	export_constant(IG_SEALED_DRACULA_SCROLL2);
	export_constant(IG_3_LIFE_POTION_10PACK5);
	export_constant(IG_3_LIFE_POTION_PACK5);
	export_constant(IG_SEALED_MYSTERIOUS_EGG);
	export_constant(IG_SEALED_DRACULA_ALBUM);
	export_constant(IG_LIMIT_POWER_BOOSTER_BOX);
	export_constant(IG_LIMIT_POWER_BOOSTER100);
	export_constant(IG_SEALED_BERZ_ALBUM);
	export_constant(IG_SEALED_BERZ_SCROLL2);
	export_constant(IG_NYANGVINE_BOX200);
	export_constant(IG_APRILGIFTBOX);
	export_constant(IG_NOVEMBERGIFTBOX);
	export_constant(IG_SEPTEMBERGIFTBOX);
	export_constant(IG_REFINE_ORE_BOX9);
	export_constant(IG_REFINE_ORE_BOX9_SET10);
	export_constant(IG_2015_NEW_YEAR_SCROLL);
	export_constant(IG_NEW_YEAR_SHADOW_CUBE);
	export_constant(IG_2015GOLDPCBOX);
	export_constant(IG_ALMIGHTY_BOX4);
	export_constant(IG_ALMIGHTY100_BOX2);
	export_constant(IG_SEALED_SCROLL2);
	export_constant(IG_INVISIBLE_BOX);
	export_constant(IG_FREEZE_DREAM);
	export_constant(IG_LAPINE_DDUKDDAKBOX);
	export_constant(IG_GUNSLINGER_BOX);
	export_constant(IG_MINI_FAN_BOX);
	export_constant(IG_KAFRA_BOX);
	export_constant(IG_CANDY_BOX_MELEE);
	export_constant(IG_CANDY_BOX_RANGE);
	export_constant(IG_CANDY_BOX_MAGIC);
	export_constant(IG_BLOODYKNIGHT_SHIELD_BOX);
	export_constant(IG_E_WING_OF_FLY_3DAY_BOX);
	export_constant(IG_REBEGINER_BOX);
	export_constant(IG_REBEGINER_S_BOX);
	export_constant(IG_OVERWHELM_ARMOR_BOX);
	export_constant(IG_POWERFUL_HELM_BOX);
	export_constant(IG_MYSTERIOUS_PLASTIC);
	export_constant(IG_80LVUP);
	export_constant(IG_JUMPING_KIT_BOX);
	export_constant(IG_MAIN_LUCKY_BOX_);
	export_constant(IG_SILLIT_PONG_BOX);
	export_constant(IG_KUNAI_SCROLL_OF_FLAME);
	export_constant(IG_KUNAI_SCROLL_OF_ICICLE);
	export_constant(IG_KUNAI_SCROLL_OF_POISON);
	export_constant(IG_KUNAI_SCROLL_OF_SOIL);
	export_constant(IG_KUNAI_SCROLL_OF_WIND);
	export_constant(IG_C_CATPAW_7DAY_BOX_);
	export_constant(IG_CANNON_BALL_BOX);
	export_constant(IG_IRON_CANNON_BALL_BOX);
	export_constant(IG_SOUL_CANNON_BALL_BOX);
	export_constant(IG_DARK_CANNON_BALL_BOX);
	export_constant(IG_HOLY_CANNON_BALL_BOX);
	export_constant(IG_CANNON_BOX_6);
	export_constant(IG_MAGIC_GEAR_FUEL_BOX);
	export_constant(IG_REPAIRA_BOX);
	export_constant(IG_REPAIRB_BOX);
	export_constant(IG_REPAIRC_BOX);
	export_constant(IG_FLAME_STONE_BUNDLE);
	export_constant(IG_ICE_STONE_BUNDLE);
	export_constant(IG_WIND_STONE_BUNDLE);
	export_constant(IG_SHADOW_ORB_BUNDLE);
	export_constant(IG_CHARM_FIRE_BUNDLE);
	export_constant(IG_CHARM_ICE_BUNDLE);
	export_constant(IG_CHARM_WIND_BUNDLE);
	export_constant(IG_CHARM_EARTH_BUNDLE);
	export_constant(IG_KUNAI_SCROLL_EXPLOSIVE);
	export_constant(IG_GEMSTONE_BLUE);
	export_constant(IG_GEMSTONE_YL);
	export_constant(IG_GEMSTONE_RED);
	export_constant(IG_BULLET_CASE_FULL);
	export_constant(IG_BULLET_CASE_MINE);
	export_constant(IG_BULLET_CASE_TAIL);
	export_constant(IG_C_BRAID_HALF_UP_BOX);
	export_constant(IG_POENETENTIA_BOX3);
	export_constant(IG_POENETENTIA_BOX4);
	export_constant(IG_CHUSEOG_PRESENT_BOX);
	export_constant(IG_LI_NYANGVINE_BOX100_2);
	export_constant(IG_BARMUND_RUNE_BOX);
	export_constant(IG_SEALED_CARD3);
	export_constant(IG_LI_NYANGVINE_STONE_BOX3);
	export_constant(IG_RO_LIVE_SHOP_BOX);
	export_constant(IG_RO_LIVE_SHOP_EX_BOX);
	export_constant(IG_SEASON_EVT_REWARD_11);
	export_constant(IG_CANNON_BOX_ICE);
	export_constant(IG_CANNON_BOX_LIGHTNING);
	export_constant(IG_CANNON_BOX_STONE);
	export_constant(IG_CANNON_BOX_FLARE);
	export_constant(IG_CANNON_BOX_POISONING);
	export_constant(IG_KUNAI_SCROLL);
	export_constant(IG_KUNAI_SCROLL_NOTHING);
	export_constant(IG_KUNAI_SCROLL_SHADOW);
	export_constant(IG_KUNAI_SCROLL_HAMAYA);
	export_constant(IG_NW_GRENADE_BOX);
	export_constant(IG_SOA_CHARM_BUNDLE);
	export_constant(IG_SS_CHARM_BOX);
	export_constant(IG_SS_CHARM_F_BOX);
	export_constant(IG_SS_CHARM_W_BOX);
	export_constant(IG_SS_CHARM_G_BOX);
	export_constant(IG_SS_CHARM_L_BOX);
	export_constant(IG_PAYMENT_COSTUME_BOX1);
	export_constant(IG_PAYMENT_COSTUME_BOX2);
	export_constant(IG_2021_PROMO_PACKAGE_1);
	export_constant(IG_2021_PROMO_PACKAGE_2);
	export_constant(IG_E_BOARDING_HALTER_BOX);
	export_constant(IG_COSTUMEMILEAGE_PACKAGE4);
	export_constant(IG_COSTUMEMILEAGE_PACKAGE5);
	export_constant(IG_COSTUMEMILEAGE_PACKAGE6);
	export_constant(IG_EVT_RAGFES_BOX);
	export_constant(IG_KR_B_SPECIAL08);
	export_constant(IG_KR_B_SPECIAL05);
	export_constant(IG_SEASON_EVT_REWARD_12);
	export_constant(IG_SECURITY_CAMPAIGN_BOX);
	export_constant(IG_HERO_HAMMER_PACKAGE_6);
	export_constant(IG_HERO_UP_PACKAGE_6);
	export_constant(IG_HERO_TOKEN_BOX);
	export_constant(IG_JANUARYGIFTBOX_);
	export_constant(IG_FEBRUARYGIFTBOX_);
	export_constant(IG_MARCHGIFTBOX_);
	export_constant(IG_APRILGIFTBOX_);
	export_constant(IG_MAYGIFTBOX_);
	export_constant(IG_JUNEGIFTBOX_);
	export_constant(IG_JULYGIFTBOX_);
	export_constant(IG_AUGUSTGIFTBOX_);
	export_constant(IG_SEPTEMBERGIFTBOX_);
	export_constant(IG_OCTOBERGIFTBOX_);
	export_constant(IG_NOVEMBERGIFTBOX_);
	export_constant(IG_DECEMBERGIFTBOX_);
	export_constant(IG_SEASON_EVT_REWARD_1);
	export_constant(IG_2021_WINTER_EVENT_BOX1);
	export_constant(IG_2021_WINTER_EVENT_BOX2);
	export_constant(IG_ICE_F_STONE_BOX);
	export_constant(IG_BS_MAKING_S);
	export_constant(IG_MONTHLY_PACKAGE_1);
	export_constant(IG_MONTHLY_PACKAGE_2);
	export_constant(IG_MONTHLY_PACKAGE_3);
	export_constant(IG_MONTHLY_BUFF_PACKAGE);
	export_constant(IG_MONTHLY_BATTLE_PACKAGE);
	export_constant(IG_MD_AIRBOAT_EXPBOX);
	export_constant(IG_ENCHANT_TICKET_3);
	export_constant(IG_FAN_GREED_1HOUR_BOX);
	export_constant(IG_KAKAO_PLUS_BOX);
	export_constant(IG_COSTUMEMILEPACK_27_1);
	export_constant(IG_COSTUMEMILEPACK_27_2);
	export_constant(IG_COSTUMEMILEPACK_27_3);
	export_constant(IG_P_BOOSTER230_GIFT);
	export_constant(IG_BOOSTER230_GIFT);
	export_constant(IG_BOOSTER_PACK_10);
	export_constant(IG_BOOSTER_PACK_20);
	export_constant(IG_BOOSTER_PACK_40);
	export_constant(IG_BOOSTER_PACK_50);
	export_constant(IG_BOOSTER_PACK_70);
	export_constant(IG_BOOSTER_PACK_80);
	export_constant(IG_BOOSTER_PACK_110);
	export_constant(IG_BOOSTER_PACK_120);
	export_constant(IG_BOOSTER_PACK_140);
	export_constant(IG_BOOSTER_PACK_150);
	export_constant(IG_BOOSTER_PACK_170);
	export_constant(IG_BOOSTER_PACK_180);
	export_constant(IG_BOOSTER_PACK_210);
	export_constant(IG_BOOSTER_PACK_220);
	export_constant(IG_BOOSTER_PACK_240);
	export_constant(IG_BOOSTER_PACK_250);
	export_constant(IG_BOOSTER_CALL_PACKAGE);
	export_constant(IG_E_BOARDING_HALTER_BOX2);
	export_constant(IG_SHADOW_UP_BOX);
	export_constant(IG_VIVA_ADUL_HAT_BOX_11);
	export_constant(IG_EVT_MAKINGMATERIALS_BOX);
	export_constant(IG_LI_NYANGVINE_BOX1_28);
	export_constant(IG_LI_NYANGVINE_BOX2_28);
	export_constant(IG_LI_NYANGVINE_BOX3_28);
	export_constant(IG_EVT_20TH_WHITEGOLD);
	export_constant(IG_EVT_20TH_GOLD);
	export_constant(IG_EVT_20TH_SILVER);
	export_constant(IG_EVT_20TH_BRONZE);
	export_constant(IG_EVT_20TH_RETURN);
	export_constant(IG_EVT_20TH_RETURN2);
	export_constant(IG_E_CLOTH_DYE_BOX);
	export_constant(IG_PLAIN_RUNE_BOX5);
	export_constant(IG_FLAME_RUNE_BOX5);
	export_constant(IG_ICE_RUNE_BOX5);
	export_constant(IG_DEATH_RUNE_BOX5);
	export_constant(IG_RO_FESTIVAL_BOX);
	export_constant(IG_SERVICE1_M_01_BOX);
	export_constant(IG_SERVICE1_M_05_BOX);
	export_constant(IG_SERVICE1_M_07_BOX);
	export_constant(IG_SERVICE1_M_10_BOX);
	export_constant(IG_SERVICE1P_M_01_BOX);
	export_constant(IG_SERVICE1P_M_05_BOX);
	export_constant(IG_SERVICE1P_M_07_BOX);
	export_constant(IG_SERVICE1P_M_10_BOX);
	export_constant(IG_SERVICE1_F_01_BOX);
	export_constant(IG_SERVICE1_F_05_BOX);
	export_constant(IG_SERVICE1_F_07_BOX);
	export_constant(IG_SERVICE1_F_10_BOX);
	export_constant(IG_SERVICE1P_F_01_BOX);
	export_constant(IG_SERVICE1P_F_05_BOX);
	export_constant(IG_SERVICE1P_F_07_BOX);
	export_constant(IG_SERVICE1P_F_10_BOX);
	export_constant(IG_R_BEARERS_EARRING_BOX);
	export_constant(IG_R_BEARERS_PENDANT_BOX);
	export_constant(IG_R_BEARERS_ARMOR_BOX);
	export_constant(IG_R_BEARERS_SHOES_BOX);
	export_constant(IG_HASTY_WEAPON_BOX);
	export_constant(IG_HASTY_SHIELD_BOX);
	export_constant(IG_S_RELOAD_SHIELD_BOX);
	export_constant(IG_RO_ARENA_BOX);
	export_constant(IG_RO_ARENA_BOX2);
	export_constant(IG_HEROSRIA_GIFT);
	export_constant(IG_MAUTOSPELL_EARRING_BOX);
	export_constant(IG_MAUTOSPELL_PENDANT_BOX);
	export_constant(IG_MAUTOSPELL_ARMOR_BOX);
	export_constant(IG_MAUTOSPELL_SHOES_BOX);
	export_constant(IG_INFINITY_WEAPON_BOX);
	export_constant(IG_INFINITY_SHIELD_BOX);
	export_constant(IG_LUXURIOUS_BLUE_BOX);
	export_constant(IG_VR_BOOK_EVENT);
	export_constant(IG_LI_NYANGVINE_BOX1_29);
	export_constant(IG_LI_NYANGVINE_BOX2_29);
	export_constant(IG_LI_NYANGVINE_BOX3_29);
	export_constant(IG_EXP_WEAPON_BOX);
	export_constant(IG_EXP_SHIELD_BOX);
	export_constant(IG_M_BLITZ_WEAPON_BOX);
	export_constant(IG_M_BLITZ_SHIELD_BOX);
	export_constant(IG_CVT_WING_BOX);
	export_constant(IG_TEMPLE_RUNE_BOX5);
	export_constant(IG_VENOM_RUNE_BOX5);
	export_constant(IG_SOUL_RUNE_BOX5);
	export_constant(IG_CASH_BOOSTER_BOX);
	export_constant(IG_A_BUBBLE_GUM_BOX10);
	export_constant(IG_COSTUMEMILEPACK_29_1);
	export_constant(IG_COSTUMEMILEPACK_29_2);
	export_constant(IG_COSTUMEMILEPACK_29_3);
	export_constant(IG_S_BEARERS_CUBE);
	export_constant(IG_PENE_SET_CUBE);
	export_constant(IG_TEMP_SET_CUBE);
	export_constant(IG_JUSTICE_WEAPON_BOX);
	export_constant(IG_INJUSTICE_WEAPON_BOX);
	export_constant(IG_GOODNEVIL_HELM_BOX);
	export_constant(IG_F_EIN_1HDAGGER_BOX);
	export_constant(IG_SHADOW_SELECT_BOX_SET);
	export_constant(IG_REFINE_HAMMER_BOX);
	export_constant(IG_LI_NYANGVINE_BOX1_30);
	export_constant(IG_LI_NYANGVINE_BOX2_30);
	export_constant(IG_LI_NYANGVINE_BOX3_30);
	export_constant(IG_SLD_BOSS_CARD_ALBUM);
	export_constant(IG_COSTUMEMILEPACK_30_1);
	export_constant(IG_COSTUMEMILEPACK_30_2);
	export_constant(IG_COSTUMEMILEPACK_30_3);
	export_constant(IG_VIP_GIFT);
	export_constant(IG_VVIP_GIFT);
	export_constant(IG_SVIP_GIFT);
	export_constant(IG_2023_SPRING_COLLECTION);
	export_constant(IG_KR_B_SPECIAL04);
	export_constant(IG_LI_NYANGVINE_BOX1_31);
	export_constant(IG_LI_NYANGVINE_BOX2_31);
	export_constant(IG_LI_NYANGVINE_BOX3_31);
	export_constant(IG_STONE_ROBE3_BOX);
	export_constant(IG_RO_CONCERT_SCROLL);
	export_constant(IG_RO_CONCERT_SCROLL_BOX);
	export_constant(IG_FAN_UPGRADE_KIT_EX_10);
	export_constant(IG_KR_B_SPECIAL06);
	export_constant(IG_COSTUMEMILEPACK_31_1);
	export_constant(IG_COSTUMEMILEPACK_31_2);
	export_constant(IG_COSTUMEMILEPACK_31_3);
	export_constant(IG_CATPAW_1DAY_BOX);
	export_constant(IG_MILEAGE_COUPON);
	export_constant(IG_LI_NYANGVINE_BOX1_32);
	export_constant(IG_LI_NYANGVINE_BOX2_32);
	export_constant(IG_LI_NYANGVINE_BOX3_32);
	export_constant(IG_21TH_PRESENT_BOX);
	export_constant(IG_21TH_COSTUME_COLLECTION);
	export_constant(IG_S_ENCHANT_ESSENCE_BOX_3);
	export_constant(IG_SEASON_EVT_REWARD_8);
	export_constant(IG_COSTUMEMILEPACK_32_1);
	export_constant(IG_COSTUMEMILEPACK_32_2);
	export_constant(IG_COSTUMEMILEPACK_32_3);
	export_constant(IG_M_ARMOR_BOX);
	export_constant(IG_M_SHOES_BOX);
	export_constant(IG_M_PENDANT_BOX);
	export_constant(IG_M_EARRING_BOX);
	export_constant(IG_EIN_ORE_BOX);
	export_constant(IG_FATE_FRAGMENT_BOX);
	export_constant(IG_SIN_FRAGMENT_BOX);
	export_constant(IG_AMETHYST_FRAGMENT_BOX);
	export_constant(IG_SNOW_F_ORE_BOX);
	export_constant(IG_SCHMIDT_ANTIQUITY);
	export_constant(IG_SCHMIDT_ANTIQUITY2);
	export_constant(IG_AMDARAIS_ANTIQUITY);
	export_constant(IG_AMDARAIS_ANTIQUITY2);
	export_constant(IG_C_AMDARAIS_ANTIQUITY);
	export_constant(IG_C_HIMEL_ANTIQUITY);
	export_constant(IG_UNKNOWN_ANTIQUITY);
	export_constant(IG_SAKRAY_ANTIQUITY);
	export_constant(IG_AIRBOAT_ANTIQUITY);
	export_constant(IG_CELINE_KIMI_ANTIQUITY);
	export_constant(IG_MIGUEL_ANTIQUITY);
	export_constant(IG_EL_A17T_ANTIQUITY);
	export_constant(IG_PITAYA_BOSS_ANTIQUITY);
	export_constant(IG_SWEETY_ANTIQUITY);
	export_constant(IG_REDPEPPER_ANTIQUITY);
	export_constant(IG_REDPEPPER_ANTIQUITY2);
	export_constant(IG_DEMI_FREYJA_ANTIQUITY);
	export_constant(IG_JUNCEA_ANTIQUITY);
	export_constant(IG_AQUILA_ANTIQUITY);
	export_constant(IG_AQUILA_ANTIQUITY2);
	export_constant(IG_F_ICESLUG_ANTIQUIY);
	export_constant(IG_LASGAND_ANTIQUITY);
	export_constant(IG_LASGAND_ANTIQUITY2);
	export_constant(IG_THANATOS_ANTIQUITY);
	export_constant(IG_CINNAMON_PACK1);
	export_constant(IG_CINNAMON_PACK2);
	export_constant(IG_CINNAMON_PACK3);
	export_constant(IG_CINNAMON_PACK4);
	export_constant(IG_COS_ENCHANTSTONE_BOX1);
	export_constant(IG_COS_ENCHANTSTONE_BOX2);
	export_constant(IG_COS_ENCHANTSTONE_BOX3);
	export_constant(IG_T_GARDEN_EV_1);
	export_constant(IG_T_GARDEN_EV_2);
	export_constant(IG_T_GARDEN_EV_3);
	export_constant(IG_LI_NYANGVINE_BOX1_33);
	export_constant(IG_LI_NYANGVINE_BOX2_33);
	export_constant(IG_LI_NYANGVINE_BOX3_33);
	export_constant(IG_LI_NYANG_CINNA_BOX1_33);
	export_constant(IG_LI_NYANG_CINNA_BOX2_33);
	export_constant(IG_LI_NYANG_CINNA_BOX3_33);
	export_constant(IG_BL_DEPTH_EV_1);
	export_constant(IG_BL_DEPTH_EV_2);
	export_constant(IG_KR_B_SPECIAL09);
	export_constant(IG_LI_A_ELUNIUM_BOX);
	export_constant(IG_LI_A_ORIDECON_BOX);
	export_constant(IG_PRESENTBOX_EP17_2);
	export_constant(IG_PRESENTBOX_EP18);
	export_constant(IG_REFINE_EVENT_BOX);
	export_constant(IG_PRESENTBOX_EP19);
	export_constant(IG_PRESENTBOX_EP20);
	export_constant(IG_PRESENTBOX_GLASTHEIM);
	export_constant(IG_BROWN_DIA_BOX);
	export_constant(IG_COSTUMEMILEPACK_33_1);
	export_constant(IG_COSTUMEMILEPACK_33_2);
	export_constant(IG_COSTUMEMILEPACK_33_3);
	export_constant(IG_2023_XMAX_PACK_1);
	export_constant(IG_2023_XMAX_PACK_2);
	export_constant(IG_A_FORCE_BOOSTER_BOX);
	export_constant(IG_A_FORCE_BOOSTER_10_BOX);
	export_constant(IG_BROWN_DIA_BOX_3_7);
	export_constant(IG_2401_EV_LUNCH_BOX);
	export_constant(IG_BLACK_DIA_3_BOX);
	export_constant(IG_LI_NYANGVINE_BOX1_34);
	export_constant(IG_LI_NYANGVINE_BOX2_34);
	export_constant(IG_LI_NYANGVINE_BOX3_34);
	export_constant(IG_ENCHANT_STONE_BOX34);
	export_constant(IG_S_BADGE_PACK);
	export_constant(IG_SUPER_SONIC_PACK);
	export_constant(IG_CHAOS_EMERALD_PACK);
	export_constant(IG_VIP_BIRTHDAY_BOX);
	export_constant(IG_R_EP17_ALBUM);
	export_constant(IG_R_EP178_BOSS);
	export_constant(IG_SONIC_PREMIUM_PACK1);
	export_constant(IG_SONIC_PREMIUM_PACK2);
	export_constant(IG_S_BADGE_PACK_);
	export_constant(IG_SUPER_SONIC_PACK_);
	export_constant(IG_CHAOS_EMERALD_PACK_);
	export_constant(IG_C_INSURANCE_PACKAGE);
	export_constant(IG_C_INSURANCE_PACKAGE50);
	export_constant(IG_C_GIANT_FLY_WING_BOX100);
	export_constant(IG_C_SIEGFRIED_BOX5);
	export_constant(IG_C_SIEGFRIED_BOX20);
	export_constant(IG_C_CONVEX_MIRROR_BOX30);
	export_constant(IG_C_BLESSING_10_BOX50);
	export_constant(IG_C_INC_AGI_10_BOX50);
	export_constant(IG_C_ASPERSIO_5_BOX50);
	export_constant(IG_C_BATTLE_MANUAL_BOX);
	export_constant(IG_C_BATTLE_MANUAL_BOX10);
	export_constant(IG_C_BUBBLE_GUM_BOX);
	export_constant(IG_C_BUBBLE_GUM_BOX10);
	export_constant(IG_C_MEGAPHONE_BOX10);
	export_constant(IG_C_ENRICHED_ELUNIUM_BOX);
	export_constant(IG_C_ENRICHED_ELUNIUM_BOX5);
	export_constant(IG_C_ENRICHED_ORIDECON_BOX);
	export_constant(IG_C_ENC_ORIDECON_BOX5);
	export_constant(IG_C_NEURALIZER_BOX);
	export_constant(IG_C_ABRASIVE_BOX10);
	export_constant(IG_C_MAX_WEIGHT_UP_BOX);
	export_constant(IG_C_REGENERATION_BOX10);
	export_constant(IG_C_S_LIFE_POTION_BOX50);
	export_constant(IG_C_MED_LIFE_POTION_BOX50);
	export_constant(IG_C_S_ARMORBOX10);
	export_constant(IG_C_HOLY_ARMOR_S_BOX30);
	export_constant(IG_C_NEW_STYLE_BOX);
	export_constant(IG_C_ALICE_SCROLL_BOX10);
	export_constant(IG_C_MIMIC_SCROLL_BOX10);
	export_constant(IG_C_DISGUISE_CROLL_BOX10);
	export_constant(IG_C_MP_SCROLL_BOX50);
	export_constant(IG_CCLOTH_DYE_COUPON_BOX);
	export_constant(IG_CCLOTH_DYE_COUPON2_BOX);
	export_constant(IG_C_MENTAL_POTION50_BOX);
	export_constant(IG_C_JOB_MANUAL25_BOX1);
	export_constant(IG_C_JOB_MANUAL25_BOX10);
	export_constant(IG_C_SIEGE_SCROLL_BOX1_30);
	export_constant(IG_C_HD_BRADIUM_BOX5);
	export_constant(IG_C_HD_BRADIUM_BOX10);
	export_constant(IG_C_HD_CARNIUM_BOX5);
	export_constant(IG_C_HD_CARNIUM_BOX10);
	export_constant(IG_C_HD_ORI_BOX5);
	export_constant(IG_C_HD_ORI_BOX10);
	export_constant(IG_C_HD_ELU_BOX5);
	export_constant(IG_C_HD_ELU_BOX10);
	export_constant(IG_C_RAPID_LIFE_WATER_BOX2);
	export_constant(IG_CHANGE_NAME_CARD_BOX);
	export_constant(IG_C_MYST_WATER_BOX50);
	export_constant(IG_STATUS_RESET_COUPON_BOX);
	export_constant(IG_AID_BUFF_BOX);
	export_constant(IG_INVENTORY_EX_BOX);
	export_constant(IG_PETTRADETICKET_BOX);
	export_constant(IG_ADVANCED_TAIMING_ITEM);
	export_constant(IG_ADVANCED_TAIMING_ITEM2);
	export_constant(IG_INVENTORY_EX_10BOX);
	export_constant(IG_COSTUMEMILEPACK_34_1);
	export_constant(IG_COSTUMEMILEPACK_34_2);
	export_constant(IG_COSTUMEMILEPACK_34_3);
	export_constant(IG_AEGIS_102947);
	export_constant(IG_AEGIS_102948);
	export_constant(IG_AEGIS_103033);
	export_constant(IG_AEGIS_103034);
	export_constant(IG_P_BOOSTER_CALL_PACKAGE);
	export_constant(IG_P_COMPENSATION_BOX);
	export_constant(IG_ENCHANT_STONE_BOX35);
	export_constant(IG_STOVE_CHANNELING_BOX_1);
	export_constant(IG_STOVE_CHANNELING_BOX_2);
	export_constant(IG_STOVE_CHANNELING_BOX_3);
	export_constant(IG_STOVE_CHANNELING_BOX_4);
	export_constant(IG_LI_NYANGVINE_BOX1_35);
	export_constant(IG_LI_NYANGVINE_BOX2_35);
	export_constant(IG_LI_NYANGVINE_BOX3_35);
	export_constant(IG_A_SPEED_BOOSTER_BOX);
	export_constant(IG_A_SPEED_BOOSTER_10_BOX);
	export_constant(IG_L_INFINITY_POWER_PACK);
	export_constant(IG_L_ALL_RED_PACK);
	export_constant(IG_L_DEFENSE_POTION_PACK);
	export_constant(IG_L_SPEED_FORCE_PACK);
	export_constant(IG_L_SPECIAL_SPEED_PACK);
	export_constant(IG_L_SPECIAL_FORCE_PACK);
	export_constant(IG_COSTUMEMILEPACK_35_1);
	export_constant(IG_COSTUMEMILEPACK_35_2);
	export_constant(IG_COSTUMEMILEPACK_35_3);
	export_constant(IG_2024ROS_BOX_1ST);
	export_constant(IG_2024ROS_BOX_2ND);
	export_constant(IG_2024ROS_BOX_3RD);
	export_constant(IG_2024ROS_BOX_4TH);
	export_constant(IG_2024ROS_BOX_5TH);
	export_constant(IG_AEGIS_103234);
	export_constant(IG_2024SPORTS_BOX);
	export_constant(IG_22TH_PRESENT_BOX);
	export_constant(IG_AEGIS_103316);
	export_constant(IG_SVIP_GIFT_22THANIV);
	export_constant(IG_VVIP_GIFT_22THANIV);
	export_constant(IG_VIP_GIFT_22THANIV);
	export_constant(IG_LI_NYANGVINE_BOX1_36);
	export_constant(IG_LI_NYANGVINE_BOX2_36);
	export_constant(IG_LI_NYANGVINE_BOX3_36);
	export_constant(IG_2024_SUMMER_PACK_1);
	export_constant(IG_2024_SUMMER_PACK_2);
	export_constant(IG_2024_SUMMER_PACK_3);
	export_constant(IG_2024_SUMMER_PACK_4);
	export_constant(IG_LI_A_HD_CARNIUMBOX);
	export_constant(IG_LI_A_HD_BRADIUMBOX);
	export_constant(IG_22TH_PACKAGE_1);
	export_constant(IG_22TH_PACKAGE_2);
	export_constant(IG_22TH_PACKAGE_3);
	export_constant(IG_22TH_PACKAGE_4);
	export_constant(IG_CLB_SS_NYANG_PACK);
	export_constant(IG_CLB_SS_REFINE1_PACK);
	export_constant(IG_CLB_SS_REFINE2_PACK);
	export_constant(IG_CLB_SS_EXP_PACK);
	export_constant(IG_RT_EP17_DOUBT_A);
	export_constant(IG_RT_EP17_DOUBT_3);
	export_constant(IG_RT_EP17_DOUBT_C);
	export_constant(IG_RT_EP17_AUTO_A);
	export_constant(IG_RT_EP17_AUTO_C);
	export_constant(IG_RT_EP17_SECRET_A);
	export_constant(IG_RT_EP17_SECRET_C);
	export_constant(IG_RT_EP17_MUTANT_A);
	export_constant(IG_RT_EP17_MUTANT_C);
	export_constant(IG_RT_EP17_MIGUEL_A);
	export_constant(IG_RT_EP17_MIGUEL_C);
	export_constant(IG_RT_EP17_MIGUEL_2);
	export_constant(IG_RT_EP17_OVERLOAD_A);
	export_constant(IG_RT_EP17_OVERLOAD_C);
	export_constant(IG_RT_EP17_OVERLOAD_3);
	export_constant(IG_RT_EP17_BATH_A);
	export_constant(IG_RT_EP17_BATH_C);
	export_constant(IG_RT_EP17_GARDEN_A);
	export_constant(IG_RT_EP17_GARDEN_C);
	export_constant(IG_RT_EP17_GARDEN_3);
	export_constant(IG_RT_EP17_GARDEN_5);
	export_constant(IG_RT_EP17_GREEN_A);
	export_constant(IG_RT_EP17_GREEN_C);
	export_constant(IG_RT_EP17_GREEN_2);
	export_constant(IG_RT_EP17_GREEN_4);
	export_constant(IG_RT_EP17_WING_A);
	export_constant(IG_RT_EP17_WING_C);
	export_constant(IG_RT_EP17_WING_2);
	export_constant(IG_RT_EP17_WING_4);
	export_constant(IG_RT_EP17_HARMFUL_A);
	export_constant(IG_RT_EP17_HARMFUL_C);
	export_constant(IG_RT_EP17_HARMFUL_2);
	export_constant(IG_RT_EP17_HARMFUL_4);
	export_constant(IG_RT_EP17_BOSS_A);
	export_constant(IG_RT_EP17_BOSS_C);
	export_constant(IG_RT_EP17_BOSS_3);
	export_constant(IG_RT_EP17_BOSS_5);
	export_constant(IG_RT_EP17_MALFUN_A);
	export_constant(IG_RT_EP17_MALFUN_C);
	export_constant(IG_RT_EP17_MALFUN_3);
	export_constant(IG_RT_EP18_ARMOR_A);
	export_constant(IG_RT_EP18_ARMOR_C);
	export_constant(IG_RT_EP18_MELEE_A);
	export_constant(IG_RT_EP18_MAGIC_C);
	export_constant(IG_RT_EP18_MELEE_C);
	export_constant(IG_RT_EP18_MAGIC_A);
	export_constant(IG_RT_EP18_RANGE_A);
	export_constant(IG_RT_EP18_RANGE_C);
	export_constant(IG_RT_EP18_FIELD_A);
	export_constant(IG_RT_EP18_FIELD_C);
	export_constant(IG_RT_EP18_FIELD_3);
	export_constant(IG_RT_EP18_LAVA_A);
	export_constant(IG_RT_EP18_LAVA_C);
	export_constant(IG_RT_EP18_LAVA_2);
	export_constant(IG_RT_EP18_TOTAL_A);
	export_constant(IG_RT_EP18_TOTAL_C);
	export_constant(IG_RT_EP18_TOTAL_3);
	export_constant(IG_RT_EP18_TOTAL_6);
	export_constant(IG_RT_EP18_FANG_A);
	export_constant(IG_RT_EP18_FANG_C);
	export_constant(IG_RT_EP18_DEMI_A);
	export_constant(IG_RT_EP18_DEMI_C);
	export_constant(IG_RT_EP18_DEMI_2);
	export_constant(IG_YOR_CARD_P_BOX);
	export_constant(IG_EP21_COSTUME_BOX1);
	export_constant(IG_EP21_COSTUME_BOX2);
	export_constant(IG_AEGIS_103537);
	export_constant(IG_AEGIS_103582);
	export_constant(IG_AEGIS_103617);
	export_constant(IG_IFIRIT_PROMOTION_PACK);
	export_constant(IG_AEGIS_103622);
	export_constant(IG_AEGIS_103623);
	export_constant(IG_AEGIS_103624);
	export_constant(IG_AEGIS_103625);
	export_constant(IG_AEGIS_103626);
	export_constant(IG_AEGIS_103627);
	export_constant(IG_C_CHARSLOT_OPEN_BOX);
	export_constant(IG_COSTUMEMILEPACK_36_1);
	export_constant(IG_COSTUMEMILEPACK_36_2);
	export_constant(IG_COSTUMEMILEPACK_36_3);
	export_constant(IG_NYANGVINE_SPECIAL_PACK1);
	export_constant(IG_NYANGVINE_SPECIAL_PACK2);
	export_constant(IG_NYANGVINE_SPECIAL_PACK3);
	export_constant(IG_LI_NYANGVINE_BOX1_37);
	export_constant(IG_LI_NYANGVINE_BOX2_37);
	export_constant(IG_LI_NYANGVINE_BOX3_37);

	/* unit stop walking */
	export_constant(USW_NONE);
	export_constant(USW_FIXPOS);
	export_constant(USW_MOVE_ONCE);
	export_constant(USW_MOVE_FULL_CELL);
	export_constant(USW_FORCE_STOP);
	export_constant(USW_ALL);

	/* achievement groups */
	export_constant(AG_NONE);
	export_constant(AG_ADD_FRIEND);
	export_constant(AG_ADVENTURE);
	export_constant(AG_BABY);
	export_constant(AG_BATTLE);
	export_constant(AG_CHATTING);
	export_constant(AG_CHATTING_COUNT);
	export_constant(AG_CHATTING_CREATE);
	export_constant(AG_CHATTING_DYING);
	export_constant(AG_EAT);
	export_constant(AG_GET_ITEM);
	export_constant(AG_GET_ZENY);
	export_constant(AG_GOAL_ACHIEVE);
	export_constant(AG_GOAL_LEVEL);
	export_constant(AG_GOAL_STATUS);
	export_constant(AG_JOB_CHANGE);
	export_constant(AG_MARRY);
	export_constant(AG_PARTY);
	export_constant(AG_ENCHANT_FAIL);
	export_constant(AG_ENCHANT_SUCCESS);
	export_constant(AG_SPEND_ZENY);
	export_constant(AG_TAMING);

	/* achievement info */
	export_constant(ACHIEVEINFO_COUNT1);
	export_constant(ACHIEVEINFO_COUNT2);
	export_constant(ACHIEVEINFO_COUNT3);
	export_constant(ACHIEVEINFO_COUNT4);
	export_constant(ACHIEVEINFO_COUNT5);
	export_constant(ACHIEVEINFO_COUNT6);
	export_constant(ACHIEVEINFO_COUNT7);
	export_constant(ACHIEVEINFO_COUNT8);
	export_constant(ACHIEVEINFO_COUNT9);
	export_constant(ACHIEVEINFO_COUNT10);
	export_constant(ACHIEVEINFO_COMPLETE);
	export_constant(ACHIEVEINFO_COMPLETEDATE);
	export_constant(ACHIEVEINFO_GOTREWARD);
	export_constant(ACHIEVEINFO_LEVEL);
	export_constant(ACHIEVEINFO_SCORE);
	export_constant(ACHIEVEINFO_MAX);

	/* refine cost types */
	export_constant(REFINE_COST_NORMAL);
	export_constant(REFINE_COST_HD);
	export_constant(REFINE_COST_ENRICHED);
	export_constant(REFINE_COST_MAX);

	/* refine information types */
	export_constant(REFINE_MATERIAL_ID);
	export_constant(REFINE_ZENY_COST);

	/* NPC view ids */
	// Special macro to strip the prefix 'JT_'
	#if !defined(export_constant_npc)
		#define export_constant_npc(a) export_constant_offset(a,3)
	#endif

	export_constant_npc(JT_WARPNPC);
	export_constant_npc(JT_1_ETC_01);
	export_constant_npc(JT_1_M_01);
	export_constant_npc(JT_1_M_02);
	export_constant_npc(JT_1_M_03);
	export_constant_npc(JT_1_M_04);
	export_constant_npc(JT_1_M_BARD);
	export_constant_npc(JT_1_M_HOF);
	export_constant_npc(JT_1_M_INNKEEPER);
	export_constant_npc(JT_1_M_JOBGUIDER);
	export_constant_npc(JT_1_M_JOBTESTER);
	export_constant_npc(JT_1_M_KNIGHTMASTER);
	export_constant_npc(JT_1_M_LIBRARYMASTER);
	export_constant_npc(JT_1_M_MERCHANT);
	export_constant_npc(JT_1_M_ORIENT01);
	export_constant_npc(JT_1_M_PASTOR);
	export_constant_npc(JT_1_M_PUBMASTER);
	export_constant_npc(JT_1_M_SIZ);
	export_constant_npc(JT_1_M_SMITH);
	export_constant_npc(JT_1_M_WIZARD);
	export_constant_npc(JT_1_M_YOUNGKNIGHT);
	export_constant_npc(JT_1_F_01);
	export_constant_npc(JT_1_F_02);
	export_constant_npc(JT_1_F_03);
	export_constant_npc(JT_1_F_04);
	export_constant_npc(JT_1_F_GYPSY);
	export_constant_npc(JT_1_F_LIBRARYGIRL);
	export_constant_npc(JT_1_F_MARIA);
	export_constant_npc(JT_1_F_MERCHANT_01);
	export_constant_npc(JT_1_F_MERCHANT_02);
	export_constant_npc(JT_1_F_ORIENT_01);
	export_constant_npc(JT_1_F_ORIENT_02);
	export_constant_npc(JT_1_F_ORIENT_03);
	export_constant_npc(JT_1_F_ORIENT_04);
	export_constant_npc(JT_1_F_PRIEST);
	export_constant_npc(JT_1_F_PUBGIRL);
	export_constant_npc(JT_4_DOG01);
	export_constant_npc(JT_4_KID01);
	export_constant_npc(JT_4_M_01);
	export_constant_npc(JT_4_M_02);
	export_constant_npc(JT_4_M_03);
	export_constant_npc(JT_4_M_04);
	export_constant_npc(JT_4_M_BARBER);
	export_constant_npc(JT_4_M_ORIENT01);
	export_constant_npc(JT_4_M_ORIENT02);
	export_constant_npc(JT_4_F_01);
	export_constant_npc(JT_4_F_02);
	export_constant_npc(JT_4_F_03);
	export_constant_npc(JT_4_F_04);
	export_constant_npc(JT_4_F_MAID);
	export_constant_npc(JT_4_F_SISTER);
	export_constant_npc(JT_4W_KID);
	export_constant_npc(JT_4W_M_01);
	export_constant_npc(JT_4W_M_02);
	export_constant_npc(JT_4W_M_03);
	export_constant_npc(JT_4W_SAILOR);
	export_constant_npc(JT_4W_F_01);
	export_constant_npc(JT_8_F);
	export_constant_npc(JT_8_F_GRANDMOTHER);
	export_constant_npc(JT_EFFECTLAUNCHER);
	export_constant_npc(JT_8W_SOLDIER);
	export_constant_npc(JT_1_M_MOC_LORD);
	export_constant_npc(JT_1_M_PAY_ELDER);
	export_constant_npc(JT_1_M_PRON_KING);
	export_constant_npc(JT_4_M_MANAGER);
	export_constant_npc(JT_4_M_MINISTER);
	export_constant_npc(JT_HIDDEN_NPC);
	export_constant_npc(JT_4_F_KAFRA6);
	export_constant_npc(JT_4_F_KAFRA5);
	export_constant_npc(JT_4_F_KAFRA4);
	export_constant_npc(JT_4_F_KAFRA3);
	export_constant_npc(JT_4_F_KAFRA2);
	export_constant_npc(JT_4_F_KAFRA1);
	export_constant_npc(JT_2_M_THIEFMASTER);
	export_constant_npc(JT_2_M_SWORDMASTER);
	export_constant_npc(JT_2_M_PHARMACIST);
	export_constant_npc(JT_2_M_MOLGENSTEIN);
	export_constant_npc(JT_2_M_DYEINGER);
	export_constant_npc(JT_2_F_MAGICMASTER);
	export_constant_npc(JT_4_F_TELEPORTER);
	export_constant_npc(JT_4_M_TELEPORTER);
	export_constant_npc(JT_HIDDEN_WARP_NPC);
	export_constant_npc(JT_4_M_MUT2);
	export_constant_npc(JT_4_M_SCIENCE);
	export_constant_npc(JT_4_F_VALKYRIE2);
	export_constant_npc(JT_4_M_UNCLEKNIGHT);
	export_constant_npc(JT_4_M_YOUNGKNIGHT);
	export_constant_npc(JT_2_MONEMUS);
	export_constant_npc(JT_4_M_ATEIL);
	export_constant_npc(JT_4_F_ANNIVERSARY);
	export_constant_npc(JT_4_M_GREATPO);
	export_constant_npc(JT_4_M_NOVELIST);
	export_constant_npc(JT_4_M_CHAMPSOUL);
	export_constant_npc(JT_4_M_OLDFRIAR);
	export_constant_npc(JT_4_M_CRU_SOLD);
	export_constant_npc(JT_4_M_CRU_KNT);
	export_constant_npc(JT_4_M_CRU_HEAD);
	export_constant_npc(JT_4_M_CRU_CRUA);
	export_constant_npc(JT_4_M_KY_SOLD);
	export_constant_npc(JT_4_M_KY_KNT);
	export_constant_npc(JT_4_M_KY_HEAD);
	export_constant_npc(JT_4_M_KY_KIYOM);
	export_constant_npc(JT_4_M_BOSSCAT);
	export_constant_npc(JT_4_M_BABYCAT);
	export_constant_npc(JT_4W_F_KAFRA2);
	export_constant_npc(JT_4_F_MUNAK);
	export_constant_npc(JT_4_M_BONGUN);
	export_constant_npc(JT_4_BEAR);
	export_constant_npc(JT_4_BLUEWOLF);
	export_constant_npc(JT_4_PECOPECO);
	export_constant_npc(JT_4_M_JP_MID);
	export_constant_npc(JT_4_M_JP_RUN);
	export_constant_npc(JT_4_ORCLADY);
	export_constant_npc(JT_4_ORCLADY2);
	export_constant_npc(JT_4_ORCWARRIOR);
	export_constant_npc(JT_4_ORCWARRIOR2);
	export_constant_npc(JT_4_F_FAIRY);
	export_constant_npc(JT_4_F_FAIRYKID);
	export_constant_npc(JT_4_F_FAIRYKID2);
	export_constant_npc(JT_4_F_FAIRYKID3);
	export_constant_npc(JT_4_F_FAIRYKID4);
	export_constant_npc(JT_4_F_FAIRYKID5);
	export_constant_npc(JT_4_F_FAIRYKID6);
	export_constant_npc(JT_4_M_FAIRYKID);
	export_constant_npc(JT_4_M_FAIRYKID2);
	export_constant_npc(JT_4_M_FAIRYKID3);
	export_constant_npc(JT_4_M_FAIRYKID4);
	export_constant_npc(JT_4_M_FAIRYKID5);
	export_constant_npc(JT_4_M_FAIRYSOLDIER);
	export_constant_npc(JT_4_M_TUFFOLD);
	export_constant_npc(JT_4_MAN_BENKUNI);
	export_constant_npc(JT_4_MAN_GALTUN);
	export_constant_npc(JT_4_MAN_JERUTOO);
	export_constant_npc(JT_4_MAN_LAVAIL);
	export_constant_npc(JT_4_MAN_NITT);
	export_constant_npc(JT_4_MAN_PIOM);
	export_constant_npc(JT_4_MAN_PIOM2);
	export_constant_npc(JT_4_M_DSTMAN);
	export_constant_npc(JT_4_M_DSTMANDEAD);
	export_constant_npc(JT_4_BABYLEOPARD);
	export_constant_npc(JT_4_M_REDSWORD);
	export_constant_npc(JT_4_MAN_PIOM3);
	export_constant_npc(JT_4_M_FAIRYSOLDIER2);
	export_constant_npc(JT_4_F_FAIRYSOLDIER);
	export_constant_npc(JT_4_DRAGON_EGG);
	export_constant_npc(JT_4_MIMIC);
	export_constant_npc(JT_4_F_FAIRY1);
	export_constant_npc(JT_4_F_GUILLOTINE);
	export_constant_npc(JT_4_M_GUILLOTINE);
	export_constant_npc(JT_4_M_KNIGHT_BLACK);
	export_constant_npc(JT_4_M_KNIGHT_GOLD);
	export_constant_npc(JT_4_M_KNIGHT_SILVER);
	export_constant_npc(JT_4_SKULL_MUD);
	export_constant_npc(JT_4_M_BRZ_INDIAN);
	export_constant_npc(JT_4_F_BRZ_INDIAN);
	export_constant_npc(JT_4_F_BRZ_INDOLD);
	export_constant_npc(JT_4_M_BRZ_JACI);
	export_constant_npc(JT_4_M_BRZ_MAN1);
	export_constant_npc(JT_4_M_BRZ_MAN2);
	export_constant_npc(JT_4_F_BRZ_WOMAN);
	export_constant_npc(JT_4_M_MINSTREL);
	export_constant_npc(JT_4_M_MINSTREL1);
	export_constant_npc(JT_4_M_SHADOWCHASER);
	export_constant_npc(JT_4_F_SHADOWCHASER);
	export_constant_npc(JT_4_M_SURA);
	export_constant_npc(JT_4_F_SURA);
	export_constant_npc(JT_4_F_WANDERER);
	export_constant_npc(JT_4_M_BARD);
	export_constant_npc(JT_1_FLAG_NOFEAR);
	export_constant_npc(JT_4_M_NOFEARGUY);
	export_constant_npc(JT_4_MAN_PIOM6);
	export_constant_npc(JT_4_MAN_PIOM4);
	export_constant_npc(JT_4_MAN_PIOM5);
	export_constant_npc(JT_4_MAN_GALTUN1);
	export_constant_npc(JT_4_HUMAN_GERUTOO);
	export_constant_npc(JT_4_M_ROKI);
	export_constant_npc(JT_4_M_MERCAT1);
	export_constant_npc(JT_4_M_MERCAT2);
	export_constant_npc(JT_4_M_CATMAN1);
	export_constant_npc(JT_4_M_CATMAN2);
	export_constant_npc(JT_4_F_BRZ_WOMAN2);
	export_constant_npc(JT_4_M_JP_DISH);
	export_constant_npc(JT_4_F_JP_NOAH);
	export_constant_npc(JT_4_F_JP_OZ);
	export_constant_npc(JT_4_F_JP_CHROME);
	export_constant_npc(JT_4_F_JP_RINNE);
	export_constant_npc(JT_4_WHITETIGER);
	export_constant_npc(JT_4_VENDING_MACHINE);
	export_constant_npc(JT_4_MISTY);
	export_constant_npc(JT_4_NECORING);
	export_constant_npc(JT_4_ELEPHANT);
	export_constant_npc(JT_4_F_NYDHOG);
	export_constant_npc(JT_4_F_NYDHOG2);
	export_constant_npc(JT_4_M_ROKI2);
	export_constant_npc(JT_4_M_DOGTRAVELER);
	export_constant_npc(JT_4_M_DOGTRAVELER2);
	export_constant_npc(JT_4_F_DOGTRAVELER);
	export_constant_npc(JT_4_M_RAFLE_GR);
	export_constant_npc(JT_4_M_RAFLE_OLD);
	export_constant_npc(JT_4_F_RAFLE_PK);
	export_constant_npc(JT_4_M_LYINGDOG);
	export_constant_npc(JT_4_F_MORAFINE1);
	export_constant_npc(JT_4_F_MORAFINE2);
	export_constant_npc(JT_4_M_RAFLE_OR);
	export_constant_npc(JT_4_F_RAFLE_YE);
	export_constant_npc(JT_4_M_RAFLE_VI);
	export_constant_npc(JT_4_F_RAFLE_VI);
	export_constant_npc(JT_4_M_ARDHA);
	export_constant_npc(JT_4_CREEPER);
	export_constant_npc(JT_JP_RUFAKU);
	export_constant_npc(JT_JP_SUPIKA);
	export_constant_npc(JT_JP_SABIKU);
	export_constant_npc(JT_JP_ARUGORU);
	export_constant_npc(JT_JP_ARUNA);
	export_constant_npc(JT_JP_AIRI);
	export_constant_npc(JT_4_M_DEWOLDMAN);
	export_constant_npc(JT_4_M_DEWOLDWOMAN);
	export_constant_npc(JT_4_M_DEWMAN);
	export_constant_npc(JT_4_M_DEWWOMAN);
	export_constant_npc(JT_4_M_DEWBOY);
	export_constant_npc(JT_4_M_DEWGIRL);
	export_constant_npc(JT_4_M_DEWZATICHIEF);
	export_constant_npc(JT_4_M_DEWZATIMAN);
	export_constant_npc(JT_4_M_ALCHE_E);
	export_constant_npc(JT_4_MASK_SMOKEY);
	export_constant_npc(JT_4_CAT_SAILOR1);
	export_constant_npc(JT_4_CAT_SAILOR2);
	export_constant_npc(JT_4_CAT_SAILOR3);
	export_constant_npc(JT_4_CAT_SAILOR4);
	export_constant_npc(JT_4_CAT_CHEF);
	export_constant_npc(JT_4_CAT_MERMASTER);
	export_constant_npc(JT_4_CRACK);
	export_constant_npc(JT_4_ASTER);
	export_constant_npc(JT_4_F_STARFISHGIRL);
	export_constant_npc(JT_4_CAT_DOWN);
	export_constant_npc(JT_4_CAT_REST);
	export_constant_npc(JT_4_CAT_3COLOR);
	export_constant_npc(JT_4_CAT_ADMIRAL);
	export_constant_npc(JT_4_SOIL);
	export_constant_npc(JT_4_F_ALCHE_A);
	export_constant_npc(JT_4_CAT_ADV1);
	export_constant_npc(JT_4_CAT_ADV2);
	export_constant_npc(JT_4_CAT_SAILOR5);
	export_constant_npc(JT_2_DROP_MACHINE);
	export_constant_npc(JT_2_SLOT_MACHINE);
	export_constant_npc(JT_2_VENDING_MACHINE1);
	export_constant_npc(JT_MOB_TOMB);
	export_constant_npc(JT_4_MYSTCASE);
	export_constant_npc(JT_4_M_SIT_NOVICE);
	export_constant_npc(JT_4_OCTOPUS_LEG);
	export_constant_npc(JT_4_F_NURSE);
	export_constant_npc(JT_4_MAL_SOLDIER);
	export_constant_npc(JT_4_MAL_CAPTAIN);
	export_constant_npc(JT_4_MAL_BUDIDAI);
	export_constant_npc(JT_4_M_MAYOR);
	export_constant_npc(JT_4_M_BARYO_OLD);
	export_constant_npc(JT_4_F_BARYO_OLD);
	export_constant_npc(JT_4_F_BARYO_GIRL);
	export_constant_npc(JT_4_M_BARYO_BOY);
	export_constant_npc(JT_4_M_BARYO_MAN);
	export_constant_npc(JT_4_F_BARYO_WOMAN);
	export_constant_npc(JT_4_BARYO_CHIEF);
	export_constant_npc(JT_4_MAL_KAFRA);
	export_constant_npc(JT_4_M_MALAYA);
	export_constant_npc(JT_4_F_MALAYA);
	export_constant_npc(JT_4_F_PATIENT);
	export_constant_npc(JT_4_M_PATIENT);
	export_constant_npc(JT_4_F_KR_TIGER);
	export_constant_npc(JT_4_M_KR_BOY);
	export_constant_npc(JT_4_M_KAGE_OLD);
	export_constant_npc(JT_4_WHIKEBAIN);
	export_constant_npc(JT_4_EREND);
	export_constant_npc(JT_4_RAWREL);
	export_constant_npc(JT_4_ARMAIA);
	export_constant_npc(JT_4_KAVAC);
	export_constant_npc(JT_4_YGNIZEM);
	export_constant_npc(JT_4_EREMES);
	export_constant_npc(JT_4_MAGALETA);
	export_constant_npc(JT_4_KATRINN);
	export_constant_npc(JT_4_SHECIL);
	export_constant_npc(JT_4_SEYREN);
	export_constant_npc(JT_4_HARWORD);
	export_constant_npc(JT_4_F_JP_CYNTHIA);
	export_constant_npc(JT_4_M_JP_GUSTON);
	export_constant_npc(JT_4_M_JP_BERKUT);
	export_constant_npc(JT_4_F_JP_DARK_ADELAIDE);
	export_constant_npc(JT_4_M_JP_DARK_DARIUS);
	export_constant_npc(JT_4_M_JP_JESTER);
	export_constant_npc(JT_XMAS_SMOKEY_B);
	export_constant_npc(JT_XMAS_SMOKEY_R);
	export_constant_npc(JT_XMAS_SMOKEY_Y);
	export_constant_npc(JT_4_F_CLOCKDOLL);
	export_constant_npc(JT_4_F_FAIRY2);
	export_constant_npc(JT_4_F_PINKWOMAN);
	export_constant_npc(JT_4_FAIRYDEADLEAF);
	export_constant_npc(JT_4_FROG);
	export_constant_npc(JT_4_M_BLACKMAN);
	export_constant_npc(JT_4_M_BLUEMAN);
	export_constant_npc(JT_4_M_FAIRYANG);
	export_constant_npc(JT_4_M_FAIRYAVANT);
	export_constant_npc(JT_4_M_FAIRYFREAK);
	export_constant_npc(JT_4_M_FAIRYKID6);
	export_constant_npc(JT_4_M_FAIRYSCHOLAR);
	export_constant_npc(JT_4_M_FAIRYSCHOLAR_DIRTY);
	export_constant_npc(JT_4_M_FARIY_HISIE);
	export_constant_npc(JT_4_M_FARIYKING);
	export_constant_npc(JT_4_M_NEWOZ);
	export_constant_npc(JT_4_M_OLIVER);
	export_constant_npc(JT_4_M_PROFESSORWORM);
	export_constant_npc(JT_4_M_REDMAN);
	export_constant_npc(JT_4_F_GELKA);
	export_constant_npc(JT_4_M_ROTERT);
	export_constant_npc(JT_4_BLACKDRAGON);
	export_constant_npc(JT_4_M_GUNSLINGER);
	export_constant_npc(JT_4_F_GUNSLINGER);
	export_constant_npc(JT_4_M_ARCHER);
	export_constant_npc(JT_4_M_SWORDMAN);
	export_constant_npc(JT_4_M_NINJA_RED);
	export_constant_npc(JT_4_M_NINJA_BLUE);
	export_constant_npc(JT_4_M_THIEF_RUMIN);
	export_constant_npc(JT_4_M_NOV_RUMIN);
	export_constant_npc(JT_4_F_MAYSEL);
	export_constant_npc(JT_4_F_ACOLYTE);
	export_constant_npc(JT_4_M_NOV_HUNT);
	export_constant_npc(JT_4_F_GENETIC);
	export_constant_npc(JT_4_F_TAEKWON);
	export_constant_npc(JT_4_F_SWORDMAN);
	export_constant_npc(JT_4_F_IU);
	export_constant_npc(JT_4_M_RAGI);
	export_constant_npc(JT_4_M_MELODY);
	export_constant_npc(JT_4_TRACE);
	export_constant_npc(JT_4_F_HIMEL);
	export_constant_npc(JT_4_LEVITATEMAN);
	export_constant_npc(JT_4_M_HEINRICH);
	export_constant_npc(JT_4_M_ROYALGUARD);
	export_constant_npc(JT_4_M_BARMUND);
	export_constant_npc(JT_4_F_KHALITZBURG);
	export_constant_npc(JT_4_F_HIMEL2);
	export_constant_npc(JT_4_WHITEKNIGHT);
	export_constant_npc(JT_4_COCO);
	export_constant_npc(JT_4_M_ALADDIN);
	export_constant_npc(JT_4_M_GENIE);
	export_constant_npc(JT_4_F_GENIE);
	export_constant_npc(JT_4_JP_MID_SWIM);
	export_constant_npc(JT_4_JP_RUNE_SWIM);
	export_constant_npc(JT_4_F_FENRIR);
	export_constant_npc(JT_4_F_GEFFEN_FAY);
	export_constant_npc(JT_4_F_IRIS);
	export_constant_npc(JT_4_F_LUCILE);
	export_constant_npc(JT_4_F_SARAH_BABY);
	export_constant_npc(JT_4_GEFFEN_01);
	export_constant_npc(JT_4_GEFFEN_02);
	export_constant_npc(JT_4_GEFFEN_03);
	export_constant_npc(JT_4_GEFFEN_04);
	export_constant_npc(JT_4_GEFFEN_05);
	export_constant_npc(JT_4_GEFFEN_06);
	export_constant_npc(JT_4_GEFFEN_07);
	export_constant_npc(JT_4_GEFFEN_08);
	export_constant_npc(JT_4_GEFFEN_09);
	export_constant_npc(JT_4_GEFFEN_10);
	export_constant_npc(JT_4_GEFFEN_11);
	export_constant_npc(JT_4_GEFFEN_12);
	export_constant_npc(JT_4_GEFFEN_13);
	export_constant_npc(JT_4_GEFFEN_14);
	export_constant_npc(JT_4_M_CHAOS);
	export_constant_npc(JT_4_M_CHIEF_IRIN);
	export_constant_npc(JT_4_M_SAKRAY);
	export_constant_npc(JT_4_M_SAKRAYROYAL);
	export_constant_npc(JT_4_TOWER_01);
	export_constant_npc(JT_4_TOWER_02);
	export_constant_npc(JT_4_TOWER_03);
	export_constant_npc(JT_4_TOWER_04);
	export_constant_npc(JT_4_TOWER_05);
	export_constant_npc(JT_4_TOWER_06);
	export_constant_npc(JT_4_TOWER_07);
	export_constant_npc(JT_4_TOWER_08);
	export_constant_npc(JT_4_TOWER_09);
	export_constant_npc(JT_4_TOWER_10);
	export_constant_npc(JT_4_TOWER_11);
	export_constant_npc(JT_4_TOWER_12);
	export_constant_npc(JT_4_TOWER_13);
	export_constant_npc(JT_8_F_GIRL);
	export_constant_npc(JT_4_F_GODEMOM);
	export_constant_npc(JT_4_F_GON);
	export_constant_npc(JT_4_F_KID2);
	export_constant_npc(JT_4_M_BIBI);
	export_constant_npc(JT_4_M_GEF_SOLDIER);
	export_constant_npc(JT_4_M_KID1);
	export_constant_npc(JT_4_M_MOC_SOLDIER);
	export_constant_npc(JT_4_M_PAY_SOLDIER);
	export_constant_npc(JT_4_M_SEAMAN);
	export_constant_npc(JT_4_M_SNOWMAN);
	export_constant_npc(JT_4_F_05);
	export_constant_npc(JT_4_M_05);
	export_constant_npc(JT_4_M_06);
	export_constant_npc(JT_4_F_06);
	export_constant_npc(JT_4_M_PIERROT);
	export_constant_npc(JT_4_M_KID2);
	export_constant_npc(JT_4_F_KID3);
	export_constant_npc(JT_4_M_SANTA);
	export_constant_npc(JT_4_F_NACORURI);
	export_constant_npc(JT_4_F_SHAMAN);
	export_constant_npc(JT_4_F_KAFRA7);
	export_constant_npc(JT_GUILD_FLAG);
	export_constant_npc(JT_1_SHADOW_NPC);
	export_constant_npc(JT_4_F_07);
	export_constant_npc(JT_4_F_JOB_ASSASSIN);
	export_constant_npc(JT_4_F_JOB_BLACKSMITH);
	export_constant_npc(JT_4_F_JOB_HUNTER);
	export_constant_npc(JT_4_F_JOB_KNIGHT);
	export_constant_npc(JT_4_F_NOVICE);
	export_constant_npc(JT_4_M_JOB_ASSASSIN);
	export_constant_npc(JT_4_M_JOB_BLACKSMITH);
	export_constant_npc(JT_4_M_JOB_HUNTER);
	export_constant_npc(JT_4_M_JOB_KNIGHT1);
	export_constant_npc(JT_4_M_JOB_KNIGHT2);
	export_constant_npc(JT_4_M_JOB_WIZARD);
	export_constant_npc(JT_4_BAPHOMET);
	export_constant_npc(JT_4_DARKLORD);
	export_constant_npc(JT_4_DEVIRUCHI);
	export_constant_npc(JT_8_DOPPEL);
	export_constant_npc(JT_2_M_ALCHE);
	export_constant_npc(JT_2_M_BARD_ORIENT);
	export_constant_npc(JT_2_M_SAGE_B);
	export_constant_npc(JT_2_M_SAGE_OLD);
	export_constant_npc(JT_4_F_ALCHE);
	export_constant_npc(JT_4_F_CRU);
	export_constant_npc(JT_4_F_MONK);
	export_constant_npc(JT_4_F_ROGUE);
	export_constant_npc(JT_4_M_ALCHE_A);
	export_constant_npc(JT_4_M_ALCHE_B);
	export_constant_npc(JT_4_M_ALCHE_C);
	export_constant_npc(JT_4_M_CRU);
	export_constant_npc(JT_4_M_CRU_OLD);
	export_constant_npc(JT_4_M_MONK);
	export_constant_npc(JT_4_M_SAGE_A);
	export_constant_npc(JT_4_M_SAGE_C);
	export_constant_npc(JT_4_F_SON);
	export_constant_npc(JT_4_F_JPN2);
	export_constant_npc(JT_4_F_JPN);
	export_constant_npc(JT_4_F_JPNCHIBI);
	export_constant_npc(JT_4_F_JPNOBA2);
	export_constant_npc(JT_4_F_JPNOBA);
	export_constant_npc(JT_4_M_JPN2);
	export_constant_npc(JT_4_M_JPN);
	export_constant_npc(JT_4_M_JPNCHIBI);
	export_constant_npc(JT_4_M_JPNOJI2);
	export_constant_npc(JT_4_M_JPNOJI);
	export_constant_npc(JT_8_M_JPNSOLDIER);
	export_constant_npc(JT_8_M_JPNMASTER);
	export_constant_npc(JT_4_F_JPNMU);
	export_constant_npc(JT_4_F_TWGIRL);
	export_constant_npc(JT_4_F_TWGRANDMOM);
	export_constant_npc(JT_4_F_TWMASKGIRL);
	export_constant_npc(JT_4_F_TWMIDWOMAN);
	export_constant_npc(JT_4_M_TWBOY);
	export_constant_npc(JT_4_M_TWMASKMAN);
	export_constant_npc(JT_4_M_TWMIDMAN);
	export_constant_npc(JT_4_M_TWOLDMAN);
	export_constant_npc(JT_4_M_TWTEAMAN);
	export_constant_npc(JT_4_M_YOYOROGUE);
	export_constant_npc(JT_8_M_TWSOLDIER);
	export_constant_npc(JT_4_F_UMGIRL);
	export_constant_npc(JT_4_F_UMOLDWOMAN);
	export_constant_npc(JT_4_F_UMWOMAN);
	export_constant_npc(JT_4_M_UMCHIEF);
	export_constant_npc(JT_4_M_UMDANCEKID2);
	export_constant_npc(JT_4_M_UMDANCEKID);
	export_constant_npc(JT_4_M_UMKID);
	export_constant_npc(JT_4_M_UMOLDMAN);
	export_constant_npc(JT_4_M_UMSOLDIER);
	export_constant_npc(JT_4_M_SALVATION);
	export_constant_npc(JT_4_F_NFDEADKAFRA);
	export_constant_npc(JT_4_F_NFDEADMGCIAN);
	export_constant_npc(JT_4_F_NFLOSTGIRL);
	export_constant_npc(JT_4_M_NFDEADMAN2);
	export_constant_npc(JT_4_M_NFDEADMAN);
	export_constant_npc(JT_4_M_NFDEADSWDMAN);
	export_constant_npc(JT_4_M_NFLOSTMAN);
	export_constant_npc(JT_4_M_NFMAN);
	export_constant_npc(JT_4_NFBAT);
	export_constant_npc(JT_4_NFCOCK);
	export_constant_npc(JT_4_NFCOFFIN);
	export_constant_npc(JT_4_NFWISP);
	export_constant_npc(JT_1_F_SIGNZISK);
	export_constant_npc(JT_1_M_SIGN1);
	export_constant_npc(JT_1_M_SIGNALCHE);
	export_constant_npc(JT_1_M_SIGNART);
	export_constant_npc(JT_1_M_SIGNMCNT);
	export_constant_npc(JT_1_M_SIGNMONK2);
	export_constant_npc(JT_1_M_SIGNMONK);
	export_constant_npc(JT_1_M_SIGNROGUE);
	export_constant_npc(JT_4_F_VALKYRIE);
	export_constant_npc(JT_TW_TOWER);
	export_constant_npc(JT_2_M_OLDBLSMITH);
	export_constant_npc(JT_4_F_CHNDOCTOR);
	export_constant_npc(JT_4_F_CHNDRESS1);
	export_constant_npc(JT_4_F_CHNDRESS2);
	export_constant_npc(JT_4_F_CHNDRESS3);
	export_constant_npc(JT_4_F_CHNWOMAN);
	export_constant_npc(JT_4_M_CHN8GUEK);
	export_constant_npc(JT_4_M_CHNCOOK);
	export_constant_npc(JT_4_M_CHNGENERL);
	export_constant_npc(JT_4_M_CHNMAN);
	export_constant_npc(JT_4_M_CHNMONK);
	export_constant_npc(JT_4_M_CHNOLD);
	export_constant_npc(JT_4_M_CHNSOLDIER);
	export_constant_npc(JT_4_M_DWARF);
	export_constant_npc(JT_4_M_GRANDMONK);
	export_constant_npc(JT_4_M_ROGUE);
	export_constant_npc(JT_4_M_DOMINO);
	export_constant_npc(JT_4_F_DOMINO);
	export_constant_npc(JT_4_F_ZONDAGIRL);
	export_constant_npc(JT_4_M_REIDIN_KURS);
	export_constant_npc(JT_4_M_ZONDAOYAJI);
	export_constant_npc(JT_4_M_BUDDHIST);
	export_constant_npc(JT_2_BOARD1);
	export_constant_npc(JT_2_BOARD2);
	export_constant_npc(JT_2_BULLETIN_BOARD);
	export_constant_npc(JT_4_F_THAIAYO);
	export_constant_npc(JT_4_F_THAIGIRL);
	export_constant_npc(JT_4_F_THAISHAMAN);
	export_constant_npc(JT_4_M_THAIAYO);
	export_constant_npc(JT_4_M_THAIOLD);
	export_constant_npc(JT_4_M_THAIONGBAK);
	export_constant_npc(JT_CLEAR_NPC);
	export_constant_npc(JT_4_F_RACING);
	export_constant_npc(JT_4_F_EINOLD);
	export_constant_npc(JT_4_M_EINOLD);
	export_constant_npc(JT_4_M_EINMINER);
	export_constant_npc(JT_4_M_DIEMAN);
	export_constant_npc(JT_4_F_EINWOMAN);
	export_constant_npc(JT_4_M_REPAIR);
	export_constant_npc(JT_4_M_EIN_SOLDIER);
	export_constant_npc(JT_4_M_YURI);
	export_constant_npc(JT_4_M_EINMAN2);
	export_constant_npc(JT_4_M_EINMAN);
	export_constant_npc(JT_2_F_SIGN1);
	export_constant_npc(JT_4_BOARD3);
	export_constant_npc(JT_4_BULLETIN_BOARD2);
	export_constant_npc(JT_4_F_AGENTKAFRA);
	export_constant_npc(JT_4_F_KAFRA8);
	export_constant_npc(JT_4_F_KAFRA9);
	export_constant_npc(JT_4_F_LGTGIRL);
	export_constant_npc(JT_4_F_LGTGRAND);
	export_constant_npc(JT_4_F_OPERATION);
	export_constant_npc(JT_4_LGTSCIENCE);
	export_constant_npc(JT_4_M_LGTGRAND);
	export_constant_npc(JT_4_M_LGTGUARD2);
	export_constant_npc(JT_4_M_LGTGUARD);
	export_constant_npc(JT_4_M_LGTMAN);
	export_constant_npc(JT_4_M_LGTPOOR);
	export_constant_npc(JT_4_M_OPERATION);
	export_constant_npc(JT_4_M_PRESIDENT);
	export_constant_npc(JT_4_M_REINDEER);
	export_constant_npc(JT_4_M_ZONDAMAN);
	export_constant_npc(JT_4_M_PECOKNIGHT);
	export_constant_npc(JT_4_CAT);
	export_constant_npc(JT_4_F_YUNYANG);
	export_constant_npc(JT_4_M_OILMAN);
	export_constant_npc(JT_4_F_CAPEGIRL);
	export_constant_npc(JT_4_M_MASKMAN);
	export_constant_npc(JT_4_M_SITDOWN);
	export_constant_npc(JT_4_F_SITDOWN);
	export_constant_npc(JT_4_M_ALCHE_D);
	export_constant_npc(JT_4_M_ACROSS);
	export_constant_npc(JT_4_F_ACROSS);
	export_constant_npc(JT_4_COOK);
	export_constant_npc(JT_4_M_LIEMAN);
	export_constant_npc(JT_2_POSTBOX);
	export_constant_npc(JT_4_BULL);
	export_constant_npc(JT_4_LAM);
	export_constant_npc(JT_4_F_HUGIRL);
	export_constant_npc(JT_4_F_HUGRANMA);
	export_constant_npc(JT_4_F_HUWOMAN);
	export_constant_npc(JT_4_F_KHELLISIA);
	export_constant_npc(JT_4_F_KHELLY);
	export_constant_npc(JT_4_M_HUBOY);
	export_constant_npc(JT_4_M_HUGRANFA);
	export_constant_npc(JT_4_M_HUMAN_01);
	export_constant_npc(JT_4_M_HUMAN_02);
	export_constant_npc(JT_4_M_HUMERCHANT);
	export_constant_npc(JT_4_M_HUOLDARMY);
	export_constant_npc(JT_4_M_KHKIEL);
	export_constant_npc(JT_4_M_KHKYEL);
	export_constant_npc(JT_4_M_KHMAN);
	export_constant_npc(JT_4_F_KHWOMAN);
	export_constant_npc(JT_4_F_KHGIRL);
	export_constant_npc(JT_4_M_KHBOY);
	export_constant_npc(JT_4_M_PHILMAN);
	export_constant_npc(JT_4_PORING);
	export_constant_npc(JT_2_COLAVEND);
	export_constant_npc(JT_4_F_SOCCER);
	export_constant_npc(JT_4_M_SOCCER7);
	export_constant_npc(JT_4_M_SOCCER9);
	export_constant_npc(JT_4_F_CHILD);
	export_constant_npc(JT_4_F_MADAME);
	export_constant_npc(JT_4_F_MASK1);
	export_constant_npc(JT_4_F_MASK);
	export_constant_npc(JT_4_F_RACHOLD);
	export_constant_npc(JT_4_F_SHABBY);
	export_constant_npc(JT_4_F_TRAINEE);
	export_constant_npc(JT_4_M_CHILD1);
	export_constant_npc(JT_4_M_CHILD);
	export_constant_npc(JT_4_M_DOCTOR);
	export_constant_npc(JT_4_M_FROZEN1);
	export_constant_npc(JT_4_M_FROZEN);
	export_constant_npc(JT_4_M_MASK1);
	export_constant_npc(JT_4_M_MASK);
	export_constant_npc(JT_4_M_MIDDLE1);
	export_constant_npc(JT_4_M_MIDDLE);
	export_constant_npc(JT_4_M_RACHMAN2);
	export_constant_npc(JT_4_M_RACHMAN1);
	export_constant_npc(JT_4_M_RACHOLD1);
	export_constant_npc(JT_4_M_RACHOLD);
	export_constant_npc(JT_4_M_RASWORD);
	export_constant_npc(JT_4_M_TRAINEE);
	export_constant_npc(JT_4_F_ARUNA_POP);
	export_constant_npc(JT_4_M_ARUNA_NFM1);
	export_constant_npc(JT_4_DST_CAMEL);
	export_constant_npc(JT_4_DST_SOLDIER);
	export_constant_npc(JT_4_F_DESERT);
	export_constant_npc(JT_4_F_DST_CHILD);
	export_constant_npc(JT_4_F_DST_GRAND);
	export_constant_npc(JT_4_M_DESERT);
	export_constant_npc(JT_4_M_DST_CHILD);
	export_constant_npc(JT_4_M_DST_GRAND);
	export_constant_npc(JT_4_M_DST_MASTER);
	export_constant_npc(JT_4_M_DST_TOUGH);
	export_constant_npc(JT_4_ANGELING);
	export_constant_npc(JT_4_ARCHANGELING);
	export_constant_npc(JT_4_GHOSTRING);
	export_constant_npc(JT_4_F_EDEN_MASTER);
	export_constant_npc(JT_4_F_EDEN_OFFICER);
	export_constant_npc(JT_4_M_EDEN_GUARDER);
	export_constant_npc(JT_4_M_PATRICK);
	export_constant_npc(JT_4_DONKEY);
	export_constant_npc(JT_4_M_TRISTAN);
	export_constant_npc(JT_4_WHITE_COW);
	export_constant_npc(JT_4_F_RUSCHILD);
	export_constant_npc(JT_4_F_RUSWOMAN1);
	export_constant_npc(JT_4_F_RUSWOMAN2);
	export_constant_npc(JT_4_F_RUSWOMAN3);
	export_constant_npc(JT_4_M_RUSCHILD);
	export_constant_npc(JT_4_M_GUSLIMAN);
	export_constant_npc(JT_4_M_RUSBALD);
	export_constant_npc(JT_4_M_RUSKING);
	export_constant_npc(JT_4_M_RUSKNIGHT);
	export_constant_npc(JT_4_M_RUSMAN1);
	export_constant_npc(JT_4_M_RUSMAN2);
	export_constant_npc(JT_4_M_DRAKE);
	export_constant_npc(JT_4_F_BABAYAGA);
	export_constant_npc(JT_4_F_RUSGREEN);
	export_constant_npc(JT_4_RUS_DWOLF);
	export_constant_npc(JT_1_FLAG_LION);
	export_constant_npc(JT_1_FLAG_EAGLE);
	export_constant_npc(JT_4_M_MIKID);
	export_constant_npc(JT_4_BLUE_FLOWER);
	export_constant_npc(JT_4_RED_FLOWER);
	export_constant_npc(JT_4_YELL_FLOWER);
	export_constant_npc(JT_4_F_CAVE1);
	export_constant_npc(JT_4_F_MUT1);
	export_constant_npc(JT_4_F_MUT2);
	export_constant_npc(JT_4_F_SCIENCE);
	export_constant_npc(JT_4_M_1STPRIN1);
	export_constant_npc(JT_4_M_1STPRIN2);
	export_constant_npc(JT_4_M_2NDPRIN1);
	export_constant_npc(JT_4_M_2NDPRIN2);
	export_constant_npc(JT_4_M_3RDPRIN1);
	export_constant_npc(JT_4_M_3RDPRIN2);
	export_constant_npc(JT_4_M_4THPRIN1);
	export_constant_npc(JT_4_M_4THPRIN2);
	export_constant_npc(JT_4_M_5THPRIN1);
	export_constant_npc(JT_4_M_5THPRIN2);
	export_constant_npc(JT_4_M_6THPRIN1);
	export_constant_npc(JT_4_M_6THPRIN2);
	export_constant_npc(JT_4_M_CASMAN1);
	export_constant_npc(JT_4_M_CAVE1);
	export_constant_npc(JT_4_M_MOCASS1);
	export_constant_npc(JT_4_M_MOCASS2);
	export_constant_npc(JT_4_M_MUT1);
	export_constant_npc(JT_4_TOWER_14);
	export_constant_npc(JT_4_TOWER_15);
	export_constant_npc(JT_4_TOWER_16);
	export_constant_npc(JT_4_TOWER_17);
	export_constant_npc(JT_4_TREASURE_BOX);
	export_constant_npc(JT_ACADEMY_MASTER);
	export_constant_npc(JT_PORTAL);
	export_constant_npc(JT_THANATOS_BATTLE);
	export_constant_npc(JT_THANATOS_KEEP);
	export_constant_npc(JT_4_F_LYDIA);
	export_constant_npc(JT_4_LUDE);
	export_constant_npc(JT_4_ALIZA);
	export_constant_npc(JT_4_ALICE);
	export_constant_npc(JT_4_ARCHER_SKEL);
	export_constant_npc(JT_4_JACK);
	export_constant_npc(JT_4_SOLDIER_SKEL);
	export_constant_npc(JT_4_LOLI_RURI);
	export_constant_npc(JT_4_M_SAKRAY_TIED);
	export_constant_npc(JT_4_M_ANTONIO);
	export_constant_npc(JT_4_M_COOKIE);
	export_constant_npc(JT_4_M_BELIEVER01);
	export_constant_npc(JT_4_F_BELIEVER01);
	export_constant_npc(JT_4_M_BELIEVER02);
	export_constant_npc(JT_4_ROPEPILE);
	export_constant_npc(JT_4_BRICKPILE);
	export_constant_npc(JT_4_WOODPILE);
	export_constant_npc(JT_4_M_TAMARIN);
	export_constant_npc(JT_4_M_DEATH);
	export_constant_npc(JT_4_GHOST_STAND);
	export_constant_npc(JT_4_GHOST_COLLAPSE);
	export_constant_npc(JT_4_COOKIEHOUSE);
	export_constant_npc(JT_4_F_SKULL06GIRL);
	export_constant_npc(JT_4_NONMYSTCASE);
	export_constant_npc(JT_4_F_KIMI);
	export_constant_npc(JT_4_M_FROZEN_GC);
	export_constant_npc(JT_4_M_FROZEN_KN);
	export_constant_npc(JT_4_SNAKE_LORD);
	export_constant_npc(JT_4_F_MOCBOY);
	export_constant_npc(JT_4_F_RUNAIN);
	export_constant_npc(JT_4_M_ROEL);
	export_constant_npc(JT_4_F_SHALOSH);
	export_constant_npc(JT_4_ENERGY_RED);
	export_constant_npc(JT_4_ENERGY_BLUE);
	export_constant_npc(JT_4_ENERGY_YELLOW);
	export_constant_npc(JT_4_ENERGY_BLACK);
	export_constant_npc(JT_4_ENERGY_WHITE);
	export_constant_npc(JT_4_F_PERE01);
	export_constant_npc(JT_4_JITTERBUG);
	export_constant_npc(JT_4_SEA_OTTER);
	export_constant_npc(JT_4_GALAPAGO);
	export_constant_npc(JT_4_DESERTWOLF_B);
	export_constant_npc(JT_4_BB_PORING);
	export_constant_npc(JT_4_F_CHARLESTON01);
	export_constant_npc(JT_4_F_CHARLESTON02);
	export_constant_npc(JT_4_F_CHARLESTON03);
	export_constant_npc(JT_4_M_IAN);
	export_constant_npc(JT_4_M_OLDSCHOLAR);
	export_constant_npc(JT_4_F_LAPERM);
	export_constant_npc(JT_4_M_DEBON);
	export_constant_npc(JT_4_M_BIRMAN);
	export_constant_npc(JT_4_F_SHAM);
	export_constant_npc(JT_4_M_REBELLION);
	export_constant_npc(JT_4_F_REBELLION);
	export_constant_npc(JT_4_CHN_SHAOTH);
	export_constant_npc(JT_4_SHOAL);
	export_constant_npc(JT_4_F_SARAH);
	export_constant_npc(JT_4_GIGANTES_BIG);
	export_constant_npc(JT_4_GIGANTES);
	export_constant_npc(JT_4_GIGANTES_SMALL);
	export_constant_npc(JT_4_GARGOYLE_STATUE);
	export_constant_npc(JT_4_AIRA);
	export_constant_npc(JT_4_EZELLA);
	export_constant_npc(JT_4_KULUNA);
	export_constant_npc(JT_4_LUNE);
	export_constant_npc(JT_4_MALLINA);
	export_constant_npc(JT_4_MORIN);
	export_constant_npc(JT_4_NASARIN);
	export_constant_npc(JT_4_F_BERRYTEA);
	export_constant_npc(JT_4_F_FRUIT);
	export_constant_npc(JT_4_SCR_MT_ROBOTS);
	export_constant_npc(JT_4_MACHINE_DEVICE);
	export_constant_npc(JT_4_GC109);
	export_constant_npc(JT_4_SYS_MSG);
	export_constant_npc(JT_4_M_TATIO);
	export_constant_npc(JT_4_M_REKENBER);
	export_constant_npc(JT_4_XMAS_CAT1);
	export_constant_npc(JT_4_XMAS_CAT2);
	export_constant_npc(JT_4_XMAS_CAT3);
	export_constant_npc(JT_4_XMAS_CAT4);
	export_constant_npc(JT_4_XMAS_CAT5);
	export_constant_npc(JT_4_XMAS_CAT6);
	export_constant_npc(JT_4_M_DEATH2);
	export_constant_npc(JT_4_S_KADOMATSU);
	export_constant_npc(JT_4_B_KADOMATSU);
	export_constant_npc(JT_4_F_08);
	export_constant_npc(JT_4_F_08_STATUE);
	export_constant_npc(JT_4_M_DARKPRIEST);
	export_constant_npc(JT_4_JP_GARM_H);
	export_constant_npc(JT_4_JP_MEDUSA_H);
	export_constant_npc(JT_4_CHN_GVG_01);
	export_constant_npc(JT_4_SPRING_RABBIT);
	export_constant_npc(JT_4_PD_TYRA);
	export_constant_npc(JT_4_PD_TYRANOS);
	export_constant_npc(JT_4_PD_PLESI);
	export_constant_npc(JT_4_PD_PLESIO);
	export_constant_npc(JT_4_PD_BRACHI);
	export_constant_npc(JT_4_PD_BRACHIOS);
	export_constant_npc(JT_4_PD_GOLDDRAGON);
	export_constant_npc(JT_4_PD_ZAEROG);
	export_constant_npc(JT_4_PD_TAMADORA);
	export_constant_npc(JT_4_JP_EDGA_H);
	export_constant_npc(JT_4_JP_BRAGOLEM_H);
	export_constant_npc(JT_4_EL_AQUA);
	export_constant_npc(JT_4_EP16_NIHIL);
	export_constant_npc(JT_4_EP16_SPICA);
	export_constant_npc(JT_4_EP16_SKIA);
	export_constant_npc(JT_4_EP16_PETER);
	export_constant_npc(JT_4_EP16_CRUX);
	export_constant_npc(JT_4_EP16_GRANZ);
	export_constant_npc(JT_4_EP16_STOLZ);
	export_constant_npc(JT_4_EP16_EGEO);
	export_constant_npc(JT_4_EP16_COOK);
	export_constant_npc(JT_4_EP16_MARK);
	export_constant_npc(JT_4_EP16_TAMARIN);
	export_constant_npc(JT_4_EP16_POE);
	export_constant_npc(JT_4_EP16_ISAAC);
	export_constant_npc(JT_4_EP16_HELMUT);
	export_constant_npc(JT_4_EP16_WOLF);
	export_constant_npc(JT_4_EP16_MEYER);
	export_constant_npc(JT_4_EP16_AGNES);
	export_constant_npc(JT_4_EP16_FOOD);
	export_constant_npc(JT_4_EP16_LOUVIERE);
	export_constant_npc(JT_4_EP16_MAX);
	export_constant_npc(JT_4_EP16_SPIEGEL);
	export_constant_npc(JT_4_MOONLIGHT);
	export_constant_npc(JT_4_MISTRESS);
	export_constant_npc(JT_4_DRACULA);
	export_constant_npc(JT_4_STORMKNIGHT);
	export_constant_npc(JT_4_TATTER);
	export_constant_npc(JT_4_AS_RAGGED_GOLEM);
	export_constant_npc(JT_4_AS_BLOODY_KNIGHT);
	export_constant_npc(JT_4_AS_WIND_GHOST);
	export_constant_npc(JT_4_F_BIJOU);
	export_constant_npc(JT_4_EP16_COOK2);
	export_constant_npc(JT_4_SERVICE_30_M_01);
	export_constant_npc(JT_4_SERVICE_30_F_01);
	export_constant_npc(JT_4_SCR_AT_ROBOTS);
	export_constant_npc(JT_4_F_RANGER);
	export_constant_npc(JT_4_WAG);
	export_constant_npc(JT_4_NPC_TRAP);
	export_constant_npc(JT_4_RAGGLER);
	export_constant_npc(JT_4_DR_PEPE);
	export_constant_npc(JT_4_DR_GAMBERI);
	export_constant_npc(JT_4_DR_AGLIO);
	export_constant_npc(JT_4_DR_OLIO);
	export_constant_npc(JT_4_DR_STELO);
	export_constant_npc(JT_4_DR_TORTEL);
	export_constant_npc(JT_4_BASIL_SLAVE);
	export_constant_npc(JT_4_DOU_JINDO);
	export_constant_npc(JT_4_DOU_SIBA);
	export_constant_npc(JT_4_TARUTUPI);
	export_constant_npc(JT_4_DR_SOLDIER);
	export_constant_npc(JT_4_DR_M_01);
	export_constant_npc(JT_4_DR_M_02);
	export_constant_npc(JT_4_DR_F_01);
	export_constant_npc(JT_4_DR_F_02);
	export_constant_npc(JT_4_DR_KID_01);
	export_constant_npc(JT_4_JP_2015EVT);
	export_constant_npc(JT_4_ALLIGATOR);
	export_constant_npc(JT_4_ANOLIAN);
	export_constant_npc(JT_4_TACNU);
	export_constant_npc(JT_4_CENERE);
	export_constant_npc(JT_4_F_ARUNA_POP2);
	export_constant_npc(JT_4_JACK_HEAD);
	export_constant_npc(JT_4_INJUSTICE);
	export_constant_npc(JT_4_BLOODYMAN);
	export_constant_npc(JT_4_GIBBET);
	export_constant_npc(JT_4_DULLAHAN);
	export_constant_npc(JT_4_M_LAZY);
	export_constant_npc(JT_4_M_GONY);
	export_constant_npc(JT_4_M_ROOKIE);
	export_constant_npc(JT_4_M_PHILOFONTES);
	export_constant_npc(JT_4_F_ESTLOVELOY);
	export_constant_npc(JT_4_F_LEEDSH);
	export_constant_npc(JT_4_F_DIENE);
	export_constant_npc(JT_4_F_COATNEIS);
	export_constant_npc(JT_4_M_RUPERT);
	export_constant_npc(JT_4_M_FALLENGONY);
	export_constant_npc(JT_4_M_EISEN);
	export_constant_npc(JT_4_F_DEADEVIL);
	export_constant_npc(JT_4_F_HUNTER_EVIL);
	export_constant_npc(JT_4_F_ELENA);
	export_constant_npc(JT_4_F_ANYA);
	export_constant_npc(JT_4_M_SEIREN_UC);
	export_constant_npc(JT_4_M_GUNSLINGER2);
	export_constant_npc(JT_4_M_GUNSLINGER3);
	export_constant_npc(JT_4_M_REBELLION2);
	export_constant_npc(JT_4_M_REBELLION3);
	export_constant_npc(JT_4_F_GUNSLINGER2);
	export_constant_npc(JT_4_F_GUNSLINGER3);
	export_constant_npc(JT_4_F_REBELLION2);
	export_constant_npc(JT_4_F_REBELLION3);
	export_constant_npc(JT_4_M_ILYA);
	export_constant_npc(JT_4_ELDER);
	export_constant_npc(JT_4_LUNATIC);
	export_constant_npc(JT_4_F_NOVICE2);
	export_constant_npc(JT_4_WICKEDNYMPH);
	export_constant_npc(JT_4_F_PREMI);
	export_constant_npc(JT_4_M_COSTELL);
	export_constant_npc(JT_4_M_YATTWARP);
	export_constant_npc(JT_4_M_EVOKASCUDI);
	export_constant_npc(JT_4_M_JOHNNYJAMES);
	export_constant_npc(JT_4_M_ALBERTFORD);
	export_constant_npc(JT_4_M_SEANMCCURDY);
	export_constant_npc(JT_4_M_KARAMPUCCI);
	export_constant_npc(JT_4_M_CACTUSMAN1);
	export_constant_npc(JT_4_M_CACTUSMAN2);
	export_constant_npc(JT_4_M_CACTUSMAN3);
	export_constant_npc(JT_4_M_CACTUSLADY);
	export_constant_npc(JT_4_M_GAST);
	export_constant_npc(JT_4_M_CACTUSCHILD);
	export_constant_npc(JT_4_KING);
	export_constant_npc(JT_4_F_BOMI);
	export_constant_npc(JT_4_M_CACTUSCHIEF);
	export_constant_npc(JT_4_F_CACTUSCHILD2);
	export_constant_npc(JT_4_F_CACTUSLADY2);
	export_constant_npc(JT_4_F_CACTUSLADY3);
	export_constant_npc(JT_4_M_CACTUS);
	export_constant_npc(JT_4_M_COWRAIDERS1);
	export_constant_npc(JT_4_M_COWRAIDERS2);
	export_constant_npc(JT_4_M_COWRAIDERS3);
	export_constant_npc(JT_4_F_JP14THEVT);
	export_constant_npc(JT_4_M_POORSCHOLAR);
	export_constant_npc(JT_4_M_PEPPERROTI);
	export_constant_npc(JT_JP_NPC01);
	export_constant_npc(JT_4_PURPLE_WARP);
	export_constant_npc(JT_4_F_NARIN);
	export_constant_npc(JT_4_M_URGENT_MAN);
	export_constant_npc(JT_4_M_KEEN_SOLDIER);
	export_constant_npc(JT_4_F_SLOPPY_WOMAN);
	export_constant_npc(JT_4_F_DRKAFRA01);
	export_constant_npc(JT_4_M_DRZONDA01);
	export_constant_npc(JT_4_M_SWD_RENO);
	export_constant_npc(JT_4_M_KNG_RENO);
	export_constant_npc(JT_4_M_AC_RUMIN);
	export_constant_npc(JT_4_M_HIGH_WIZARD);
	export_constant_npc(JT_4_SYSTEM_BOX);
	export_constant_npc(JT_4_STEELBOX);
	export_constant_npc(JT_4_WOODBOX);
	export_constant_npc(JT_4_M_POPFESTA);
	export_constant_npc(JT_4_BONFIRE);
	export_constant_npc(JT_4_PCCOUNT);
	export_constant_npc(JT_4_LAVAGOLEM);
	export_constant_npc(JT_4_F_IA);
	export_constant_npc(JT_4_LOCKE);
	export_constant_npc(JT_4_LIL_LIF);
	export_constant_npc(JT_4_LIL_LIF2);
	export_constant_npc(JT_4_F_DRAGONHAT);
	export_constant_npc(JT_4_M_DRAGONHAT);
	export_constant_npc(JT_JP_NPC02);
	export_constant_npc(JT_JP_NPC03);
	export_constant_npc(JT_JP_NPC04);
	export_constant_npc(JT_JP_NPC05);
	export_constant_npc(JT_JP_NPC06);
	export_constant_npc(JT_JP_NPC07);
	export_constant_npc(JT_JP_NPC08);
	export_constant_npc(JT_JP_NPC09);
	export_constant_npc(JT_JP_NPC10);
	export_constant_npc(JT_4_FIRERING);
	export_constant_npc(JT_4_SCATLETON);
	export_constant_npc(JT_4_JP_AB_NPC_001);
	export_constant_npc(JT_4_JP_AB_NPC_002);
	export_constant_npc(JT_4_JP_AB_NPC_003);
	export_constant_npc(JT_4_JP_AB_NPC_004);
	export_constant_npc(JT_4_JP_AB_NPC_005);
	export_constant_npc(JT_4_JP_AB_NPC_006);
	export_constant_npc(JT_4_JP_AB_NPC_007);
	export_constant_npc(JT_4_JP_AB_NPC_008);
	export_constant_npc(JT_4_JJAK);
	export_constant_npc(JT_4_M_SNOWMAN_B);
	export_constant_npc(JT_4_M_SNOWMAN_R);
	export_constant_npc(JT_4_M_SNOWMAN_G);
	export_constant_npc(JT_WARPEFFECTNPC);
	export_constant_npc(JT_4_HEN);
	export_constant_npc(JT_4_F_DANGDANG);
	export_constant_npc(JT_4_M_DANGDANG);
	export_constant_npc(JT_4_F_DANGDANG1);
	export_constant_npc(JT_4_LEAFCAT);
	export_constant_npc(JT_4_NASARIAN);
	export_constant_npc(JT_4_NASARIAN_EM);
	export_constant_npc(JT_4_TEDDY_BEAR_W);
	export_constant_npc(JT_4_TEDDY_BEAR_B);
	export_constant_npc(JT_4_TEDDY_BEAR_B_L);
	export_constant_npc(JT_4_M_SOULREAPER);
	export_constant_npc(JT_4_F_SE_SUN);
	export_constant_npc(JT_4_M_SE_MOON);
	export_constant_npc(JT_4_M_SE_STAR);
	export_constant_npc(JT_4_EP17_KAYA);
	export_constant_npc(JT_4_EP17_AS);
	export_constant_npc(JT_4_EP17_ELYUMINA);
	export_constant_npc(JT_4_EP17_MORNING);
	export_constant_npc(JT_4_EP17_MIGUEL);
	export_constant_npc(JT_4_EP17_NIHIL_K);
	export_constant_npc(JT_4_EP17_MIGUEL_D);
	export_constant_npc(JT_4_ED_SCHMIDT);
	export_constant_npc(JT_4_ED_OSCAR);
	export_constant_npc(JT_4_ED_ORB);
	export_constant_npc(JT_4_ED_FENCE);
	export_constant_npc(JT_4_M_ANDREA);
	export_constant_npc(JT_4_M_ANDREA_D);
	export_constant_npc(JT_4_F_ANES);
	export_constant_npc(JT_4_F_ANES_D);
	export_constant_npc(JT_4_M_SILVANO);
	export_constant_npc(JT_4_M_SILVANO_D);
	export_constant_npc(JT_4_F_CECILIA);
	export_constant_npc(JT_4_F_CECILIA_D);
	export_constant_npc(JT_4_M_MD_SEYREN);
	export_constant_npc(JT_4_M_MD_EREMES);
	export_constant_npc(JT_4_M_MD_HARWORD);
	export_constant_npc(JT_4_F_MD_MAGALETA);
	export_constant_npc(JT_4_F_MD_SHECIL);
	export_constant_npc(JT_4_F_MD_KATRINN);
	export_constant_npc(JT_4_M_MD_SEYREN_H);
	export_constant_npc(JT_4_M_MD_EREMES_H);
	export_constant_npc(JT_4_M_MD_HARWORD_H);
	export_constant_npc(JT_4_F_MD_MAGALETA_H);
	export_constant_npc(JT_4_F_MD_SHECIL_H);
	export_constant_npc(JT_4_F_MD_KATRINN_H);
	export_constant_npc(JT_4_M_MD_SEYREN_D);
	export_constant_npc(JT_4_M_MD_EREMES_D);
	export_constant_npc(JT_4_M_MD_HARWORD_D);
	export_constant_npc(JT_4_F_MD_MAGALETA_D);
	export_constant_npc(JT_4_F_MD_SHECIL_D);
	export_constant_npc(JT_4_F_MD_KATRINN_D);
	export_constant_npc(JT_4_F_MD_YGNIZEM);
	export_constant_npc(JT_4_F_ERENE);
	export_constant_npc(JT_4_M_EINCPTMINER);
	export_constant_npc(JT_4_F_EINRESERCHER);
	export_constant_npc(JT_4_F_REINDEER);
	export_constant_npc(JT_4_PIGOCTO);
	export_constant_npc(JT_4_ORK_HERO);
	export_constant_npc(JT_4_JP_16TH);
	export_constant_npc(JT_4_EP17_MASTER_A);
	export_constant_npc(JT_4_EP17_BASIC_B);
	export_constant_npc(JT_4_EP17_GUARD_B);
	export_constant_npc(JT_4_EP17_BASIC_B_NG);
	export_constant_npc(JT_4_EP17_GUARD_B_NG);
	export_constant_npc(JT_4_EP17_SWEETY);
	export_constant_npc(JT_4_EP17_BOY_A);
	export_constant_npc(JT_4_EP17_BOY_B);
	export_constant_npc(JT_4_EP17_TAMARIN);
	export_constant_npc(JT_4_EP17_SCISSORE);
	export_constant_npc(JT_4_EP17_TABLET);
	export_constant_npc(JT_4_EP17_BUCKETS);
	export_constant_npc(JT_4_EP17_CLEANER);
	export_constant_npc(JT_4_EP17_BASKET);
	export_constant_npc(JT_4_EP17_BROKENBETA);
	export_constant_npc(JT_4_EP17_CLEANER_W);
	export_constant_npc(JT_4_EP17_MERMAID);
	export_constant_npc(JT_4_JP_AB_NPC_009);
	export_constant_npc(JT_4_JP_AB_NPC_010);
	export_constant_npc(JT_4_4JOB_SILLA);
	export_constant_npc(JT_4_4JOB_MAGGI);
	export_constant_npc(JT_4_4JOB_ROBIN);
	export_constant_npc(JT_4_4JOB_ROBIN_DRUNK);
	export_constant_npc(JT_4_4JOB_LETICIA);
	export_constant_npc(JT_4_4JOB_SERANG);
	export_constant_npc(JT_4_4JOB_EINHAR);
	export_constant_npc(JT_4_4JOB_SEALSTONE);
	export_constant_npc(JT_4_4JOB_PHANTOMBOOK1);
	export_constant_npc(JT_4_4JOB_PHANTOMBOOK2);
	export_constant_npc(JT_4_4JOB_PHANTOMBOOK3);
	export_constant_npc(JT_4_VENDING_MACHINE2);
	export_constant_npc(JT_4_EP18_MARAM);
	export_constant_npc(JT_4_EP18_MIRIAM);
	export_constant_npc(JT_4_EP18_SUAD);
	export_constant_npc(JT_4_EP18_IMRIL);
	export_constant_npc(JT_4_EP18_MERCHANT);
	export_constant_npc(JT_4_EP18_TAMARIN);
	export_constant_npc(JT_4_EP18_DEW);
	export_constant_npc(JT_4_EP18_MARK);
	export_constant_npc(JT_4_EP18_ALF);
	export_constant_npc(JT_4_EP18_SHULANG);
	export_constant_npc(JT_4_EP18_BAGOT);
	export_constant_npc(JT_4_EP18_DEMIFREYA);
	export_constant_npc(JT_4_EP18_KAMIL);
	export_constant_npc(JT_4_EP18_HAZAR);
	export_constant_npc(JT_4_EP18_WAGON);
	export_constant_npc(JT_4_EP18_PAPERS);
	export_constant_npc(JT_4_EP18_HALFFLOWER);
	export_constant_npc(JT_4_EP18_GW_OLD01);
	export_constant_npc(JT_4_EP18_GW_OLD02);
	export_constant_npc(JT_4_EP18_GW_MIDDLE01);
	export_constant_npc(JT_4_EP18_GW_MIDDLE02);
	export_constant_npc(JT_4_EP18_GW_MAN01);
	export_constant_npc(JT_4_EP18_GW_MAN02);
	export_constant_npc(JT_4_EP18_GW_WOMAN01);
	export_constant_npc(JT_4_EP18_GW_WOMAN02);
	export_constant_npc(JT_4_EP18_GW_CHILD01);
	export_constant_npc(JT_4_EP18_GW_CHILD02);
	export_constant_npc(JT_4_STAR_BOX_SCORE);
	export_constant_npc(JT_4_STAR_BOX_POW1);
	export_constant_npc(JT_4_STAR_BOX_POW2);
	export_constant_npc(JT_4_STAR_BOX_STA1);
	export_constant_npc(JT_4_STAR_BOX_STA2);
	export_constant_npc(JT_4_STAR_BOX_SPL1);
	export_constant_npc(JT_4_STAR_BOX_SPL2);
	export_constant_npc(JT_4_STAR_BOX_CON1);
	export_constant_npc(JT_4_STAR_BOX_CON2);
	export_constant_npc(JT_4_STAR_BOX_WIS1);
	export_constant_npc(JT_4_STAR_BOX_WIS2);
	export_constant_npc(JT_4_STAR_BOX_CRT1);
	export_constant_npc(JT_4_STAR_BOX_CRT2);
	export_constant_npc(JT_4_4JOB_MAURA);
	export_constant_npc(JT_4_STAR_BOX_N);
	export_constant_npc(JT_4_STAR_BOX_H);
	export_constant_npc(JT_4_STAR_BOX_HP1);
	export_constant_npc(JT_4_STAR_BOX_HP2);
	export_constant_npc(JT_4_STAR_BOX_ATK1);
	export_constant_npc(JT_4_STAR_BOX_ATK2);
	export_constant_npc(JT_4_STAR_BOX_BARRIER1);
	export_constant_npc(JT_4_STAR_BOX_BARRIER2);
	export_constant_npc(JT_4_STAR_BOX_TRAP1);
	export_constant_npc(JT_4_STAR_BOX_TRAP2);
	export_constant_npc(JT_4_STAR_BOX_MASTER);
	export_constant_npc(JT_4_POINT_RED);
	export_constant_npc(JT_4_POINT_BLUE);
	export_constant_npc(JT_4_POINT_YELLOW);
	export_constant_npc(JT_4_POINT_BLACK);
	export_constant_npc(JT_4_POINT_WHITE);
	export_constant_npc(JT_4_EXJOB_GERHOLD);
	export_constant_npc(JT_4_EXJOB_NINJA);
	export_constant_npc(JT_4_EXJOB_MASTER_J);
	export_constant_npc(JT_4_EXJOB_MR_SEO);
	export_constant_npc(JT_4_EXJOB_HAPPY_CLOUD);
	export_constant_npc(JT_4_EXJOB_STAR);
	export_constant_npc(JT_4_EXJOB_CHUL_HO);
	export_constant_npc(JT_4_EXJOB_KI_SUL);
	export_constant_npc(JT_4_EXJOB_HYUN_ROK);
	export_constant_npc(JT_1_JOURNEY_STONE_D);
	export_constant_npc(JT_1_JOURNEY_STONE_F);
	export_constant_npc(JT_ROZ_MQ_SIGRUN);
	export_constant_npc(JT_ROZ_MQ_SIGRUN_S);
	export_constant_npc(JT_ROZ_MQ_HARACE01);
	export_constant_npc(JT_ROZ_MQ_HARACE02);
	export_constant_npc(JT_ROZ_MQ_SAHARIO);
	export_constant_npc(JT_ROZ_MQ_SUPIGEL);
	export_constant_npc(JT_ROZ_MQ_DEADSOLDIER);
	export_constant_npc(JT_4_EP19_ZORYARA);
	export_constant_npc(JT_4_EP19_MORYARA);
	export_constant_npc(JT_4_EP19_LUNCH);
	export_constant_npc(JT_4_EP19_LAZY);
	export_constant_npc(JT_4_EP19_JUNCEA);
	export_constant_npc(JT_4_EP19_JUNCEA_M);
	export_constant_npc(JT_4_EP19_JUNCEA_D);
	export_constant_npc(JT_4_EP19_FRIEDERIKE);
	export_constant_npc(JT_4_EP19_SUITCASE);
	export_constant_npc(JT_4_EP19_HEALROCK);
	export_constant_npc(JT_4_EP19_IWIN);
	export_constant_npc(JT_4_EP19_IWIN_DIVER);
	export_constant_npc(JT_4_EP19_TAMARIN);
	export_constant_npc(JT_4_EP19_LEON);
	export_constant_npc(JT_4_EP19_AURELIE);
	export_constant_npc(JT_4_EP19_LASGAND);
	export_constant_npc(JT_4_EP19_VOGLINDE);
	export_constant_npc(JT_4_EP19_VELLGUNDE);
	export_constant_npc(JT_4_EP19_LEHAR);
	export_constant_npc(JT_4_EP19_RGAN_R1);
	export_constant_npc(JT_4_EP19_RGAN_R2);
	export_constant_npc(JT_4_EP19_RGAN_R3);
	export_constant_npc(JT_4_EP19_RGAN_SR1);
	export_constant_npc(JT_4_EP19_RGAN_SR2);
	export_constant_npc(JT_4_EP19_RGAN_SR3);
	export_constant_npc(JT_1_RAGFES_01);
	export_constant_npc(JT_1_RAGFES_01_M);
	export_constant_npc(JT_4_RAGFES_02);
	export_constant_npc(JT_4_RAGFES_02_M);
	export_constant_npc(JT_4_RAGFES_03);
	export_constant_npc(JT_4_RAGFES_03_M);
	export_constant_npc(JT_4_RAGFES_04);
	export_constant_npc(JT_4_RAGFES_04_M);
	export_constant_npc(JT_4_RAGFES_05);
	export_constant_npc(JT_4_RAGFES_05_M);
	export_constant_npc(JT_4_RAGFES_06);
	export_constant_npc(JT_4_RAGFES_06_M);
	export_constant_npc(JT_4_RAGFES_07);
	export_constant_npc(JT_4_RAGFES_07_M);
	export_constant_npc(JT_4_RAGFES_08);
	export_constant_npc(JT_4_RAGFES_08_M);
	export_constant_npc(JT_4_RAGFES_09);
	export_constant_npc(JT_4_RAGFES_09_M);
	export_constant_npc(JT_4_RAGFES_10);
	export_constant_npc(JT_4_RAGFES_10_M);
	export_constant_npc(JT_4_RAGFES_11);
	export_constant_npc(JT_4_RAGFES_11_M);
	export_constant_npc(JT_4_RAGFES_12);
	export_constant_npc(JT_4_RAGFES_12_M);
	export_constant_npc(JT_4_RAGFES_13);
	export_constant_npc(JT_4_RAGFES_13_M);
	export_constant_npc(JT_4_RAGFES_14);
	export_constant_npc(JT_4_RAGFES_14_M);
	export_constant_npc(JT_4_RAGFES_15);
	export_constant_npc(JT_4_RAGFES_15_M);
	export_constant_npc(JT_4_RAGFES_16);
	export_constant_npc(JT_4_RAGFES_16_M);
	export_constant_npc(JT_4_EXJOB_NINJA2);
	export_constant_npc(JT_4_VR_BOOK_FAIRY);
	export_constant_npc(JT_ROZ_MQ_LUCIAN);
	export_constant_npc(JT_ROZ_MQ_BRITIA);
	export_constant_npc(JT_ROZ_MQ_ASSASIN01);
	export_constant_npc(JT_STRANGE_B_SMITH1);
	export_constant_npc(JT_STRONGER_B_SMTIH);
	export_constant_npc(JT_4_VR_BOOK_RED);
	export_constant_npc(JT_4_VR_BOOK_BLUE);
	export_constant_npc(JT_4_VR_BOOK_YELLOW);
	export_constant_npc(JT_4_VR_BOOK_GREEN);
	export_constant_npc(JT_4_VR_BOOK_WHITE);
	export_constant_npc(JT_4_VR_YGNIZEM);
	export_constant_npc(JT_4_JP_19TH);
	export_constant_npc(JT_4_KING_PORING);
	export_constant_npc(JT_4_VR_SWORDMAN_DEAD);
	export_constant_npc(JT_GATE_SKYBLUE);
	export_constant_npc(JT_4_CS_RIGEL);
	export_constant_npc(JT_4_M_NILLEM);
	export_constant_npc(JT_4_LARVA_RED);
	export_constant_npc(JT_4_LARVA_YELLOW);
	export_constant_npc(JT_4_LARVA_BLACK);
	export_constant_npc(JT_4_LARVA_VIOLET);
	export_constant_npc(JT_4_HERO_SAUSAGE);
	export_constant_npc(JT_4_PRINCESS_SAUSAGE);
	export_constant_npc(JT_4_EP20_LASGAND);
	export_constant_npc(JT_4_EP20_NYAR);
	export_constant_npc(JT_4_EP20_DEVICE_BLUE);
	export_constant_npc(JT_4_EP20_DEVICE_RED);
	export_constant_npc(JT_4_EP20_DEVICE_BLACK);
	export_constant_npc(JT_4_GACHA_MACHINE);
	export_constant_npc(JT_4_VR_CHAO);
	export_constant_npc(JT_4_RUNESTONE);
	export_constant_npc(JT_4_EM_ARDOR);
	export_constant_npc(JT_4_EM_DILUVIO);
	export_constant_npc(JT_4_EM_PROCELLA);
	export_constant_npc(JT_4_EM_TERREMOTUS);
	export_constant_npc(JT_4_EM_SERPENS);
	export_constant_npc(JT_4_SNOWDOG);
	export_constant_npc(JT_1_SHADOW_RED);
	export_constant_npc(JT_1_SHADOW_ORANGE);
	export_constant_npc(JT_1_SHADOW_YELLOW);
	export_constant_npc(JT_1_SHADOW_GREEN);
	export_constant_npc(JT_1_SHADOW_BLUE);
	export_constant_npc(JT_1_SHADOW_INDIGO);
	export_constant_npc(JT_1_SHADOW_VIOLET);
	export_constant_npc(JT_4_EVT_LAMMIR);
	export_constant_npc(JT_4_EVT_SULKI);
	export_constant_npc(JT_4_EVT_KKAT);
	export_constant_npc(JT_4_EP21_SOLDIER_A);
	export_constant_npc(JT_4_EP21_SOLDIER_B);
	export_constant_npc(JT_4_EP21_M_WORKER_A);
	export_constant_npc(JT_4_EP21_M_WORKER_B);
	export_constant_npc(JT_4_EP21_F_WORKER_A);
	export_constant_npc(JT_4_EP21_F_WORKER_B);
	export_constant_npc(JT_4_EP21_WORKER_KID_A);
	export_constant_npc(JT_4_EP21_WORKER_KID_B);
	export_constant_npc(JT_4_EP21_TAN);
	export_constant_npc(JT_4_EP21_TRIS);
	export_constant_npc(JT_4_EP21_NADOYO);
	export_constant_npc(JT_4_EP21_REINHARDT);
	export_constant_npc(JT_4_EP21_WILHELM);
	export_constant_npc(JT_4_EP21_MARISTELLA);
	export_constant_npc(JT_4_EP21_YOHAN);
	export_constant_npc(JT_4_EP21_RICHARD);
	export_constant_npc(JT_4_EP21_VALDARIS);
	export_constant_npc(JT_4_EP21_GUNTER);
	export_constant_npc(JT_4_EP21_GALAXIA_A);
	export_constant_npc(JT_4_EP21_GALAXIA_B);
	export_constant_npc(JT_4_EP21_IVAN);
	export_constant_npc(JT_4_EP21_LALAILA);
	export_constant_npc(JT_4_EP21_ILSE);
	export_constant_npc(JT_4_EP21_HOWELL);
	export_constant_npc(JT_4_EP21_EPESTO);
	export_constant_npc(JT_4_EP21_HEINE_TAB);
	export_constant_npc(JT_4_EP21_IANA);
	export_constant_npc(JT_4_EP21_LEE);
	export_constant_npc(JT_4_EP21_AURELIE);
	export_constant_npc(JT_4_EP21_HOWELL_S);
	export_constant_npc(JT_4_EP21_TAN_S);
	export_constant_npc(JT_4_M_VACATION_MARAM);
	export_constant_npc(JT_4_CLB_SS_FC);
	export_constant_npc(JT_4_CLB_SS_TZ);
	export_constant_npc(JT_4_CLB_SS_AJ);
	export_constant_npc(JT_4_CLB_SS_LK);
	export_constant_npc(JT_4_SMART_ANDRE);
	export_constant_npc(JT_ROZ_MQ_XAVIER);
	export_constant_npc(JT_ROZ_MQ_MOCLORD);
	export_constant_npc(JT_ROZ_MQ_SKULD);
	export_constant_npc(JT_NEW_NPC_3RD_END);
	#undef export_constant_npc

	/* special effects */
	export_constant(EF_NONE);
	export_constant(EF_HIT1);
	export_constant(EF_HIT2);
	export_constant(EF_HIT3);
	export_constant(EF_HIT4);
	export_constant(EF_HIT5);
	export_constant(EF_HIT6);
	export_constant(EF_ENTRY);
	export_constant(EF_EXIT);
	export_constant(EF_WARP);
	export_constant(EF_ENHANCE);
	export_constant(EF_COIN);
	export_constant(EF_ENDURE);
	export_constant(EF_BEGINSPELL);
	export_constant(EF_GLASSWALL);
	export_constant(EF_HEALSP);
	export_constant(EF_SOULSTRIKE);
	export_constant(EF_BASH);
	export_constant(EF_MAGNUMBREAK);
	export_constant(EF_STEAL);
	export_constant(EF_HIDING);
	export_constant(EF_PATTACK);
	export_constant(EF_DETOXICATION);
	export_constant(EF_SIGHT);
	export_constant(EF_STONECURSE);
	export_constant(EF_FIREBALL);
	export_constant(EF_FIREWALL);
	export_constant(EF_ICEARROW);
	export_constant(EF_FROSTDIVER);
	export_constant(EF_FROSTDIVER2);
	export_constant(EF_LIGHTBOLT);
	export_constant(EF_THUNDERSTORM);
	export_constant(EF_FIREARROW);
	export_constant(EF_NAPALMBEAT);
	export_constant(EF_RUWACH);
	export_constant(EF_TELEPORTATION);
	export_constant(EF_READYPORTAL);
	export_constant(EF_PORTAL);
	export_constant(EF_INCAGILITY);
	export_constant(EF_DECAGILITY);
	export_constant(EF_AQUA);
	export_constant(EF_SIGNUM);
	export_constant(EF_ANGELUS);
	export_constant(EF_BLESSING);
	export_constant(EF_INCAGIDEX);
	export_constant(EF_SMOKE);
	export_constant(EF_FIREFLY);
	export_constant(EF_SANDWIND);
	export_constant(EF_TORCH);
	export_constant(EF_SPRAYPOND);
	export_constant(EF_FIREHIT);
	export_constant(EF_FIRESPLASHHIT);
	export_constant(EF_COLDHIT);
	export_constant(EF_WINDHIT);
	export_constant(EF_POISONHIT);
	export_constant(EF_BEGINSPELL2);
	export_constant(EF_BEGINSPELL3);
	export_constant(EF_BEGINSPELL4);
	export_constant(EF_BEGINSPELL5);
	export_constant(EF_BEGINSPELL6);
	export_constant(EF_BEGINSPELL7);
	export_constant(EF_LOCKON);
	export_constant(EF_WARPZONE);
	export_constant(EF_SIGHTRASHER);
	export_constant(EF_BARRIER);
	export_constant(EF_ARROWSHOT);
	export_constant(EF_INVENOM);
	export_constant(EF_CURE);
	export_constant(EF_PROVOKE);
	export_constant(EF_MVP);
	export_constant(EF_SKIDTRAP);
	export_constant(EF_BRANDISHSPEAR);
	export_constant(EF_CONE);
	export_constant(EF_SPHERE);
	export_constant(EF_BOWLINGBASH);
	export_constant(EF_ICEWALL);
	export_constant(EF_GLORIA);
	export_constant(EF_MAGNIFICAT);
	export_constant(EF_RESURRECTION);
	export_constant(EF_RECOVERY);
	export_constant(EF_EARTHSPIKE);
	export_constant(EF_SPEARBMR);
	export_constant(EF_PIERCE);
	export_constant(EF_TURNUNDEAD);
	export_constant(EF_SANCTUARY);
	export_constant(EF_IMPOSITIO);
	export_constant(EF_LEXAETERNA);
	export_constant(EF_ASPERSIO);
	export_constant(EF_LEXDIVINA);
	export_constant(EF_SUFFRAGIUM);
	export_constant(EF_STORMGUST);
	export_constant(EF_LORD);
	export_constant(EF_BENEDICTIO);
	export_constant(EF_METEORSTORM);
	export_constant(EF_YUFITEL);
	export_constant(EF_YUFITELHIT);
	export_constant(EF_QUAGMIRE);
	export_constant(EF_FIREPILLAR);
	export_constant(EF_FIREPILLARBOMB);
	export_constant(EF_HASTEUP);
	export_constant(EF_FLASHER);
	export_constant(EF_REMOVETRAP);
	export_constant(EF_REPAIRWEAPON);
	export_constant(EF_CRASHEARTH);
	export_constant(EF_PERFECTION);
	export_constant(EF_MAXPOWER);
	export_constant(EF_BLASTMINE);
	export_constant(EF_BLASTMINEBOMB);
	export_constant(EF_CLAYMORE);
	export_constant(EF_FREEZING);
	export_constant(EF_BUBBLE);
	export_constant(EF_GASPUSH);
	export_constant(EF_SPRINGTRAP);
	export_constant(EF_KYRIE);
	export_constant(EF_MAGNUS);
	export_constant(EF_BOTTOM);
	export_constant(EF_BLITZBEAT);
	export_constant(EF_WATERBALL);
	export_constant(EF_WATERBALL2);
	export_constant(EF_FIREIVY);
	export_constant(EF_DETECTING);
	export_constant(EF_CLOAKING);
	export_constant(EF_SONICBLOW);
	export_constant(EF_SONICBLOWHIT);
	export_constant(EF_GRIMTOOTH);
	export_constant(EF_VENOMDUST);
	export_constant(EF_ENCHANTPOISON);
	export_constant(EF_POISONREACT);
	export_constant(EF_POISONREACT2);
	export_constant(EF_OVERTHRUST);
	export_constant(EF_SPLASHER);
	export_constant(EF_TWOHANDQUICKEN);
	export_constant(EF_AUTOCOUNTER);
	export_constant(EF_GRIMTOOTHATK);
	export_constant(EF_FREEZE);
	export_constant(EF_FREEZED);
	export_constant(EF_ICECRASH);
	export_constant(EF_SLOWPOISON);
	export_constant(EF_BOTTOM2);
	export_constant(EF_FIREPILLARON);
	export_constant(EF_SANDMAN);
	export_constant(EF_REVIVE);
	export_constant(EF_PNEUMA);
	export_constant(EF_HEAVENSDRIVE);
	export_constant(EF_SONICBLOW2);
	export_constant(EF_BRANDISH2);
	export_constant(EF_SHOCKWAVE);
	export_constant(EF_SHOCKWAVEHIT);
	export_constant(EF_EARTHHIT);
	export_constant(EF_PIERCESELF);
	export_constant(EF_BOWLINGSELF);
	export_constant(EF_SPEARSTABSELF);
	export_constant(EF_SPEARBMRSELF);
	export_constant(EF_HOLYHIT);
	export_constant(EF_CONCENTRATION);
	export_constant(EF_REFINEOK);
	export_constant(EF_REFINEFAIL);
	export_constant(EF_JOBCHANGE);
	export_constant(EF_LVUP);
	export_constant(EF_JOBLVUP);
	export_constant(EF_TOPRANK);
	export_constant(EF_PARTY);
	export_constant(EF_RAIN);
	export_constant(EF_SNOW);
	export_constant(EF_SAKURA);
	export_constant(EF_STATUS_STATE);
	export_constant(EF_BANJJAKII);
	export_constant(EF_MAKEBLUR);
	export_constant(EF_TAMINGSUCCESS);
	export_constant(EF_TAMINGFAILED);
	export_constant(EF_ENERGYCOAT);
	export_constant(EF_CARTREVOLUTION);
	export_constant(EF_VENOMDUST2);
	export_constant(EF_CHANGEDARK);
	export_constant(EF_CHANGEFIRE);
	export_constant(EF_CHANGECOLD);
	export_constant(EF_CHANGEWIND);
	export_constant(EF_CHANGEFLAME);
	export_constant(EF_CHANGEEARTH);
	export_constant(EF_CHAINGEHOLY);
	export_constant(EF_CHANGEPOISON);
	export_constant(EF_HITDARK);
	export_constant(EF_MENTALBREAK);
	export_constant(EF_MAGICALATTHIT);
	export_constant(EF_SUI_EXPLOSION);
	export_constant(EF_DARKATTACK);
	export_constant(EF_SUICIDE);
	export_constant(EF_COMBOATTACK1);
	export_constant(EF_COMBOATTACK2);
	export_constant(EF_COMBOATTACK3);
	export_constant(EF_COMBOATTACK4);
	export_constant(EF_COMBOATTACK5);
	export_constant(EF_GUIDEDATTACK);
	export_constant(EF_POISONATTACK);
	export_constant(EF_SILENCEATTACK);
	export_constant(EF_STUNATTACK);
	export_constant(EF_PETRIFYATTACK);
	export_constant(EF_CURSEATTACK);
	export_constant(EF_SLEEPATTACK);
	export_constant(EF_TELEKHIT);
	export_constant(EF_PONG);
	export_constant(EF_LEVEL99);
	export_constant(EF_LEVEL99_2);
	export_constant(EF_LEVEL99_3);
	export_constant(EF_GUMGANG);
	export_constant(EF_POTION1);
	export_constant(EF_POTION2);
	export_constant(EF_POTION3);
	export_constant(EF_POTION4);
	export_constant(EF_POTION5);
	export_constant(EF_POTION6);
	export_constant(EF_POTION7);
	export_constant(EF_POTION8);
	export_constant(EF_DARKBREATH);
	export_constant(EF_DEFFENDER);
	export_constant(EF_KEEPING);
	export_constant(EF_SUMMONSLAVE);
	export_constant(EF_BLOODDRAIN);
	export_constant(EF_ENERGYDRAIN);
	export_constant(EF_POTION_CON);
	export_constant(EF_POTION_);
	export_constant(EF_POTION_BERSERK);
	export_constant(EF_POTIONPILLAR);
	export_constant(EF_DEFENDER);
	export_constant(EF_GANBANTEIN);
	export_constant(EF_WIND);
	export_constant(EF_VOLCANO);
	export_constant(EF_GRANDCROSS);
	export_constant(EF_INTIMIDATE);
	export_constant(EF_CHOOKGI);
	export_constant(EF_CLOUD);
	export_constant(EF_CLOUD2);
	export_constant(EF_MAPPILLAR);
	export_constant(EF_LINELINK);
	export_constant(EF_CLOUD3);
	export_constant(EF_SPELLBREAKER);
	export_constant(EF_DISPELL);
	export_constant(EF_DELUGE);
	export_constant(EF_VIOLENTGALE);
	export_constant(EF_LANDPROTECTOR);
	export_constant(EF_BOTTOM_VO);
	export_constant(EF_BOTTOM_DE);
	export_constant(EF_BOTTOM_VI);
	export_constant(EF_BOTTOM_LA);
	export_constant(EF_FASTMOVE);
	export_constant(EF_MAGICROD);
	export_constant(EF_HOLYCROSS);
	export_constant(EF_SHIELDCHARGE);
	export_constant(EF_MAPPILLAR2);
	export_constant(EF_PROVIDENCE);
	export_constant(EF_SHIELDBOOMERANG);
	export_constant(EF_SPEARQUICKEN);
	export_constant(EF_DEVOTION);
	export_constant(EF_REFLECTSHIELD);
	export_constant(EF_ABSORBSPIRITS);
	export_constant(EF_STEELBODY);
	export_constant(EF_FLAMELAUNCHER);
	export_constant(EF_FROSTWEAPON);
	export_constant(EF_LIGHTNINGLOADER);
	export_constant(EF_SEISMICWEAPON);
	export_constant(EF_MAPPILLAR3);
	export_constant(EF_MAPPILLAR4);
	export_constant(EF_GUMGANG2);
	export_constant(EF_TEIHIT1);
	export_constant(EF_GUMGANG3);
	export_constant(EF_TEIHIT2);
	export_constant(EF_TANJI);
	export_constant(EF_TEIHIT1X);
	export_constant(EF_CHIMTO);
	export_constant(EF_STEALCOIN);
	export_constant(EF_STRIPWEAPON);
	export_constant(EF_STRIPSHIELD);
	export_constant(EF_STRIPARMOR);
	export_constant(EF_STRIPHELM);
	export_constant(EF_CHAINCOMBO);
	export_constant(EF_RG_COIN);
	export_constant(EF_BACKSTAP);
	export_constant(EF_TEIHIT3);
	export_constant(EF_BOTTOM_DISSONANCE);
	export_constant(EF_BOTTOM_LULLABY);
	export_constant(EF_BOTTOM_RICHMANKIM);
	export_constant(EF_BOTTOM_ETERNALCHAOS);
	export_constant(EF_BOTTOM_DRUMBATTLEFIELD);
	export_constant(EF_BOTTOM_RINGNIBELUNGEN);
	export_constant(EF_BOTTOM_ROKISWEIL);
	export_constant(EF_BOTTOM_INTOABYSS);
	export_constant(EF_BOTTOM_SIEGFRIED);
	export_constant(EF_BOTTOM_WHISTLE);
	export_constant(EF_BOTTOM_ASSASSINCROSS);
	export_constant(EF_BOTTOM_POEMBRAGI);
	export_constant(EF_BOTTOM_APPLEIDUN);
	export_constant(EF_BOTTOM_UGLYDANCE);
	export_constant(EF_BOTTOM_HUMMING);
	export_constant(EF_BOTTOM_DONTFORGETME);
	export_constant(EF_BOTTOM_FORTUNEKISS);
	export_constant(EF_BOTTOM_SERVICEFORYOU);
	export_constant(EF_TALK_FROSTJOKE);
	export_constant(EF_TALK_SCREAM);
	export_constant(EF_POKJUK);
	export_constant(EF_THROWITEM);
	export_constant(EF_THROWITEM2);
	export_constant(EF_CHEMICALPROTECTION);
	export_constant(EF_POKJUK_SOUND);
	export_constant(EF_DEMONSTRATION);
	export_constant(EF_CHEMICAL2);
	export_constant(EF_TELEPORTATION2);
	export_constant(EF_PHARMACY_OK);
	export_constant(EF_PHARMACY_FAIL);
	export_constant(EF_FORESTLIGHT);
	export_constant(EF_THROWITEM3);
	export_constant(EF_FIRSTAID);
	export_constant(EF_SPRINKLESAND);
	export_constant(EF_LOUD);
	export_constant(EF_HEAL);
	export_constant(EF_HEAL2);
	export_constant(EF_EXIT2);
	export_constant(EF_GLASSWALL2);
	export_constant(EF_READYPORTAL2);
	export_constant(EF_PORTAL2);
	export_constant(EF_BOTTOM_MAG);
	export_constant(EF_BOTTOM_SANC);
	export_constant(EF_HEAL3);
	export_constant(EF_WARPZONE2);
	export_constant(EF_FORESTLIGHT2);
	export_constant(EF_FORESTLIGHT3);
	export_constant(EF_FORESTLIGHT4);
	export_constant(EF_HEAL4);
	export_constant(EF_FOOT);
	export_constant(EF_FOOT2);
	export_constant(EF_BEGINASURA);
	export_constant(EF_TRIPLEATTACK);
	export_constant(EF_HITLINE);
	export_constant(EF_HPTIME);
	export_constant(EF_SPTIME);
	export_constant(EF_MAPLE);
	export_constant(EF_BLIND);
	export_constant(EF_POISON);
	export_constant(EF_GUARD);
	export_constant(EF_JOBLVUP50);
	export_constant(EF_ANGEL2);
	export_constant(EF_MAGNUM2);
	export_constant(EF_CALLZONE);
	export_constant(EF_PORTAL3);
	export_constant(EF_COUPLECASTING);
	export_constant(EF_HEARTCASTING);
	export_constant(EF_ENTRY2);
	export_constant(EF_SAINTWING);
	export_constant(EF_SPHEREWIND);
	export_constant(EF_COLORPAPER);
	export_constant(EF_LIGHTSPHERE);
	export_constant(EF_WATERFALL);
	export_constant(EF_WATERFALL_90);
	export_constant(EF_WATERFALL_SMALL);
	export_constant(EF_WATERFALL_SMALL_90);
	export_constant(EF_WATERFALL_T2);
	export_constant(EF_WATERFALL_T2_90);
	export_constant(EF_WATERFALL_SMALL_T2);
	export_constant(EF_WATERFALL_SMALL_T2_90);
	export_constant(EF_MINI_TETRIS);
	export_constant(EF_GHOST);
	export_constant(EF_BAT);
	export_constant(EF_BAT2);
	export_constant(EF_SOULBREAKER);
	export_constant(EF_LEVEL99_4);
	export_constant(EF_VALLENTINE);
	export_constant(EF_VALLENTINE2);
	export_constant(EF_PRESSURE);
	export_constant(EF_BASH3D);
	export_constant(EF_AURABLADE);
	export_constant(EF_REDBODY);
	export_constant(EF_LKCONCENTRATION);
	export_constant(EF_BOTTOM_GOSPEL);
	export_constant(EF_ANGEL);
	export_constant(EF_DEVIL);
	export_constant(EF_DRAGONSMOKE);
	export_constant(EF_BOTTOM_BASILICA);
	export_constant(EF_ASSUMPTIO);
	export_constant(EF_HITLINE2);
	export_constant(EF_BASH3D2);
	export_constant(EF_ENERGYDRAIN2);
	export_constant(EF_TRANSBLUEBODY);
	export_constant(EF_MAGICCRASHER);
	export_constant(EF_LIGHTSPHERE2);
	export_constant(EF_LIGHTBLADE);
	export_constant(EF_ENERGYDRAIN3);
	export_constant(EF_LINELINK2);
	export_constant(EF_LINKLIGHT);
	export_constant(EF_TRUESIGHT);
	export_constant(EF_FALCONASSAULT);
	export_constant(EF_TRIPLEATTACK2);
	export_constant(EF_PORTAL4);
	export_constant(EF_MELTDOWN);
	export_constant(EF_CARTBOOST);
	export_constant(EF_REJECTSWORD);
	export_constant(EF_TRIPLEATTACK3);
	export_constant(EF_SPHEREWIND2);
	export_constant(EF_LINELINK3);
	export_constant(EF_PINKBODY);
	export_constant(EF_LEVEL99_5);
	export_constant(EF_LEVEL99_6);
	export_constant(EF_BASH3D3);
	export_constant(EF_BASH3D4);
	export_constant(EF_NAPALMVALCAN);
	export_constant(EF_PORTAL5);
	export_constant(EF_MAGICCRASHER2);
	export_constant(EF_BOTTOM_SPIDER);
	export_constant(EF_BOTTOM_FOGWALL);
	export_constant(EF_SOULBURN);
	export_constant(EF_SOULCHANGE);
	export_constant(EF_BABY);
	export_constant(EF_SOULBREAKER2);
	export_constant(EF_RAINBOW);
	export_constant(EF_PEONG);
	export_constant(EF_TANJI2);
	export_constant(EF_PRESSEDBODY);
	export_constant(EF_SPINEDBODY);
	export_constant(EF_KICKEDBODY);
	export_constant(EF_AIRTEXTURE);
	export_constant(EF_HITBODY);
	export_constant(EF_DOUBLEGUMGANG);
	export_constant(EF_REFLECTBODY);
	export_constant(EF_BABYBODY);
	export_constant(EF_BABYBODY2);
	export_constant(EF_GIANTBODY);
	export_constant(EF_GIANTBODY2);
	export_constant(EF_ASURABODY);
	export_constant(EF_4WAYBODY);
	export_constant(EF_QUAKEBODY);
	export_constant(EF_ASURABODY_MONSTER);
	export_constant(EF_HITLINE3);
	export_constant(EF_HITLINE4);
	export_constant(EF_HITLINE5);
	export_constant(EF_HITLINE6);
	export_constant(EF_ELECTRIC);
	export_constant(EF_ELECTRIC2);
	export_constant(EF_HITLINE7);
	export_constant(EF_STORMKICK);
	export_constant(EF_HALFSPHERE);
	export_constant(EF_ATTACKENERGY);
	export_constant(EF_ATTACKENERGY2);
	export_constant(EF_CHEMICAL3);
	export_constant(EF_ASSUMPTIO2);
	export_constant(EF_BLUECASTING);
	export_constant(EF_RUN);
	export_constant(EF_STOPRUN);
	export_constant(EF_STOPEFFECT);
	export_constant(EF_JUMPBODY);
	export_constant(EF_LANDBODY);
	export_constant(EF_FOOT3);
	export_constant(EF_FOOT4);
	export_constant(EF_TAE_READY);
	export_constant(EF_GRANDCROSS2);
	export_constant(EF_SOULSTRIKE2);
	export_constant(EF_YUFITEL2);
	export_constant(EF_NPC_STOP);
	export_constant(EF_DARKCASTING);
	export_constant(EF_GUMGANGNPC);
	export_constant(EF_AGIUP);
	export_constant(EF_JUMPKICK);
	export_constant(EF_QUAKEBODY2);
	export_constant(EF_STORMKICK1);
	export_constant(EF_STORMKICK2);
	export_constant(EF_STORMKICK3);
	export_constant(EF_STORMKICK4);
	export_constant(EF_STORMKICK5);
	export_constant(EF_STORMKICK6);
	export_constant(EF_STORMKICK7);
	export_constant(EF_SPINEDBODY2);
	export_constant(EF_BEGINASURA1);
	export_constant(EF_BEGINASURA2);
	export_constant(EF_BEGINASURA3);
	export_constant(EF_BEGINASURA4);
	export_constant(EF_BEGINASURA5);
	export_constant(EF_BEGINASURA6);
	export_constant(EF_BEGINASURA7);
	export_constant(EF_AURABLADE2);
	export_constant(EF_DEVIL1);
	export_constant(EF_DEVIL2);
	export_constant(EF_DEVIL3);
	export_constant(EF_DEVIL4);
	export_constant(EF_DEVIL5);
	export_constant(EF_DEVIL6);
	export_constant(EF_DEVIL7);
	export_constant(EF_DEVIL8);
	export_constant(EF_DEVIL9);
	export_constant(EF_DEVIL10);
	export_constant(EF_DOUBLEGUMGANG2);
	export_constant(EF_DOUBLEGUMGANG3);
	export_constant(EF_BLACKDEVIL);
	export_constant(EF_FLOWERCAST);
	export_constant(EF_FLOWERCAST2);
	export_constant(EF_FLOWERCAST3);
	export_constant(EF_MOCHI);
	export_constant(EF_LAMADAN);
	export_constant(EF_EDP);
	export_constant(EF_SHIELDBOOMERANG2);
	export_constant(EF_RG_COIN2);
	export_constant(EF_GUARD2);
	export_constant(EF_SLIM);
	export_constant(EF_SLIM2);
	export_constant(EF_SLIM3);
	export_constant(EF_CHEMICALBODY);
	export_constant(EF_CASTSPIN);
	export_constant(EF_PIERCEBODY);
	export_constant(EF_SOULLINK);
	export_constant(EF_CHOOKGI2);
	export_constant(EF_MEMORIZE);
	export_constant(EF_SOULLIGHT);
	export_constant(EF_MAPAE);
	export_constant(EF_ITEMPOKJUK);
	export_constant(EF_05VAL);
	export_constant(EF_BEGINASURA11);
	export_constant(EF_NIGHT);
	export_constant(EF_CHEMICAL2DASH);
	export_constant(EF_GROUNDSAMPLE);
	export_constant(EF_GI_EXPLOSION);
	export_constant(EF_CLOUD4);
	export_constant(EF_CLOUD5);
	export_constant(EF_BOTTOM_HERMODE);
	export_constant(EF_CARTTER);
	export_constant(EF_ITEMFAST);
	export_constant(EF_SHIELDBOOMERANG3);
	export_constant(EF_DOUBLECASTBODY);
	export_constant(EF_GRAVITATION);
	export_constant(EF_TAROTCARD1);
	export_constant(EF_TAROTCARD2);
	export_constant(EF_TAROTCARD3);
	export_constant(EF_TAROTCARD4);
	export_constant(EF_TAROTCARD5);
	export_constant(EF_TAROTCARD6);
	export_constant(EF_TAROTCARD7);
	export_constant(EF_TAROTCARD8);
	export_constant(EF_TAROTCARD9);
	export_constant(EF_TAROTCARD10);
	export_constant(EF_TAROTCARD11);
	export_constant(EF_TAROTCARD12);
	export_constant(EF_TAROTCARD13);
	export_constant(EF_TAROTCARD14);
	export_constant(EF_ACIDDEMON);
	export_constant(EF_GREENBODY);
	export_constant(EF_THROWITEM4);
	export_constant(EF_BABYBODY_BACK);
	export_constant(EF_THROWITEM5);
	export_constant(EF_BLUEBODY);
	export_constant(EF_HATED);
	export_constant(EF_REDLIGHTBODY);
	export_constant(EF_RO2YEAR);
	export_constant(EF_SMA_READY);
	export_constant(EF_STIN);
	export_constant(EF_RED_HIT);
	export_constant(EF_BLUE_HIT);
	export_constant(EF_QUAKEBODY3);
	export_constant(EF_SMA);
	export_constant(EF_SMA2);
	export_constant(EF_STIN2);
	export_constant(EF_HITTEXTURE);
	export_constant(EF_STIN3);
	export_constant(EF_SMA3);
	export_constant(EF_BLUEFALL);
	export_constant(EF_BLUEFALL_90);
	export_constant(EF_FASTBLUEFALL);
	export_constant(EF_FASTBLUEFALL_90);
	export_constant(EF_BIG_PORTAL);
	export_constant(EF_BIG_PORTAL2);
	export_constant(EF_SCREEN_QUAKE);
	export_constant(EF_HOMUNCASTING);
	export_constant(EF_HFLIMOON1);
	export_constant(EF_HFLIMOON2);
	export_constant(EF_HFLIMOON3);
	export_constant(EF_HO_UP);
	export_constant(EF_HAMIDEFENCE);
	export_constant(EF_HAMICASTLE);
	export_constant(EF_HAMIBLOOD);
	export_constant(EF_HATED2);
	export_constant(EF_TWILIGHT1);
	export_constant(EF_TWILIGHT2);
	export_constant(EF_TWILIGHT3);
	export_constant(EF_ITEM_THUNDER);
	export_constant(EF_ITEM_CLOUD);
	export_constant(EF_ITEM_CURSE);
	export_constant(EF_ITEM_ZZZ);
	export_constant(EF_ITEM_RAIN);
	export_constant(EF_ITEM_LIGHT);
	export_constant(EF_ANGEL3);
	export_constant(EF_M01);
	export_constant(EF_M02);
	export_constant(EF_M03);
	export_constant(EF_M04);
	export_constant(EF_M05);
	export_constant(EF_M06);
	export_constant(EF_M07);
	export_constant(EF_KAIZEL);
	export_constant(EF_KAAHI);
	export_constant(EF_CLOUD6);
	export_constant(EF_FOOD01);
	export_constant(EF_FOOD02);
	export_constant(EF_FOOD03);
	export_constant(EF_FOOD04);
	export_constant(EF_FOOD05);
	export_constant(EF_FOOD06);
	export_constant(EF_SHRINK);
	export_constant(EF_THROWITEM6);
	export_constant(EF_SIGHT2);
	export_constant(EF_QUAKEBODY4);
	export_constant(EF_FIREHIT2);
	export_constant(EF_NPC_STOP2);
	export_constant(EF_NPC_STOP2_DEL);
	export_constant(EF_FVOICE);
	export_constant(EF_WINK);
	export_constant(EF_COOKING_OK);
	export_constant(EF_COOKING_FAIL);
	export_constant(EF_TEMP_OK);
	export_constant(EF_TEMP_FAIL);
	export_constant(EF_HAPGYEOK);
	export_constant(EF_THROWITEM7);
	export_constant(EF_THROWITEM8);
	export_constant(EF_THROWITEM9);
	export_constant(EF_THROWITEM10);
	export_constant(EF_BUNSINJYUTSU);
	export_constant(EF_KOUENKA);
	export_constant(EF_HYOUSENSOU);
	export_constant(EF_BOTTOM_SUITON);
	export_constant(EF_STIN4);
	export_constant(EF_THUNDERSTORM2);
	export_constant(EF_CHEMICAL4);
	export_constant(EF_STIN5);
	export_constant(EF_MADNESS_BLUE);
	export_constant(EF_MADNESS_RED);
	export_constant(EF_RG_COIN3);
	export_constant(EF_BASH3D5);
	export_constant(EF_CHOOKGI3);
	export_constant(EF_KIRIKAGE);
	export_constant(EF_TATAMI);
	export_constant(EF_KASUMIKIRI);
	export_constant(EF_ISSEN);
	export_constant(EF_KAEN);
	export_constant(EF_BAKU);
	export_constant(EF_HYOUSYOURAKU);
	export_constant(EF_DESPERADO);
	export_constant(EF_LIGHTNING_S);
	export_constant(EF_BLIND_S);
	export_constant(EF_POISON_S);
	export_constant(EF_FREEZING_S);
	export_constant(EF_FLARE_S);
	export_constant(EF_RAPIDSHOWER);
	export_constant(EF_MAGICALBULLET);
	export_constant(EF_SPREADATTACK);
	export_constant(EF_TRACKCASTING);
	export_constant(EF_TRACKING);
	export_constant(EF_TRIPLEACTION);
	export_constant(EF_BULLSEYE);
	export_constant(EF_MAP_MAGICZONE);
	export_constant(EF_MAP_MAGICZONE2);
	export_constant(EF_DAMAGE1);
	export_constant(EF_DAMAGE1_2);
	export_constant(EF_DAMAGE1_3);
	export_constant(EF_UNDEADBODY);
	export_constant(EF_UNDEADBODY_DEL);
	export_constant(EF_GREEN_NUMBER);
	export_constant(EF_BLUE_NUMBER);
	export_constant(EF_RED_NUMBER);
	export_constant(EF_PURPLE_NUMBER);
	export_constant(EF_BLACK_NUMBER);
	export_constant(EF_WHITE_NUMBER);
	export_constant(EF_YELLOW_NUMBER);
	export_constant(EF_PINK_NUMBER);
	export_constant(EF_BUBBLE_DROP);
	export_constant(EF_NPC_EARTHQUAKE);
	export_constant(EF_DA_SPACE);
	export_constant(EF_DRAGONFEAR);
	export_constant(EF_BLEEDING);
	export_constant(EF_WIDECONFUSE);
	export_constant(EF_BOTTOM_RUNNER);
	export_constant(EF_BOTTOM_TRANSFER);
	export_constant(EF_CRYSTAL_BLUE);
	export_constant(EF_BOTTOM_EVILLAND);
	export_constant(EF_GUARD3);
	export_constant(EF_NPC_SLOWCAST);
	export_constant(EF_CRITICALWOUND);
	export_constant(EF_GREEN99_3);
	export_constant(EF_GREEN99_5);
	export_constant(EF_GREEN99_6);
	export_constant(EF_MAPSPHERE);
	export_constant(EF_POK_LOVE);
	export_constant(EF_POK_WHITE);
	export_constant(EF_POK_VALEN);
	export_constant(EF_POK_BIRTH);
	export_constant(EF_POK_CHRISTMAS);
	export_constant(EF_MAP_MAGICZONE3);
	export_constant(EF_MAP_MAGICZONE4);
	export_constant(EF_DUST);
	export_constant(EF_TORCH_RED);
	export_constant(EF_TORCH_GREEN);
	export_constant(EF_MAP_GHOST);
	export_constant(EF_GLOW1);
	export_constant(EF_GLOW2);
	export_constant(EF_GLOW4);
	export_constant(EF_TORCH_PURPLE);
	export_constant(EF_CLOUD7);
	export_constant(EF_CLOUD8);
	export_constant(EF_FLOWERLEAF);
	export_constant(EF_MAPSPHERE2);
	export_constant(EF_GLOW11);
	export_constant(EF_GLOW12);
	export_constant(EF_CIRCLELIGHT);
	export_constant(EF_ITEM315);
	export_constant(EF_ITEM316);
	export_constant(EF_ITEM317);
	export_constant(EF_ITEM318);
	export_constant(EF_STORM_MIN);
	export_constant(EF_POK_JAP);
	export_constant(EF_MAP_GREENLIGHT);
	export_constant(EF_MAP_MAGICWALL);
	export_constant(EF_MAP_GREENLIGHT2);
	export_constant(EF_YELLOWFLY1);
	export_constant(EF_YELLOWFLY2);
	export_constant(EF_BOTTOM_BLUE);
	export_constant(EF_BOTTOM_BLUE2);
	export_constant(EF_WEWISH);
	export_constant(EF_FIREPILLARON2);
	export_constant(EF_FORESTLIGHT5);
	export_constant(EF_SOULBREAKER3);
	export_constant(EF_ADO_STR);
	export_constant(EF_IGN_STR);
	export_constant(EF_CHIMTO2);
	export_constant(EF_WINDCUTTER);
	export_constant(EF_DETECT2);
	export_constant(EF_FROSTMYSTY);
	export_constant(EF_CRIMSON_STR);
	export_constant(EF_HELL_STR);
	export_constant(EF_SPR_MASH);
	export_constant(EF_SPR_SOULE);
	export_constant(EF_DHOWL_STR);
	export_constant(EF_EARTHWALL);
	export_constant(EF_SOULBREAKER4);
	export_constant(EF_CHAINL_STR);
	export_constant(EF_CHOOKGI_FIRE);
	export_constant(EF_CHOOKGI_WIND);
	export_constant(EF_CHOOKGI_WATER);
	export_constant(EF_CHOOKGI_GROUND);
	export_constant(EF_MAGENTA_TRAP);
	export_constant(EF_COBALT_TRAP);
	export_constant(EF_MAIZE_TRAP);
	export_constant(EF_VERDURE_TRAP);
	export_constant(EF_NORMAL_TRAP);
	export_constant(EF_CLOAKING2);
	export_constant(EF_AIMED_STR);
	export_constant(EF_ARROWSTORM_STR);
	export_constant(EF_LAULAMUS_STR);
	export_constant(EF_LAUAGNUS_STR);
	export_constant(EF_MILSHIELD_STR);
	export_constant(EF_CONCENTRATION2);
	export_constant(EF_FIREBALL2);
	export_constant(EF_BUNSINJYUTSU2);
	export_constant(EF_CLEARTIME);
	export_constant(EF_GLASSWALL3);
	export_constant(EF_ORATIO);
	export_constant(EF_POTION_BERSERK2);
	export_constant(EF_CIRCLEPOWER);
	export_constant(EF_ROLLING1);
	export_constant(EF_ROLLING2);
	export_constant(EF_ROLLING3);
	export_constant(EF_ROLLING4);
	export_constant(EF_ROLLING5);
	export_constant(EF_ROLLING6);
	export_constant(EF_ROLLING7);
	export_constant(EF_ROLLING8);
	export_constant(EF_ROLLING9);
	export_constant(EF_ROLLING10);
	export_constant(EF_PURPLEBODY);
	export_constant(EF_STIN6);
	export_constant(EF_RG_COIN4);
	export_constant(EF_POISONWAV);
	export_constant(EF_POISONSMOKE);
	export_constant(EF_GUMGANG4);
	export_constant(EF_SHIELDBOOMERANG4);
	export_constant(EF_CASTSPIN2);
	export_constant(EF_VULCANWAV);
	export_constant(EF_AGIUP2);
	export_constant(EF_DETECT3);
	export_constant(EF_AGIUP3);
	export_constant(EF_DETECT4);
	export_constant(EF_ELECTRIC3);
	export_constant(EF_GUARD4);
	export_constant(EF_BOTTOM_BARRIER);
	export_constant(EF_BOTTOM_STEALTH);
	export_constant(EF_REPAIRTIME);
	export_constant(EF_NC_ANAL);
	export_constant(EF_FIRETHROW);
	export_constant(EF_VENOMIMPRESS);
	export_constant(EF_FROSTMISTY);
	export_constant(EF_BURNING);
	export_constant(EF_COLDTHROW);
	export_constant(EF_MAKEHALLU);
	export_constant(EF_HALLUTIME);
	export_constant(EF_INFRAREDSCAN);
	export_constant(EF_CRASHAXE);
	export_constant(EF_GTHUNDER);
	export_constant(EF_STONERING);
	export_constant(EF_INTIMIDATE2);
	export_constant(EF_STASIS);
	export_constant(EF_REDLINE);
	export_constant(EF_FROSTDIVER3);
	export_constant(EF_BOTTOM_BASILICA2);
	export_constant(EF_RECOGNIZED);
	export_constant(EF_TETRA);
	export_constant(EF_TETRACASTING);
	export_constant(EF_FIREBALL3);
	export_constant(EF_INTIMIDATE3);
	export_constant(EF_RECOGNIZED2);
	export_constant(EF_CLOAKING3);
	export_constant(EF_INTIMIDATE4);
	export_constant(EF_STRETCH);
	export_constant(EF_BLACKBODY);
	export_constant(EF_ENERVATION);
	export_constant(EF_ENERVATION2);
	export_constant(EF_ENERVATION3);
	export_constant(EF_ENERVATION4);
	export_constant(EF_ENERVATION5);
	export_constant(EF_ENERVATION6);
	export_constant(EF_LINELINK4);
	export_constant(EF_RG_COIN5);
	export_constant(EF_WATERFALL_ANI);
	export_constant(EF_BOTTOM_MANHOLE);
	export_constant(EF_MANHOLE);
	export_constant(EF_MAKEFEINT);
	export_constant(EF_FORESTLIGHT6);
	export_constant(EF_DARKCASTING2);
	export_constant(EF_BOTTOM_ANI);
	export_constant(EF_BOTTOM_MAELSTROM);
	export_constant(EF_BOTTOM_BLOODYLUST);
	export_constant(EF_BEGINSPELL_N1);
	export_constant(EF_BEGINSPELL_N2);
	export_constant(EF_HEAL_N);
	export_constant(EF_CHOOKGI_N);
	export_constant(EF_JOBLVUP50_2);
	export_constant(EF_CHEMICAL2DASH2);
	export_constant(EF_CHEMICAL2DASH3);
	export_constant(EF_ROLLINGCAST);
	export_constant(EF_WATER_BELOW);
	export_constant(EF_WATER_FADE);
	export_constant(EF_BEGINSPELL_N3);
	export_constant(EF_BEGINSPELL_N4);
	export_constant(EF_BEGINSPELL_N5);
	export_constant(EF_BEGINSPELL_N6);
	export_constant(EF_BEGINSPELL_N7);
	export_constant(EF_BEGINSPELL_N8);
	export_constant(EF_WATER_SMOKE);
	export_constant(EF_DANCE1);
	export_constant(EF_DANCE2);
	export_constant(EF_LINKPARTICLE);
	export_constant(EF_SOULLIGHT2);
	export_constant(EF_SPR_PARTICLE);
	export_constant(EF_SPR_PARTICLE2);
	export_constant(EF_SPR_PLANT);
	export_constant(EF_CHEMICAL_V);
	export_constant(EF_SHOOTPARTICLE);
	export_constant(EF_BOT_REVERB);
	export_constant(EF_RAIN_PARTICLE);
	export_constant(EF_CHEMICAL_V2);
	export_constant(EF_SECRA);
	export_constant(EF_BOT_REVERB2);
	export_constant(EF_CIRCLEPOWER2);
	export_constant(EF_SECRA2);
	export_constant(EF_CHEMICAL_V3);
	export_constant(EF_ENERVATION7);
	export_constant(EF_CIRCLEPOWER3);
	export_constant(EF_SPR_PLANT2);
	export_constant(EF_CIRCLEPOWER4);
	export_constant(EF_SPR_PLANT3);
	export_constant(EF_RG_COIN6);
	export_constant(EF_SPR_PLANT4);
	export_constant(EF_CIRCLEPOWER5);
	export_constant(EF_SPR_PLANT5);
	export_constant(EF_CIRCLEPOWER6);
	export_constant(EF_SPR_PLANT6);
	export_constant(EF_CIRCLEPOWER7);
	export_constant(EF_SPR_PLANT7);
	export_constant(EF_CIRCLEPOWER8);
	export_constant(EF_SPR_PLANT8);
	export_constant(EF_HEARTASURA);
	export_constant(EF_BEGINSPELL_150);
	export_constant(EF_LEVEL99_150);
	export_constant(EF_PRIMECHARGE);
	export_constant(EF_GLASSWALL4);
	export_constant(EF_GRADIUS_LASER);
	export_constant(EF_BASH3D6);
	export_constant(EF_GUMGANG5);
	export_constant(EF_HITLINE8);
	export_constant(EF_ELECTRIC4);
	export_constant(EF_TEIHIT1T);
	export_constant(EF_SPINMOVE);
	export_constant(EF_FIREBALL4);
	export_constant(EF_TRIPLEATTACK4);
	export_constant(EF_CHEMICAL3S);
	export_constant(EF_GROUNDSHAKE);
	export_constant(EF_DQ9_CHARGE);
	export_constant(EF_DQ9_CHARGE2);
	export_constant(EF_DQ9_CHARGE3);
	export_constant(EF_DQ9_CHARGE4);
	export_constant(EF_BLUELINE);
	export_constant(EF_SELFSCROLL);
	export_constant(EF_SPR_LIGHTPRINT);
	export_constant(EF_PNG_TEST);
	export_constant(EF_BEGINSPELL_YB);
	export_constant(EF_CHEMICAL2DASH4);
	export_constant(EF_GROUNDSHAKE2);
	export_constant(EF_PRESSURE2);
	export_constant(EF_RG_COIN7);
	export_constant(EF_PRIMECHARGE2);
	export_constant(EF_PRIMECHARGE3);
	export_constant(EF_PRIMECHARGE4);
	export_constant(EF_GREENCASTING);
	export_constant(EF_WALLOFTHORN);
	export_constant(EF_FIREBALL5);
	export_constant(EF_THROWITEM11);
	export_constant(EF_SPR_PLANT9);
	export_constant(EF_DEMONICFIRE);
	export_constant(EF_DEMONICFIRE2);
	export_constant(EF_DEMONICFIRE3);
	export_constant(EF_HELLSPLANT);
	export_constant(EF_FIREWALL2);
	export_constant(EF_VACUUM);
	export_constant(EF_SPR_PLANT10);
	export_constant(EF_SPR_LIGHTPRINT2);
	export_constant(EF_POISONSMOKE2);
	export_constant(EF_MAKEHALLU2);
	export_constant(EF_SHOCKWAVE2);
	export_constant(EF_SPR_PLANT11);
	export_constant(EF_COLDTHROW2);
	export_constant(EF_DEMONICFIRE4);
	export_constant(EF_PRESSURE3);
	export_constant(EF_LINKPARTICLE2);
	export_constant(EF_SOULLIGHT3);
	export_constant(EF_CHAREFFECT);
	export_constant(EF_GUMGANG6);
	export_constant(EF_FIREBALL6);
	export_constant(EF_GUMGANG7);
	export_constant(EF_GUMGANG8);
	export_constant(EF_GUMGANG9);
	export_constant(EF_BOTTOM_DE2);
	export_constant(EF_COLDSTATUS);
	export_constant(EF_SPR_LIGHTPRINT3);
	export_constant(EF_WATERBALL3);
	export_constant(EF_HEAL_N2);
	export_constant(EF_RAIN_PARTICLE2);
	export_constant(EF_CLOUD9);
	export_constant(EF_YELLOWFLY3);
	export_constant(EF_EL_GUST);
	export_constant(EF_EL_BLAST);
	export_constant(EF_EL_AQUAPLAY);
	export_constant(EF_EL_UPHEAVAL);
	export_constant(EF_EL_WILD_STORM);
	export_constant(EF_EL_CHILLY_AIR);
	export_constant(EF_EL_CURSED_SOIL);
	export_constant(EF_EL_COOLER);
	export_constant(EF_EL_TROPIC);
	export_constant(EF_EL_PYROTECHNIC);
	export_constant(EF_EL_PETROLOGY);
	export_constant(EF_EL_HEATER);
	export_constant(EF_POISON_MIST);
	export_constant(EF_ERASER_CUTTER);
	export_constant(EF_SILENT_BREEZE);
	export_constant(EF_MAGMA_FLOW);
	export_constant(EF_GRAYBODY);
	export_constant(EF_LAVA_SLIDE);
	export_constant(EF_SONIC_CLAW);
	export_constant(EF_TINDER_BREAKER);
	export_constant(EF_MIDNIGHT_FRENZY);
	export_constant(EF_MACRO);
	export_constant(EF_CHEMICAL_ALLRANGE);
	export_constant(EF_TETRA_FIRE);
	export_constant(EF_TETRA_WATER);
	export_constant(EF_TETRA_WIND);
	export_constant(EF_TETRA_GROUND);
	export_constant(EF_EMITTER);
	export_constant(EF_VOLCANIC_ASH);
	export_constant(EF_LEVEL99_ORB1);
	export_constant(EF_LEVEL99_ORB2);
	export_constant(EF_LEVEL150);
	export_constant(EF_LEVEL150_SUB);
	export_constant(EF_THROWITEM4_1);
	export_constant(EF_THROW_HAPPOKUNAI);
	export_constant(EF_THROW_MULTIPLE_COIN);
	export_constant(EF_THROW_BAKURETSU);
	export_constant(EF_ROTATE_HUUMARANKA);
	export_constant(EF_ROTATE_BG);
	export_constant(EF_ROTATE_LINE_GRAY);
	export_constant(EF_2011RWC);
	export_constant(EF_2011RWC2);
	export_constant(EF_KAIHOU);
	export_constant(EF_GROUND_EXPLOSION);
	export_constant(EF_KG_KAGEHUMI);
	export_constant(EF_KO_ZENKAI_WATER);
	export_constant(EF_KO_ZENKAI_LAND);
	export_constant(EF_KO_ZENKAI_FIRE);
	export_constant(EF_KO_ZENKAI_WIND);
	export_constant(EF_KO_JYUMONJIKIRI);
	export_constant(EF_KO_SETSUDAN);
	export_constant(EF_RED_CROSS);
	export_constant(EF_KO_IZAYOI);
	export_constant(EF_ROTATE_LINE_BLUE);
	export_constant(EF_KG_KYOMU);
	export_constant(EF_KO_HUUMARANKA);
	export_constant(EF_BLUELIGHTBODY);
	export_constant(EF_KAGEMUSYA);
	export_constant(EF_OB_GENSOU);
	export_constant(EF_NO100_FIRECRACKER);
	export_constant(EF_KO_MAKIBISHI);
	export_constant(EF_KAIHOU1);
	export_constant(EF_AKAITSUKI);
	export_constant(EF_ZANGETSU);
	export_constant(EF_GENSOU);
	export_constant(EF_HAT_EFFECT);
	export_constant(EF_CHERRYBLOSSOM);
	export_constant(EF_EVENT_CLOUD);
	export_constant(EF_RUN_MAKE_OK);
	export_constant(EF_RUN_MAKE_FAILURE);
	export_constant(EF_MIRESULT_MAKE_OK);
	export_constant(EF_MIRESULT_MAKE_FAIL);
	export_constant(EF_ALL_RAY_OF_PROTECTION);
	export_constant(EF_VENOMFOG);
	export_constant(EF_DUSTSTORM);
	export_constant(EF_LEVEL160);
	export_constant(EF_LEVEL160_SUB);
	export_constant(EF_MAPCHAIN);
	export_constant(EF_MAGIC_FLOOR);
	export_constant(EF_ICEMINE);
	export_constant(EF_FLAMECORSS);
	export_constant(EF_ICEMINE_1);
	export_constant(EF_DANCE_BLADE_ATK);
	export_constant(EF_DARKPIERCING);
	export_constant(EF_INVINCIBLEOFF2);
	export_constant(EF_MAXPAIN);
	export_constant(EF_DEATHSUMMON);
	export_constant(EF_MOONSTAR);
	export_constant(EF_STRANGELIGHTS);
	export_constant(EF_SUPER_STAR);
	export_constant(EF_YELLOBODY);
	export_constant(EF_COLORPAPER2);
	export_constant(EF_EVILS_PAW);
	export_constant(EF_GC_DARKCROW);
	export_constant(EF_RK_DRAGONBREATH_WATER);
	export_constant(EF_ALL_FULL_THROTTLE);
	export_constant(EF_SR_FLASHCOMBO);
	export_constant(EF_RK_LUXANIMA);
	export_constant(EF_CLOUD10);
	export_constant(EF_SO_ELEMENTAL_SHIELD);
	export_constant(EF_AB_OFFERTORIUM);
	export_constant(EF_WL_TELEKINESIS_INTENSE);
	export_constant(EF_GN_ILLUSIONDOPING);
	export_constant(EF_NC_MAGMA_ERUPTION);
	export_constant(EF_LG_KINGS_GRACE);
	export_constant(EF_BLOODDRAIN2);
	export_constant(EF_NPC_WIDEWEB);
	export_constant(EF_NPC_BURNT);
	export_constant(EF_NPC_CHILL);
	export_constant(EF_RA_UNLIMIT);
	export_constant(EF_AB_OFFERTORIUM_RING);
	export_constant(EF_SC_ESCAPE);
	export_constant(EF_WM_FRIGG_SONG);
	export_constant(EF_FLICKER);
	export_constant(EF_C_MAKER);
	export_constant(EF_HAMMER_OF_GOD);
	export_constant(EF_MASS_SPIRAL);
	export_constant(EF_FIRE_RAIN);
	export_constant(EF_WHITEBODY);
	export_constant(EF_BANISHING_BUSTER);
	export_constant(EF_SLUGSHOT);
	export_constant(EF_D_TAIL);
	export_constant(EF_BIND_TRAP1);
	export_constant(EF_BIND_TRAP2);
	export_constant(EF_BIND_TRAP3);
	export_constant(EF_JUMPBODY1);
	export_constant(EF_ANIMATED_EMITTER);
	export_constant(EF_RL_EXPLOSION);
	export_constant(EF_C_MAKER_1);
	export_constant(EF_QD_SHOT);
	export_constant(EF_P_ALTER);
	export_constant(EF_S_STORM);
	export_constant(EF_MUSIC_HAT);
	export_constant(EF_CLOUD_KILL);
	export_constant(EF_ESCAPE);
	export_constant(EF_XENO_SLASHER);
	export_constant(EF_FLOWERSMOKE);
	export_constant(EF_FSTONE);
	export_constant(EF_QSCARABA);
	export_constant(EF_LJOSALFAR);
	export_constant(EF_HAPPINESSSTAR);
	export_constant(EF_POWER_OF_GAIA);
	export_constant(EF_MAPLE_FALLS);
	export_constant(EF_MARKING_USE_CHANGEMONSTER);
	export_constant(EF_MAGICAL_FEATHER);
	export_constant(EF_MERMAID_LONGING);
	export_constant(EF_GIFT_OF_SNOW);
	export_constant(EF_ACH_COMPLETE);
	export_constant(EF_TIME_ACCESSORY);
	export_constant(EF_SPRITEMABLE);
	export_constant(EF_TUNAPARTY);
	export_constant(EF_FRESHSHRIMP);
	export_constant(EF_SU_GROOMING);
	export_constant(EF_SU_CHATTERING);
	export_constant(EF_FIREDANCE);
	export_constant(EF_RICHS_COIN_A);
	export_constant(EF_E_CHAIN);
	export_constant(EF_HEAT_BARREL);
	export_constant(EF_H_MINE);
	export_constant(EF_FALLEN_ANGEL);
	export_constant(EF_IMMUNE_PROPERTY);
	export_constant(EF_MOVE_COORDINATE);
	export_constant(EF_LIGHTSPHERE_SUN);
	export_constant(EF_LIGHTSPHERE_MOON);
	export_constant(EF_LIGHTSPHERE_STAR);
	export_constant(EF_NOVAEXPLOSING);
	export_constant(EF_STAR_EMPEROR);
	export_constant(EF_SMA_BLACK);
	export_constant(EF_ENERGYDRAIN_BLACK);
	export_constant(EF_BLINK_BODY);
	export_constant(EF_SOLARBURST);
	export_constant(EF_SJ_DOCUMENT);
	export_constant(EF_FALLING_STAR);
	export_constant(EF_STORMKICK8);
	export_constant(EF_NEWMOON_KICK);
	export_constant(EF_FULLMOON_KICK);
	export_constant(EF_BOOK_OF_DIMENSION);
	export_constant(EF_CURSE_EXPLOSION);
	export_constant(EF_SOUL_REAPER);
	export_constant(EF_SOUL_EXPLOSION);

	/* hat effects */
	export_constant(HAT_EF_BLOSSOM_FLUTTERING);
	export_constant(HAT_EF_MERMAID_LONGING);
	export_constant(HAT_EF_RL_BANISHING_BUSTER);
	export_constant(HAT_EF_LJOSALFAR);
	export_constant(HAT_EF_CLOCKING);
	export_constant(HAT_EF_SNOW);
	export_constant(HAT_EF_MAKEBLUR);
	export_constant(HAT_EF_SLEEPATTACK);
	export_constant(HAT_EF_GUMGANG);
	export_constant(HAT_EF_TALK_FROSTJOKE);
	export_constant(HAT_EF_DEMONSTRATION);
	export_constant(HAT_EF_FLUTTER_BUTTERFLY);
	export_constant(HAT_EF_ANGEL_FLUTTERING);
	export_constant(HAT_EF_BLESSING_OF_ANGELS);
	export_constant(HAT_EF_ELECTRIC);
	export_constant(HAT_EF_GREEN_FLOOR);
	export_constant(HAT_EF_SHRINK);
	export_constant(HAT_EF_VALHALLA_IDOL);
	export_constant(HAT_EF_ANGEL_STAIRS);
	export_constant(HAT_EF_GLOW_OF_NEW_YEAR);
	export_constant(HAT_EF_BOTTOM_FORTUNEKISS);
	export_constant(HAT_EF_PINKBODY);
	export_constant(HAT_EF_DOUBLEGUMGANG);
	export_constant(HAT_EF_GIANTBODY);
	export_constant(HAT_EF_GREEN99_6);
	export_constant(HAT_EF_CIRCLEPOWER);
	export_constant(HAT_EF_BOTTOM_BLOODYLUST);
	export_constant(HAT_EF_WATER_BELOW);
	export_constant(HAT_EF_LEVEL99_150);
	export_constant(HAT_EF_YELLOWFLY3);
	export_constant(HAT_EF_KAGEMUSYA);
	export_constant(HAT_EF_CHERRYBLOSSOM);
	export_constant(HAT_EF_STRANGELIGHTS);
	export_constant(HAT_EF_WL_TELEKINESIS_INTENSE);
	export_constant(HAT_EF_AB_OFFERTORIUM_RING);
	export_constant(HAT_EF_WHITEBODY2);
	export_constant(HAT_EF_SAKURA);
	export_constant(HAT_EF_CLOUD2);
	export_constant(HAT_EF_FEATHER_FLUTTERING);
	export_constant(HAT_EF_CAMELLIA_HAIR_PIN);
	export_constant(HAT_EF_JP_EV_EFFECT01);
	export_constant(HAT_EF_JP_EV_EFFECT02);
	export_constant(HAT_EF_JP_EV_EFFECT03);
	export_constant(HAT_EF_FLORAL_WALTZ);
	export_constant(HAT_EF_MAGICAL_FEATHER);
	export_constant(HAT_EF_HAT_EFFECT);
	export_constant(HAT_EF_BAKURETSU_HADOU);
	export_constant(HAT_EF_GOLD_SHOWER);
	export_constant(HAT_EF_WHITEBODY);
	export_constant(HAT_EF_WATER_BELOW2);
	export_constant(HAT_EF_FIREWORK);
	export_constant(HAT_EF_RETURN_TW_1ST_HAT);
	export_constant(HAT_EF_C_FLUTTERBUTTERFLY_BL);
	export_constant(HAT_EF_QSCARABA);
	export_constant(HAT_EF_FSTONE);
	export_constant(HAT_EF_MAGICCIRCLE);
	export_deprecated_constant2("HAT_EF_GODCLASS",HAT_EF_BRYSINGGAMEN);	// Feb 3, 2023
	export_deprecated_constant2("HAT_EF_GODCLASS2",HAT_EF_MAGINGIORDE);
	export_constant(HAT_EF_BRYSINGGAMEN);
	export_constant(HAT_EF_MAGINGIORDE);
	export_constant(HAT_EF_LEVEL99_RED);
	export_constant(HAT_EF_LEVEL99_ULTRAMARINE);
	export_constant(HAT_EF_LEVEL99_CYAN);
	export_constant(HAT_EF_LEVEL99_LIME);
	export_constant(HAT_EF_LEVEL99_VIOLET);
	export_constant(HAT_EF_LEVEL99_LILAC);
	export_constant(HAT_EF_LEVEL99_SUN_ORANGE);
	export_constant(HAT_EF_LEVEL99_DEEP_PINK);
	export_constant(HAT_EF_LEVEL99_BLACK);
	export_constant(HAT_EF_LEVEL99_WHITE);
	export_constant(HAT_EF_LEVEL160_RED);
	export_constant(HAT_EF_LEVEL160_ULTRAMARINE);
	export_constant(HAT_EF_LEVEL160_CYAN);
	export_constant(HAT_EF_LEVEL160_LIME);
	export_constant(HAT_EF_LEVEL160_VIOLET);
	export_constant(HAT_EF_LEVEL160_LILAC);
	export_constant(HAT_EF_LEVEL160_SUN_ORANGE);
	export_constant(HAT_EF_LEVEL160_DEEP_PINK);
	export_constant(HAT_EF_LEVEL160_BLACK);
	export_constant(HAT_EF_LEVEL160_WHITE);
	export_constant(HAT_EF_FULL_BLOOMCHERRY_TREE);
	export_constant(HAT_EF_C_BLESSINGS_OF_SOUL);
	export_constant(HAT_EF_MANYSTARS);
	export_constant(HAT_EF_SUBJECT_AURA_GOLD);
	export_constant(HAT_EF_SUBJECT_AURA_WHITE);
	export_constant(HAT_EF_SUBJECT_AURA_RED);
	export_constant(HAT_EF_C_SHINING_ANGEL_WING);
	export_constant(HAT_EF_MAGIC_STAR_TW);
	export_constant(HAT_EF_DIGITAL_SPACE);
	export_constant(HAT_EF_SLEIPNIR);
	export_constant(HAT_EF_C_MAPLE_WHICH_FALLS_RD);
	export_constant(HAT_EF_MAGICCIRCLERAINBOW);
	export_constant(HAT_EF_SNOWFLAKE_TIARA);
	export_constant(HAT_EF_MIDGARTS_GLORY);
	export_constant(HAT_EF_LEVEL99_TIGER);
	export_constant(HAT_EF_LEVEL160_TIGER);
	export_constant(HAT_EF_FLUFFYWING);
	export_constant(HAT_EF_C_GHOST_EFFECT);
	export_constant(HAT_EF_C_POPPING_PORING_AURA);
	export_constant(HAT_EF_RESONATETAEGO);
	export_constant(HAT_EF_99LV_RUNE_RED);
	export_constant(HAT_EF_99LV_ROYAL_GUARD_BLUE);
	export_constant(HAT_EF_99LV_WARLOCK_VIOLET);
	export_constant(HAT_EF_99LV_SORCERER_LBLUE);
	export_constant(HAT_EF_99LV_RANGER_GREEN);
	export_constant(HAT_EF_99LV_MINSTREL_PINK);
	export_constant(HAT_EF_99LV_ARCHBISHOP_WHITE);
	export_constant(HAT_EF_99LV_GUILL_SILVER);
	export_constant(HAT_EF_99LV_SHADOWC_BLACK);
	export_constant(HAT_EF_99LV_MECHANIC_GOLD);
	export_constant(HAT_EF_99LV_GENETIC_YGREEN);
	export_constant(HAT_EF_160LV_RUNE_RED);
	export_constant(HAT_EF_160LV_ROYAL_G_BLUE);
	export_constant(HAT_EF_160LV_WARLOCK_VIOLET);
	export_constant(HAT_EF_160LV_SORCERER_LBLUE);
	export_constant(HAT_EF_160LV_RANGER_GREEN);
	export_constant(HAT_EF_160LV_MINSTREL_PINK);
	export_constant(HAT_EF_160LV_ARCHB_WHITE);
	export_constant(HAT_EF_160LV_GUILL_SILVER);
	export_constant(HAT_EF_160LV_SHADOWC_BLACK);
	export_constant(HAT_EF_160LV_MECHANIC_GOLD);
	export_constant(HAT_EF_160LV_GENETIC_YGREEN);
	export_constant(HAT_EF_WATER_BELOW3);
	export_constant(HAT_EF_WATER_BELOW4);
	export_constant(HAT_EF_C_VALKYRIE_WING);
	export_constant(HAT_EF_2019RTC_CELEAURA_TW);
	export_constant(HAT_EF_2019RTC1ST_TW);
	export_constant(HAT_EF_2019RTC2ST_TW);
	export_constant(HAT_EF_2019RTC3ST_TW);
	export_constant(HAT_EF_CONS_OF_WIND);
	export_constant(HAT_EF_MAPLE_FALLS);
	export_constant(HAT_EF_BJ_HEADSETB);
	export_constant(HAT_EF_VIP_HAIR);
	export_constant(HAT_EF_C_MAGIC_HEIR_TW);
	export_constant(HAT_EF_C_SUDDEN_WEALTH_TW);
	export_constant(HAT_EF_C_ROMANCE_ROSE_TW);
	export_constant(HAT_EF_C_DISAPEAR_TIME_TW);
	export_constant(HAT_EF_2020RTC_01);
	export_constant(HAT_EF_2020RTC_02);
	export_constant(HAT_EF_2020RTC_03);
	export_constant(HAT_EF_C_2020RTC_IMP_TW);
	export_constant(HAT_EF_SUBJECT_AURA_BLACK);
	export_constant(HAT_EF_2020RTC_EFFECT_01);
	export_constant(HAT_EF_2020RTC_EFFECT_02);
	export_constant(HAT_EF_2020RTC_EFFECT_03);
	export_constant(HAT_EF_99LV_STAR_E_MBLUE);
	export_constant(HAT_EF_160LV_STAR_E_MBLUE);
	export_constant(HAT_EF_99LV_SOUL_R_GRAY);
	export_constant(HAT_EF_160LV_SOUL_R_GRAY);
	export_constant(HAT_EF_GEARWHEEL);
	export_constant(HAT_EF_GIFT_OF_SNOW);
	export_constant(HAT_EF_SNOW_POWDER);
	export_constant(HAT_EF_FALLING_SNOW);
	export_constant(HAT_EF_C_PHIGASIA_SCARF_EXE);
	export_constant(HAT_EF_C_KYEL_HYRE_ULTI_TW);
	export_constant(HAT_EF_C_MASTER);
	export_constant(HAT_EF_C_TIME_ACCESSORY);
	export_constant(HAT_EF_C_HELM_OF_RA);
	export_constant(HAT_EF_C_2021RTC_HEADSET_TW);
	export_constant(HAT_EF_C_MOONSTAR_ACCESSORY);
	export_constant(HAT_EF_BLACK_THUNDER);
	export_constant(HAT_EF_BLACK_THUNDER_DARK);
	export_constant(HAT_EF_C_RELEASED_GROUND);
	export_constant(HAT_EF_C_SAMBA_CARNIVAL);
	export_constant(HAT_EF_POISON_MASTER);
	export_constant(HAT_EF_C_SWIRLING_FLAME);
	export_constant(HAT_EF_C_2021RTC_HEADSET_1_TW);
	export_constant(HAT_EF_C_2021RTC_HEADSET_2_TW);
	export_constant(HAT_EF_C_2021RTC_HEADSET_3_TW);
	export_constant(HAT_EF_SUBJECT_AURA_WHITE_ALPHA);
	export_constant(HAT_EF_GC_DARKCROW);
	export_constant(HAT_EF_DIABOLUS_RING);
	export_constant(HAT_EF_MAGICCIRCLE_BLUE_TW);
	export_constant(HAT_EF_C_DISAPEAR_TIME_TW_2);
	export_constant(HAT_EF_C_MELODY_WING);
	export_constant(HAT_EF_C_SPOT_LIGHT);
	export_constant(HAT_EF_C_ASTRA_BLESSING);
	export_constant(HAT_EF_EFST_C_20TH_ANNIVERSARY_HAT);
	export_constant(HAT_EF_SUBJECT_AURA_NAVY);
	export_constant(HAT_EF_20TH_SCARF_J);
	export_constant(HAT_EF_GHOST_FIRE);
	export_constant(HAT_EF_SERPENT_SHADOW);
	export_constant(HAT_EF_C_1ST_EVT_HAT_MSP);
	export_constant(HAT_EF_C_1ST_EVT_BALLOON_MSP);
	export_constant(HAT_EF_RABBIT_AURA);
	export_constant(HAT_EF_ALICE_TEA);
	export_constant(HAT_EF_C_DARK_LORD_CLOAK);
	export_constant(HAT_EF_C_SAKURA_FUBUKI);
	export_constant(HAT_EF_C_DARK_LORD_MANTEAU);
	export_constant(HAT_EF_DECORATION_OF_MUSIC);
	export_constant(HAT_EF_2023RTC_S_ROBE1);
	export_constant(HAT_EF_2023RTC_S_ROBE2);
	export_constant(HAT_EF_2023RTC_S_ROBE3);
	export_constant(HAT_EF_C_CONSECRATE_F_AUREOLA);
	export_constant(HAT_EF_C_BULB_WREATH);
	export_constant(HAT_EF_MD_HOL_BARRIER1);
	export_constant(HAT_EF_MD_HOL_BARRIER2);
	export_constant(HAT_EF_MD_HOL_BARRIER3);
	export_constant(HAT_EF_MD_HOL_BARRIER4);
	export_constant(HAT_EF_MD_HOL_BARRIER5);
	export_constant(HAT_EF_MD_HOL_BARRIER6);
	export_constant(HAT_EF_MD_HOL_BARRIER7);
	export_constant(HAT_EF_MD_HOL_BARRIER8);
	export_constant(HAT_EF_MD_HOL_BARRIER9);
	export_constant(HAT_EF_MD_HOL_BARRIER10);
	export_constant(HAT_EF_MD_HOL_BARRIER11);
	export_constant(HAT_EF_MD_HOL_BARRIER12);
	export_constant(HAT_EF_MD_HOL_BARRIER13);
	export_constant(HAT_EF_MD_HOL_BARRIER14);
	export_constant(HAT_EF_MD_HOL_BARRIER15);
	export_constant(HAT_EF_MD_HOL_BARRIER16);
	export_constant(HAT_EF_MD_HOL_BARRIER17);
	export_constant(HAT_EF_MD_HOL_BARRIER18);
	export_constant(HAT_EF_MD_HOL_BARRIER19);
	export_constant(HAT_EF_MD_HOL_BARRIER20);
	export_constant(HAT_EF_C_FLUTTERING_HAZE);
	export_constant(HAT_EF_EFST_CINNAMON);
	export_constant(HAT_EF_AUTUMN_FULL_MOON);
	export_constant(HAT_EF_NIFLHEIM_NIGHT_SKY);
	export_constant(HAT_EF_C_ROS2023_CAPE_1);
	export_constant(HAT_EF_BLACK_THUNDER_);
	export_constant(HAT_EF_C_ROS2023_CAPE_2);
	export_constant(HAT_EF_C_15TH_NOV_HELMET);
	export_constant(HAT_EF_COSMIC_CONNECTION);
	export_constant(HAT_EF_C_BABY_GLOOM);
	export_constant(HAT_EF_WINTERNIGHTBELLS);
	export_constant(HAT_EF_NIGHTSKYOFRUTIE);
	export_constant(FOOTPRINT_EF_BASE);
	export_constant(FOOTPRINT_EF_STR_BASE);
	export_constant(FOOTPRINT_EF_PURPLESTAR);
	export_constant(FOOTPRINT_EF_YELLOWSTAR);
	export_constant(FOOTPRINT_EF_REDSTAR);
	export_constant(HAT_EF_RAINBOW_POISON_MASTER);
	export_constant(HAT_EF_C_ANCIENT_RUNE);
	export_constant(HAT_EF_C_DRAGON_GREEN_AURA);
	export_constant(HAT_EF_C_DRAGON_RED_AURA);
	export_constant(HAT_EF_C_DRAGON_YELLOW_AURA);
	export_constant(HAT_EF_INTERDIMENSIONAL_RIFT);
	export_constant(HAT_EF_C_CLB_SS_LL);
	export_constant(HAT_EF_VACATION);
	export_constant(HAT_EF_C_FH_LOSTWING);
	export_constant(FOOTPRINT_EF_DOGFOOT);
	export_constant(HAT_EF_C_AUSPICLOUD);
	export_constant(HAT_EF_AURA_OF_GHOST_S);

	/* pet catch */
	export_constant(PET_CATCH_UNIVERSAL);
	export_constant(PET_CATCH_UNIVERSAL_ITEM);

	/* pet intimacy levels */
	export_constant(PET_INTIMATE_NONE);
	export_constant(PET_INTIMATE_AWKWARD);
	export_constant(PET_INTIMATE_SHY);
	export_constant(PET_INTIMATE_NEUTRAL);
	export_constant(PET_INTIMATE_CORDIAL);
	export_constant(PET_INTIMATE_LOYAL);
	export_constant(PET_INTIMATE_MAX);

	/* pet hunger levels */
	export_constant(PET_HUNGRY_NONE);
	export_constant(PET_HUNGRY_VERY_HUNGRY);
	export_constant(PET_HUNGRY_HUNGRY);
	export_constant(PET_HUNGRY_NEUTRAL);
	export_constant(PET_HUNGRY_SATISFIED);
	export_constant(PET_HUNGRY_STUFFED);

	/* monster modes */
	export_constant(MD_NONE);
	export_constant(MD_CANMOVE);
	export_constant(MD_LOOTER);
	export_constant(MD_AGGRESSIVE);
	export_constant(MD_ASSIST);
	export_constant(MD_CASTSENSORIDLE);
	export_constant(MD_NORANDOMWALK);
	export_constant(MD_NOCAST);
	export_constant(MD_CANATTACK);
	export_constant(MD_CASTSENSORCHASE);
	export_constant(MD_CHANGECHASE);
	export_constant(MD_ANGRY);
	export_constant(MD_CHANGETARGETMELEE);
	export_constant(MD_CHANGETARGETCHASE);
	export_constant(MD_TARGETWEAK);
	export_constant(MD_RANDOMTARGET);
	export_constant(MD_IGNOREMELEE);
	export_constant(MD_IGNOREMAGIC);
	export_constant(MD_IGNORERANGED);
	export_constant(MD_MVP);
	export_constant(MD_IGNOREMISC);
	export_constant(MD_KNOCKBACKIMMUNE);
	export_constant(MD_TELEPORTBLOCK);
	export_constant(MD_FIXEDITEMDROP);
	export_constant(MD_DETECTOR);
	export_constant(MD_STATUSIMMUNE);
	export_constant(MD_SKILLIMMUNE);

	/* guild storage flags */
	export_constant(GSTORAGE_OPEN);
	export_constant(GSTORAGE_STORAGE_ALREADY_OPEN);
	export_constant(GSTORAGE_ALREADY_OPEN);
	export_constant(GSTORAGE_NO_GUILD);
	export_constant(GSTORAGE_NO_STORAGE);
	export_constant(GSTORAGE_NO_PERMISSION);

	/* block list types */
	export_constant(BL_PC);
	export_constant(BL_MOB);
	export_constant(BL_PET);
	export_constant(BL_HOM);
	export_constant(BL_MER);
	export_constant(BL_NPC);
	export_constant(BL_ELEM);

	/* skill damage mapflag types */
	export_constant(SKILLDMG_PC);
	export_constant(SKILLDMG_MOB);
	export_constant(SKILLDMG_BOSS);
	export_constant(SKILLDMG_OTHER);
	export_constant(SKILLDMG_MAX);
	export_constant(SKILLDMG_CASTER);

	/* player permissions */
	export_constant(PC_PERM_TRADE);
	export_constant(PC_PERM_PARTY);
	export_constant(PC_PERM_ALL_SKILL);
	export_constant(PC_PERM_USE_ALL_EQUIPMENT);
	export_constant(PC_PERM_SKILL_UNCONDITIONAL);
	export_constant(PC_PERM_JOIN_ALL_CHAT);
	export_constant(PC_PERM_NO_CHAT_KICK);
	export_constant(PC_PERM_HIDE_SESSION);
	export_constant(PC_PERM_WHO_DISPLAY_AID);
	export_constant(PC_PERM_RECEIVE_HACK_INFO);
	export_constant(PC_PERM_WARP_ANYWHERE);
	export_constant(PC_PERM_VIEW_HPMETER);
	export_constant(PC_PERM_VIEW_EQUIPMENT);
	export_constant(PC_PERM_USE_CHECK);
	export_constant(PC_PERM_USE_CHANGEMAPTYPE);
	export_constant(PC_PERM_USE_ALL_COMMANDS);
	export_constant(PC_PERM_RECEIVE_REQUESTS);
	export_constant(PC_PERM_SHOW_BOSS);
	export_constant(PC_PERM_DISABLE_PVM);
	export_constant(PC_PERM_DISABLE_PVP);
	export_constant(PC_PERM_DISABLE_CMD_DEAD);
	export_constant(PC_PERM_CHANNEL_ADMIN);
	export_constant(PC_PERM_TRADE_BOUNDED);
	export_constant(PC_PERM_ITEM_UNCONDITIONAL);
	export_constant(PC_PERM_ENABLE_COMMAND);
	export_constant(PC_PERM_BYPASS_STAT_ONCLONE);
	export_constant(PC_PERM_BYPASS_MAX_STAT);
	export_constant(PC_PERM_ATTENDANCE);
	export_constant(PC_PERM_MACRO_DETECT);
	export_constant(PC_PERM_MACRO_REGISTER);
	export_constant(PC_PERM_TRADE_UNCONDITIONAL);
	export_constant(PC_PERM_MAX);

	/* guild permissions */
	export_constant(GUILD_PERM_INVITE);
	export_constant(GUILD_PERM_EXPEL);
	export_constant(GUILD_PERM_STORAGE);
	export_constant(GUILD_PERM_ALL);

	/* guild storage log */
	export_constant(GUILDSTORAGE_LOG_FINAL_SUCCESS);
	export_constant(GUILDSTORAGE_LOG_EMPTY);
	export_constant(GUILDSTORAGE_LOG_FAILED);

	/* castle data flags */
	export_constant(CD_NONE);
	export_constant(CD_GUILD_ID);
	export_constant(CD_CURRENT_ECONOMY);
	export_constant(CD_CURRENT_DEFENSE);
	export_constant(CD_INVESTED_ECONOMY);
	export_constant(CD_INVESTED_DEFENSE);
	export_constant(CD_NEXT_TIME);
	export_constant(CD_PAY_TIME);
	export_constant(CD_CREATE_TIME);
	export_constant(CD_ENABLED_KAFRA);
	for( int32 i = CD_ENABLED_GUARDIAN00, j = 0; i < CD_MAX; i++, j++ ){
		char constant[32];

		sprintf( constant, "CD_ENABLED_GUARDIAN%02d", j );

		script_set_constant( constant, i, false, false );
	}
	export_constant(CD_MAX);

	/* timer related */
	export_constant(INFINITE_TICK);

	/* block action */
	export_constant(PCBLOCK_MOVE);
	export_constant(PCBLOCK_ATTACK);
	export_constant(PCBLOCK_SKILL);
	export_constant(PCBLOCK_USEITEM);
	export_constant(PCBLOCK_CHAT);
	export_constant(PCBLOCK_IMMUNE);
	export_constant(PCBLOCK_SITSTAND);
	export_constant(PCBLOCK_COMMANDS);
	export_constant(PCBLOCK_NPCCLICK);
	export_constant(PCBLOCK_EMOTION);
	export_constant(PCBLOCK_EQUIP);
	export_constant(PCBLOCK_NPC);
	export_constant(PCBLOCK_ALL);

	/* convertpcinfo command */
	export_constant(CPC_NAME);
	export_constant(CPC_CHAR);
	export_constant(CPC_ACCOUNT);

	/* instance_warpall flags */
	export_constant(IWA_NONE);
	export_constant(IWA_NOTDEAD);

	/* npcspeed command */
	export_constant(MIN_WALK_SPEED);
	export_constant(MAX_WALK_SPEED);
	export_constant(DEFAULT_NPC_WALK_SPEED);

	/* skill hit */
	export_constant(DMG_SINGLE);
	export_constant(DMG_MULTI_HIT);

	/* skill nk */
	export_constant(NK_NODAMAGE);
	export_constant(NK_SPLASH);
	export_constant(NK_SPLASHSPLIT);
	export_constant(NK_IGNOREATKCARD);
	export_constant(NK_IGNOREELEMENT);
	export_constant(NK_IGNOREDEFENSE);
	export_constant(NK_IGNOREFLEE);
	export_constant(NK_IGNOREDEFCARD);
	export_constant(NK_IGNORELONGCARD);
	export_constant(NK_CRITICAL);
	export_constant(NK_SIMPLEDEFENSE);

	/* skill inf */
	export_constant(INF_PASSIVE_SKILL);
	export_constant(INF_ATTACK_SKILL);
	export_constant(INF_GROUND_SKILL);
	export_constant(INF_SELF_SKILL);
	export_constant(INF_SUPPORT_SKILL);
	export_constant(INF_TRAP_SKILL);

	/* skill inf2 */
	export_constant(INF2_ISQUEST);
	export_constant(INF2_ISNPC);
	export_constant(INF2_ISWEDDING);
	export_constant(INF2_ISSPIRIT);
	export_constant(INF2_ISGUILD);
	export_constant(INF2_ISSONG);
	export_constant(INF2_ISENSEMBLE);
	export_constant(INF2_ISTRAP);
	export_constant(INF2_TARGETSELF);
	export_constant(INF2_NOTARGETSELF);
	export_constant(INF2_PARTYONLY);
	export_constant(INF2_GUILDONLY);
	export_constant(INF2_NOTARGETENEMY);
	export_constant(INF2_ISAUTOSHADOWSPELL);
	export_constant(INF2_ISCHORUS);
	export_constant(INF2_IGNOREBGREDUCTION);
	export_constant(INF2_IGNOREGVGREDUCTION);
	export_constant(INF2_DISABLENEARNPC);
	export_constant(INF2_TARGETTRAP);
	export_constant(INF2_IGNORELANDPROTECTOR);
	export_constant(INF2_ALLOWWHENHIDDEN);
	export_constant(INF2_ALLOWWHENPERFORMING);
	export_constant(INF2_TARGETEMPERIUM);
	export_constant(INF2_IGNOREKAGEHUMI);
	export_constant(INF2_ALTERRANGEVULTURE);
	export_constant(INF2_ALTERRANGESNAKEEYE);
	export_constant(INF2_ALTERRANGESHADOWJUMP);
	export_constant(INF2_ALTERRANGERADIUS);
	export_constant(INF2_ALTERRANGERESEARCHTRAP);
	export_constant(INF2_IGNOREHOVERING);
	export_constant(INF2_ALLOWONWARG);
	export_constant(INF2_ALLOWONMADO);
	export_constant(INF2_TARGETMANHOLE);
	export_constant(INF2_TARGETHIDDEN);
	export_constant(INF2_INCREASEDANCEWITHWUGDAMAGE);
	export_constant(INF2_IGNOREWUGBITE);
	export_constant(INF2_IGNOREAUTOGUARD);
	export_constant(INF2_IGNORECICADA);
	export_constant(INF2_SHOWSCALE);
	export_constant(INF2_IGNOREGTB);
	export_constant(INF2_TOGGLEABLE);

	/* skill no near npc flags */
	export_constant(SKILL_NONEAR_WARPPORTAL);
	export_constant(SKILL_NONEAR_SHOP);
	export_constant(SKILL_NONEAR_NPC);
	export_constant(SKILL_NONEAR_TOMB);

	/* skill cast flags */
	export_constant(SKILL_CAST_IGNOREDEX);
	export_constant(SKILL_CAST_IGNORESTATUS);
	export_constant(SKILL_CAST_IGNOREITEMBONUS);

	/* skill require cost flags */
	export_constant(SKILL_REQ_HPCOST);
	export_constant(SKILL_REQ_SPCOST);
	export_constant(SKILL_REQ_HPRATECOST);
	export_constant(SKILL_REQ_SPRATECOST);
	export_constant(SKILL_REQ_MAXHPTRIGGER);
	export_constant(SKILL_REQ_ZENYCOST);
	export_constant(SKILL_REQ_WEAPON);
	export_constant(SKILL_REQ_AMMO);
	export_constant(SKILL_REQ_STATE);
	export_constant(SKILL_REQ_STATUS);
	export_constant(SKILL_REQ_SPIRITSPHERECOST);
	export_constant(SKILL_REQ_ITEMCOST);
	export_constant(SKILL_REQ_EQUIPMENT);
	export_constant(SKILL_REQ_APCOST);
	export_constant(SKILL_REQ_APRATECOST);

	/* skill require state */
	export_constant(ST_NONE);
	export_constant(ST_HIDDEN);
	export_constant(ST_RIDING);
	export_constant(ST_FALCON);
	export_constant(ST_CART);
	export_constant(ST_SHIELD);
	export_constant(ST_RECOVER_WEIGHT_RATE);
	export_constant(ST_MOVE_ENABLE);
	export_constant(ST_WATER);
	export_constant(ST_RIDINGDRAGON);
	export_constant(ST_WUG);
	export_constant(ST_RIDINGWUG);
	export_constant(ST_MADO);
	export_constant(ST_ELEMENTALSPIRIT);
	export_constant(ST_ELEMENTALSPIRIT2);
	export_constant(ST_PECO);
	export_constant(ST_SUNSTANCE);
	export_constant(ST_MOONSTANCE);
	export_constant(ST_STARSTANCE);
	export_constant(ST_UNIVERSESTANCE);

	/* skill unit flags */
	export_constant(UF_NOENEMY);
	export_constant(UF_NOREITERATION);
	export_constant(UF_NOFOOTSET);
	export_constant(UF_NOOVERLAP);
	export_constant(UF_PATHCHECK);
	export_constant(UF_NOPC);
	export_constant(UF_NOMOB);
	export_constant(UF_SKILL);
	export_constant(UF_DANCE);
	export_constant(UF_ENSEMBLE);
	export_constant(UF_SONG);
	export_constant(UF_DUALMODE);
	export_constant(UF_NOKNOCKBACK);
	export_constant(UF_RANGEDSINGLEUNIT);
	export_constant(UF_CRAZYWEEDIMMUNE);
	export_constant(UF_REMOVEDBYFIRERAIN);
	export_constant(UF_KNOCKBACKGROUP);
	export_constant(UF_HIDDENTRAP);

	/* battle check target */
	export_constant(BCT_SELF);
	export_constant(BCT_ENEMY);
	export_constant(BCT_PARTY);
	export_constant(BCT_GUILDALLY);
	export_constant(BCT_NEUTRAL);
	export_constant(BCT_SAMEGUILD);
	export_constant(BCT_ALL);
	export_constant(BCT_WOS);
	export_constant(BCT_GUILD);
	export_constant(BCT_NOGUILD);
	export_constant(BCT_NOPARTY);
	export_constant(BCT_NOENEMY);
	export_constant(BCT_ALLY);
	export_constant(BCT_FRIEND);

	/* skill unit */
	export_constant(UNT_SAFETYWALL);
	export_constant(UNT_FIREWALL);
	export_constant(UNT_WARP_WAITING);
	export_constant(UNT_WARP_ACTIVE);
	export_constant(UNT_SANCTUARY);
	export_constant(UNT_MAGNUS);
	export_constant(UNT_PNEUMA);
	export_constant(UNT_DUMMYSKILL);
	export_constant(UNT_FIREPILLAR_WAITING);
	export_constant(UNT_FIREPILLAR_ACTIVE);
	export_constant(UNT_USED_TRAPS);
	export_constant(UNT_ICEWALL);
	export_constant(UNT_QUAGMIRE);
	export_constant(UNT_BLASTMINE);
	export_constant(UNT_SKIDTRAP);
	export_constant(UNT_ANKLESNARE);
	export_constant(UNT_VENOMDUST);
	export_constant(UNT_LANDMINE);
	export_constant(UNT_SHOCKWAVE);
	export_constant(UNT_SANDMAN);
	export_constant(UNT_FLASHER);
	export_constant(UNT_FREEZINGTRAP);
	export_constant(UNT_CLAYMORETRAP);
	export_constant(UNT_TALKIEBOX);
	export_constant(UNT_VOLCANO);
	export_constant(UNT_DELUGE);
	export_constant(UNT_VIOLENTGALE);
	export_constant(UNT_LANDPROTECTOR);
	export_constant(UNT_LULLABY);
	export_constant(UNT_RICHMANKIM);
	export_constant(UNT_ETERNALCHAOS);
	export_constant(UNT_DRUMBATTLEFIELD);
	export_constant(UNT_RINGNIBELUNGEN);
	export_constant(UNT_ROKISWEIL);
	export_constant(UNT_INTOABYSS);
	export_constant(UNT_SIEGFRIED);
	export_constant(UNT_DISSONANCE);
	export_constant(UNT_WHISTLE);
	export_constant(UNT_ASSASSINCROSS);
	export_constant(UNT_POEMBRAGI);
	export_constant(UNT_APPLEIDUN);
	export_constant(UNT_UGLYDANCE);
	export_constant(UNT_HUMMING);
	export_constant(UNT_DONTFORGETME);
	export_constant(UNT_FORTUNEKISS);
	export_constant(UNT_SERVICEFORYOU);
	export_constant(UNT_GRAFFITI);
	export_constant(UNT_DEMONSTRATION);
	export_constant(UNT_CALLFAMILY);
	export_constant(UNT_GOSPEL);
	export_constant(UNT_BASILICA);
	export_constant(UNT_MOONLIT);
	export_constant(UNT_FOGWALL);
	export_constant(UNT_SPIDERWEB);
	export_constant(UNT_GRAVITATION);
	export_constant(UNT_HERMODE);
	export_constant(UNT_SUITON);
	export_constant(UNT_TATAMIGAESHI);
	export_constant(UNT_KAEN);
	export_constant(UNT_GROUNDDRIFT_WIND);
	export_constant(UNT_GROUNDDRIFT_DARK);
	export_constant(UNT_GROUNDDRIFT_POISON);
	export_constant(UNT_GROUNDDRIFT_WATER);
	export_constant(UNT_GROUNDDRIFT_FIRE);
	export_constant(UNT_EARTHQUAKE);
	export_constant(UNT_EVILLAND);
	export_constant(UNT_EPICLESIS);
	export_constant(UNT_EARTHSTRAIN);
	export_constant(UNT_MANHOLE);
	export_constant(UNT_DIMENSIONDOOR);
	export_constant(UNT_CHAOSPANIC);
	export_constant(UNT_MAELSTROM);
	export_constant(UNT_BLOODYLUST);
	export_constant(UNT_FEINTBOMB);
	export_constant(UNT_MAGENTATRAP);
	export_constant(UNT_COBALTTRAP);
	export_constant(UNT_MAIZETRAP);
	export_constant(UNT_VERDURETRAP);
	export_constant(UNT_FIRINGTRAP);
	export_constant(UNT_ICEBOUNDTRAP);
	export_constant(UNT_ELECTRICSHOCKER);
	export_constant(UNT_CLUSTERBOMB);
	export_constant(UNT_REVERBERATION);
	export_constant(UNT_SEVERE_RAINSTORM);
	export_constant(UNT_FIREWALK);
	export_constant(UNT_ELECTRICWALK);
	export_constant(UNT_NETHERWORLD);
	export_constant(UNT_PSYCHIC_WAVE);
	export_constant(UNT_CLOUD_KILL);
	export_constant(UNT_POISONSMOKE);
	export_constant(UNT_NEUTRALBARRIER);
	export_constant(UNT_STEALTHFIELD);
	export_constant(UNT_WARMER);
	export_constant(UNT_THORNS_TRAP);
	export_constant(UNT_WALLOFTHORN);
	export_constant(UNT_DEMONIC_FIRE);
	export_constant(UNT_FIRE_EXPANSION_SMOKE_POWDER);
	export_constant(UNT_FIRE_EXPANSION_TEAR_GAS);
	export_constant(UNT_HELLS_PLANT);
	export_constant(UNT_VACUUM_EXTREME);
	export_constant(UNT_BANDING);
	export_constant(UNT_FIRE_MANTLE);
	export_constant(UNT_WATER_BARRIER);
	export_constant(UNT_ZEPHYR);
	export_constant(UNT_POWER_OF_GAIA);
	export_constant(UNT_FIRE_INSIGNIA);
	export_constant(UNT_WATER_INSIGNIA);
	export_constant(UNT_WIND_INSIGNIA);
	export_constant(UNT_EARTH_INSIGNIA);
	export_constant(UNT_POISON_MIST);
	export_constant(UNT_LAVA_SLIDE);
	export_constant(UNT_VOLCANIC_ASH);
	export_constant(UNT_ZENKAI_WATER);
	export_constant(UNT_ZENKAI_LAND);
	export_constant(UNT_ZENKAI_FIRE);
	export_constant(UNT_ZENKAI_WIND);
	export_constant(UNT_MAKIBISHI);
	export_constant(UNT_VENOMFOG);
	export_constant(UNT_ICEMINE);
	export_constant(UNT_FLAMECROSS);
	export_constant(UNT_HELLBURNING);
	export_constant(UNT_MAGMA_ERUPTION);
	export_constant(UNT_KINGS_GRACE);
	export_constant(UNT_GLITTERING_GREED);
	export_constant(UNT_B_TRAP);
	export_constant(UNT_FIRE_RAIN);
	export_constant(UNT_CATNIPPOWDER);
	export_constant(UNT_NYANGGRASS);
	export_constant(UNT_CREATINGSTAR);
	export_constant(UNT_DUMMY_0);
	export_constant(UNT_RAIN_OF_CRYSTAL);
	export_constant(UNT_MYSTERY_ILLUSION);
	export_constant(UNT_STRANTUM_TREMOR);
	export_constant(UNT_VIOLENT_QUAKE);
	export_constant(UNT_ALL_BLOOM);
	export_constant(UNT_TORNADO_STORM);
	export_constant(UNT_FLORAL_FLARE_ROAD);
	export_constant(UNT_ASTRAL_STRIKE);
	export_constant(UNT_CROSS_RAIN);
	export_constant(UNT_PNEUMATICUS_PROCELLA);
	export_constant(UNT_ABYSS_SQUARE);
	export_constant(UNT_ACIDIFIED_ZONE_WATER);
	export_constant(UNT_ACIDIFIED_ZONE_GROUND);
	export_constant(UNT_ACIDIFIED_ZONE_WIND);
	export_constant(UNT_ACIDIFIED_ZONE_FIRE);
	export_constant(UNT_LIGHTNING_LAND);
	export_constant(UNT_VENOM_SWAMP);
	export_constant(UNT_CONFLAGRATION);
	export_constant(UNT_DEEPBLINDTRAP);
	export_constant(UNT_SOLIDTRAP);
	export_constant(UNT_SWIFTTRAP);
	export_constant(UNT_FLAMETRAP);
	export_constant(UNT_TWINKLING_GALAXY);
	export_constant(UNT_STAR_CANNON);
	export_constant(UNT_GRENADES_DROPPING);
	export_constant(UNT_FUUMASHOUAKU);
	export_constant(UNT_MISSION_BOMBARD);
	export_constant(UNT_TOTEM_OF_TUTELARY);
	export_constant(UNT_HYUN_ROKS_BREEZE);
	export_constant(UNT_SHINKIROU);
	export_constant(UNT_JACK_FROST_NOVA);
	export_constant(UNT_GROUND_GRAVITATION);
	export_constant(UNT_KUNAIWAIKYOKU);
	export_constant(UNT_GD_LEADERSHIP);
	export_constant(UNT_GD_GLORYWOUNDS);
	export_constant(UNT_GD_SOULCOLD);
	export_constant(UNT_GD_HAWKEYES);
	export_constant(UNT_CANE_OF_EVIL_EYE);

	/* battleground info types */
	export_constant(BG_INFO_ID);
	export_constant(BG_INFO_REQUIRED_PLAYERS);
	export_constant(BG_INFO_MAX_PLAYERS);
	export_constant(BG_INFO_MIN_LEVEL);
	export_constant(BG_INFO_MAX_LEVEL);
	export_constant(BG_INFO_MAPS);
	export_constant(BG_INFO_DESERTER_TIME);

	/* item job classes */
	export_constant(ITEMJ_NORMAL);
	export_constant(ITEMJ_UPPER);
	export_constant(ITEMJ_BABY);
	export_constant(ITEMJ_THIRD);
	export_constant(ITEMJ_THIRD_UPPER);
	export_constant(ITEMJ_THIRD_BABY);
	export_constant(ITEMJ_FOURTH);
	export_constant(ITEMJ_ALL_UPPER);
	export_constant(ITEMJ_ALL_BABY);
	export_constant(ITEMJ_ALL_THIRD);

	/* item drop effects */
	export_constant(DROPEFFECT_NONE);
	export_constant(DROPEFFECT_CLIENT);
	export_constant(DROPEFFECT_WHITE_PILLAR);
	export_constant(DROPEFFECT_BLUE_PILLAR);
	export_constant(DROPEFFECT_YELLOW_PILLAR);
	export_constant(DROPEFFECT_PURPLE_PILLAR);
	export_constant(DROPEFFECT_ORANGE_PILLAR);
	export_constant(DROPEFFECT_GREEN_PILLAR);
	export_constant(DROPEFFECT_RED_PILLAR);
	export_constant(DROPEFFECT_MAX);

	/* penalty types */
	export_constant(PENALTY_EXP);
	export_constant(PENALTY_DROP);
	export_constant(PENALTY_MVP_EXP);
	export_constant(PENALTY_MVP_DROP);

	/* madogears */
	export_constant(MADO_ROBOT);
	export_constant(MADO_SUIT);

	/* getiteminfo/setiteminfo script commands */
	export_constant(ITEMINFO_BUY);
	export_constant(ITEMINFO_SELL);
	export_constant(ITEMINFO_TYPE);
	export_constant(ITEMINFO_MAXCHANCE);
	export_constant(ITEMINFO_GENDER);
	export_constant(ITEMINFO_LOCATIONS);
	export_constant(ITEMINFO_WEIGHT);
	export_constant(ITEMINFO_ATTACK);
	export_constant(ITEMINFO_DEFENSE);
	export_constant(ITEMINFO_RANGE);
	export_constant(ITEMINFO_SLOT);
	export_constant(ITEMINFO_VIEW);
	export_constant(ITEMINFO_EQUIPLEVELMIN);
	export_constant(ITEMINFO_WEAPONLEVEL);
	export_constant(ITEMINFO_ALIASNAME);
	export_constant(ITEMINFO_EQUIPLEVELMAX);
	export_constant(ITEMINFO_MAGICATTACK);
	export_constant(ITEMINFO_ID);
	export_constant(ITEMINFO_AEGISNAME);
	export_constant(ITEMINFO_ARMORLEVEL);
	export_constant(ITEMINFO_SUBTYPE);

	/* geteleminfo script command */
	export_constant(ELEMINFO_ID);
	export_constant(ELEMINFO_GAMEID);
	export_constant(ELEMINFO_CLASS);

	/* setdialogalign script command */
	export_constant(DIALOG_ALIGN_LEFT);
	export_constant(DIALOG_ALIGN_RIGHT);
	export_constant(DIALOG_ALIGN_CENTER);
	export_constant(DIALOG_ALIGN_TOP);
	export_constant(DIALOG_ALIGN_MIDDLE);
	export_constant(DIALOG_ALIGN_BOTTOM);

	/* refine types */
	export_constant(REFINE_TYPE_ARMOR);
	export_constant(REFINE_TYPE_WEAPON);
	export_constant(REFINE_TYPE_SHADOW_ARMOR);
	export_constant(REFINE_TYPE_SHADOW_WEAPON);

	/* autospell flags */
	export_constant(AUTOSPELL_FORCE_SELF);
	export_constant(AUTOSPELL_FORCE_TARGET);
	export_constant(AUTOSPELL_FORCE_RANDOM_LEVEL);
	export_constant(AUTOSPELL_FORCE_ALL);

	/* stats */
	export_constant(PARAM_STR);
	export_constant(PARAM_AGI);
	export_constant(PARAM_VIT);
	export_constant(PARAM_INT);
	export_constant(PARAM_DEX);
	export_constant(PARAM_LUK);
	export_constant(PARAM_POW);
	export_constant(PARAM_STA);
	export_constant(PARAM_WIS);
	export_constant(PARAM_SPL);
	export_constant(PARAM_CON);
	export_constant(PARAM_CRT);

	/* Elemental Skill Mode */
	export_constant(EL_SKILLMODE_PASSIVE);
	export_constant(EL_SKILLMODE_ASSIST);
	export_constant(EL_SKILLMODE_AGGRESSIVE);

	/* status calc bl */
	export_constant(SCB_NONE);
	export_constant(SCB_BASE);
	export_constant(SCB_MAXHP);
	export_constant(SCB_MAXSP);
	export_constant(SCB_STR);
	export_constant(SCB_AGI);
	export_constant(SCB_VIT);
	export_constant(SCB_INT);
	export_constant(SCB_DEX);
	export_constant(SCB_LUK);
	export_constant(SCB_BATK);
	export_constant(SCB_WATK);
	export_constant(SCB_MATK);
	export_constant(SCB_HIT);
	export_constant(SCB_FLEE);
	export_constant(SCB_DEF);
	export_constant(SCB_DEF2);
	export_constant(SCB_MDEF);
	export_constant(SCB_MDEF2);
	export_constant(SCB_SPEED);
	export_constant(SCB_ASPD);
	export_constant(SCB_DSPD);
	export_constant(SCB_CRI);
	export_constant(SCB_FLEE2);
	export_constant(SCB_ATK_ELE);
	export_constant(SCB_DEF_ELE);
	export_constant(SCB_MODE);
	export_constant(SCB_SIZE);
	export_constant(SCB_RACE);
	export_constant(SCB_RANGE);
	export_constant(SCB_REGEN);
	export_constant(SCB_DYE);
	export_constant(SCB_MAXAP);
	export_constant(SCB_POW);
	export_constant(SCB_STA);
	export_constant(SCB_WIS);
	export_constant(SCB_SPL);
	export_constant(SCB_CON);
	export_constant(SCB_CRT);
	export_constant(SCB_PATK);
	export_constant(SCB_SMATK);
	export_constant(SCB_RES);
	export_constant(SCB_MRES);
	export_constant(SCB_HPLUS);
	export_constant(SCB_CRATE);

	/* status change states */
	export_constant(SCS_NONE);
	export_constant(SCS_NOMOVECOND);
	export_constant(SCS_NOMOVE);
	export_constant(SCS_NOPICKITEMCOND);
	export_constant(SCS_NOPICKITEM);
	export_constant(SCS_NODROPITEMCOND);
	export_constant(SCS_NODROPITEM);
	export_constant(SCS_NOCASTCOND);
	export_constant(SCS_NOCAST);
	export_constant(SCS_NOCHAT);
	export_constant(SCS_NOCHATCOND);
	export_constant(SCS_NOEQUIPITEM);
	export_constant(SCS_NOEQUIPITEMCOND);
	export_constant(SCS_NOUNEQUIPITEM);
	export_constant(SCS_NOUNEQUIPITEMCOND);
	export_constant(SCS_NOCONSUMEITEM);
	export_constant(SCS_NOCONSUMEITEMCOND);
	export_constant(SCS_NOATTACK);
	export_constant(SCS_NOATTACKCOND);
	export_constant(SCS_NOWARP);
	export_constant(SCS_NOWARPCOND);
	export_constant(SCS_NODEATHPENALTY);
	export_constant(SCS_NODEATHPENALTYCOND);
	export_constant(SCS_NOINTERACT);
	export_constant(SCS_NOINTERACTCOND);

	/* body states */
	export_constant(OPT1_STONE);
	export_constant(OPT1_FREEZE);
	export_constant(OPT1_STUN);
	export_constant(OPT1_SLEEP);
	export_constant(OPT1_STONEWAIT);
	export_constant(OPT1_BURNING);
	export_constant(OPT1_IMPRISON);

	/* health states */
	export_constant(OPT2_POISON);
	export_constant(OPT2_CURSE);
	export_constant(OPT2_SILENCE);
	export_constant(OPT2_SIGNUMCRUCIS);
	export_constant(OPT2_BLIND);
	export_constant(OPT2_ANGELUS);
	export_constant(OPT2_BLEEDING);
	export_constant(OPT2_DPOISON);
	export_constant(OPT2_FEAR);

	/* show effect states */
	export_constant(OPT3_NORMAL);
	export_constant(OPT3_QUICKEN);
	export_constant(OPT3_OVERTHRUST);
	export_constant(OPT3_ENERGYCOAT);
	export_constant(OPT3_EXPLOSIONSPIRITS);
	export_constant(OPT3_STEELBODY);
	export_constant(OPT3_BLADESTOP);
	export_constant(OPT3_AURABLADE);
	export_constant(OPT3_BERSERK);
	export_constant(OPT3_LIGHTBLADE);
	export_constant(OPT3_MOONLIT);
	export_constant(OPT3_MARIONETTE);
	export_constant(OPT3_ASSUMPTIO);
	export_constant(OPT3_WARM);
	export_constant(OPT3_KAITE);
	export_constant(OPT3_BUNSIN);
	export_constant(OPT3_SOULLINK);
	export_constant(OPT3_UNDEAD);
	export_constant(OPT3_CONTRACT);

	/* status change flags */
	export_constant(SCF_BLEFFECT);
	export_constant(SCF_DISPLAYPC);
	export_constant(SCF_NOCLEARBUFF);
	export_constant(SCF_NOREMOVEONDEAD);
	export_constant(SCF_NODISPELL);
	export_constant(SCF_NOCLEARANCE);
	export_constant(SCF_NOBANISHINGBUSTER);
	export_constant(SCF_NOSAVE);
	export_constant(SCF_NOSAVEINFINITE);
	export_constant(SCF_REMOVEONDAMAGED);
	export_constant(SCF_REMOVEONREFRESH);
	export_constant(SCF_REMOVEONLUXANIMA);
	export_constant(SCF_STOPATTACKING);
	export_constant(SCF_STOPCASTING);
	export_constant(SCF_STOPWALKING);
	export_constant(SCF_BOSSRESIST);
	export_constant(SCF_MVPRESIST);
	export_constant(SCF_SETSTAND);
	export_constant(SCF_FAILEDMADO);
	export_constant(SCF_DEBUFF);
	export_constant(SCF_REMOVEONCHANGEMAP);
	export_constant(SCF_REMOVEONMAPWARP);
	export_constant(SCF_REMOVECHEMICALPROTECT);
	export_constant(SCF_OVERLAPIGNORELEVEL);
	export_constant(SCF_SENDOPTION);
	export_constant(SCF_ONTOUCH);
	export_constant(SCF_UNITMOVE);
	export_constant(SCF_NONPLAYER);
	export_constant(SCF_SENDLOOK);
	export_constant(SCF_DISPLAYNPC);
	export_constant(SCF_REQUIREWEAPON);
	export_constant(SCF_REQUIRESHIELD);
	export_constant(SCF_MOBLOSETARGET);
	export_constant(SCF_REMOVEELEMENTALOPTION);
	export_constant(SCF_SUPERNOVICEANGEL);
	export_constant(SCF_TAEKWONANGEL);
	export_constant(SCF_MADOCANCEL);
	export_constant(SCF_MADOENDCANCEL);
	export_constant(SCF_RESTARTONMAPWARP);
	export_constant(SCF_SPREADEFFECT);
	export_constant(SCF_SENDVAL1);
	export_constant(SCF_SENDVAL2);
	export_constant(SCF_SENDVAL3);
	export_constant(SCF_NOFORCEDEND);
	export_constant(SCF_NOWARNING);
	export_constant(SCF_REMOVEONUNEQUIP);
	export_constant(SCF_REMOVEONUNEQUIPWEAPON);
	export_constant(SCF_REMOVEONUNEQUIPARMOR);
	export_constant(SCF_REMOVEONHERMODE);
	export_constant(SCF_REQUIRENOWEAPON);
	export_constant(SCF_REMOVEFROMHOMONWARP);
	export_constant(SCF_REMOVEFROMHOMONMAPWARP);

	/* enchantgrades */
	export_constant(ENCHANTGRADE_NONE);
	export_constant(ENCHANTGRADE_D);
	export_constant(ENCHANTGRADE_C);
	export_constant(ENCHANTGRADE_B);
	export_constant(ENCHANTGRADE_A);
	export_constant(MAX_ENCHANTGRADE);

	/* cash shop tabs */
	export_constant(CASHSHOP_TAB_NEW);
	export_constant(CASHSHOP_TAB_HOT);
	export_constant(CASHSHOP_TAB_LIMITED);
	export_constant(CASHSHOP_TAB_RENTAL);
	export_constant(CASHSHOP_TAB_PERMANENT);
	export_constant(CASHSHOP_TAB_SCROLLS);
	export_constant(CASHSHOP_TAB_CONSUMABLES);
	export_constant(CASHSHOP_TAB_OTHER);
	export_constant(CASHSHOP_TAB_SALE);

	/* WoE Types */
	export_constant(WOE_FIRST_EDITION);
	export_constant(WOE_SECOND_EDITION);
	export_constant(WOE_THIRD_EDITION);

	/* homunculus view IDs */
	export_constant(MER_LIF);
	export_constant(MER_AMISTR);
	export_constant(MER_FILIR);
	export_constant(MER_VANILMIRTH);
	export_constant(MER_LIF2);
	export_constant(MER_AMISTR2);
	export_constant(MER_FILIR2);
	export_constant(MER_VANILMIRTH2);
	export_constant(MER_LIF_H);
	export_constant(MER_AMISTR_H);
	export_constant(MER_FILIR_H);
	export_constant(MER_VANILMIRTH_H);
	export_constant(MER_LIF_H2);
	export_constant(MER_AMISTR_H2);
	export_constant(MER_FILIR_H2);
	export_constant(MER_VANILMIRTH_H2);
	export_constant(MER_EIRA);
	export_constant(MER_BAYERI);
	export_constant(MER_SERA);
	export_constant(MER_DIETER);
	export_constant(MER_ELEANOR);

	/* searchstore constants */
	export_constant(SEARCHSTORE_EFFECT_NORMAL);
	export_constant(SEARCHSTORE_EFFECT_REMOTE);

	#undef export_constant
	#undef export_constant2
	#undef export_parameter
	#undef export_constant_offset
	#undef export_deprecated_constant
	#undef export_deprecated_constant2

#endif /* SCRIPT_CONSTANTS_HPP */
